/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/strings","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/marshalling","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(H){for(var e=[],v=0,t=H.length;v<t;v++)e[v]=Z[H[v]];return e};define(Z[120],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function v(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=v;function t(k,R="Unreachable"){throw new Error(R)}e.assertNever=t}),define(Z[121],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(D){return D?D.replace(/\$\((.*?)\)/g,(y,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(y,h,p){this.id=y,this.definition=h,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.terminalDecorationSuccess=new t("terminal-decoration-success",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.terminalDecorationIncomplete=new t("terminal-decoration-incomplete",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.terminalDecorationMark=new t("terminal-decoration-mark",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.terminalDecorationError=new t("terminal-decoration-error",t.errorSmall.definition),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,y){const h=["codicon","codicon-"+D];return y&&h.push("codicon-modifier-"+y),h}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(E){if(E instanceof t)return["codicon","codicon-"+E.id];const S=y.exec(E.id);if(!S)return h(t.error);const[,f,d]=S,C=["codicon","codicon-"+f];return d&&C.push("codicon-modifier-"+d.substr(1)),C}D.asClassNameArray=h;function p(E){return h(E).join(" ")}D.asClassName=p;function I(E){return"."+h(E).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[122],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(y,h){const p=Math.pow(10,h);return Math.round(y*p)/p}class t{constructor(h,p,I,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=v(Math.max(Math.min(1,E),0),3)}static equals(h,p){return h.r===p.r&&h.g===p.g&&h.b===p.b&&h.a===p.a}}e.RGBA=t;class k{constructor(h,p,I,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.l=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,E),0),3)}static equals(h,p){return h.h===p.h&&h.s===p.s&&h.l===p.l&&h.a===p.a}static fromRGBA(h){const p=h.r/255,I=h.g/255,E=h.b/255,S=h.a,f=Math.max(p,I,E),d=Math.min(p,I,E);let C=0,b=0;const w=(d+f)/2,m=f-d;if(m>0){switch(b=Math.min(w<=.5?m/(2*w):m/(2-2*w),1),f){case p:C=(I-E)/m+(I<E?6:0);break;case I:C=(E-p)/m+2;break;case E:C=(p-I)/m+4;break}C*=60,C=Math.round(C)}return new k(C,b,w,S)}static _hue2rgb(h,p,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?h+(p-h)*6*I:I<1/2?p:I<2/3?h+(p-h)*(2/3-I)*6:h}static toRGBA(h){const p=h.h/360,{s:I,l:E,a:S}=h;let f,d,C;if(I===0)f=d=C=E;else{const b=E<.5?E*(1+I):E+I-E*I,w=2*E-b;f=k._hue2rgb(w,b,p+1/3),d=k._hue2rgb(w,b,p),C=k._hue2rgb(w,b,p-1/3)}return new t(Math.round(f*255),Math.round(d*255),Math.round(C*255),S)}}e.HSLA=k;class R{constructor(h,p,I,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.v=v(Math.max(Math.min(1,I),0),3),this.a=v(Math.max(Math.min(1,E),0),3)}static equals(h,p){return h.h===p.h&&h.s===p.s&&h.v===p.v&&h.a===p.a}static fromRGBA(h){const p=h.r/255,I=h.g/255,E=h.b/255,S=Math.max(p,I,E),f=Math.min(p,I,E),d=S-f,C=S===0?0:d/S;let b;return d===0?b=0:S===p?b=((I-E)/d%6+6)%6:S===I?b=(E-p)/d+2:b=(p-I)/d+4,new R(Math.round(b*60),C,S,h.a)}static toRGBA(h){const{h:p,s:I,v:E,a:S}=h,f=E*I,d=f*(1-Math.abs(p/60%2-1)),C=E-f;let[b,w,m]=[0,0,0];return p<60?(b=f,w=d):p<120?(b=d,w=f):p<180?(w=f,m=d):p<240?(w=d,m=f):p<300?(b=d,m=f):p<=360&&(b=f,m=d),b=Math.round((b+C)*255),w=Math.round((w+C)*255),m=Math.round((m+C)*255),new t(b,w,m,S)}}e.HSVA=R;class D{constructor(h){if(h)if(h instanceof t)this.rgba=h;else if(h instanceof k)this._hsla=h,this.rgba=k.toRGBA(h);else if(h instanceof R)this._hsva=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(h){return!!h&&t.equals(this.rgba,h.rgba)&&k.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D._relativeLuminanceForComponent(this.rgba.r),p=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),E=.2126*h+.7152*p+.0722*I;return v(E,4)}static _relativeLuminanceForComponent(h){const p=h/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p>I?(p+.05)/(I+.05):(I+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p>I}isDarkerThan(h){const p=this.getRelativeLuminance(),I=h.getRelativeLuminance();return p<I}lighten(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:p,g:I,b:E,a:S}=this.rgba;return new D(new t(p,I,E,S*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const p=h.rgba,I=this.rgba.a,E=p.a,S=I+E*(1-I);if(S<1e-6)return D.transparent;const f=this.rgba.r*I/S+p.r*E*(1-I)/S,d=this.rgba.g*I/S+p.g*E*(1-I)/S,C=this.rgba.b*I/S+p.b*E*(1-I)/S;return new D(new t(f,d,C,S))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:p,g:I,b:E,a:S}=this.rgba;return new D(new t(h.rgba.r-S*(h.rgba.r-p),h.rgba.g-S*(h.rgba.g-I),h.rgba.b-S*(h.rgba.b-E),1))}flatten(...h){const p=h.reduceRight((I,E)=>D._flatten(E,I));return D._flatten(this,p)}static _flatten(h,p){const I=1-h.rgba.a;return new D(new t(I*p.rgba.r+h.rgba.a*h.rgba.r,I*p.rgba.g+h.rgba.a*h.rgba.g,I*p.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(h,p,I){if(h.isLighterThan(p))return h;I=I||.5;const E=h.getRelativeLuminance(),S=p.getRelativeLuminance();return I=I*(S-E)/S,h.lighten(I)}static getDarkerColor(h,p,I){if(h.isDarkerThan(p))return h;I=I||.5;const E=h.getRelativeLuminance(),S=p.getRelativeLuminance();return I=I*(E-S)/E,h.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(y){let h;(function(p){let I;(function(E){function S(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:y.Format.CSS.formatRGBA(s)}E.formatRGB=S;function f(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}E.formatRGBA=f;function d(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(s)}E.formatHSL=d;function C(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}E.formatHSLA=C;function b(s){const r=s.toString(16);return r.length!==2?"0"+r:r}function w(s){return`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}`}E.formatHex=w;function m(s,r=!1){return r&&s.rgba.a===1?y.Format.CSS.formatHex(s):`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}${b(Math.round(s.rgba.a*255))}`}E.formatHexA=m;function g(s){return s.isOpaque()?y.Format.CSS.formatHex(s):y.Format.CSS.formatRGBA(s)}E.format=g;function u(s){const r=s.length;if(r===0||s.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6));return new y(new t(i,n,o,1))}if(r===9){const i=16*c(s.charCodeAt(1))+c(s.charCodeAt(2)),n=16*c(s.charCodeAt(3))+c(s.charCodeAt(4)),o=16*c(s.charCodeAt(5))+c(s.charCodeAt(6)),a=16*c(s.charCodeAt(7))+c(s.charCodeAt(8));return new y(new t(i,n,o,a/255))}if(r===4){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3));return new y(new t(16*i+i,16*n+n,16*o+o))}if(r===5){const i=c(s.charCodeAt(1)),n=c(s.charCodeAt(2)),o=c(s.charCodeAt(3)),a=c(s.charCodeAt(4));return new y(new t(16*i+i,16*n+n,16*o+o,(16*a+a)/255))}return null}E.parseHex=u;function c(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=p.CSS||(p.CSS={}))})(h=y.Format||(y.Format={}))}(D=e.Color||(e.Color={}))}),define(Z[51],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(D){return(y,h,p)=>{let I=null,E=null;if(typeof p.value=="function"?(I="value",E=p.value):typeof p.get=="function"&&(I="get",E=p.get),!E)throw new Error("not supported");p[I]=D(E,h)}}e.createDecorator=v;function t(D,y,h){let p=null,I=null;if(typeof h.value=="function"?(p="value",I=h.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(p="get",I=h.get),!I)throw new Error("not supported");const E=`$memoize$${y}`;h[p]=function(...S){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,S)}),this[E]}}e.memoize=t;function k(D,y,h){return v((p,I)=>{const E=`$debounce$${I}`,S=`$debounce$result$${I}`;return function(...f){this[S]||(this[S]=h?h():void 0),clearTimeout(this[E]),y&&(this[S]=y(this[S],...f),f=[this[S]]),this[E]=setTimeout(()=>{p.apply(this,f),this[S]=h?h():void 0},D)}})}e.debounce=k;function R(D,y,h){return v((p,I)=>{const E=`$throttle$timer$${I}`,S=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...C){if(this[S]||(this[S]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),y&&(this[S]=y(this[S],...C)),this[d])return;const b=this[f]+D;b<=Date.now()?(this[f]=Date.now(),p.apply(this,[this[S]]),this[S]=h?h():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),p.apply(this,[this[S]]),this[S]=h?h():void 0},b-Date.now()))}})}e.throttle=R}),define(Z[18],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?g.isErrorNoTelemetry(s)?new g(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=v,e.errorHandler=new v;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){h(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){h(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:s,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:s,message:r,stack:i,noTelemetry:g.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const y="Canceled";function h(c){return c instanceof p?!0:c instanceof Error&&c.name===y&&c.message===y}e.isCancellationError=h;class p extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=p;function I(){const c=new Error(y);return c.name=c.message,c}e.canceled=I;function E(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=E;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function f(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function d(c){const s=new Error(`${c} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function C(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=C;class b extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=b;class w extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=w;class m extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=m;class g extends Error{constructor(s){super(s);this.name="CodeExpectedError"}static fromError(s){if(s instanceof g)return s;const r=new g;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class u extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(Z[24],ee([0,1,18]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,te=0){return j[j.length-(1+te)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,te,ie=(ce,he)=>ce===he){if(j===te)return!0;if(!j||!te||j.length!==te.length)return!1;for(let ce=0,he=j.length;ce<he;ce++)if(!ie(j[ce],te[ce]))return!1;return!0}e.equals=R;function D(j,te){const ie=j.length-1;te<ie&&(j[te]=j[ie]),j.pop()}e.removeFastWithoutKeepingOrder=D;function y(j,te,ie){return h(j.length,ce=>ie(j[ce],te))}e.binarySearch=y;function h(j,te){let ie=0,ce=j-1;for(;ie<=ce;){const he=(ie+ce)/2|0,ke=te(he);if(ke<0)ie=he+1;else if(ke>0)ce=he-1;else return he}return-(ie+1)}e.binarySearch2=h;function p(j,te){let ie=0,ce=j.length;if(ce===0)return 0;for(;ie<ce;){const he=Math.floor((ie+ce)/2);te(j[he])?ce=he:ie=he+1}return ie}e.findFirstInSorted=p;function I(j,te,ie){if(j=j|0,j>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],he=[],ke=[],Le=[];for(const Me of te){const Ae=ie(Me,ce);Ae<0?he.push(Me):Ae>0?ke.push(Me):Le.push(Me)}return j<he.length?I(j,he,ie):j<he.length+Le.length?Le[0]:I(j-(he.length+Le.length),ke,ie)}e.quickSelect=I;function E(j,te){const ie=[];let ce;for(const he of j.slice(0).sort(te))!ce||te(ce[0],he)!==0?(ce=[he],ie.push(ce)):ce.push(he);return ie}e.groupBy=E;function S(j,te,ie){const ce=[];function he(Me,Ae,Ve){if(Ae===0&&Ve.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===Me?(me.deleteCount+=Ae,me.toInsert.push(...Ve)):ce.push({start:Me,deleteCount:Ae,toInsert:Ve})}let ke=0,Le=0;for(;;){if(ke===j.length){he(ke,0,te.slice(Le));break}if(Le===te.length){he(ke,j.length-ke,[]);break}const Me=j[ke],Ae=te[Le],Ve=ie(Me,Ae);Ve===0?(ke+=1,Le+=1):Ve<0?(he(ke,1,[]),ke+=1):Ve>0&&(he(ke,0,[Ae]),Le+=1)}return ce}e.sortedDiff=S;function f(j,te,ie){const ce=S(j,te,ie),he=[],ke=[];for(const Le of ce)he.push(...j.slice(Le.start,Le.start+Le.deleteCount)),ke.push(...Le.toInsert);return{removed:he,added:ke}}e.delta=f;function d(j,te,ie){if(ie===0)return[];const ce=j.slice(0,ie).sort(te);return b(j,te,ce,ie,j.length),ce}e.top=d;function C(j,te,ie,ce,he){return ie===0?Promise.resolve([]):new Promise((ke,Le)=>{(async()=>{const Me=j.length,Ae=j.slice(0,ie).sort(te);for(let Ve=ie,me=Math.min(ie+ce,Me);Ve<Me;Ve=me,me=Math.min(me+ce,Me)){if(Ve>ie&&await new Promise(pe=>setTimeout(pe)),he&&he.isCancellationRequested)throw new v.CancellationError;b(j,te,Ae,Ve,me)}return Ae})().then(ke,Le)})}e.topAsync=C;function b(j,te,ie,ce,he){for(const ke=ie.length;ce<he;ce++){const Le=j[ce];if(te(Le,ie[ke-1])<0){ie.pop();const Me=p(ie,Ae=>te(Le,Ae)<0);ie.splice(Me,0,Le)}}}function w(j){return j.filter(te=>!!te)}e.coalesce=w;function m(j){let te=0;for(let ie=0;ie<j.length;ie++)j[ie]&&(j[te]=j[ie],te+=1);j.length=te}e.coalesceInPlace=m;function g(j,te,ie){j.splice(ie,0,j.splice(te,1)[0])}e.move=g;function u(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=u;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function s(j,te=ie=>ie){const ie=new Set;return j.filter(ce=>{const he=te(ce);return ie.has(he)?!1:(ie.add(he),!0)})}e.distinct=s;function r(j){const te=new Set;return ie=>{const ce=j(ie);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=r;function i(j,te){const ie=n(j,te);if(ie!==-1)return j[ie]}e.findLast=i;function n(j,te){for(let ie=j.length-1;ie>=0;ie--){const ce=j[ie];if(te(ce))return ie}return-1}e.lastIndex=n;function o(j,te){return j.length>0?j[0]:te}e.firstOrDefault=o;function a(j,te){return j.length>0?j[j.length-1]:te}e.lastOrDefault=a;function l(j,te,ie=(ce,he)=>ce===he){let ce=0;for(let he=0,ke=Math.min(j.length,te.length);he<ke&&ie(j[he],te[he]);he++)ce++;return ce}e.commonPrefixLength=l;function P(j){return[].concat(...j)}e.flatten=P;function M(j,te){let ie=typeof te=="number"?j:0;typeof te=="number"?ie=j:(ie=0,te=j);const ce=[];if(ie<=te)for(let he=ie;he<te;he++)ce.push(he);else for(let he=ie;he>te;he--)ce.push(he);return ce}e.range=M;function A(j,te,ie){return j.reduce((ce,he)=>(ce[te(he)]=ie?ie(he):he,ce),Object.create(null))}e.index=A;function F(j,te){return j.push(te),()=>U(j,te)}e.insert=F;function U(j,te){const ie=j.indexOf(te);if(ie>-1)return j.splice(ie,1),te}e.remove=U;function Q(j,te,ie){const ce=j.slice(0,te),he=j.slice(te);return ce.concat(ie,he)}e.arrayInsert=Q;function re(j,te){let ie;if(typeof te=="number"){let ce=te;ie=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else ie=Math.random;for(let ce=j.length-1;ce>0;ce-=1){const he=Math.floor(ie()*(ce+1)),ke=j[ce];j[ce]=j[he],j[he]=ke}}e.shuffle=re;function le(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.unshift(te))}e.pushToStart=le;function fe(j,te){const ie=j.indexOf(te);ie>-1&&(j.splice(ie,1),j.push(te))}e.pushToEnd=fe;function se(j,te){for(const ie of te)j.push(ie)}e.pushMany=se;function ue(j,te){return Array.isArray(j)?j.map(te):te(j)}e.mapArrayOrNot=ue;function K(j){return Array.isArray(j)?j:[j]}e.asArray=K;function N(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=N;function W(j,te){for(const ie of j){const ce=te(ie);if(ce!==void 0)return ce}}e.mapFind=W;function _(j,te,ie){const ce=$(j,te),he=j.length,ke=ie.length;j.length=he+ke;for(let Le=he-1;Le>=ce;Le--)j[Le+ke]=j[Le];for(let Le=0;Le<ke;Le++)j[Le+ce]=ie[Le]}e.insertInto=_;function T(j,te,ie,ce){const he=$(j,te),ke=j.splice(he,ie);return _(j,he,ce),ke}e.splice=T;function $(j,te){return te<0?Math.max(te+j.length,0):Math.min(te,j.length)}var x;(function(j){function te(he){return he<0}j.isLessThan=te;function ie(he){return he>0}j.isGreaterThan=ie;function ce(he){return he===0}j.isNeitherLessOrGreaterThan=ce,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(x=e.CompareResult||(e.CompareResult={}));function z(j,te){return(ie,ce)=>te(j(ie),j(ce))}e.compareBy=z;function q(...j){return(te,ie)=>{for(const ce of j){const he=ce(te,ie);if(!x.isNeitherLessOrGreaterThan(he))return he}return x.neitherLessOrGreaterThan}}e.tieBreakComparators=q;const L=(j,te)=>j-te;e.numberComparator=L;function O(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const he=j[ce];te(he,ie)>0&&(ie=he)}return ie}e.findMaxBy=O;function B(j,te){if(j.length===0)return;let ie=j[0];for(let ce=1;ce<j.length;ce++){const he=j[ce];te(he,ie)>=0&&(ie=he)}return ie}e.findLastMaxBy=B;function V(j,te){return O(j,(ie,ce)=>-te(ie,ce))}e.findMinBy=V;class X{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const ce=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,ce}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const ce=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=X;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(ce=>te(ce)?ie(ce):!0))}map(te){return new ne(ie=>this.iterate(ce=>ie(te(ce))))}some(te){let ie=!1;return this.iterate(ce=>(ie=te(ce),!ie)),ie}findFirst(te){let ie;return this.iterate(ce=>te(ce)?(ie=ce,!1):!0),ie}findLast(te){let ie;return this.iterate(ce=>(te(ce)&&(ie=ce),!0)),ie}findLastMaxBy(te){let ie,ce=!0;return this.iterate(he=>((ce||x.isGreaterThan(te(he,ie)))&&(ce=!1,ie=he),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(j=>{})}),define(Z[48],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=v}),define(Z[56],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*y(r){yield r}t.single=y;function h(r){return r||R}t.from=h;function p(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=p;function I(r){return r[Symbol.iterator]().next().value}t.first=I;function E(r,i){for(const n of r)if(i(n))return!0;return!1}t.some=E;function S(r,i){for(const n of r)if(i(n))return n}t.find=S;function*f(r,i){for(const n of r)i(n)&&(yield n)}t.filter=f;function*d(r,i){let n=0;for(const o of r)yield i(o,n++)}t.map=d;function*C(...r){for(const i of r)for(const n of i)yield n}t.concat=C;function*b(r){for(const i of r)for(const n of i)yield n}t.concatNested=b;function w(r,i,n){let o=n;for(const a of r)o=i(o,a);return o}t.reduce=w;function m(r,i){let n=0;for(const o of r)i(o,n++)}t.forEach=m;function*g(r,i,n=r.length){for(i<0&&(i+=r.length),n<0?n+=r.length:n>r.length&&(n=r.length);i<n;i++)yield r[i]}t.slice=g;function u(r,i=Number.POSITIVE_INFINITY){const n=[];if(i===0)return[n,r];const o=r[Symbol.iterator]();for(let a=0;a<i;a++){const l=o.next();if(l.done)return[n,t.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return o}}]}t.consume=u;function c(r){return u(r)[0]}t.collect=c;function s(r,i,n=(o,a)=>o===a){const o=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const l=o.next(),P=a.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!n(l.value,P.value))return!1}}t.equals=s})(v=e.Iterable||(e.Iterable={}))}),define(Z[42],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(s){s.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(s,r=!1){let i=0;const n=s.length;let o="",a=0,l=16,P=0;function M(fe){let se=0,ue=0;for(;se<fe;){const K=s.charCodeAt(i);if(K>=48&&K<=57)ue=ue*16+K-48;else if(K>=65&&K<=70)ue=ue*16+K-65+10;else if(K>=97&&K<=102)ue=ue*16+K-97+10;else break;i++,se++}return se<fe&&(ue=-1),ue}function A(fe){i=fe,o="",a=0,l=16,P=0}function F(){const fe=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&p(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&p(s.charCodeAt(i)))for(i++;i<s.length&&p(s.charCodeAt(i));)i++;else return P=3,s.substring(fe,i);let se=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&p(s.charCodeAt(i))){for(i++;i<s.length&&p(s.charCodeAt(i));)i++;se=i}else P=3;return s.substring(fe,se)}function U(){let fe="",se=i;for(;;){if(i>=n){fe+=s.substring(se,i),P=2;break}const ue=s.charCodeAt(i);if(ue===34){fe+=s.substring(se,i),i++;break}if(ue===92){if(fe+=s.substring(se,i),i++,i>=n){P=2;break}switch(s.charCodeAt(i++)){case 34:fe+='"';break;case 92:fe+="\\";break;case 47:fe+="/";break;case 98:fe+="\b";break;case 102:fe+="\f";break;case 110:fe+=`
`;break;case 114:fe+="\r";break;case 116:fe+="	";break;case 117:{const N=M(4);N>=0?fe+=String.fromCharCode(N):P=4;break}default:P=5}se=i;continue}if(ue>=0&&ue<=31)if(h(ue)){fe+=s.substring(se,i),P=2;break}else P=6;i++}return fe}function Q(){if(o="",P=0,a=i,i>=n)return a=n,l=17;let fe=s.charCodeAt(i);if(y(fe)){do i++,o+=String.fromCharCode(fe),fe=s.charCodeAt(i);while(y(fe));return l=15}if(h(fe))return i++,o+=String.fromCharCode(fe),fe===13&&s.charCodeAt(i)===10&&(i++,o+=`
`),l=14;switch(fe){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,o=U(),l=10;case 47:{const se=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(s.charCodeAt(i));)i++;return o=s.substring(se,i),l=12}if(s.charCodeAt(i+1)===42){i+=2;const ue=n-1;let K=!1;for(;i<ue;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),o=s.substring(se,i),l=13}return o+=String.fromCharCode(fe),i++,l=16}case 45:if(o+=String.fromCharCode(fe),i++,i===n||!p(s.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),l=11;default:for(;i<n&&re(fe);)i++,fe=s.charCodeAt(i);if(a!==i){switch(o=s.substring(a,i),o){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return o+=String.fromCharCode(fe),i++,l=16}}function re(fe){if(y(fe)||h(fe))return!1;switch(fe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let fe;do fe=Q();while(fe>=12&&fe<=15);return fe}return{setPosition:A,getPosition:()=>i,scan:r?le:Q,getToken:()=>l,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=D;function y(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function p(s){return s>=48&&s<=57}var I;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(I||(I={}));function E(s,r){const i=[],n=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,A,F,U){a.value=M,a.offset=A,a.length=F,a.type=U,a.colonOffset=void 0,o=a}try{g(s,{onObjectBegin:(M,A)=>{if(r<=M)throw n;o=void 0,l=r>M,i.push("")},onObjectProperty:(M,A,F)=>{if(r<A||(P(M,A,F,"property"),i[i.length-1]=M,r<=A+F))throw n},onObjectEnd:(M,A)=>{if(r<=M)throw n;o=void 0,i.pop()},onArrayBegin:(M,A)=>{if(r<=M)throw n;o=void 0,i.push(0)},onArrayEnd:(M,A)=>{if(r<=M)throw n;o=void 0,i.pop()},onLiteralValue:(M,A,F)=>{if(r<A||(P(M,A,F,c(M)),r<=A+F))throw n},onSeparator:(M,A,F)=>{if(r<=A)throw n;if(M===":"&&o&&o.type==="property")o.colonOffset=A,l=!1,o=void 0;else if(M===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(l=!0,i[i.length-1]=""),o=void 0}}})}catch(M){if(M!==n)throw M}return{path:i,previousNode:o,isAtPropertyKey:l,matches:M=>{let A=0;for(let F=0;A<M.length&&F<i.length;F++)if(M[A]===i[F]||M[A]==="*")A++;else if(M[A]!=="**")return!1;return A===M.length}}}e.getLocation=E;function S(s,r=[],i=R.DEFAULT){let n=null,o=[];const a=[];function l(M){Array.isArray(o)?o.push(M):n!==null&&(o[n]=M)}return g(s,{onObjectBegin:()=>{const M={};l(M),a.push(o),o=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const M=[];l(M),a.push(o),o=M,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(M,A,F)=>{r.push({error:M,offset:A,length:F})}},i),o[0]}e.parse=S;function f(s,r=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){n.type==="property"&&(n.length=M-n.offset,n=n.parent)}function a(M){return n.children.push(M),M}g(s,{onObjectBegin:M=>{n=a({type:"object",offset:M,length:-1,parent:n,children:[]})},onObjectProperty:(M,A,F)=>{n=a({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:M,offset:A,length:F,parent:n})},onObjectEnd:(M,A)=>{n.length=M+A-n.offset,n=n.parent,o(M+A)},onArrayBegin:(M,A)=>{n=a({type:"array",offset:M,length:-1,parent:n,children:[]})},onArrayEnd:(M,A)=>{n.length=M+A-n.offset,n=n.parent,o(M+A)},onLiteralValue:(M,A,F)=>{a({type:c(M),offset:A,length:F,parent:n,value:M}),o(A+F)},onSeparator:(M,A,F)=>{n.type==="property"&&(M===":"?n.colonOffset=A:M===","&&o(A))},onError:(M,A,F)=>{r.push({error:M,offset:A,length:F})}},i);const P=n.children[0];return P&&delete P.parent,P}e.parseTree=f;function d(s,r){if(!s)return;let i=s;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=d;function C(s){if(!s.parent||!s.parent.children)return[];const r=C(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;r.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&r.push(i)}return r}e.getNodePath=C;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":{const r=Object.create(null);for(const i of s.children){const n=i.children[1];n&&(r[i.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function w(s,r,i=!1){return r>=s.offset&&r<s.offset+s.length||i&&r===s.offset+s.length}e.contains=w;function m(s,r,i=!1){if(w(s,r,i)){const n=s.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const a=m(n[o],r,i);if(a)return a}return s}}e.findNodeAtOffset=m;function g(s,r,i=R.DEFAULT){const n=D(s,!1);function o(z){return z?()=>z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(z){return z?q=>z(q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=o(r.onObjectBegin),P=a(r.onObjectProperty),M=o(r.onObjectEnd),A=o(r.onArrayBegin),F=o(r.onArrayEnd),U=a(r.onLiteralValue),Q=a(r.onSeparator),re=o(r.onComment),le=a(r.onError),fe=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ue(){for(;;){const z=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:fe||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(z){case 12:case 13:fe?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return z}}}function K(z,q=[],L=[]){if(le(z),q.length+L.length>0){let O=n.getToken();for(;O!==17;){if(q.indexOf(O)!==-1){ue();break}else if(L.indexOf(O)!==-1)break;O=ue()}}}function N(z){const q=n.getTokenValue();return z?U(q):P(q),ue(),!0}function W(){switch(n.getToken()){case 11:{let z=0;try{z=JSON.parse(n.getTokenValue()),typeof z!="number"&&(K(2),z=0)}catch{K(2)}U(z);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ue(),!0}function _(){return n.getToken()!==10?(K(3,[],[2,5]),!1):(N(!1),n.getToken()===6?(Q(":"),ue(),x()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function T(){l(),ue();let z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),ue(),n.getToken()===2&&se)break}else z&&K(6,[],[]);_()||K(4,[],[2,5]),z=!0}return M(),n.getToken()!==2?K(7,[2],[]):ue(),!0}function $(){A(),ue();let z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(z||K(4,[],[]),Q(","),ue(),n.getToken()===4&&se)break}else z&&K(6,[],[]);x()||K(4,[],[4,5]),z=!0}return F(),n.getToken()!==4?K(8,[4],[]):ue(),!0}function x(){switch(n.getToken()){case 3:return $();case 1:return T();case 10:return N(!0);default:return W()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):x()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=g;function u(s,r){const i=D(s),n=[];let o,a=0,l;do switch(l=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==l&&n.push(s.substring(a,l)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=u;function c(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[123],ee([0,1,42]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(p,I,E){let S,f,d,C,b;if(I){for(C=I.offset,b=C+I.length,d=C;d>0&&!h(p,d-1);)d--;let l=b;for(;l<p.length&&!h(p,l);)l++;f=p.substring(d,l),S=D(f,E)}else f=p,S=0,d=0,C=0,b=p.length;const w=y(E,p);let m=!1,g=0,u;E.insertSpaces?u=R(" ",E.tabSize||4):u="	";const c=(0,v.createScanner)(f,!1);let s=!1;function r(){return w+R(u,S+g)}function i(){let l=c.scan();for(m=!1;l===15||l===14;)m=m||l===14,l=c.scan();return s=l===16||c.getTokenError()!==0,l}const n=[];function o(l,P,M){!s&&P<b&&M>C&&p.substring(P,M)!==l&&n.push({offset:P,length:M-P,content:l})}let a=i();if(a!==17){const l=c.getTokenOffset()+d,P=R(u,S);o(P,d,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,P=i(),M="";for(;!m&&(P===12||P===13);){const F=c.getTokenOffset()+d;o(" ",l,F),l=c.getTokenOffset()+c.getTokenLength()+d,M=P===12?r():"",P=i()}if(P===2)a!==1&&(g--,M=r());else if(P===4)a!==3&&(g--,M=r());else{switch(a){case 3:case 1:g++,M=r();break;case 5:case 12:M=r();break;case 13:m?M=r():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(s=!0);break;case 16:s=!0;break}m&&(P===12||P===13)&&(M=r())}const A=c.getTokenOffset()+d;o(M,l,A),a=P}return n}e.format=t;function k(p,I){const E=JSON.stringify(p,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?E.replace(/\r\n|\r|\n/g,I.eol):E}e.toFormattedString=k;function R(p,I){let E="";for(let S=0;S<I;S++)E+=p;return E}function D(p,I){let E=0,S=0;const f=I.tabSize||4;for(;E<p.length;){const d=p.charAt(E);if(d===" ")S++;else if(d==="	")S+=f;else break;E++}return Math.floor(S/f)}function y(p,I){for(let E=0;E<I.length;E++){const S=I.charAt(E);if(S==="\r")return E+1<I.length&&I.charAt(E+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=y;function h(p,I){return`\r
`.indexOf(p.charAt(I))!==-1}e.isEOL=h}),define(Z[124],ee([0,1,42,123]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(p,I,E){return R(p,I,void 0,E)}e.removeProperty=k;function R(p,I,E,S,f){const d=I.slice(),C=[],b=(0,v.parseTree)(p,C);let w,m;for(;d.length>0&&(m=d.pop(),w=(0,v.findNodeAtLocation)(b,d),w===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(w)if(w.type==="object"&&typeof m=="string"&&Array.isArray(w.children)){const g=(0,v.findNodeAtLocation)(w,[m]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const u=w.children.indexOf(g.parent);let c,s=g.parent.offset+g.parent.length;if(u>0){const r=w.children[u-1];c=r.offset+r.length}else c=w.offset+1,w.children.length>1&&(s=w.children[1].offset);return D(p,{offset:c,length:s-c,content:""},S)}else return D(p,{offset:g.offset,length:g.length,content:JSON.stringify(E)},S);else{if(E===void 0)return[];const u=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,c=f?f(w.children.map(r=>r.children[0].value)):w.children.length;let s;if(c>0){const r=w.children[c-1];s={offset:r.offset+r.length,length:0,content:","+u}}else w.children.length===0?s={offset:w.offset+1,length:0,content:u}:s={offset:w.offset+1,length:0,content:u+","};return D(p,s,S)}}else if(w.type==="array"&&typeof m=="number"&&Array.isArray(w.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let u;if(w.children.length===0||m===0)u={offset:w.offset+1,length:0,content:w.children.length===0?g:g+","};else{const c=m===-1||m>w.children.length?w.children.length:m,s=w.children[c-1];u={offset:s.offset+s.length,length:0,content:","+g}}return D(p,u,S)}else{const g=m,u=w.children[g];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===g){const s=w.children[g-1],r=s.offset+s.length,i=w.offset+w.length;c={offset:r,length:i-2-r,content:""}}else c={offset:u.offset,length:w.children[g+1].offset-u.offset,content:""};return D(p,c,S)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${w.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(p,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},S)}}e.setProperty=R;function D(p,I,E){let S=y(p,I),f=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,t.isEOL)(S,f-1);)f--;for(;d<S.length&&!(0,t.isEOL)(S,d);)d++}const C=(0,t.format)(S,{offset:f,length:d-f},E);for(let w=C.length-1;w>=0;w--){const m=C[w];S=y(S,m),f=Math.min(f,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const b=p.length-(S.length-d)-f;return[{offset:f,length:b,content:S.substring(f,d)}]}e.withFormatting=D;function y(p,I){return p.substring(0,I.offset)+I.content+p.substring(I.offset+I.length)}e.applyEdit=y;function h(p,I){const E=I.slice(0).sort((f,d)=>{const C=f.offset-d.offset;return C===0?f.length-d.length:C});let S=p.length;for(let f=E.length-1;f>=0;f--){const d=E[f];if(d.offset+d.length<=S)p=y(p,d);else throw new Error("Overlapping edit");S=d.offset}return p}e.applyEdits=h}),define(Z[125],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(Z[2],ee([0,1,48,56]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(a){R=a}if(e.setDisposableTracker=D,k){const a="__is_disposable_tracked__";D(new class{trackDisposable(l){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[a]||console.log(P)},3e3)}setParent(l,P){if(l&&l!==g.None)try{l[a]=!0}catch{}}markAsDisposed(l){if(l&&l!==g.None)try{l[a]=!0}catch{}}markAsSingleton(l){}})}function y(a){return R?.trackDisposable(a),a}function h(a){R?.markAsDisposed(a)}function p(a,l){R?.setParent(a,l)}function I(a,l){if(!!R)for(const P of a)R.setParent(P,l)}function E(a){return R?.markAsSingleton(a),a}e.markAsSingleton=E;class S extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=S;function f(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=f;function d(a){if(t.Iterable.is(a)){const l=[];for(const P of a)if(P)try{P.dispose()}catch(M){l.push(M)}if(l.length===1)throw l[0];if(l.length>1)throw new S(l);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function C(a){for(const l of a)f(l)&&l.dispose();return[]}e.disposeIfDisposable=C;function b(...a){const l=w(()=>d(a));return I(a,l),l}e.combinedDisposable=b;function w(a){const l=y({dispose:(0,v.once)(()=>{h(l),a()})});return l}e.toDisposable=w;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return p(l,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,y(this),p(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&p(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&p(l,null),l}}e.MutableDisposable=u;class c{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(l){let P=l;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,h(this))},this}}e.SafeDisposable=s;class r{constructor(){this.references=new Map}acquire(l,...P){let M=this.references.get(l);M||(M={counter:0,object:this.createReferencedObject(l,...P)},this.references.set(l,M));const{object:A}=M,F=(0,v.once)(()=>{--M.counter==0&&(this.destroyReferencedObject(l,M.object),this.references.delete(l))});return M.counter++,{object:A,dispose:F}}}e.ReferenceCollection=r;class i{constructor(l){this.referenceCollection=l}async acquire(l,...P){const M=this.referenceCollection.acquire(l,...P);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(A){throw M.dispose(),A}}}e.AsyncReferenceCollection=i;class n{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=n;function o(a){const l=new m;try{a(l)}finally{l.dispose()}}e.disposeOnReturn=o}),define(Z[126],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const D=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=D}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const y=new v(R);if(this._first===v.Undefined)this._first=y,this._last=y;else if(D){const p=this._last;this._last=y,y.prev=p,p.next=y}else{const p=this._first;this._first=y,y.next=p,p.prev=y}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(y))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function H(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(h){R.push(h,Date.now())}function y(){const h=[];for(let p=0;p<R.length;p+=2)h.push({name:R[p],startTime:R[p+1]});return h}return{mark:D,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var t in v)(typeof exports=="object"?exports:H)[t]=v[t]}}(typeof self!="undefined"?self:this,function(){return function(H){var e={};function v(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return H[t].call(k.exports,k,k.exports,v),k.l=!0,k.exports}return v.m=H,v.c=e,v.d=function(t,k,R){v.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},v.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},v.t=function(t,k){if(1&k&&(t=v(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(v.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)v.d(R,D,function(y){return t[y]}.bind(null,D));return R},v.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return v.d(k,"a",k),k},v.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},v.p="",v(v.s=0)}([function(H,e,v){(function(t){var k;e=H.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],h=e.src=[],p=0,I=p++;h[I]="0|[1-9]\\d*";var E=p++;h[E]="[0-9]+";var S=p++;h[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=p++;h[f]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var d=p++;h[d]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var C=p++;h[C]="(?:"+h[I]+"|"+h[S]+")";var b=p++;h[b]="(?:"+h[E]+"|"+h[S]+")";var w=p++;h[w]="(?:-("+h[C]+"(?:\\."+h[C]+")*))";var m=p++;h[m]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var g=p++;h[g]="[0-9A-Za-z-]+";var u=p++;h[u]="(?:\\+("+h[g]+"(?:\\."+h[g]+")*))";var c=p++,s="v?"+h[f]+h[w]+"?"+h[u]+"?";h[c]="^"+s+"$";var r="[v=\\s]*"+h[d]+h[m]+"?"+h[u]+"?",i=p++;h[i]="^"+r+"$";var n=p++;h[n]="((?:<|>)?=?)";var o=p++;h[o]=h[E]+"|x|X|\\*";var a=p++;h[a]=h[I]+"|x|X|\\*";var l=p++;h[l]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[w]+")?"+h[u]+"?)?)?";var P=p++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[m]+")?"+h[u]+"?)?)?";var M=p++;h[M]="^"+h[n]+"\\s*"+h[l]+"$";var A=p++;h[A]="^"+h[n]+"\\s*"+h[P]+"$";var F=p++;h[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=p++;h[U]="(?:~>?)";var Q=p++;h[Q]="(\\s*)"+h[U]+"\\s+",y[Q]=new RegExp(h[Q],"g");var re=p++;h[re]="^"+h[U]+h[l]+"$";var le=p++;h[le]="^"+h[U]+h[P]+"$";var fe=p++;h[fe]="(?:\\^)";var se=p++;h[se]="(\\s*)"+h[fe]+"\\s+",y[se]=new RegExp(h[se],"g");var ue=p++;h[ue]="^"+h[fe]+h[l]+"$";var K=p++;h[K]="^"+h[fe]+h[P]+"$";var N=p++;h[N]="^"+h[n]+"\\s*("+r+")$|^$";var W=p++;h[W]="^"+h[n]+"\\s*("+s+")$|^$";var _=p++;h[_]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",y[_]=new RegExp(h[_],"g");var T=p++;h[T]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var $=p++;h[$]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var x=p++;h[x]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,h[z]),y[z]||(y[z]=new RegExp(h[z]));function q(Y,ae){if(Y instanceof L)return Y;if(typeof Y!="string"||Y.length>R||!(ae?y[i]:y[c]).test(Y))return null;try{return new L(Y,ae)}catch{return null}}function L(Y,ae){if(Y instanceof L){if(Y.loose===ae)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(Y,ae);k("SemVer",Y,ae),this.loose=ae;var de=Y.trim().match(ae?y[i]:y[c]);if(!de)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<D)return Ce}return Se}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=q,e.valid=function(Y,ae){var de=q(Y,ae);return de?de.version:null},e.clean=function(Y,ae){var de=q(Y.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(Y){return k("SemVer.compare",this.version,this.loose,Y),Y instanceof L||(Y=new L(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},L.prototype.compareMain=function(Y){return Y instanceof L||(Y=new L(Y,this.loose)),B(this.major,Y.major)||B(this.minor,Y.minor)||B(this.patch,Y.patch)},L.prototype.comparePre=function(Y){if(Y instanceof L||(Y=new L(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Se=Y.prerelease[ae];if(k("prerelease compare",ae,de,Se),de===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(de===void 0)return-1;if(de!==Se)return B(de,Se)}while(++ae)},L.prototype.inc=function(Y,ae){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ae,de,Se){typeof de=="string"&&(Se=de,de=void 0);try{return new L(Y,de).inc(ae,Se).version}catch{return null}},e.diff=function(Y,ae){if(j(Y,ae))return null;var de=q(Y),Se=q(ae);if(de.prerelease.length||Se.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=B;var O=/^[0-9]+$/;function B(Y,ae){var de=O.test(Y),Se=O.test(ae);return de&&Se&&(Y=+Y,ae=+ae),de&&!Se?-1:Se&&!de?1:Y<ae?-1:Y>ae?1:0}function V(Y,ae,de){return new L(Y,de).compare(new L(ae,de))}function X(Y,ae,de){return V(Y,ae,de)>0}function ne(Y,ae,de){return V(Y,ae,de)<0}function j(Y,ae,de){return V(Y,ae,de)===0}function te(Y,ae,de){return V(Y,ae,de)!==0}function ie(Y,ae,de){return V(Y,ae,de)>=0}function ce(Y,ae,de){return V(Y,ae,de)<=0}function he(Y,ae,de,Se){var Ce;switch(ae){case"===":typeof Y=="object"&&(Y=Y.version),typeof de=="object"&&(de=de.version),Ce=Y===de;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof de=="object"&&(de=de.version),Ce=Y!==de;break;case"":case"=":case"==":Ce=j(Y,de,Se);break;case"!=":Ce=te(Y,de,Se);break;case">":Ce=X(Y,de,Se);break;case">=":Ce=ie(Y,de,Se);break;case"<":Ce=ne(Y,de,Se);break;case"<=":Ce=ce(Y,de,Se);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function ke(Y,ae){if(Y instanceof ke){if(Y.loose===ae)return Y;Y=Y.value}if(!(this instanceof ke))return new ke(Y,ae);k("comparator",Y,ae),this.loose=ae,this.parse(Y),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Y,ae){return B(ae,Y)},e.major=function(Y,ae){return new L(Y,ae).major},e.minor=function(Y,ae){return new L(Y,ae).minor},e.patch=function(Y,ae){return new L(Y,ae).patch},e.compare=V,e.compareLoose=function(Y,ae){return V(Y,ae,!0)},e.rcompare=function(Y,ae,de){return V(ae,Y,de)},e.sort=function(Y,ae){return Y.sort(function(de,Se){return e.compare(de,Se,ae)})},e.rsort=function(Y,ae){return Y.sort(function(de,Se){return e.rcompare(de,Se,ae)})},e.gt=X,e.lt=ne,e.eq=j,e.neq=te,e.gte=ie,e.lte=ce,e.cmp=he,e.Comparator=ke;var Le={};function Me(Y,ae){if(Y instanceof Me)return Y.loose===ae?Y:new Me(Y.raw,ae);if(Y instanceof ke)return new Me(Y.value,ae);if(!(this instanceof Me))return new Me(Y,ae);if(this.loose=ae,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ae(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Ve(Y,ae,de,Se,Ce,Te,Oe,Be,Ne,_e,qe,G,oe){return((ae=Ae(de)?"":Ae(Se)?">="+de+".0.0":Ae(Ce)?">="+de+"."+Se+".0":">="+ae)+" "+(Be=Ae(Ne)?"":Ae(_e)?"<"+(+Ne+1)+".0.0":Ae(qe)?"<"+Ne+"."+(+_e+1)+".0":G?"<="+Ne+"."+_e+"."+qe+"-"+G:"<="+Be)).trim()}function me(Y,ae){for(var de=0;de<Y.length;de++)if(!Y[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<Y.length;de++)if(k(Y[de].semver),Y[de].semver!==Le&&Y[de].semver.prerelease.length>0){var Se=Y[de].semver;if(Se.major===ae.major&&Se.minor===ae.minor&&Se.patch===ae.patch)return!0}return!1}return!0}function pe(Y,ae,de){try{ae=new Me(ae,de)}catch{return!1}return ae.test(Y)}function Ee(Y,ae,de,Se){var Ce,Te,Oe,Be,Ne;switch(Y=new L(Y,Se),ae=new Me(ae,Se),de){case">":Ce=X,Te=ce,Oe=ne,Be=">",Ne=">=";break;case"<":Ce=ne,Te=ie,Oe=X,Be="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(Y,ae,Se))return!1;for(var _e=0;_e<ae.set.length;++_e){var qe=ae.set[_e],G=null,oe=null;if(qe.forEach(function(ge){ge.semver===Le&&(ge=new ke(">=0.0.0")),G=G||ge,oe=oe||ge,Ce(ge.semver,G.semver,Se)?G=ge:Oe(ge.semver,oe.semver,Se)&&(oe=ge)}),G.operator===Be||G.operator===Ne||(!oe.operator||oe.operator===Be)&&Te(Y,oe.semver)||oe.operator===Ne&&Oe(Y,oe.semver))return!1}return!0}ke.prototype.parse=function(Y){var ae=this.loose?y[N]:y[W],de=Y.match(ae);if(!de)throw new TypeError("Invalid comparator: "+Y);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Le},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(Y){return k("Comparator.test",Y,this.loose),this.semver===Le||(typeof Y=="string"&&(Y=new L(Y,this.loose)),he(Y,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(Y,ae){if(!(Y instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(Y.value,ae),pe(this.value,de,ae);if(Y.operator==="")return de=new Me(this.value,ae),pe(Y.semver,de,ae);var Se=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Te=this.semver.version===Y.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Be=he(this.semver,"<",Y.semver,ae)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Ne=he(this.semver,">",Y.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Se||Ce||Te&&Oe||Be||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(Y){var ae=this.loose;Y=Y.trim(),k("range",Y,ae);var de=ae?y[$]:y[T];Y=Y.replace(de,Ve),k("hyphen replace",Y),Y=Y.replace(y[_],"$1$2$3"),k("comparator trim",Y,y[_]),Y=(Y=(Y=Y.replace(y[Q],"$1~")).replace(y[se],"$1^")).split(/\s+/).join(" ");var Se=ae?y[N]:y[W],Ce=Y.split(" ").map(function(Te){return function(Oe,Be){return k("comp",Oe),Oe=function(Ne,_e){return Ne.trim().split(/\s+/).map(function(qe){return function(G,oe){k("caret",G,oe);var ge=oe?y[K]:y[ue];return G.replace(ge,function(ye,we,Ie,We,ze){var Ke;return k("caret",G,ye,we,Ie,We,ze),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(We)?Ke=we==="0"?">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+".0 <"+(+we+1)+".0.0":ze?(k("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+We+ze+" <"+we+"."+Ie+"."+(+We+1):">="+we+"."+Ie+"."+We+ze+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+We+ze+" <"+(+we+1)+".0.0"):(k("no pr"),Ke=we==="0"?Ie==="0"?">="+we+"."+Ie+"."+We+" <"+we+"."+Ie+"."+(+We+1):">="+we+"."+Ie+"."+We+" <"+we+"."+(+Ie+1)+".0":">="+we+"."+Ie+"."+We+" <"+(+we+1)+".0.0"),k("caret return",Ke),Ke})}(qe,_e)}).join(" ")}(Oe,Be),k("caret",Oe),Oe=function(Ne,_e){return Ne.trim().split(/\s+/).map(function(qe){return function(G,oe){var ge=oe?y[le]:y[re];return G.replace(ge,function(ye,we,Ie,We,ze){var Ke;return k("tilde",G,ye,we,Ie,We,ze),Ae(we)?Ke="":Ae(Ie)?Ke=">="+we+".0.0 <"+(+we+1)+".0.0":Ae(We)?Ke=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0":ze?(k("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ke=">="+we+"."+Ie+"."+We+ze+" <"+we+"."+(+Ie+1)+".0"):Ke=">="+we+"."+Ie+"."+We+" <"+we+"."+(+Ie+1)+".0",k("tilde return",Ke),Ke})}(qe,_e)}).join(" ")}(Oe,Be),k("tildes",Oe),Oe=function(Ne,_e){return k("replaceXRanges",Ne,_e),Ne.split(/\s+/).map(function(qe){return function(G,oe){G=G.trim();var ge=oe?y[A]:y[M];return G.replace(ge,function(ye,we,Ie,We,ze,Ke){k("xRange",G,ye,we,Ie,We,ze,Ke);var Qe=Ae(Ie),Ye=Qe||Ae(We),et=Ye||Ae(ze);return we==="="&&et&&(we=""),Qe?ye=we===">"||we==="<"?"<0.0.0":"*":we&&et?(Ye&&(We=0),et&&(ze=0),we===">"?(we=">=",Ye?(Ie=+Ie+1,We=0,ze=0):et&&(We=+We+1,ze=0)):we==="<="&&(we="<",Ye?Ie=+Ie+1:We=+We+1),ye=we+Ie+"."+We+"."+ze):Ye?ye=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":et&&(ye=">="+Ie+"."+We+".0 <"+Ie+"."+(+We+1)+".0"),k("xRange return",ye),ye})}(qe,_e)}).join(" ")}(Oe,Be),k("xrange",Oe),Oe=function(Ne,_e){return k("replaceStars",Ne,_e),Ne.trim().replace(y[x],"")}(Oe,Be),k("stars",Oe),Oe}(Te,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Te){return!!Te.match(Se)})),Ce=Ce.map(function(Te){return new ke(Te,ae)})},Me.prototype.intersects=function(Y,ae){if(!(Y instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Se){return Y.set.some(function(Ce){return Ce.every(function(Te){return Se.intersects(Te,ae)})})})})},e.toComparators=function(Y,ae){return new Me(Y,ae).set.map(function(de){return de.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new L(Y,this.loose));for(var ae=0;ae<this.set.length;ae++)if(me(this.set[ae],Y))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(Y,ae,de){var Se=null,Ce=null;try{var Te=new Me(ae,de)}catch{return null}return Y.forEach(function(Oe){Te.test(Oe)&&(Se&&Ce.compare(Oe)!==-1||(Ce=new L(Se=Oe,de)))}),Se},e.minSatisfying=function(Y,ae,de){var Se=null,Ce=null;try{var Te=new Me(ae,de)}catch{return null}return Y.forEach(function(Oe){Te.test(Oe)&&(Se&&Ce.compare(Oe)!==1||(Ce=new L(Se=Oe,de)))}),Se},e.validRange=function(Y,ae){try{return new Me(Y,ae).range||"*"}catch{return null}},e.ltr=function(Y,ae,de){return Ee(Y,ae,"<",de)},e.gtr=function(Y,ae,de){return Ee(Y,ae,">",de)},e.outside=Ee,e.prerelease=function(Y,ae){var de=q(Y,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Y,ae,de){return Y=new Me(Y,de),ae=new Me(ae,de),Y.intersects(ae)},e.coerce=function(Y){if(Y instanceof L)return Y;if(typeof Y!="string")return null;var ae=Y.match(y[F]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,v(1))},function(H,e){var v,t,k=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function y(b){if(v===setTimeout)return setTimeout(b,0);if((v===R||!v)&&setTimeout)return v=setTimeout,setTimeout(b,0);try{return v(b,0)}catch{try{return v.call(null,b,0)}catch{return v.call(this,b,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:R}catch{v=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var h,p=[],I=!1,E=-1;function S(){I&&h&&(I=!1,h.length?p=h.concat(p):E=-1,p.length&&f())}function f(){if(!I){var b=y(S);I=!0;for(var w=p.length;w;){for(h=p,p=[];++E<w;)h&&h[E].run();E=-1,w=p.length}h=null,I=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(b)}}function d(b,w){this.fun=b,this.array=w}function C(){}k.nextTick=function(b){var w=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)w[m-1]=arguments[m];p.push(new d(b,w)),p.length!==1||I||y(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[127],ee([0,1]),function(H,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(y,h,p){this.level=y,this.key=h,this.value=p,this.forward=[]}}const k=void 0;class R{constructor(y,h=2**16){this.comparator=y,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(y){return Boolean(R._search(this,y,this.comparator))}get(y){return R._search(this,y,this.comparator)?.value}set(y,h){return R._insert(this,y,h,this.comparator)&&(this._size+=1),this}delete(y){const h=R._delete(this,y,this.comparator);return h&&(this._size-=1),h}forEach(y,h){let p=this._header.forward[0];for(;p;)y.call(h,p.value,p.key,this),p=p.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",h=this._header.forward[0];for(;h;)y+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return y}static _search(y,h,p){let I=y._header;for(let E=y._level-1;E>=0;E--)for(;I.forward[E]&&p(I.forward[E].key,h)<0;)I=I.forward[E];if(I=I.forward[0],I&&p(I.key,h)===0)return I}static _insert(y,h,p,I){const E=[];let S=y._header;for(let f=y._level-1;f>=0;f--){for(;S.forward[f]&&I(S.forward[f].key,h)<0;)S=S.forward[f];E[f]=S}if(S=S.forward[0],S&&I(S.key,h)===0)return S.value=p,!1;{const f=R._randomLevel(y);if(f>y._level){for(let d=y._level;d<f;d++)E[d]=y._header;y._level=f}S=new t(f,h,p);for(let d=0;d<f;d++)S.forward[d]=E[d].forward[d],E[d].forward[d]=S;return!0}}static _randomLevel(y,h=.5){let p=1;for(;Math.random()<h&&p<y._maxLevel;)p+=1;return p}static _delete(y,h,p){const I=[];let E=y._header;for(let S=y._level-1;S>=0;S--){for(;E.forward[S]&&p(E.forward[S].key,h)<0;)E=E.forward[S];I[S]=E}if(E=E.forward[0],!E||p(E.key,h)!==0)return!1;for(let S=0;S<y._level&&I[S].forward[S]===E;S++)I[S].forward[S]=E.forward[S];for(;y._level>0&&y._header.forward[y._level-1]===k;)y._level-=1;return!0}}e.SkipList=R}),define(Z[57],ee([0,1,18,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=k;function R(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function D(u){const c=u;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function y(u,c){return new h(u,c)}e.newWriteableStream=y;class h{constructor(c,s){this.reducer=c,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(s=>s(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(s=>s(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,s){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(c,s){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(s);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(u,c){const s=[];let r;for(;(r=u.read())!==null;)s.push(r);return c(s)}e.consumeReadable=p;function I(u,c,s){const r=[];let i;for(;(i=u.read())!==null&&r.length<s;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return u.read()}}}e.peekReadable=I;function E(u,c){return new Promise((s,r)=>{const i=[];S(u,{onData:n=>{c&&i.push(n)},onError:n=>{c?r(n):s(void 0)},onEnd:()=>{s(c?c(i):void 0)}})})}e.consumeStream=E;function S(u,c){let s=!1;return u.on("error",r=>{s||c.onError(r)}),u.on("end",()=>{s||c.onEnd()}),u.on("data",r=>{s||c.onData(r)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=S;function f(u,c){return new Promise((s,r)=>{const i=new t.DisposableStore,n=[],o=P=>{if(n.push(P),n.length>c)return i.dispose(),u.pause(),s({stream:u,buffer:n,ended:!1})},a=P=>r(P),l=()=>s({stream:u,buffer:n,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=f;function d(u,c){const s=y(c);return s.end(u),s}e.toStream=d;function C(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=C;function b(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=b;function w(u,c,s){const r=y(s);return S(u,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=w;function m(u,c,s){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?s([u,i]):u)}}}e.prefixedReadable=m;function g(u,c,s){let r=!1;const i=y(s);return S(c,{onData:n=>r?i.write(n):(r=!0,i.write(s([u,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(u)),i.end()}}),i}e.prefixedStream=g}),define(Z[17],ee([0,1,57]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let A=0,F=P.length;A<F;A++)M.buffer[A]=P[A];return M}static concat(P,M){if(typeof M=="undefined"){M=0;for(let U=0,Q=P.length;U<Q;U++)M+=P[U].byteLength}const A=D.alloc(M);let F=0;for(let U=0,Q=P.length;U<Q;U++){const re=P[U];A.set(re,F),F+=re.byteLength}return A}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return p(this.buffer,P)}writeUInt32BE(P,M){I(this.buffer,P,M)}readUInt32LE(P){return E(this.buffer,P)}writeUInt32LE(P,M){S(this.buffer,P,M)}readUInt8(P){return f(this.buffer,P)}writeUInt8(P,M){d(this.buffer,P,M)}}e.VSBuffer=D;function y(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=y;function h(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=h;function p(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=p;function I(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=I;function E(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=E;function S(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=S;function f(l,P){return l[P]}e.readUInt8=f;function d(l,P,M){l[M]=P}e.writeUInt8=d;function C(l){return v.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=C;function b(l){return v.toReadable(l)}e.bufferToReadable=b;function w(l){return v.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=w;async function m(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await w(l.stream)])}e.bufferedStreamToBuffer=m;function g(l){return v.toStream(l,P=>D.concat(P))}e.bufferToStream=g;function u(l){return v.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=u;function c(l){return v.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=c;function s(l,P){return v.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=s;function r(l,P){return v.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=r;function i(l){let P=0,M=0,A=0;const F=new Uint8Array(Math.floor(l.length/4*3)),U=re=>{switch(M){case 3:F[A++]=P|re,M=0;break;case 2:F[A++]=P|re>>>2,P=re<<6,M=3;break;case 1:F[A++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<l.length;re++){const le=l.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${l[re]}`)}}const Q=A;for(;M>0;)U(0);return D.wrap(F).slice(0,Q)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:l},P=!0,M=!1){const A=M?o:n;let F="";const U=l.byteLength%3;let Q=0;for(;Q<l.byteLength-U;Q+=3){const re=l[Q+0],le=l[Q+1],fe=l[Q+2];F+=A[re>>>2],F+=A[(re<<4|le>>>4)&63],F+=A[(le<<2|fe>>>6)&63],F+=A[fe&63]}if(U===1){const re=l[Q+0];F+=A[re>>>2],F+=A[re<<4&63],P&&(F+="==")}else if(U===2){const re=l[Q+0],le=l[Q+1];F+=A[re>>>2],F+=A[(re<<4|le>>>4)&63],F+=A[le<<2&63],P&&(F+="=")}return F}e.encodeBase64=a}),define(Z[12],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function v(r){return typeof r=="string"}e.isString=v;function t(r){return Array.isArray(r)&&r.every(i=>v(i))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function y(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=y;function h(r){return r===!0||r===!1}e.isBoolean=h;function p(r){return typeof r=="undefined"}e.isUndefined=p;function I(r){return!E(r)}e.isDefined=I;function E(r){return p(r)||r===null}e.isUndefinedOrNull=E;function S(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function f(r){if(E(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=f;function d(...r){const i=[];for(let n=0;n<r.length;n++){const o=r[n];if(E(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=d;const C=Object.prototype.hasOwnProperty;function b(r){if(!k(r))return!1;for(const i in r)if(C.call(r,i))return!1;return!0}e.isEmptyObject=b;function w(r){return typeof r=="function"}e.isFunction=w;function m(...r){return r.length>0&&r.every(w)}e.areFunctions=m;function g(r,i){const n=Math.min(r.length,i.length);for(let o=0;o<n;o++)u(r[o],i[o])}e.validateConstraints=g;function u(r,i){if(v(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(w(i)){try{if(r instanceof i)return}catch{}if(!E(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s}),define(Z[49],ee([0,1,12]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const m=Array.isArray(w)?[]:{};return Object.keys(w).forEach(g=>{w[g]&&typeof w[g]=="object"?m[g]=t(w[g]):m[g]=w[g]}),m}e.deepClone=t;function k(w){if(!w||typeof w!="object")return w;const m=[w];for(;m.length>0;){const g=m.shift();Object.freeze(g);for(const u in g)if(R.call(g,u)){const c=g[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,v.isTypedArray)(c)&&m.push(c)}}return w}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(w,m){return y(w,m,new Set)}e.cloneAndChange=D;function y(w,m,g){if((0,v.isUndefinedOrNull)(w))return w;const u=m(w);if(typeof u!="undefined")return u;if(Array.isArray(w)){const c=[];for(const s of w)c.push(y(s,m,g));return c}if((0,v.isObject)(w)){if(g.has(w))throw new Error("Cannot clone recursive data-structure");g.add(w);const c={};for(const s in w)R.call(w,s)&&(c[s]=y(w[s],m,g));return g.delete(w),c}return w}function h(w,m,g=!0){return(0,v.isObject)(w)?((0,v.isObject)(m)&&Object.keys(m).forEach(u=>{u in w?g&&((0,v.isObject)(w[u])&&(0,v.isObject)(m[u])?h(w[u],m[u],g):w[u]=m[u]):w[u]=m[u]}),w):m}e.mixin=h;function p(w,m){if(w===m)return!0;if(w==null||m===null||m===void 0||typeof w!=typeof m||typeof w!="object"||Array.isArray(w)!==Array.isArray(m))return!1;let g,u;if(Array.isArray(w)){if(w.length!==m.length)return!1;for(g=0;g<w.length;g++)if(!p(w[g],m[g]))return!1}else{const c=[];for(u in w)c.push(u);c.sort();const s=[];for(u in m)s.push(u);if(s.sort(),!p(c,s))return!1;for(g=0;g<c.length;g++)if(!p(w[c[g]],m[c[g]]))return!1}return!0}e.equals=p;function I(w){const m=new Set;return JSON.stringify(w,(g,u)=>{if((0,v.isObject)(u)||Array.isArray(u)){if(m.has(u))return"[Circular]";m.add(u)}return u})}e.safeStringify=I;function E(w,m){const g=Object.create(null);return!w||!m||Object.keys(m).forEach(c=>{const s=w[c],r=m[c];p(s,r)||(g[c]=r)}),g}e.distinct=E;function S(w,m){const g=m.toLowerCase(),u=Object.keys(w).find(c=>c.toLowerCase()===g);return u?w[u]:w[m]}e.getCaseInsensitive=S;function f(w,m){const g=Object.create(null);for(const[u,c]of Object.entries(w))m(u,c)&&(g[u]=c);return g}e.filter=f;function d(w){let m=[],g=Object.getPrototypeOf(w);for(;Object.prototype!==g;)m=m.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return m}e.getAllPropertyNames=d;function C(w){const m=[];for(const g of d(w))typeof w[g]=="function"&&m.push(g);return m}e.getAllMethodNames=C;function b(w,m){const g=c=>function(){const s=Array.prototype.slice.call(arguments,0);return m(c,s)},u={};for(const c of w)u[c]=g(c);return u}e.createProxyObject=b}),define(Z[28],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return v.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let h=0;h<y.length;h++)y[h]=Math.floor(Math.random()*256);return y};const R=new Uint8Array(16),D=[];for(let y=0;y<256;y++)D.push(y.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,p="";return p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+="-",p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p+=D[R[h++]],p}}()}),define(Z[128],ee([0,1,76,29,48]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,y){if(await new Promise((I,E)=>{const S=t.createReadStream(D),f=v.createHash("sha1");S.pipe(f);const d=(0,k.once)((C,b)=>{S.removeAllListeners(),f.removeAllListeners(),C?E(C):I(b)});S.once("error",d),S.once("end",d),f.once("error",d),f.once("data",C=>d(void 0,C.toString("hex")))})!==y)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[129],ee([0,1,30]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const y=D.replace(/\-/g,":").toLowerCase();return!t.has(y)}function R(){const D=(0,v.networkInterfaces)();for(const y in D){const h=D[y];if(h){for(const{mac:p}of h)if(k(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[92],ee([0,1,77]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(y,h,p,I=1){let E=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!E)return E=!0,S(0)},p);k(y,h,I,d=>{if(!E)return E=!0,clearTimeout(f),S(d)})})}e.findFreePort=t;function k(y,h,p,I){if(h===0)return I(0);const E=new v.Socket;E.once("connect",()=>(D(E),k(y+p,h-1,p,I))),E.once("data",()=>{}),E.once("error",S=>(D(E),S.code!=="ECONNREFUSED"?k(y+p,h-1,p,I):I(y))),E.connect(y,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(y,h,p){let I=!1,E,S=1;const f=v.createServer({pauseOnConnect:!0});function d(C,b){I||(I=!0,f.removeAllListeners(),f.close(),E&&clearTimeout(E),b(C))}return new Promise(C=>{E=setTimeout(()=>{d(0,C)},p),f.on("listening",()=>{d(y,C)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&S<h?(y++,S++,f.listen(y,"127.0.0.1")):d(0,C)}),f.on("close",()=>{d(0,C)}),f.listen(y,"127.0.0.1")})}e.findFreePortFaster=R;function D(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(h){console.error(h)}}}),define(Z[130],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[131],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[40],ee([0,1,15,18]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,y){const h=(p,...I)=>{this.validateEvent(D,p)&&y(p,...I)};return this.mapListenerToWrapper.set(y,h),v.ipcMain.on(D,h),this}once(D,y){return v.ipcMain.once(D,(h,...p)=>{this.validateEvent(D,h)&&y(h,...p)}),this}handle(D,y){return v.ipcMain.handle(D,(h,...p)=>this.validateEvent(D,h)?y(h,...p):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return v.ipcMain.removeHandler(D),this}removeListener(D,y){const h=this.mapListenerToWrapper.get(y);return h&&(v.ipcMain.removeListener(D,h),this.mapListenerToWrapper.delete(y)),this}validateEvent(D,y){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=y.senderFrame,p=h.url;if(!p)return!0;let I="unknown";try{I=new URL(p).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${p}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):h.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[132],ee([0,1,15,40,12,130]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(h,p,I,E,S)=>{const f=y(h,E,I);f.popup({window:(0,k.withNullAsUndefined)(v.BrowserWindow.fromWebContents(h.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{f&&h.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=D;function y(h,p,I){const E=new v.Menu;return I.forEach(S=>{let f;S.type==="separator"?f=new v.MenuItem({type:S.type}):Array.isArray(S.submenu)?f=new v.MenuItem({submenu:y(h,p,S.submenu),label:S.label}):f=new v.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(d,C,b)=>h.sender.send(p,S.id,b)}),E.append(f)}),E}}),define(Z[133],ee([11,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(Z[134],ee([0,1,133]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,y=R*30,h=R*365;function p(E,S,f){typeof E!="number"&&(E=E.getTime());const d=Math.round((new Date().getTime()-E)/1e3);if(d<-30)return(0,v.localize)(0,null,p(new Date().getTime()+d*1e3,!1));if(d<30)return(0,v.localize)(1,null);let C;return d<t?(C=d,S?C===1?f?(0,v.localize)(2,null,C):(0,v.localize)(3,null,C):f?(0,v.localize)(4,null,C):(0,v.localize)(5,null,C):C===1?f?(0,v.localize)(6,null,C):(0,v.localize)(7,null,C):f?(0,v.localize)(8,null,C):(0,v.localize)(9,null,C)):d<k?(C=Math.floor(d/t),S?C===1?f?(0,v.localize)(10,null,C):(0,v.localize)(11,null,C):f?(0,v.localize)(12,null,C):(0,v.localize)(13,null,C):C===1?f?(0,v.localize)(14,null,C):(0,v.localize)(15,null,C):f?(0,v.localize)(16,null,C):(0,v.localize)(17,null,C)):d<R?(C=Math.floor(d/k),S?C===1?f?(0,v.localize)(18,null,C):(0,v.localize)(19,null,C):f?(0,v.localize)(20,null,C):(0,v.localize)(21,null,C):C===1?f?(0,v.localize)(22,null,C):(0,v.localize)(23,null,C):f?(0,v.localize)(24,null,C):(0,v.localize)(25,null,C)):d<D?(C=Math.floor(d/R),S?C===1?(0,v.localize)(26,null,C):(0,v.localize)(27,null,C):C===1?(0,v.localize)(28,null,C):(0,v.localize)(29,null,C)):d<y?(C=Math.floor(d/D),S?C===1?f?(0,v.localize)(30,null,C):(0,v.localize)(31,null,C):f?(0,v.localize)(32,null,C):(0,v.localize)(33,null,C):C===1?f?(0,v.localize)(34,null,C):(0,v.localize)(35,null,C):f?(0,v.localize)(36,null,C):(0,v.localize)(37,null,C)):d<h?(C=Math.floor(d/y),S?C===1?f?(0,v.localize)(38,null,C):(0,v.localize)(39,null,C):f?(0,v.localize)(40,null,C):(0,v.localize)(41,null,C):C===1?f?(0,v.localize)(42,null,C):(0,v.localize)(43,null,C):f?(0,v.localize)(44,null,C):(0,v.localize)(45,null,C)):(C=Math.floor(d/h),S?C===1?f?(0,v.localize)(46,null,C):(0,v.localize)(47,null,C):f?(0,v.localize)(48,null,C):(0,v.localize)(49,null,C):C===1?f?(0,v.localize)(50,null,C):(0,v.localize)(51,null,C):f?(0,v.localize)(52,null,C):(0,v.localize)(53,null,C))}e.fromNow=p;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[135],ee([11,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,24,12,135]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(E,S){return S&&(E.stack||E.stacktrace)?k.localize(0,null,y(E),D(E.stack)||D(E.stacktrace)):y(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function y(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function h(E=null,S=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const f=v.coalesce(E),d=h(f[0],S);return f.length>1?k.localize(4,null,d,f.length):d}if(t.isString(E))return E;if(E.detail){const f=E.detail;if(f.error)return R(f.error,S);if(f.exception)return R(f.exception,S)}return E.stack?R(E,S):E.message?E.message:k.localize(5,null)}e.toErrorMessage=h;function p(E){const S=E;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=p;function I(E,S){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=S,f}e.createErrorWithActions=I}),define(Z[136],ee([11,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(Z[137],ee([0,1,136]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,v.localize)(0,null);case 2:return(0,v.localize)(1,null);case 3:return(0,v.localize)(2,null);case 4:return(0,v.localize)(3,null);case 5:return(0,v.localize)(4,null);case 6:return(0,v.localize)(5,null);case 7:return(0,v.localize)(6,null);case 8:return(0,v.localize)(7,null);case 9:return(0,v.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[138],ee([11,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,138]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,y=!1,h=!1,p=!1,I=!1,E=!1,S=!1,f,d=t,C,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const m=typeof w?.versions?.electron=="string",g=m&&w?.type==="renderer";if(typeof navigator=="object"&&!g)b=navigator.userAgent,k=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,E=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=b.indexOf("Linux")>=0,p=!0,f=v.getConfiguredDefaultLocale(v.localize(0,null))||t,d=f;else if(typeof w=="object"){k=w.platform==="win32",R=w.platform==="darwin",D=w.platform==="linux",y=D&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,I=m,S=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t,d=t;const l=w.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];f=P.locale,d=M||t,C=P._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var u;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let s=0;R?s=1:k?s=3:D&&(s=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=y,e.isNative=h,e.isElectron=I,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isCI=S,e.platform=s,e.userAgent=b,e.language=d;var r;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function A(){return e.language==="en"}l.isDefault=A})(r=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let A=0,F=l.length;A<F;A++){const U=l[A];if(U.id===M.data.vscodeScheduleAsyncWork){l.splice(A,1),U.callback();return}}});let P=0;return M=>{const A=++P;l.push({id:A,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return l=>setTimeout(l)})();var i;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:k?1:3;let n=!0,o=!1;function a(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[35],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,35]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,y=46,h=47,p=92,I=58,E=63;class S extends Error{constructor(u,c,s){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=u.indexOf(".")!==-1?"property":"argument";let n=`The "${u}" ${i} ${r} of type ${c}`;n+=`. Received type ${typeof s}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function f(g,u){if(typeof g!="string")throw new S(u,"string",g)}function d(g){return g===h||g===p}function C(g){return g===h}function b(g){return g>=t&&g<=R||g>=k&&g<=D}function w(g,u,c,s){let r="",i=0,n=-1,o=0,a=0;for(let l=0;l<=g.length;++l){if(l<g.length)a=g.charCodeAt(l);else{if(s(a))break;a=h}if(s(a)){if(!(n===l-1||o===1))if(o===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const P=r.lastIndexOf(c);P===-1?(r="",i=0):(r=r.slice(0,P),i=r.length-1-r.lastIndexOf(c)),n=l,o=0;continue}else if(r.length!==0){r="",i=0,n=l,o=0;continue}}u&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${g.slice(n+1,l)}`:r=g.slice(n+1,l),i=l-n-1;n=l,o=0}else a===y&&o!==-1?++o:o=-1}return r}function m(g,u){if(u===null||typeof u!="object")throw new S("pathObject","Object",u);const c=u.dir||u.root,s=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${s}`:`${c}${g}${s}`:s}e.win32={resolve(...g){let u="",c="",s=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],f(i,"path"),i.length===0)continue}else u.length===0?i=v.cwd():(i=v.env[`=${u}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===p)&&(i=`${u}\\`));const n=i.length;let o=0,a="",l=!1;const P=i.charCodeAt(0);if(n===1)d(P)&&(o=1,l=!0);else if(d(P))if(l=!0,d(i.charCodeAt(1))){let M=2,A=M;for(;M<n&&!d(i.charCodeAt(M));)M++;if(M<n&&M!==A){const F=i.slice(A,M);for(A=M;M<n&&d(i.charCodeAt(M));)M++;if(M<n&&M!==A){for(A=M;M<n&&!d(i.charCodeAt(M));)M++;(M===n||M!==A)&&(a=`\\\\${F}\\${i.slice(A,M)}`,o=M)}}}else o=1;else b(P)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),o=2,n>2&&d(i.charCodeAt(2))&&(l=!0,o=3));if(a.length>0)if(u.length>0){if(a.toLowerCase()!==u.toLowerCase())continue}else u=a;if(s){if(u.length>0)break}else if(c=`${i.slice(o)}\\${c}`,s=l,l&&u.length>0)break}return c=w(c,!s,"\\",d),s?`${u}\\${c}`:`${u}${c}`||"."},normalize(g){f(g,"path");const u=g.length;if(u===0)return".";let c=0,s,r=!1;const i=g.charCodeAt(0);if(u===1)return C(i)?"\\":g;if(d(i))if(r=!0,d(g.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(g.charCodeAt(o));)o++;if(o<u&&o!==a){const l=g.slice(a,o);for(a=o;o<u&&d(g.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(g.charCodeAt(o));)o++;if(o===u)return`\\\\${l}\\${g.slice(a)}\\`;o!==a&&(s=`\\\\${l}\\${g.slice(a,o)}`,c=o)}}}else c=1;else b(i)&&g.charCodeAt(1)===I&&(s=g.slice(0,2),c=2,u>2&&d(g.charCodeAt(2))&&(r=!0,c=3));let n=c<u?w(g.slice(c),!r,"\\",d):"";return n.length===0&&!r&&(n="."),n.length>0&&d(g.charCodeAt(u-1))&&(n+="\\"),s===void 0?r?`\\${n}`:n:r?`${s}\\${n}`:`${s}${n}`},isAbsolute(g){f(g,"path");const u=g.length;if(u===0)return!1;const c=g.charCodeAt(0);return d(c)||u>2&&b(c)&&g.charCodeAt(1)===I&&d(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let u,c;for(let i=0;i<g.length;++i){const n=g[i];f(n,"path"),n.length>0&&(u===void 0?u=c=n:u+=`\\${n}`)}if(u===void 0)return".";let s=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++r,i>2&&(d(c.charCodeAt(2))?++r:s=!1))}if(s){for(;r<u.length&&d(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(g,u){if(f(g,"from"),f(u,"to"),g===u)return"";const c=e.win32.resolve(g),s=e.win32.resolve(u);if(c===s||(g=c.toLowerCase(),u=s.toLowerCase(),g===u))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===p;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===p;)i--;const n=i-r;let o=0;for(;o<u.length&&u.charCodeAt(o)===p;)o++;let a=u.length;for(;a-1>o&&u.charCodeAt(a-1)===p;)a--;const l=a-o,P=n<l?n:l;let M=-1,A=0;for(;A<P;A++){const U=g.charCodeAt(r+A);if(U!==u.charCodeAt(o+A))break;U===p&&(M=A)}if(A!==P){if(M===-1)return s}else{if(l>P){if(u.charCodeAt(o+A)===p)return s.slice(o+A+1);if(A===2)return s.slice(o+A)}n>P&&(g.charCodeAt(r+A)===p?M=A:A===2&&(M=3)),M===-1&&(M=0)}let F="";for(A=r+M+1;A<=i;++A)(A===i||g.charCodeAt(A)===p)&&(F+=F.length===0?"..":"\\..");return o+=M,F.length>0?`${F}${s.slice(o,a)}`:(s.charCodeAt(o)===p&&++o,s.slice(o,a))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const u=e.win32.resolve(g);if(u.length<=2)return g;if(u.charCodeAt(0)===p){if(u.charCodeAt(1)===p){const c=u.charCodeAt(2);if(c!==E&&c!==y)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===p)return`\\\\?\\${u}`;return g},dirname(g){f(g,"path");const u=g.length;if(u===0)return".";let c=-1,s=0;const r=g.charCodeAt(0);if(u===1)return d(r)?g:".";if(d(r)){if(c=s=1,d(g.charCodeAt(1))){let o=2,a=o;for(;o<u&&!d(g.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&d(g.charCodeAt(o));)o++;if(o<u&&o!==a){for(a=o;o<u&&!d(g.charCodeAt(o));)o++;if(o===u)return g;o!==a&&(c=s=o+1)}}}}else b(r)&&g.charCodeAt(1)===I&&(c=u>2&&d(g.charCodeAt(2))?3:2,s=c);let i=-1,n=!0;for(let o=u-1;o>=s;--o)if(d(g.charCodeAt(o))){if(!n){i=o;break}}else n=!1;if(i===-1){if(c===-1)return".";i=c}return g.slice(0,i)},basename(g,u){u!==void 0&&f(u,"ext"),f(g,"path");let c=0,s=-1,r=!0,i;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===I&&(c=2),u!==void 0&&u.length>0&&u.length<=g.length){if(u===g)return"";let n=u.length-1,o=-1;for(i=g.length-1;i>=c;--i){const a=g.charCodeAt(i);if(d(a)){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=g.length),g.slice(c,s)}for(i=g.length-1;i>=c;--i)if(d(g.charCodeAt(i))){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":g.slice(c,s)},extname(g){f(g,"path");let u=0,c=-1,s=0,r=-1,i=!0,n=0;g.length>=2&&g.charCodeAt(1)===I&&b(g.charCodeAt(0))&&(u=s=2);for(let o=g.length-1;o>=u;--o){const a=g.charCodeAt(o);if(d(a)){if(!i){s=o+1;break}continue}r===-1&&(i=!1,r=o+1),a===y?c===-1?c=o:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===s+1?"":g.slice(c,r)},format:m.bind(null,"\\"),parse(g){f(g,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return u;const c=g.length;let s=0,r=g.charCodeAt(0);if(c===1)return d(r)?(u.root=u.dir=g,u):(u.base=u.name=g,u);if(d(r)){if(s=1,d(g.charCodeAt(1))){let M=2,A=M;for(;M<c&&!d(g.charCodeAt(M));)M++;if(M<c&&M!==A){for(A=M;M<c&&d(g.charCodeAt(M));)M++;if(M<c&&M!==A){for(A=M;M<c&&!d(g.charCodeAt(M));)M++;M===c?s=M:M!==A&&(s=M+1)}}}}else if(b(r)&&g.charCodeAt(1)===I){if(c<=2)return u.root=u.dir=g,u;if(s=2,d(g.charCodeAt(2))){if(c===3)return u.root=u.dir=g,u;s=3}}s>0&&(u.root=g.slice(0,s));let i=-1,n=s,o=-1,a=!0,l=g.length-1,P=0;for(;l>=s;--l){if(r=g.charCodeAt(l),d(r)){if(!a){n=l+1;break}continue}o===-1&&(a=!1,o=l+1),r===y?i===-1?i=l:P!==1&&(P=1):i!==-1&&(P=-1)}return o!==-1&&(i===-1||P===0||P===1&&i===o-1&&i===n+1?u.base=u.name=g.slice(n,o):(u.name=g.slice(n,i),u.base=g.slice(n,o),u.ext=g.slice(i,o))),n>0&&n!==s?u.dir=g.slice(0,n-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let u="",c=!1;for(let s=g.length-1;s>=-1&&!c;s--){const r=s>=0?g[s]:v.cwd();f(r,"path"),r.length!==0&&(u=`${r}/${u}`,c=r.charCodeAt(0)===h)}return u=w(u,!c,"/",C),c?`/${u}`:u.length>0?u:"."},normalize(g){if(f(g,"path"),g.length===0)return".";const u=g.charCodeAt(0)===h,c=g.charCodeAt(g.length-1)===h;return g=w(g,!u,"/",C),g.length===0?u?"/":c?"./":".":(c&&(g+="/"),u?`/${g}`:g)},isAbsolute(g){return f(g,"path"),g.length>0&&g.charCodeAt(0)===h},join(...g){if(g.length===0)return".";let u;for(let c=0;c<g.length;++c){const s=g[c];f(s,"path"),s.length>0&&(u===void 0?u=s:u+=`/${s}`)}return u===void 0?".":e.posix.normalize(u)},relative(g,u){if(f(g,"from"),f(u,"to"),g===u||(g=e.posix.resolve(g),u=e.posix.resolve(u),g===u))return"";const c=1,s=g.length,r=s-c,i=1,n=u.length-i,o=r<n?r:n;let a=-1,l=0;for(;l<o;l++){const M=g.charCodeAt(c+l);if(M!==u.charCodeAt(i+l))break;M===h&&(a=l)}if(l===o)if(n>o){if(u.charCodeAt(i+l)===h)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else r>o&&(g.charCodeAt(c+l)===h?a=l:l===0&&(a=0));let P="";for(l=c+a+1;l<=s;++l)(l===s||g.charCodeAt(l)===h)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(i+a)}`},toNamespacedPath(g){return g},dirname(g){if(f(g,"path"),g.length===0)return".";const u=g.charCodeAt(0)===h;let c=-1,s=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===h){if(!s){c=r;break}}else s=!1;return c===-1?u?"/":".":u&&c===1?"//":g.slice(0,c)},basename(g,u){u!==void 0&&f(u,"ext"),f(g,"path");let c=0,s=-1,r=!0,i;if(u!==void 0&&u.length>0&&u.length<=g.length){if(u===g)return"";let n=u.length-1,o=-1;for(i=g.length-1;i>=0;--i){const a=g.charCodeAt(i);if(a===h){if(!r){c=i+1;break}}else o===-1&&(r=!1,o=i+1),n>=0&&(a===u.charCodeAt(n)?--n==-1&&(s=i):(n=-1,s=o))}return c===s?s=o:s===-1&&(s=g.length),g.slice(c,s)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===h){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1);return s===-1?"":g.slice(c,s)},extname(g){f(g,"path");let u=-1,c=0,s=-1,r=!0,i=0;for(let n=g.length-1;n>=0;--n){const o=g.charCodeAt(n);if(o===h){if(!r){c=n+1;break}continue}s===-1&&(r=!1,s=n+1),o===y?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||s===-1||i===0||i===1&&u===s-1&&u===c+1?"":g.slice(u,s)},format:m.bind(null,"/"),parse(g){f(g,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return u;const c=g.charCodeAt(0)===h;let s;c?(u.root="/",s=1):s=0;let r=-1,i=0,n=-1,o=!0,a=g.length-1,l=0;for(;a>=s;--a){const P=g.charCodeAt(a);if(P===h){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),P===y?r===-1?r=a:l!==1&&(l=1):r!==-1&&(l=-1)}if(n!==-1){const P=i===0&&c?1:i;r===-1||l===0||l===1&&r===n-1&&r===i+1?u.base=u.name=g.slice(P,n):(u.name=g.slice(P,r),u.base=g.slice(P,n),u.ext=g.slice(r,n))}return i>0?u.dir=g.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(y,...h){const p=h.reduce((S,f)=>(S[f]=!0,S),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(S=>!p[S]).forEach(S=>{for(let f=0;f<I.length;f++)if(S.search(I[f])!==-1){delete y[S];break}})}e.sanitizeProcessEnvironment=R;function D(y){!y||(delete y.DEBUG,v.isMacintosh&&delete y.DYLD_LIBRARY_PATH,v.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Z[79],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,18,48,2,126,79]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const y=!1,h=!1;var p;(function(a){a.None=()=>k.Disposable.None;function l(O){if(h){const{onListenerDidAdd:B}=O,V=d.create();let X=0;O.onListenerDidAdd=()=>{++X==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),B?.()}}}function P(O){return(B,V=null,X)=>{let ne=!1,j;return j=O(te=>{if(!ne)return j?j.dispose():ne=!0,B.call(V,te)},null,X),ne&&j.dispose(),j}}a.once=P;function M(O,B,V){return le((X,ne=null,j)=>O(te=>X.call(ne,B(te)),null,j),V)}a.map=M;function A(O,B,V){return le((X,ne=null,j)=>O(te=>{B(te),X.call(ne,te)},null,j),V)}a.forEach=A;function F(O,B,V){return le((X,ne=null,j)=>O(te=>B(te)&&X.call(ne,te),null,j),V)}a.filter=F;function U(O){return O}a.signal=U;function Q(...O){return(B,V=null,X)=>(0,k.combinedDisposable)(...O.map(ne=>ne(j=>B.call(V,j),null,X)))}a.any=Q;function re(O,B,V,X){let ne=V;return M(O,j=>(ne=B(ne,j),ne),X)}a.reduce=re;function le(O,B){let V;const X={onFirstListenerAdd(){V=O(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};B||l(X);const ne=new b(X);return B?.add(ne),ne.event}function fe(O,B,V=100,X=!1,ne,j){let te,ie,ce,he=0;const ke={leakWarningThreshold:ne,onFirstListenerAdd(){te=O(Me=>{he++,ie=B(ie,Me),X&&!ce&&(Le.fire(ie),ie=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ie;ie=void 0,ce=void 0,(!X||he>1)&&Le.fire(Ae),he=0},V)})},onLastListenerRemove(){te.dispose()}};j||l(ke);const Le=new b(ke);return j?.add(Le),Le.event}a.debounce=fe;function se(O,B=(X,ne)=>X===ne,V){let X=!0,ne;return F(O,j=>{const te=X||!B(j,ne);return X=!1,ne=j,te},V)}a.latch=se;function ue(O,B,V){return[a.filter(O,B,V),a.filter(O,X=>!B(X),V)]}a.split=ue;function K(O,B=!1,V=[]){let X=V.slice(),ne=O(ie=>{X?X.push(ie):te.fire(ie)});const j=()=>{X?.forEach(ie=>te.fire(ie)),X=null},te=new b({onFirstListenerAdd(){ne||(ne=O(ie=>te.fire(ie)))},onFirstListenerDidAdd(){X&&(B?setTimeout(j):j())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}a.buffer=K;class N{constructor(B){this.event=B,this.disposables=new k.DisposableStore}map(B){return new N(M(this.event,B,this.disposables))}forEach(B){return new N(A(this.event,B,this.disposables))}filter(B){return new N(F(this.event,B,this.disposables))}reduce(B,V){return new N(re(this.event,B,V,this.disposables))}latch(){return new N(se(this.event,void 0,this.disposables))}debounce(B,V=100,X=!1,ne){return new N(fe(this.event,B,V,X,ne,this.disposables))}on(B,V,X){return this.event(B,V,X)}once(B,V,X){return P(this.event)(B,V,X)}dispose(){this.disposables.dispose()}}function W(O){return new N(O)}a.chain=W;function _(O,B,V=X=>X){const X=(...ie)=>te.fire(V(...ie)),ne=()=>O.on(B,X),j=()=>O.removeListener(B,X),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromNodeEventEmitter=_;function T(O,B,V=X=>X){const X=(...ie)=>te.fire(V(...ie)),ne=()=>O.addEventListener(B,X),j=()=>O.removeEventListener(B,X),te=new b({onFirstListenerAdd:ne,onLastListenerRemove:j});return te.event}a.fromDOMEventEmitter=T;function $(O){return new Promise(B=>P(O)(B))}a.toPromise=$;function x(O,B){return B(void 0),O(V=>B(V))}a.runAndSubscribe=x;function z(O,B){let V=null;function X(j){V?.dispose(),V=new k.DisposableStore,B(j,V)}X(void 0);const ne=O(j=>X(j));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=z;class q{constructor(B,V){this.obs=B,this._counter=0,this._hasChanged=!1;const X={onFirstListenerAdd:()=>{B.addObserver(this)},onLastListenerRemove:()=>{B.removeObserver(this)}};V||l(X),this.emitter=new b(X),V&&V.add(this.emitter)}beginUpdate(B){this._counter++}handleChange(B,V){this._hasChanged=!0}endUpdate(B){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,B){return new q(O,B).emitter.event}a.fromObservable=L})(p=e.Event||(e.Event={}));class I{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${I._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let E=-1;function S(a){const l=E;return E=a,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=E;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let F,U=0;for(const[Q,re]of this._stacks)(!F||U<re)&&(F=Q,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this._stacks.get(l.value)||0;this._stacks.set(l.value,F-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class b{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,U;this._leakageMon&&this._listeners.size>=30&&(U=d.create(),F=this._leakageMon.check(U,this._listeners.size+1)),y&&(U=U??d.create());const Q=new C(l,P,U),re=this._listeners.push(Q);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const le=Q.subscription.set(()=>{F?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(le):Array.isArray(M)&&M.push(le),le}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class w{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new g(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,v.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=w;class m extends w{clear(l){this._queue.clear()}}class g{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class u extends b{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[A,F]=this._asyncDeliveryQueue.shift(),U=[],Q={...F,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,A.callback)),U.push(re)}};try{A.invoke(Q)}catch(re){(0,v.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,v.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=u;class c extends b{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class s extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=s;class r extends b{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const A=this.events.indexOf(P);this.events.splice(A,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,A)=>l(F=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,F)):P.call(M,F)},void 0,A)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(A=>A()),M}}e.EventBufferer=n;class o{constructor(){this.listening=!1,this.inputEvent=p.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Z[21],ee([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(y,h){const p=setTimeout(y.bind(h),0);return{dispose(){clearTimeout(p)}}});var k;(function(y){function h(p){return p===y.None||p===y.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}y.isCancellationToken=h,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(Z[139],ee([0,1,21]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new v.CancellationTokenSource,h=this.task(y.token);return this.result={promise:h,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}e.Cache=t;class k{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const h=JSON.stringify(y);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(y)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(y){this.fn=y,this._map=new Map}get cachedValues(){return this._map}get(y){if(this._map.has(y))return this._map.get(y);const h=this.fn(y);return this._map.set(y,h),h}}e.CachedFunction=R}),define(Z[93],ee([0,1,3,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:v.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(y){super();this._value=y,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}}e.MutableObservableValue=R}),define(Z[27],ee([0,1,139,125]),function(H,e,v,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function y(G,...oe){return oe.length===0?G:G.replace(D,function(ge,ye){const we=parseInt(ye,10);return isNaN(we)||we<0||we>=oe.length?ge:oe[we]})}e.format=y;const h=/{([^}]+)}/g;function p(G,oe){return G.replace(h,(ge,ye)=>oe[ye]??ge)}e.format2=p;function I(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function E(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function S(G,oe){let ge=0;const ye=oe.charCodeAt(0);for(let we=G.length-1;we>=0;we--)G.charCodeAt(we)===ye&&ge++;return ge}e.count=S;function f(G,oe,ge="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${ge}`}e.truncate=f;function d(G,oe=" "){const ge=C(G,oe);return b(ge,oe)}e.trim=d;function C(G,oe){if(!G||!oe)return G;const ge=oe.length;if(ge===0||G.length===0)return G;let ye=0;for(;G.indexOf(oe,ye)===ye;)ye=ye+ge;return G.substring(ye)}e.ltrim=C;function b(G,oe){if(!G||!oe)return G;const ge=oe.length,ye=G.length;if(ge===0||ye===0)return G;let we=ye,Ie=-1;for(;Ie=G.lastIndexOf(oe,we-1),!(Ie===-1||Ie+ge!==we);){if(Ie===0)return"";we=Ie}return G.substring(0,we)}e.rtrim=b;function w(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function m(G){return G.replace(/\*/g,"")}e.stripWildcards=m;function g(G,oe,ge={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=E(G)),ge.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(G,ye)}e.createRegExp=g;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function s(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=s;function r(G){return G.split(/\r\n|\r|\n/)}e.splitLines=r;function i(G){for(let oe=0,ge=G.length;oe<ge;oe++){const ye=G.charCodeAt(oe);if(ye!==32&&ye!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function n(G,oe=0,ge=G.length){for(let ye=oe;ye<ge;ye++){const we=G.charCodeAt(ye);if(we!==32&&we!==9)return G.substring(oe,ye)}return G.substring(oe,ge)}e.getLeadingWhitespace=n;function o(G,oe=G.length-1){for(let ge=oe;ge>=0;ge--){const ye=G.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function a(G,oe,ge){const ye=[];let we=0;for(const Ie of G.matchAll(oe)){if(ye.push(G.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,ye.push(ge(Ie[0],...Ie.slice(1),Ie.index,G,Ie.groups))}return ye.push(G.slice(we)),Promise.all(ye).then(Ie=>Ie.join(""))}e.replaceAsync=a;function l(G,oe){return G<oe?-1:G>oe?1:0}e.compare=l;function P(G,oe,ge=0,ye=G.length,we=0,Ie=oe.length){for(;ge<ye&&we<Ie;ge++,we++){const Ke=G.charCodeAt(ge),Qe=oe.charCodeAt(we);if(Ke<Qe)return-1;if(Ke>Qe)return 1}const We=ye-ge,ze=Ie-we;return We<ze?-1:We>ze?1:0}e.compareSubstring=P;function M(G,oe){return A(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=M;function A(G,oe,ge=0,ye=G.length,we=0,Ie=oe.length){for(;ge<ye&&we<Ie;ge++,we++){let Ke=G.charCodeAt(ge),Qe=oe.charCodeAt(we);if(Ke===Qe)continue;if(Ke>=128||Qe>=128)return P(G.toLowerCase(),oe.toLowerCase(),ge,ye,we,Ie);U(Ke)&&(Ke-=32),U(Qe)&&(Qe-=32);const Ye=Ke-Qe;if(Ye!==0)return Ye}const We=ye-ge,ze=Ie-we;return We<ze?-1:We>ze?1:0}e.compareSubstringIgnoreCase=A;function F(G){return G>=48&&G<=57}e.isAsciiDigit=F;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function Q(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Q;function re(G,oe){return G.length===oe.length&&A(G,oe)===0}e.equalsIgnoreCase=re;function le(G,oe){const ge=oe.length;return oe.length>G.length?!1:A(G,oe,0,ge)===0}e.startsWithIgnoreCase=le;function fe(G,oe){const ge=Math.min(G.length,oe.length);let ye;for(ye=0;ye<ge;ye++)if(G.charCodeAt(ye)!==oe.charCodeAt(ye))return ye;return ge}e.commonPrefixLength=fe;function se(G,oe){const ge=Math.min(G.length,oe.length);let ye;const we=G.length-1,Ie=oe.length-1;for(ye=0;ye<ge;ye++)if(G.charCodeAt(we-ye)!==oe.charCodeAt(Ie-ye))return ye;return ge}e.commonSuffixLength=se;function ue(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ue;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function N(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=N;function W(G,oe,ge){const ye=G.charCodeAt(ge);if(ue(ye)&&ge+1<oe){const we=G.charCodeAt(ge+1);if(K(we))return N(ye,we)}return ye}e.getNextCodePoint=W;function _(G,oe){const ge=G.charCodeAt(oe-1);if(K(ge)&&oe>1){const ye=G.charCodeAt(oe-2);if(ue(ye))return N(ye,ge)}return ge}class T{constructor(oe,ge=0){this._str=oe,this._len=oe.length,this._offset=ge}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=_(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=W(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=T;class ${constructor(oe,ge=0){this._iterator=new T(oe,ge)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Se.getInstance(),ge=this._iterator,ye=ge.offset;let we=oe.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ie=ge.offset,We=oe.getGraphemeBreakType(ge.nextCodePoint());if(ae(we,We)){ge.setOffset(Ie);break}we=We}return ge.offset-ye}prevGraphemeLength(){const oe=Se.getInstance(),ge=this._iterator,ye=ge.offset;let we=oe.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ie=ge.offset,We=oe.getGraphemeBreakType(ge.prevCodePoint());if(ae(We,we)){ge.setOffset(Ie);break}we=We}return ye-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=$;function x(G,oe){return new $(G,oe).nextGraphemeLength()}e.nextCharLength=x;function z(G,oe){return new $(G,oe).prevGraphemeLength()}e.prevCharLength=z;function q(G,oe){oe>0&&K(G.charCodeAt(oe))&&oe--;const ge=oe+x(G,oe);return[ge-z(G,ge),ge]}e.getCharContainingOffset=q;const L=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(G){return L.test(G)}e.containsRTL=O;const B=/^[\t\n\r\x20-\x7E]*$/;function V(G){return B.test(G)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=X;function ne(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ne;function j(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=j;function te(G,oe){if(G.length<oe)return G;const ge=/\b/g;let ye=0;for(;ge.test(G)&&!(G.length-ge.lastIndex<oe);)ye=ge.lastIndex,ge.lastIndex+=1;return G.substring(ye).replace(/^\s/,"")}e.lcut=te;const ie=/\x1B\x5B[12]?K/g,ce=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function ke(G){return G&&(G=G.replace(ie,""),G=G.replace(ce,""),G=G.replace(he,"")),G}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Me(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=Me;function Ae(G,oe){if(!G||!oe||G.length<oe.length)return!1;const ge=oe.length,ye=G.toLowerCase();let we=0,Ie=-1;for(;we<ge;){const We=ye.indexOf(oe[we],Ie+1);if(We<0)return!1;Ie=We,we++}return!0}e.fuzzyContains=Ae;function Ve(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ve;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function pe(G,oe=1){if(oe===0)return"";let ge=-1;do ge=G.indexOf(`
`,ge+1),oe--;while(oe>0&&ge>=0);return ge===-1?G:(G[ge-1]==="\r"&&ge--,G.substr(0,ge))}e.getNLines=pe;function Ee(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=Ee;function Y(G){return Se.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Y;function ae(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}var de;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Se{constructor(){this._data=Ce()}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ge=this._data,ye=ge.length/3;let we=1;for(;we<=ye;)if(oe<ge[3*we])we=2*we;else if(oe>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}Se._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(G,oe){if(G===0)return 0;const ge=Oe(G,oe);if(ge!==void 0)return ge;const ye=new T(oe,G);return ye.prevCodePoint(),ye.offset}e.getLeftDeleteOffset=Te;function Oe(G,oe){const ge=new T(oe,G);let ye=ge.prevCodePoint();for(;Be(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!j(ye))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function Be(G){return 127995<=G&&G<=127999}var Ne;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class _e{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return _e.cache.get(Array.from(oe))}static getLocales(){return _e._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,k=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new v.LRUCachedFunction(G=>{function oe(Qe){const Ye=new Map;for(let et=0;et<Qe.length;et+=2)Ye.set(Qe[et],Qe[et+1]);return Ye}function ge(Qe,Ye){const et=new Map(Qe);for(const[ot,at]of Ye)et.set(ot,at);return et}function ye(Qe,Ye){if(!Qe)return Ye;const et=new Map;for(const[ot,at]of Qe)Ye.has(ot)&&et.set(ot,at);return et}const we=k.ambiguousCharacterData.getValue();let Ie=G.filter(Qe=>!Qe.startsWith("_")&&Qe in we);Ie.length===0&&(Ie=["_default"]);let We;for(const Qe of Ie){const Ye=oe(we[Qe]);We=ye(We,Ye)}const ze=oe(we._common),Ke=ge(ze,We);return new _e(Ke)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(oe){return qe.getData().has(oe)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(Z[31],ee([0,1,9,4,27,12]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(o){return o===47||o===92}e.isPathSeparator=D;function y(o){return o.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=y;function h(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=h;function p(o,a=v.posix.sep){if(!o)return"";const l=o.length,P=o.charCodeAt(0);if(D(P)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let A=3;const F=A;for(;A<l&&!D(o.charCodeAt(A));A++);if(F!==A&&!D(o.charCodeAt(A+1))){for(A+=1;A<l;A++)if(D(o.charCodeAt(A)))return o.slice(0,A+1).replace(/[\\/]/g,a)}}return a}else if(w(P)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let M=o.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(o.charCodeAt(M)))return o.slice(0,M+1)}return""}e.getRoot=p;function I(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let l=2;const P=l;for(;l<o.length&&(a=o.charCodeAt(l),a!==92);l++);return!(P===l||(a=o.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,a=t.isWindows){const l=a?E:S;return!(!o||o.length===0||/^\s+$/.test(o)||(l.lastIndex=0,l.test(o))||a&&f.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function C(o,a,l){const P=o===a;return!l||P?P:!o||!a?!1:(0,k.equalsIgnoreCase)(o,a)}e.isEqual=C;function b(o,a,l,P=v.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let A=a.length;return a.charAt(a.length-1)===P&&A--,o.charAt(A)===P}return a.charAt(a.length-1)!==P&&(a+=P),o.indexOf(a)===0}e.isEqualOrParent=b;function w(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=w;function m(o,a){return t.isWindows&&o.endsWith(":")&&(o+=v.sep),(0,v.isAbsolute)(o)||(o=(0,v.join)(a,o)),o=(0,v.normalize)(o),t.isWindows?(o=(0,k.rtrim)(o,v.sep),o.endsWith(":")&&(o+=v.sep)):(o=(0,k.rtrim)(o,v.sep),o||(o=v.sep)),o}e.sanitizeFilePath=m;function g(o){const a=(0,v.normalize)(o);return t.isWindows?o.length>3?!1:u(a)&&(o.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=g;function u(o,a=t.isWindows){return a?w(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(o){return u(o)?o[0]:void 0}e.getDriveLetter=c;function s(o,a,l){return a.length>o.length?-1:o===a?0:(l&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function r(o){const a=o.split(":");let l,P,M;for(const A of a){const F=Number(A);(0,R.isNumber)(F)?P===void 0?P=F:M===void 0&&(M=F):l=l?[l,A].join(":"):A}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,a,l=8){let P="";for(let A=0;A<l;A++)P+=i.charAt(Math.floor(Math.random()*i.length));let M;return a?M=`${a}-${P}`:M=P,o?(0,v.join)(o,M):M}e.randomPath=n}),define(Z[67],ee([0,1,27]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(w){return k(w,0)}e.hash=t;function k(w,m){switch(typeof w){case"object":return w===null?R(349,m):Array.isArray(w)?h(w,m):p(w,m);case"string":return y(w,m);case"boolean":return D(w,m);case"number":return R(w,m);case"undefined":return R(937,m);default:return R(617,m)}}e.doHash=k;function R(w,m){return(m<<5)-m+w|0}e.numberHash=R;function D(w,m){return R(w?433:863,m)}function y(w,m){m=R(149417,m);for(let g=0,u=w.length;g<u;g++)m=R(w.charCodeAt(g),m);return m}e.stringHash=y;function h(w,m){return m=R(104579,m),w.reduce((g,u)=>k(u,g),m)}function p(w,m){return m=R(181387,m),Object.keys(w).sort().reduce((g,u)=>(g=y(u,g),k(w[u],g)),m)}class I{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=k(m,this._value),this._value}}e.Hasher=I;var E;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function S(w,m,g=32){const u=g-m,c=~((1<<u)-1);return(w<<m|(c&w)>>>u)>>>0}function f(w,m=0,g=w.byteLength,u=0){for(let c=0;c<g;c++)w[m+c]=u}function d(w,m,g="0"){for(;w.length<m;)w=g+w;return w}function C(w,m=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),m/4)}e.toHexString=C;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const g=m.length;if(g===0)return;const u=this._buff;let c=this._buffLen,s=this._leftoverHighSurrogate,r,i;for(s!==0?(r=s,i=-1,s=0):(r=m.charCodeAt(0),i=0);;){let n=r;if(v.isHighSurrogate(r))if(i+1<g){const o=m.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,n=v.computeCodePoint(r,o)):n=65533}else{s=r;break}else v.isLowSurrogate(r)&&(n=65533);if(c=this._push(u,c,n),i++,i<g)r=m.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=s}_push(m,g,u){return u<128?m[g++]=u:u<2048?(m[g++]=192|(u&1984)>>>6,m[g++]=128|(u&63)>>>0):u<65536?(m[g++]=224|(u&61440)>>>12,m[g++]=128|(u&4032)>>>6,m[g++]=128|(u&63)>>>0):(m[g++]=240|(u&1835008)>>>18,m[g++]=128|(u&258048)>>>12,m[g++]=128|(u&4032)>>>6,m[g++]=128|(u&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=b._bigBlock32,g=this._buffDV;for(let l=0;l<64;l+=4)m.setUint32(l,g.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)m.setUint32(l,S(m.getUint32(l-12,!1)^m.getUint32(l-32,!1)^m.getUint32(l-56,!1)^m.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,s=this._h2,r=this._h3,i=this._h4,n,o,a;for(let l=0;l<80;l++)l<20?(n=c&s|~c&r,o=1518500249):l<40?(n=c^s^r,o=1859775393):l<60?(n=c&s|c&r|s&r,o=2400959708):(n=c^s^r,o=3395469782),a=S(u,5)+n+i+o+m.getUint32(l*4,!1)&4294967295,i=r,r=s,s=S(c,30),c=u,u=a;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[32],ee([0,1,24,27]),function(H,e,v,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.getOrSet=y;function h(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function p(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=p;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class S{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var f;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(f||(f={}));class d{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(b||(b={}));class w{constructor(n){this._iter=n}static forUris(n=()=>!1,o=()=>!1){return new w(new d(n,o))}static forPaths(n=!1){return new w(new S(void 0,!n))}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new E)}clear(){this._root=void 0}fill(n,o){if(o){const a=o.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l,n)}else{const a=n.slice(0);(0,v.shuffle)(a);for(const l of a)this.set(l[0],l[1])}}set(n,o){const a=this._iter.reset(n);let l;this._root||(this._root=new C,this._root.segment=a.value());const P=[];for(l=this._root;;){const A=a.cmp(l.segment);if(A>0)l.left||(l.left=new C,l.left.segment=a.value()),P.push([-1,l]),l=l.left;else if(A<0)l.right||(l.right=new C,l.right.segment=a.value()),P.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new C,l.mid.segment=a.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=o,l.key=n;for(let A=P.length-1;A>=0;A--){const F=P[A][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Q=P[A][0],re=P[A+1][0];if(Q===1&&re===1)P[A][1]=F.rotateLeft();else if(Q===-1&&re===-1)P[A][1]=F.rotateRight();else if(Q===1&&re===-1)F.right=P[A+1][1]=P[A+1][1].rotateRight(),P[A][1]=F.rotateLeft();else if(Q===-1&&re===1)F.left=P[A+1][1]=P[A+1][1].rotateLeft(),P[A][1]=F.rotateRight();else throw new Error;if(A>0)switch(P[A-1][0]){case-1:P[A-1][1].left=P[A][1];break;case 1:P[A-1][1].right=P[A][1];break;case 0:P[A-1][1].mid=P[A][1];break}else this._root=P[0][1]}}return M}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const a=this._iter.reset(n),l=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(a.hasNext())a.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(o?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:A,value:F,segment:U}=M;this._delete(M.key,!1),P.key=A,P.value=F,P.segment=U}else{const M=P.left??P.right;if(l.length>0){const[A,F]=l[l.length-1];switch(A){case-1:F.left=M;break;case 0:F.mid=M;break;case 1:F.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const A=l[M][1];A.updateHeight();const F=A.balanceFactor();if(F>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),l[M][1]=A.rotateLeft()):F<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),l[M][1]=A.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let a=this._root,l;for(;a;){const P=o.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(o.hasNext())o.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(n){const o=this._iter.reset(n);let a=this._root;for(;a;){const l=o.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[o,a]of this)n(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=w;class m{constructor(n,o){this.uri=n,this.value=o}}class g{constructor(n,o){this[k]="ResourceMap",n instanceof g?(this.map=new Map(n.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=n??g.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new m(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(const[a,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=g,g.defaultToKey=i=>i.toString();class u{constructor(n,o){this[R]="ResourceSet",!n||typeof n=="function"?this._map=new g(n):(this._map=new g(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((a,l)=>n.call(o,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const a=this._map.get(n);if(!!a)return o!==0&&this.touch(a,o),a.value}set(n,o,a=0){let l=this._map.get(n);if(l)l.value=o,a!==0&&this.touch(l,a);else{switch(l={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const a=this._state;let l=this._head;for(;l;){if(o?n.bind(o)(l.value,l.key,this):n(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}values(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}entries(){const n=this,o=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>n;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const a=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const a=n.next,l=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.LinkedMap=s;class r extends s{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(Z[80],ee([0,1,32]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function k(p){return h(p,"NFC",t)}e.normalizeNFC=k;const R=new v.LRUCache(1e4);function D(p){return h(p,"NFD",R)}e.normalizeNFD=D;const y=/[^\u0000-\u0080]/;function h(p,I,E){if(!p)return p;const S=E.get(p);if(S)return S;let f;return y.test(p)?f=p.normalize(I):f=p,E.set(p,f),f}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(I){return D(I).replace(p,"")}}()}),define(Z[94],ee([0,1,27]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",y="warn",h="info",p="ignore";function I(S){return S?v.equalsIgnoreCase(R,S)?k.Error:v.equalsIgnoreCase(D,S)||v.equalsIgnoreCase(y,S)?k.Warning:v.equalsIgnoreCase(h,S)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function E(S){switch(S){case k.Error:return R;case k.Warning:return D;case k.Info:return h;default:return p}}k.toString=E}(t||(t={})),e.default=t}),define(Z[7],ee([0,1,9,4]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function y(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function p(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const I="",E="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(n,o,a,l,P,M=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=h(n,M),this.authority=o||I,this.path=p(this.scheme,a||I),this.query=l||I,this.fragment=P||I,y(this,M))}static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return g(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:a,path:l,query:P,fragment:M}=n;return o===void 0?o=this.scheme:o===null&&(o=I),a===void 0?a=this.authority:a===null&&(a=I),l===void 0?l=this.path:l===null&&(l=I),P===void 0?P=this.query:P===null&&(P=I),M===void 0?M=this.fragment:M===null&&(M=I),o===this.scheme&&a===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new C(o,a,l,P,M)}static parse(n,o=!1){const a=S.exec(n);return a?new C(a[2]||I,r(a[4]||I),r(a[5]||I),r(a[7]||I),r(a[9]||I),o):new C(I,I,I,I,I)}static file(n){let o=I;if(t.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const a=n.indexOf(E,2);a===-1?(o=n.substring(2),n=E):(o=n.substring(2,a),n=n.substring(a)||E)}return new C("file",o,n,I,I)}static from(n){const o=new C(n.scheme,n.authority,n.path,n.query,n.fragment);return y(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&n.scheme==="file"?a=f.file(v.win32.join(g(n,!0),...o)).path:a=v.posix.join(n.path,...o),n.with({path:a})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new C(n);return o._formatted=n.external,o._fsPath=n._sep===d?n.fsPath:null,o}}else return n}}e.URI=f;const d=t.isWindows?1:void 0;class C extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,n){let o,a=-1;for(let l=0;l<i.length;l++){const P=i.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||n&&P===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o!==void 0&&(o+=i.charAt(l));else{o===void 0&&(o=i.substr(0,l));const M=b[P];M!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,l)),a=-1),o+=M):a===-1&&(a=l)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function m(i){let n;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(n===void 0&&(n=i.substr(0,o)),n+=b[a]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function g(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function u(i,n){const o=n?m:w;let a="",{scheme:l,authority:P,path:M,query:A,fragment:F}=i;if(l&&(a+=l,a+=":"),(P||l==="file")&&(a+=E,a+=E),P){let U=P.indexOf("@");if(U!==-1){const Q=P.substr(0,U);P=P.substr(U+1),U=Q.indexOf(":"),U===-1?a+=o(Q,!1):(a+=o(Q.substr(0,U),!1),a+=":",a+=o(Q.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=o(P,!1):(a+=o(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=o(M,!0)}return A&&(a+="?",a+=o(A,!1)),F&&(a+="#",a+=n?F:w(F,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(s)?i.replace(s,n=>c(n)):i}}),define(Z[140],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(p){const I=p;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(p){const I=[];let E;try{const S=JSON.parse(p.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),E=f.__$stack),I.push(...S)}catch{I.push("Unable to log remote console arguments",p.arguments)}return{args:I,stack:E}}e.parse=k;function R(p){if(typeof p!="string")return R(k(p).stack);const I=p;if(I){const E=D(I),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(S&&S.length===4)return{uri:v.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function D(p){if(!p)return p;const I=p.indexOf(`
`);return I===-1?p:p.substring(0,I)}function y(p,I){const{args:E,stack:S}=k(p),f=typeof E[0]=="string"&&E.length===1;let d=D(S);d&&(d=`(${d.trim()})`);let C=[];if(typeof E[0]=="string"?d&&f?C=[`%c[${I}] %c${E[0]} %c${d}`,h("blue"),h(""),h("grey")]:C=[`%c[${I}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:C=[`%c[${I}]%`,h("blue"),...E],d&&!f&&C.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,C)}e.log=y;function h(p){return`color: ${p}`}}),define(Z[58],ee([0,1,17,27,7]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,y)}e.stringify=R;function D(p){let I=JSON.parse(p);return I=h(I),I}e.parse=D;function y(p,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function h(p,I=0){if(!p||I>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return k.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let E=0;E<p.length;++E)p[E]=h(p[E],I+1);else for(const E in p)Object.hasOwnProperty.call(p,E)&&(p[E]=h(p[E],I+1))}return p}e.revive=h}),define(Z[13],ee([0,1,4,7]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h){this._remoteResourcesPath=`${h}/${k.vscodeRemoteResource}`}set(h,p,I){this._hosts[h]=p,this._ports[h]=I}setConnectionToken(h,p){this._connectionTokens[h]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)return this._delegate(h);const p=h.authority;let I=this._hosts[p];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const E=this._ports[p],S=this._connectionTokens[p];let f=`path=${encodeURIComponent(h.path)}`;return typeof S=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${E}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new R;class D{asBrowserUri(h,p){const I=this.toUri(h,p);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(h,p){const I=this.toUri(h,p);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==D.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(h,p){return t.URI.isUri(h)?h:t.URI.parse(p.toUrl(h))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(Z[16],ee([0,1,31,13,9,4,27,7]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(f){return(0,y.uriToFsPath)(f,!0)}e.originalFSPath=h;class p{constructor(d){this._ignorePathCasing=d}compare(d,C,b=!1){return d===C?0:(0,D.compare)(this.getComparisonKey(d,b),this.getComparisonKey(C,b))}isEqual(d,C,b=!1){return d===C?!0:!d||!C?!1:this.getComparisonKey(d,b)===this.getComparisonKey(C,b)}getComparisonKey(d,C=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,C,b=!1){if(d.scheme===C.scheme){if(d.scheme===t.Schemas.file)return v.isEqualOrParent(h(d),h(C),this._ignorePathCasing(d))&&d.query===C.query&&(b||d.fragment===C.fragment);if((0,e.isEqualAuthority)(d.authority,C.authority))return v.isEqualOrParent(d.path,C.path,this._ignorePathCasing(d),"/")&&d.query===C.query&&(b||d.fragment===C.fragment)}return!1}joinPath(d,...C){return y.URI.joinPath(d,...C)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let C;return d.scheme===t.Schemas.file?C=y.URI.file(k.dirname(h(d))).path:(C=k.posix.dirname(d.path),d.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),C="/")),d.with({path:C})}normalizePath(d){if(!d.path.length)return d;let C;return d.scheme===t.Schemas.file?C=y.URI.file(k.normalize(h(d))).path:C=k.posix.normalize(d.path),d.with({path:C})}relativePath(d,C){if(d.scheme!==C.scheme||!(0,e.isEqualAuthority)(d.authority,C.authority))return;if(d.scheme===t.Schemas.file){const m=k.relative(h(d),h(C));return R.isWindows?v.toSlashes(m):m}let b=d.path||"/";const w=C.path||"/";if(this._ignorePathCasing(d)){let m=0;for(const g=Math.min(b.length,w.length);m<g&&!(b.charCodeAt(m)!==w.charCodeAt(m)&&b.charAt(m).toLowerCase()!==w.charAt(m).toLowerCase());m++);b=w.substr(0,m)+b.substr(m)}return k.posix.relative(b,w)}resolvePath(d,C){if(d.scheme===t.Schemas.file){const b=y.URI.file(k.resolve(h(d),C));return d.with({authority:b.authority,path:b.path})}return C=v.toPosixPath(C),d.with({path:k.posix.resolve(d.path,C)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,C){return d===C||d!==void 0&&C!==void 0&&(0,D.equalsIgnoreCase)(d,C)}hasTrailingPathSeparator(d,C=k.sep){if(d.scheme===t.Schemas.file){const b=h(d);return b.length>v.getRoot(b).length&&b[b.length-1]===C}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,C=k.sep){return(0,e.hasTrailingPathSeparator)(d,C)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,C=k.sep){let b=!1;if(d.scheme===t.Schemas.file){const w=h(d);b=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===C}else{C="/";const w=d.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,C)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,d){const C=[];for(let b=0;b<f.length;b++){const w=d(f[b]);f.some((m,g)=>g===b?!1:(0,e.isEqualOrParent)(w,d(m)))||C.push(f[b])}return C}e.distinctParents=I;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(C){const b=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(g=>{const[u,c]=g.split(":");u&&c&&b.set(u,c)});const m=C.path.substring(0,C.path.indexOf(";"));return m&&b.set(f.META_DATA_MIME,m),b}f.parseMetaData=d})(E=e.DataUri||(e.DataUri={}));function S(f,d,C){if(d){let b=f.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),f.with({scheme:C,authority:d,path:b})}return f.with({scheme:C})}e.toLocalResource=S}),define(Z[8],ee([0,1,21,18,3,2,16,4]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(q){return!!q&&typeof q.then=="function"}e.isThenable=h;function p(q){const L=new v.CancellationTokenSource,O=q(L.token),B=new Promise((V,X)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),X(new t.CancellationError)});Promise.resolve(O).then(j=>{ne.dispose(),L.dispose(),V(j)},j=>{ne.dispose(),L.dispose(),X(j)})});return new class{cancel(){L.cancel()}then(V,X){return B.then(V,X)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.createCancelablePromise=p;function I(q,L,O){return new Promise((B,V)=>{const X=L.onCancellationRequested(()=>{X.dispose(),B(O)});q.then(B,V).finally(()=>X.dispose())})}e.raceCancellation=I;function E(q,L){return new Promise((O,B)=>{const V=L.onCancellationRequested(()=>{V.dispose(),B(new t.CancellationError)});q.then(O,B).finally(()=>V.dispose())})}e.raceCancellationError=E;async function S(q){let L=-1;const O=q.map((V,X)=>V.then(ne=>(L=X,ne))),B=await Promise.race(O);return q.forEach((V,X)=>{X!==L&&V.cancel()}),B}e.raceCancellablePromises=S;function f(q,L,O){let B;const V=setTimeout(()=>{B?.(void 0),O?.()},L);return Promise.race([q.finally(()=>clearTimeout(V)),new Promise(X=>B=X)])}e.raceTimeout=f;function d(q){return new Promise((L,O)=>{const B=q();h(B)?B.then(L,O):L(B)})}e.asPromise=d;class C{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=L(),new Promise((O,B)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,B(V)})})}}e.Throttler=C;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class w{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=w;const m=(q,L)=>{let O=!0;const B=setTimeout(()=>{O=!1,L()},q);return{isTriggered:()=>O,dispose:()=>{clearTimeout(B),O=!1}}},g=q=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,q())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,X)=>{this.doResolve=V,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?g(B):m(O,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(L){this.delayer=new u(L),this.throttler=new C}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class s{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(q,L){return L?new Promise((O,B)=>{const V=setTimeout(()=>{X.dispose(),O()},q),X=L.onCancellationRequested(()=>{clearTimeout(V),X.dispose(),B(new t.CancellationError)})}):p(O=>i(q,O))}e.timeout=i;function n(q,L=0){const O=setTimeout(q,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function o(q){const L=[];let O=0;const B=q.length;function V(){return O<B?q[O++]():null}function X(ne){ne!=null&&L.push(ne);const j=V();return j?j.then(X):Promise.resolve(L)}return Promise.resolve(null).then(X)}e.sequence=o;function a(q,L=B=>!!B,O=null){let B=0;const V=q.length,X=()=>{if(B>=V)return Promise.resolve(O);const ne=q[B++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):X())};return X()}e.first=a;function l(q,L=B=>!!B,O=null){if(q.length===0)return Promise.resolve(O);let B=q.length;const V=()=>{B=-1;for(const X of q)X.cancel?.()};return new Promise((X,ne)=>{for(const j of q)j.then(te=>{--B>=0&&L(te)?(V(),X(te)):B===0&&X(O)}).catch(te=>{--B>=0&&(V(),ne(te))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:L,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new W;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const B=O.getComparisonKey(L);let V=this.queues.get(B);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(B),this.onDidQueueDrain()}),this.queues.set(B,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class F{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class Q{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class re{constructor(L,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends Q{constructor(L,O){super(L,O);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class fe extends R.Disposable{constructor(L,O){super();this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=fe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{(0,y.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(q,L)=>{const O=requestIdleCallback(q,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function ue(q,L,O){let B;for(let V=0;V<O;V++)try{return await q()}catch(X){B=X,await i(L)}throw B}e.retry=ue;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,O,B){return this._pending={taskId:L,cancel:()=>B?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,B;const V=new Promise((X,ne)=>{O=X,B=ne});this._next={run:L,promise:V,promiseResolve:O,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=K;class N{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=W;var _;(function(q){async function L(B){let V;const X=await Promise.all(B.map(ne=>ne.then(j=>j,j=>{V||(V=j)})));if(typeof V!="undefined")throw V;return X}q.settled=L;function O(B){return new Promise(async(V,X)=>{try{await B(V,X)}catch(ne){X(ne)}})}q.withAsyncBody=O})(_=e.Promises||(e.Promises={}));var T;(function(q){q[q.Initial=0]="Initial",q[q.DoneOK=1]="DoneOK",q[q.DoneError=2]="DoneError"})(T||(T={}));class ${constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(L(O)),this.resolve()}catch(B){this.reject(B)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new $(O=>{O.emitMany(L)})}static fromPromise(L){return new $(async O=>{O.emitMany(await L)})}static fromPromises(L){return new $(async O=>{await Promise.all(L.map(async B=>O.emitOne(await B)))})}static merge(L){return new $(async O=>{await Promise.all(L.map(async B=>{for await(const V of B)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new $(async B=>{for await(const V of L)B.emitOne(O(V))})}map(L){return $.map(this,L)}static filter(L,O){return new $(async B=>{for await(const V of L)O(V)&&B.emitOne(V)})}filter(L){return $.filter(this,L)}static coalesce(L){return $.filter(L,O=>!!O)}coalesce(){return $.coalesce(this)}static async toPromise(L){const O=[];for await(const B of L)O.push(B);return O}toPromise(){return $.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class x extends ${constructor(L,O){super(O);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=x;function z(q){const L=new v.CancellationTokenSource,O=q(L.token);return new x(L,async B=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),B.reject(new t.CancellationError)});try{for await(const X of O){if(L.token.isCancellationRequested)return;B.emitOne(X)}V.dispose(),L.dispose()}catch(X){V.dispose(),L.dispose(),B.reject(X)}})}e.createCancelableAsyncIterable=z}),define(Z[95],ee([0,1,24,8,31,32,9,4,27]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",E="[^/\\\\]",S=/\//g;function f(W,_){switch(W){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}${_?`|${I}${E}+`:""})*?`}}function d(W,_){if(!W)return[];const T=[];let $=!1,x=!1,z="";for(const q of W){switch(q){case _:if(!$&&!x){T.push(z),z="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":x=!0;break;case"]":x=!1;break}z+=q}return z&&T.push(z),T}e.splitGlobAware=d;function C(W){if(!W)return"";let _="";const T=d(W,e.GLOB_SPLIT);if(T.every($=>$===e.GLOBSTAR))_=".*";else{let $=!1;T.forEach((x,z)=>{if(x===e.GLOBSTAR){if($)return;_+=f(2,z===T.length-1)}else{let q=!1,L="",O=!1,B="";for(const V of x){if(V!=="}"&&q){L+=V;continue}if(O&&(V!=="]"||!B)){let X;V==="-"?X=V:(V==="^"||V==="!")&&!B?X="^":V===e.GLOB_SPLIT?X="":X=(0,h.escapeRegExpCharacters)(V),B+=X;continue}switch(V){case"{":q=!0;continue;case"[":O=!0;continue;case"}":{_+=`(?:${d(L,",").map(j=>C(j)).join("|")})`,q=!1,L="";break}case"]":{_+="["+B+"]",O=!1,B="";break}case"?":_+=E;continue;case"*":_+=f(1);continue;default:_+=(0,h.escapeRegExpCharacters)(V)}}z<T.length-1&&(T[z+1]!==e.GLOBSTAR||z+2<T.length)&&(_+=I)}$=x===e.GLOBSTAR})}return _}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(W,_){if(!W)return i;let T;typeof W!="string"?T=W.pattern:T=W,T=T.trim();const $=`${T}_${!!_.trimForExclusions}`;let x=s.get($);if(x)return o(x,W);let z;return b.test(T)?x=l(T.substr(4),T):(z=w.exec(a(T,_)))?x=P(z[1],T):(_.trimForExclusions?g:m).test(T)?x=M(T,_):(z=u.exec(a(T,_)))?x=A(z[1].substr(1),T,!0):(z=c.exec(a(T,_)))?x=A(z[1],T,!1):x=F(T),s.set($,x),o(x,W)}function o(W,_){if(typeof _=="string")return W;const T=function($,x){return(0,k.isEqualOrParent)($,_.base,!y.isLinux)?W($.substr(_.base.length+1),x):null};return T.allBasenames=W.allBasenames,T.allPaths=W.allPaths,T.basenames=W.basenames,T.patterns=W.patterns,T}function a(W,_){return _.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function l(W,_){return function(T,$){return typeof T=="string"&&T.endsWith(W)?_:null}}function P(W,_){const T=`/${W}`,$=`\\${W}`,x=function(q,L){return typeof q!="string"?null:L?L===W?_:null:q===W||q.endsWith(T)||q.endsWith($)?_:null},z=[W];return x.basenames=z,x.patterns=[_],x.allBasenames=z,x}function M(W,_){const T=K(W.slice(1,-1).split(",").map(L=>n(L,_)).filter(L=>L!==i),W),$=T.length;if(!$)return i;if($===1)return T[0];const x=function(L,O){for(let B=0,V=T.length;B<V;B++)if(T[B](L,O))return W;return null},z=T.find(L=>!!L.allBasenames);z&&(x.allBasenames=z.allBasenames);const q=T.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return q.length&&(x.allPaths=q),x}function A(W,_,T){const $=D.sep===D.posix.sep,x=$?W:W.replace(S,D.sep),z=D.sep+x,q=D.posix.sep+W;let L;return T?L=function(O,B){return typeof O=="string"&&(O===x||O.endsWith(z)||!$&&(O===W||O.endsWith(q)))?_:null}:L=function(O,B){return typeof O=="string"&&(O===x||!$&&O===W)?_:null},L.allPaths=[(T?"*/":"./")+W],L}function F(W){try{const _=new RegExp(`^${C(W)}$`);return function(T){return _.lastIndex=0,typeof T=="string"&&_.test(T)?W:null}}catch{return i}}function U(W,_,T){return!W||typeof _!="string"?!1:Q(W)(_,void 0,T)}e.match=U;function Q(W,_={}){if(!W)return r;if(typeof W=="string"||re(W)){const T=n(W,_);if(T===i)return r;const $=function(x,z){return!!T(x,z)};return T.allBasenames&&($.allBasenames=T.allBasenames),T.allPaths&&($.allPaths=T.allPaths),$}return se(W,_)}e.parse=Q;function re(W){const _=W;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=re;function le(W){return W.allBasenames||[]}e.getBasenameTerms=le;function fe(W){return W.allPaths||[]}e.getPathTerms=fe;function se(W,_){const T=K(Object.getOwnPropertyNames(W).map(L=>ue(L,W[L],_)).filter(L=>L!==i)),$=T.length;if(!$)return i;if(!T.some(L=>!!L.requiresSiblings)){if($===1)return T[0];const L=function(V,X){let ne;for(let j=0,te=T.length;j<te;j++){const ie=T[j](V,X);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const j of ne){const te=await j;if(typeof te=="string")return te}return null})():null},O=T.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const B=T.reduce((V,X)=>X.allPaths?V.concat(X.allPaths):V,[]);return B.length&&(L.allPaths=B),L}const x=function(L,O,B){let V,X;for(let ne=0,j=T.length;ne<j;ne++){const te=T[ne];te.requiresSiblings&&B&&(O||(O=(0,D.basename)(L)),V||(V=O.substr(0,O.length-(0,D.extname)(L).length)));const ie=te(L,O,V,B);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(X||(X=[]),X.push(ie))}return X?(async()=>{for(const ne of X){const j=await ne;if(typeof j=="string")return j}return null})():null},z=T.find(L=>!!L.allBasenames);z&&(x.allBasenames=z.allBasenames);const q=T.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return q.length&&(x.allPaths=q),x}function ue(W,_,T){if(_===!1)return i;const $=n(W,T);if($===i)return i;if(typeof _=="boolean")return $;if(_){const x=_.when;if(typeof x=="string"){const z=(q,L,O,B)=>{if(!B||!$(q,L))return null;const V=x.replace("$(basename)",O),X=B(V);return(0,t.isThenable)(X)?X.then(ne=>ne?W:null):X?W:null};return z.requiresSiblings=!0,z}}return $}function K(W,_){const T=W.filter(L=>!!L.basenames);if(T.length<2)return W;const $=T.reduce((L,O)=>{const B=O.basenames;return B?L.concat(B):L},[]);let x;if(_){x=[];for(let L=0,O=$.length;L<O;L++)x.push(_)}else x=T.reduce((L,O)=>{const B=O.patterns;return B?L.concat(B):L},[]);const z=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const X=L.charCodeAt(V-1);if(X===47||X===92)break}O=L.substr(V)}const B=$.indexOf(O);return B!==-1?x[B]:null};z.basenames=$,z.patterns=x,z.allBasenames=$;const q=W.filter(L=>!L.basenames);return q.push(z),q}function N(W,_){return(0,v.equals)(W,_,(T,$)=>typeof T=="string"&&typeof $=="string"?T===$:typeof T!="string"&&typeof $!="string"?T.base===$.base&&T.pattern===$.pattern:!1)}e.patternsEquals=N}),define(Z[36],ee([0,1,24,31,9,4,16,27]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:a,relative:l}=n;if(l){const A=p(i,l,o);if(typeof A=="string")return A}let P=i.fsPath;if(o===1&&!R.isWindows?P=P.replace(/\//g,"\\"):o!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),o!==1&&a?.userHome){const A=a.userHome.fsPath;let F;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?F=a.userHome.with({path:i.path}).fsPath:F=i.fsPath,P=S(F,A,o)}return(o===1?k.win32:k.posix).normalize(I(P,o===1))}e.getPathLabel=h;function p(i,n,o){const a=o===1?k.win32:k.posix,l=o===3?D.extUri:D.extUriIgnorePathCase,P=n.getWorkspace(),M=(0,v.firstOrDefault)(P.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let F;if(l.isEqual(A.uri,i)?F="":F=l.relativePath(A.uri,i)??"",F&&(F=a.normalize(F)),P.folders.length>1&&!n.noPrefix){const U=A.name?A.name:l.basenameOrAuthority(A.uri);F=F?`${U} \u2022 ${F}`:U}return F}function I(i,n=R.isWindows){return(0,t.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let E=Object.create(null);function S(i,n,o=R.OS){if(o===1||!i||!n)return i;let a=E.original===n?E.normalized:void 0;a||(a=n,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,y.rtrim)(a,k.posix.sep)}${k.posix.sep}`,E={original:n,normalized:a});let l=i;return R.isWindows&&(l=(0,t.toSlashes)(l)),(o===3?l.startsWith(a):(0,y.startsWithIgnoreCase)(l,a))?`~/${l.substr(a.length)}`:i}e.tildify=S;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const d="\u2026",C="\\\\",b="~";function w(i,n=k.sep){const o=new Array(i.length);let a=!1;for(let l=0;l<i.length;l++){const P=i[l];if(P===""){o[l]=`.${n}`;continue}if(!P){o[l]=P;continue}a=!0;let M="",A=P;A.indexOf(C)===0?(M=A.substr(0,A.indexOf(C)+C.length),A=A.substr(A.indexOf(C)+C.length)):A.indexOf(n)===0?(M=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(b)===0&&(M=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const F=A.split(n);for(let U=1;a&&U<=F.length;U++)for(let Q=F.length-U;a&&Q>=0;Q--){a=!1;let re=F.slice(Q,Q+U).join(n);for(let le=0;!a&&le<i.length;le++)if(le!==l&&i[le]&&i[le].indexOf(re)>-1){const fe=Q+U===F.length,se=Q>0&&i[le].indexOf(n)>-1?n+re:re,ue=i[le].endsWith(se);a=!fe||ue}if(!a){let le="";(F[0].endsWith(":")||M!=="")&&(Q===1&&(Q=0,U++,re=F[0]+n+re),Q>0&&(le=F[0]+n),le=M+le),Q>0&&(le=le+d+n),le=le+re,Q+U<F.length&&(le=le+n+d),o[l]=le}}a&&(o[l]=P)}return o}e.shorten=w;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function g(i,n=Object.create(null)){const o=[];let a=!1,l="";for(const P of i)if(P==="$"||a&&P==="{")l&&o.push({value:l,type:m.TEXT}),l="",a=!0;else if(P==="}"&&a){const M=n[l];if(typeof M=="string")M.length&&o.push({value:M,type:m.VARIABLE});else if(M){const A=o[o.length-1];(!A||A.type!==m.SEPARATOR)&&o.push({value:M.label,type:m.SEPARATOR})}l="",a=!1}else l+=P;return l&&!a&&o.push({value:l,type:m.TEXT}),o.filter((P,M)=>{if(P.type===m.SEPARATOR){const A=o[M-1],F=o[M+1];return[A,F].every(U=>U&&(U.type===m.VARIABLE||U.type===m.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=g;function u(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function c(i,n){return R.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function s(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,o=n.basename(i),a=n.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(Z[141],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const S=this._uriTransformer.transformIncoming(E);return S===E?E:t(v.URI.from(S))}transformOutgoing(E){const S=this._uriTransformer.transformOutgoing(E);return S===E?E:t(v.URI.from(S))}transformOutgoingURI(E){const S=this._uriTransformer.transformOutgoing(E);return S===E?E:v.URI.from(S)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,E,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof v.URI)return E.transformOutgoing(I);for(const f in I)if(Object.hasOwnProperty.call(I,f)){const d=R(I[f],E,S+1);d!==null&&(I[f]=d)}}return null}function D(I,E){const S=R(I,E,0);return S===null?I:S}e.transformOutgoingURIs=D;function y(I,E,S,f){if(!I||f>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?v.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const C=y(I[d],E,S,f+1);C!==null&&(I[d]=C)}}return null}function h(I,E){const S=y(I,E,!1,0);return S===null?I:S}e.transformIncomingURIs=h;function p(I,E){const S=y(I,E,!0,0);return S===null?I:S}e.transformAndReviveIncomingURIs=p}),define(Z[81],ee([0,1,30,18,32,28,129]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const S=(0,v.networkInterfaces)();for(const f in S){const d=S[f];if(d)for(const{mac:C,internal:b}of d)b||(E+=1,this._isVirtualMachineMacAddress(C.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let y;async function h(){return y||(y=(async()=>await p()||R.generateUuid())()),y}e.getMachineId=h;async function p(){try{const I=await new Promise((S,f)=>{H(["crypto"],S,f)}),E=(0,D.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[23],ee([0,1,29,30,142,8,31,80,9,4,16,7]),function(H,e,v,t,k,R,D,y,h,p,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function f(se,ue=S.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===S.UNLINK?C(se):d(se)}async function d(se){try{const ue=(0,D.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,ue)}catch{return C(se)}C(ue).catch(K=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function C(se){return(0,k.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function b(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function w(se,ue){return u(await(ue?m(se):(0,k.promisify)(v.readdir)(se)))}async function m(se){try{return await(0,k.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const ue=[],K=await w(se);for(const N of K){let W=!1,_=!1,T=!1;try{const $=await e.Promises.lstat((0,h.join)(se,N));W=$.isFile(),_=$.isDirectory(),T=$.isSymbolicLink()}catch($){console.warn("[node.js fs] unexpected error from lstat after readdir: ",$)}ue.push({name:N,isFile:()=>W,isDirectory:()=>_,isSymbolicLink:()=>T})}return ue}function g(se){return u(v.readdirSync(se))}e.readdirSync=g;function u(se){return se.map(ue=>typeof ue=="string"?p.isMacintosh?(0,y.normalizeNFC)(ue):ue:(ue.name=p.isMacintosh?(0,y.normalizeNFC)(ue.name):ue.name,ue))}async function c(se){const ue=await w(se),K=[];for(const N of ue)await r.existsDirectory((0,h.join)(se,N))&&K.push(N);return K}function s(se,ue=1e3){return new Promise(K=>{let N=!1;const W=setInterval(()=>{N||(N=!0,v.access(se,_=>{N=!1,_&&(clearInterval(W),K(void 0))}))},ue)})}e.whenDeleted=s;var r;(function(se){async function ue(W){let _;try{if(_=await e.Promises.lstat(W),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(p.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch($){if($.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw $}throw T}}se.stat=ue;async function K(W){try{const{stat:_,symbolicLink:T}=await se.stat(W);return _.isFile()&&T?.dangling!==!0}catch{}return!1}se.existsFile=K;async function N(W){try{const{stat:_,symbolicLink:T}=await se.stat(W);return _.isDirectory()&&T?.dangling!==!0}catch{}return!1}se.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function n(se,ue,K){return i.queueFor(E.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const N=M(K);return new Promise((W,_)=>l(se,ue,N,T=>T?_(T):W()))})}let o=!0;function a(se){o=se}e.configureFlushOnWrite=a;function l(se,ue,K,N){if(!o)return v.writeFile(se,ue,{mode:K.mode,flag:K.flag},N);v.open(se,K.flag,K.mode,(W,_)=>{if(W)return N(W);v.writeFile(_,ue,T=>{if(T)return v.close(_,()=>N(T));v.fdatasync(_,$=>($&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",$),a(!1)),v.close(_,x=>N(x))))})})}function P(se,ue,K){const N=M(K);if(!o)return v.writeFileSync(se,ue,{mode:N.mode,flag:N.flag});const W=v.openSync(se,N.flag,N.mode);try{v.writeFileSync(W,ue);try{v.fdatasyncSync(W)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),a(!1)}}finally{v.closeSync(W)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function A(se,ue){if(se!==ue)try{await e.Promises.rename(se,ue)}catch(K){if(se.toLowerCase()!==ue.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await F(se,ue,{preserveSymlinks:!1}),await f(se,S.MOVE);else throw K}}async function F(se,ue,K){return Q(se,ue,{root:{source:se,target:ue},options:K,handledSourcePaths:new Set})}const U=511;async function Q(se,ue,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:N,symbolicLink:W}=await r.stat(se);if(W){if(K.options.preserveSymlinks)try{return await fe(se,ue,K)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(W.dangling)return}return N.isDirectory()?re(se,ue,N.mode&U,K):le(se,ue,N.mode&U)}async function re(se,ue,K,N){await e.Promises.mkdir(ue,{recursive:!0,mode:K});const W=await w(se);for(const _ of W)await Q((0,h.join)(se,_),(0,h.join)(ue,_),N)}async function le(se,ue,K){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,K)}async function fe(se,ue,K){let N=await e.Promises.readlink(se);(0,D.isEqualOrParent)(N,K.root.source,!p.isLinux)&&(N=(0,h.join)(K.root.target,N.substr(K.root.source.length+1))),await e.Promises.symlink(N,ue)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(se,ue,K,N,W)=>new Promise((_,T)=>{v.read(se,ue,K,N,W,($,x,z)=>$?T($):_({bytesRead:x,buffer:z}))})}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(se,ue,K,N,W)=>new Promise((_,T)=>{v.write(se,ue,K,N,W,($,x,z)=>$?T($):_({bytesWritten:x,buffer:z}))})}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return f}get move(){return A}get copy(){return F}}}),define(Z[96],ee([0,1,29,9,4,27,23]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function y(S){if(k.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const b=(0,D.readdirSync)(f).filter(w=>w.toLowerCase()===d);if(b.length===1){const w=y(f);if(w)return(0,t.join)(w,b[0])}else if(b.length>1){const w=b.indexOf(d);if(w>=0){const m=y(f);if(m)return(0,t.join)(m,b[w])}}}catch{}return null}e.realcaseSync=y;async function h(S){if(k.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const d=((0,t.basename)(S)||S).toLowerCase();try{const b=(await D.Promises.readdir(f)).filter(w=>w.toLowerCase()===d);if(b.length===1){const w=await h(f);if(w)return(0,t.join)(w,b[0])}else if(b.length>1){const w=b.indexOf(d);if(w>=0){const m=await h(f);if(m)return(0,t.join)(m,b[w])}}}catch{}return null}e.realcase=h;async function p(S){try{return await D.Promises.realpath(S)}catch{const d=E(S);return await D.Promises.access(d,v.constants.R_OK),d}}e.realpath=p;function I(S){try{return v.realpathSync(S)}catch{const d=E(S);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=I;function E(S){return(0,R.rtrim)((0,t.normalize)(S),t.sep)}}),define(Z[143],ee([0,1,30,9,23]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(c,s,r){this.exePath=c,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:u=!1}={}){return u?p===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:u=!1,findPreview:c=!1}={}){const s=S({useAlternateBitness:u});if(!s)return null;const r=t.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(c){const A=l.indexOf("-");if(A<0)continue;const F=l.substring(0,A);if(!R.test(F)||l.substring(A+1)!=="preview")continue;P=parseInt(F,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const M=t.join(r,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(n=M,i=P)}if(!n)return null;const o=s.includes("x86")?" (x86)":"",a=c?" Preview":"";return new E(n,`PowerShell${a}${o}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=u?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(s.test(i)){const n=t.join(c,i,"pwsh.exe");return new E(n,r)}return null}function C(){const u=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function b(){const u=t.join(process.env.windir,p===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*w(){let u=await f();u&&(yield u),u=await f({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=C(),u&&(yield u),u=await f({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await f({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*m(){for await(const u of w())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=m;async function g(){for await(const u of m())return u;return null}e.getFirstAvailablePowerShellInstallation=g}),define(Z[82],ee([0,1,9,4,35,78,12,23]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(E=k.env){return E.comspec||"cmd.exe"}e.getWindowsShell=h;function p(E){let S=[],f=!1;const d=function(C){if(f){S.push(C);return}(!E.send(C,w=>{if(w&&console.error(w),f=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(g=>d(g))}})||t.isWindows)&&(f=!0)};return{send:d}}e.createQueuedSender=p;var I;(function(E){async function S(f,d,C){if(v.isAbsolute(f))return f;if(d===void 0&&(d=k.cwd()),v.dirname(f)!=="."||(C===void 0&&D.isString(k.env.PATH)&&(C=k.env.PATH.split(v.delimiter)),C===void 0||C.length===0))return v.join(d,f);async function w(m){if(await y.Promises.exists(m)){let g;try{g=await y.Promises.stat(m)}catch(u){u.message.startsWith("EACCES")&&(g=await y.Promises.lstat(m))}return g?!g.isDirectory():!1}return!1}for(const m of C){let g;if(v.isAbsolute(m)?g=v.join(m,f):g=v.join(d,m,f),await w(g))return g;let u=g+".com";if(await w(u)||(u=g+".exe",await w(u)))return u}return v.join(d,f)}E.findExecutable=S})(I=e.win32||(e.win32={}))}),define(Z[97],ee([0,1,50,13]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((y,h)=>{let p;const I=new Map;function E(f,d,C,b,w){const m=I.get(d);if(f===D||m){const g={name:S(C),cmd:C,pid:f,ppid:d,load:b,mem:w};I.set(f,g),f===D&&(p=g),m&&(m.children||(m.children=[]),m.children.push(g),m.children.length>1&&(m.children=m.children.sort((u,c)=>u.pid-c.pid)))}}function S(f){const d=/--vscode-window-kind=shared-process/,C=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,u=/\\pipe\\winpty-control/,c=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(u.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let r=s.exec(f);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(f)?"shared-process":C.exec(f)?"issue-reporter":b.exec(f)?"process-explorer":"window";if(r[1]==="utility"){if(w.exec(f))return"utility-network-service";if(m.exec(f))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let n="";do r=i.exec(f),r&&(n+=r+" ");while(r);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${n}`:f}if(process.platform==="win32"){const f=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,C)=>{H(["windows-process-tree"],d,C)}).then(d=>{d.getProcessList(D,C=>{if(!C){h(new Error(`Root process ${D} not found`));return}d.getProcessCpuUsage(C,b=>{const w=new Map;b.forEach(m=>{const g=f(m.commandLine||"");w.set(m.pid,{name:S(g),cmd:g,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),p=w.get(D),p?(w.forEach(m=>{const g=w.get(m.ppid);g&&(g.children||(g.children=[]),g.children.push(m))}),w.forEach(m=>{m.children&&(m.children=m.children.sort((g,u)=>g.pid-u.pid))}),y(p)):h(new Error(`Root process ${D} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let f=function(){let d=[p];const C=[];for(;d.length;){const w=d.shift();w&&(C.push(w.pid),w.children&&(d=d.concat(w.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);b+=" "+C.join(" "),(0,v.exec)(b,{},(w,m,g)=>{if(w||g)h(w||new Error(g.toString()));else{const u=m.toString().split(`
`);for(let c=0;c<C.length;c++){const s=I.get(C[c]);s.load=parseFloat(u[c])}if(!p){h(new Error(`Root process ${D} not found`));return}y(p)}})};(0,v.exec)("which ps",{},(d,C,b)=>{if(d||b)if(process.platform!=="linux")h(d||new Error(b.toString()));else{const w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,v.exec)(w,{},(m,g,u)=>{m||u?h(m||new Error(u.toString())):(R(g,E),f())})}else{const w=C.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,u,c)=>{g||c&&!c.includes("screen size is bogus")?h(g||new Error(c.toString())):(R(u,E),process.platform==="linux"?f():p?y(p):h(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,y){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=D.toString().split(`
`);for(const I of p){const E=h.exec(I.trim());E&&E.length===6&&y(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Z[144],ee([0,1,30,4,143,82]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(f,d){return f===1?t.isWindows?E():R.getWindowsShell(d):p(f,d)}e.getSystemShell=D;function y(f,d){return f===1?t.isWindows?S(d):R.getWindowsShell(d):p(f,d)}e.getSystemShellSync=y;let h=null;function p(f,d){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!h){let C;if(t.isWindows)C="/bin/bash";else{if(C=d.SHELL,!C)try{C=(0,v.userInfo)().shell}catch{}C||(C="sh"),C==="/bin/false"&&(C="/bin/bash")}h=C}return h}let I=null;async function E(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function S(f){if(I)return I;const d=t.isWindows&&parseFloat((0,v.release)())>=10,C=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${f.windir}\\${C?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:R.getWindowsShell(f)}});var ve=this&&this.__decorate||function(H,e,v,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,v,t);else for(var y=H.length-1;y>=0;y--)(D=H[y])&&(R=(k<3?D(R):k>3?D(e,v,R):D(e,v))||R);return k>3&&R&&Object.defineProperty(e,v,R),R};define(Z[44],ee([0,1,24,8,17,21,51,18,3,2,58,27,12]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function b(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(w||(w={}));class m{constructor(_){this.buffer=_,this.pos=0}read(_){const T=this.buffer.slice(this.pos,this.pos+_);return this.pos+=T.byteLength,T}}class g{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var u;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(u||(u={}));function c(W){const _=k.VSBuffer.alloc(4);return _.writeUInt32BE(W,0),_}function s(W){return W.read(4).readUInt32BE(0)}function r(W){const _=k.VSBuffer.alloc(1);return _.writeUInt8(W,0),_}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},n=typeof Buffer!="undefined";function o(W,_){if(typeof _=="undefined")W.write(i.Undefined);else if(typeof _=="string"){const T=k.VSBuffer.fromString(_);W.write(i.String),W.write(c(T.byteLength)),W.write(T)}else if(n&&Buffer.isBuffer(_)){const T=k.VSBuffer.wrap(_);W.write(i.Buffer),W.write(c(T.byteLength)),W.write(T)}else if(_ instanceof k.VSBuffer)W.write(i.VSBuffer),W.write(c(_.byteLength)),W.write(_);else if(Array.isArray(_)){W.write(i.Array),W.write(c(_.length));for(const T of _)o(W,T)}else{const T=k.VSBuffer.fromString(JSON.stringify(_));W.write(i.Object),W.write(c(T.byteLength)),W.write(T)}}function a(W){switch(W.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return W.read(s(W)).toString();case u.Buffer:return W.read(s(W)).buffer;case u.VSBuffer:return W.read(s(W));case u.Array:{const T=s(W),$=[];for(let x=0;x<T;x++)$.push(a(W));return $}case u.Object:return JSON.parse(W.read(s(W)).toString())}}class l{constructor(_,T,$=null,x=1e3){this.protocol=_,this.ctx=T,this.logger=$,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(_,T){this.channels.set(_,T),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const T=this.send([_.type]);this.logger?.logOutgoing(T,0,1,b(_.type));return}case 201:case 202:case 204:case 203:{const T=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(T,_.id,1,b(_.type),_.data);return}}}send(_,T=void 0){const $=new g;return o($,_),o($,T),this.sendBuffer($.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const T=new m(_),$=a(T),x=a(T),z=$[0];switch(z){case 100:return this.logger?.logIncoming(_.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,x),this.onPromise({type:z,id:$[1],channelName:$[2],name:$[3],arg:x});case 102:return this.logger?.logIncoming(_.byteLength,$[1],1,`${d(z)}: ${$[2]}.${$[3]}`,x),this.onEventListen({type:z,id:$[1],channelName:$[2],name:$[3],arg:x});case 101:return this.logger?.logIncoming(_.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]});case 103:return this.logger?.logIncoming(_.byteLength,$[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:$[1]})}}onPromise(_){const T=this.channels.get(_.channelName);if(!T){this.collectPendingRequest(_);return}const $=new R.CancellationTokenSource;let x;try{x=T.call(this.ctx,_.name,_.arg,$.token)}catch(L){x=Promise.reject(L)}const z=_.id;x.then(L=>{this.sendResponse({id:z,data:L,type:201}),this.activeRequests.delete(_.id)},L=>{L instanceof Error?this.sendResponse({id:z,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:z,data:L,type:203}),this.activeRequests.delete(_.id)});const q=(0,p.toDisposable)(()=>$.cancel());this.activeRequests.set(_.id,q)}onEventListen(_){const T=this.channels.get(_.channelName);if(!T){this.collectPendingRequest(_);return}const $=_.id,z=T.listen(this.ctx,_.name,_.arg)(q=>this.sendResponse({id:$,data:q,type:204}));this.activeRequests.set(_.id,z)}disposeActiveRequest(_){const T=this.activeRequests.get(_.id);T&&(T.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let T=this.pendingRequests.get(_.channelName);T||(T=[],this.pendingRequests.set(_.channelName,T));const $=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);T.push({request:_,timeoutTimer:$})}flushPendingRequests(_){const T=this.pendingRequests.get(_);if(T){for(const $ of T)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(_,T=null){this.protocol=_,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=T}getChannel(_){const T=this;return{call($,x,z){return T.isDisposed?Promise.reject(new y.CancellationError):T.requestPromise(_,$,x,z)},listen($,x){return T.isDisposed?h.Event.None:T.requestEvent(_,$,x)}}}requestPromise(_,T,$,x=R.CancellationToken.None){const z=this.lastRequestId++,L={id:z,type:100,channelName:_,name:T,arg:$};if(x.isCancellationRequested)return Promise.reject(new y.CancellationError);let O;return new Promise((V,X)=>{if(x.isCancellationRequested)return X(new y.CancellationError);const ne=()=>{const ce=he=>{switch(he.type){case 201:this.handlers.delete(z),V(he.data);break;case 202:{this.handlers.delete(z);const ke=new Error(he.data.message);ke.stack=he.data.stack,ke.name=he.data.name,X(ke);break}case 203:this.handlers.delete(z),X(he.data);break}};this.handlers.set(z,ce),this.sendRequest(L)};let j=null;this.state===w.Idle?ne():(j=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),j.then(()=>{j=null,ne()}));const te=()=>{j?(j.cancel(),j=null):this.sendRequest({id:z,type:101}),X(new y.CancellationError)},ie=x.onCancellationRequested(te);O=(0,p.combinedDisposable)((0,p.toDisposable)(te),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(_,T,$){const x=this.lastRequestId++,q={id:x,type:102,channelName:_,name:T,arg:$};let L=null;const O=new h.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(q)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:x,type:103}))}}),B=V=>O.fire(V.data);return this.handlers.set(x,B),O.event}sendRequest(_){switch(_.type){case 100:case 102:{const T=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(T,_.id,0,`${d(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const T=this.send([_.type,_.id]);this.logger?.logOutgoing(T,_.id,0,d(_.type));return}}}send(_,T=void 0){const $=new g;return o($,_),o($,T),this.sendBuffer($.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const T=new m(_),$=a(T),x=a(T),z=$[0];switch(z){case 200:return this.logger?.logIncoming(_.byteLength,0,0,b(z)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,$[1],0,b(z),x),this.onResponse({type:$[0],id:$[1],data:x})}}onResponse(_){if(_.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class A{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:T,onDidClientDisconnect:$})=>{h.Event.once(T.onMessage)(z=>{const q=new m(z),L=a(q),O=new l(T,L),B=new M(T);this.channels.forEach((X,ne)=>O.registerChannel(ne,X));const V={channelServer:O,channelClient:B,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),$(()=>{O.dispose(),B.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const _=[];return this._connections.forEach(T=>_.push(T)),_}getChannel(_,T){const $=this;return{call(x,z,q){let L;if((0,S.isFunction)(T)){const B=(0,v.getRandomElement)($.connections.filter(T));L=B?Promise.resolve(B):h.Event.toPromise(h.Event.filter($.onDidAddConnection,T))}else L=T.routeCall($,x,z);const O=L.then(B=>B.channelClient.getChannel(_));return U(O).call(x,z,q)},listen(x,z){if((0,S.isFunction)(T))return $.getMulticastEvent(_,T,x,z);const q=T.routeEvent($,x,z).then(L=>L.channelClient.getChannel(_));return U(q).listen(x,z)}}}getMulticastEvent(_,T,$,x){const z=this;let q=new p.DisposableStore;const L=new h.Emitter({onFirstListenerAdd:()=>{q=new p.DisposableStore;const O=new h.EventMultiplexer,B=new Map,V=ne=>{const te=ne.channelClient.getChannel(_).listen($,x),ie=O.add(te);B.set(ne,ie)},X=ne=>{const j=B.get(ne);!j||(j.dispose(),B.delete(ne))};z.connections.filter(T).forEach(V),h.Event.filter(z.onDidAddConnection,T)(V,void 0,q),z.onDidRemoveConnection(X,void 0,q),O.event(L.fire,L,q),q.add(O)},onLastListenerRemove:()=>{q.dispose()}});return L.event}registerChannel(_,T){this.channels.set(_,T),this._connections.forEach($=>{$.channelServer.registerChannel(_,T)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class F{constructor(_,T,$=null){const x=new g;o(x,T),_.send(x.buffer),this.channelClient=new M(_,$),this.channelServer=new l(_,T,$)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,T){this.channelServer.registerChannel(_,T)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(W){return{call(_,T,$){return W.then(x=>x.call(_,T,$))},listen(_,T){const $=new h.Relay;return W.then(x=>$.input=x.listen(_,T)),$.event}}}e.getDelayedChannel=U;function Q(W){let _=!1;return{call(T,$,x){return _?W.call(T,$,x):(0,t.timeout)(0).then(()=>_=!0).then(()=>W.call(T,$,x))},listen(T,$){if(_)return W.listen(T,$);const x=new h.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>x.input=W.listen(T,$)),x.event}}}e.getNextTickChannel=Q;class re{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const T of _.connections)if(await Promise.resolve(this.fn(T.ctx)))return Promise.resolve(T);return await h.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=re;var le;(function(W){function _(z,q){const L=z,O=q&&q.disableMarshalling,B=new Map;for(const V in L)$(V)&&B.set(V,h.Event.buffer(L[V],!0));return new class{listen(V,X,ne){const j=B.get(X);if(j)return j;if(x(X)){const te=L[X];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${X}`)}call(V,X,ne){const j=L[X];if(typeof j=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,I.revive)(ne[te]);return j.apply(L,ne)}throw new Error(`Method not found: ${X}`)}}}W.fromService=_;function T(z,q){const L=q&&q.disableMarshalling;return new Proxy({},{get(O,B){if(typeof B=="string")return q?.properties?.has(B)?q.properties.get(B):x(B)?function(V){return z.listen(B,V)}:$(B)?z.listen(B):async function(...V){let X;q&&!(0,S.isUndefinedOrNull)(q.context)?X=[q.context,...V]:X=V;const ne=await z.call(B,X);return L?ne:(0,I.revive)(ne)};throw new Error(`Property not found: ${String(B)}`)}})}W.toService=T;function $(z){return z[0]==="o"&&z[1]==="n"&&E.isUpperAsciiLetter(z.charCodeAt(2))}function x(z){return/^onDynamic/.test(z)&&E.isUpperAsciiLetter(z.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const _=W.toString();if(_!=="[object Object]")return _}return W}function ue(W){return Array.isArray(W)?W.map(se):se(W)}function K(W,_,T,$,x,z,q){q=ue(q);const L=fe[x],O=L[$%L.length];let B=[`%c[${W}]%c[${String(_).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String($).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(z)?(B=B.concat(q),B.push(")")):B.push(q),console.log.apply(console,B)}e.logWithColors=K;class N{constructor(_,T){this._outgoingPrefix=_,this._incomingPrefix=T,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,T,$,x,z){this._totalOutgoing+=_,K(this._outgoingPrefix,this._totalOutgoing,_,T,$,x,z)}logIncoming(_,T,$,x,z){this._totalIncoming+=_,K(this._incomingPrefix,this._totalIncoming,_,T,$,x,z)}}e.IPCLogger=N}),define(Z[145],ee([0,1,17,3,44]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(h){this.port=h,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",p=>v.VSBuffer.wrap(p.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(h,p){const I=new R(h);super(I,p);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(Z[98],ee([0,1,17,3,2,44]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(n){n.enableDiagnostics=!1,n.records=[];const o=new WeakMap;let a=0;function l(M,A){if(!o.has(M)){const F=String(++a);o.set(M,F)}return o.get(M)}function P(M,A,F,U){if(!n.enableDiagnostics)return;const Q=l(M,A);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=v.VSBuffer.alloc(U.byteLength);re.set(U),n.records.push({timestamp:Date.now(),id:Q,label:A,type:F,buff:re})}else n.records.push({timestamp:Date.now(),id:Q,label:A,type:F,data:U})}n.traceSocketEvent=P})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var h;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function I(){return p||(p=v.VSBuffer.alloc(0)),p}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}const l=v.VSBuffer.alloc(o);let P=0,M=0;for(;o>0;){const A=this._chunks[M];if(A.byteLength>o){const F=A.slice(0,o);l.set(F,P),P+=o,a&&(this._chunks[M]=A.slice(o),this._totalLength-=o),o-=o}else l.set(A,P),P+=A.byteLength,a?(this._chunks.shift(),this._totalLength-=A.byteLength):M++,o-=A.byteLength}return l}}e.ChunkStream=E;var S;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(S||(S={}));function f(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class C{constructor(o,a,l,P){this.type=o,this.id=a,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new C(l,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const l=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,l}_bufferTake(){const o=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class m extends k.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new C(1,0,0,o))}}e.Protocol=m;class g extends R.IPCClient{constructor(o,a,l=null){super(o,a,l);this.protocol=o}static fromSocket(o,a){return new g(new m(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let o=0,a=this._first;for(;a;)a=a.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,l=this._first;for(;l;)o[a++]=l.data,l=l.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new c(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<r._HISTORY_LENGTH;P++)o-this.lastRuns[P]<=a&&l++;return 1-l/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(o,a=null,l=r.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new C(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new C(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new C(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new C(3,0,this._incomingAckId,I());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new C(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let l=0,P=a.length;l<P;l++)this._socketWriter.write(a[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new C(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(o){const a=new C(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-a,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new C(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(Z[146],ee([0,1,40,17,3,2,44,131]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(I,E){const S=k.Event.fromNodeEventEmitter(v.validatedIpcMain,E,(d,C)=>({event:d,message:C})),f=k.Event.filter(S,({event:d})=>d.sender.id===I);return k.Event.map(f,({message:d})=>d&&t.VSBuffer.wrap(d))}class p extends D.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const E=k.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:S})=>S);return k.Event.map(E,S=>{const f=S.id;p.Clients.get(f)?.dispose();const C=new k.Emitter;p.Clients.set(f,(0,R.toDisposable)(()=>C.fire()));const b=h(f,"vscode:message"),w=k.Event.any(k.Event.signal(h(f,"vscode:disconnect")),C.event);return{protocol:new y.Protocol(S,b),onDidClientDisconnect:w}})}}e.Server=p,p.Clients=new Map}),define(Z[99],ee([0,1,40,3,28,145]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(p,I){super({addEventListener:(E,S)=>p.addListener(E,S),removeEventListener:(E,S)=>p.removeListener(E,S),postMessage:E=>p.postMessage(E),start:()=>p.start(),close:()=>p.close()},I)}}e.Client=D;async function y(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,k.generateUuid)();h.webContents.send("vscode:createMessageChannel",p);const I=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:E}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,S=>S.nonce===p)));return E}e.connect=y}),define(Z[147],ee([0,1,50,8,17,21,140,18,3,2,49,82,78,44]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends f.ChannelServer{constructor(w){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=d;class C{constructor(w,m){this.modulePath=w,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(w){const m=this;return{call(g,u,c){return m.requestPromise(w,g,u,c)},listen(g,u){return m.requestEvent(w,g,u)}}}requestPromise(w,m,g,u=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(w),s=(0,t.createCancelablePromise)(n=>c.call(m,g,n)),r=u.onCancellationRequested(()=>s.cancel()),i=(0,p.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(w,m,g){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let u;const c=new h.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(w).listen(m,g)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,S.removeDangerousEnvVariables)(m.env),this.child=(0,v.fork)(this.modulePath,w,m);const g=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,D.isRemoteConsoleLog)(o)){(0,D.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),r=g.event,i={send:s,onMessage:r};this._client=new f.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,p.dispose)(l)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(w){let m=this.channels.get(w);return m||(m=this.client.getChannel(w),this.channels.set(w,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[83],ee([0,1,17,18,3,2,9,4,28,44,98]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:H.__$__nodeRequire("crypto"),zlib:H.__$__nodeRequire("zlib"),net:H.__$__nodeRequire("net"),os:H.__$__nodeRequire("os")}}class S{constructor(l,P=""){this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(l,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(v.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{this.traceSocketEvent("close",{hadError:M}),l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=S;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class C extends R.Disposable{constructor(l,P,M,A){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new b(this,P,M,A,this._onData,(F,U)=>this._write(F,U))),this._register(this._flowManager.onError(F=>{console.error(F),(0,t.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const A=v.VSBuffer.alloc(M);if(P?A.writeUInt8(194,0):A.writeUInt8(130,0),l.byteLength<126)A.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){A.writeUInt8(126,1);let F=1;A.writeUInt8(l.byteLength>>>8&255,++F),A.writeUInt8(l.byteLength>>>0&255,++F)}else{A.writeUInt8(127,1);let F=1;A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(l.byteLength>>>24&255,++F),A.writeUInt8(l.byteLength>>>16&255,++F),A.writeUInt8(l.byteLength>>>8&255,++F),A.writeUInt8(l.byteLength>>>0&255,++F)}this.socket.write(v.VSBuffer.concat([A,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),A=(M&128)>>>7,F=(M&64)>>>6,U=P.readUInt8(1),Q=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),A=(M&128)>>>7;let F=M&127,U=1;F===126?F=P.readUInt8(++U)*2**8+P.readUInt8(++U):F===127&&(F=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let Q=0;A&&(Q=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=F,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),g(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class b extends R.Disposable{constructor(l,P,M,A,F,U){super();this._tracer=l,this._onData=F,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new w(this._tracer,A,M,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,A)=>{l.write(P),l.flush(F=>M(F))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((A,F)=>{l.write(P),M&&l.write(v.VSBuffer.fromByteArray([0,0,255,255])),l.flush(U=>A(U))})}}class w extends R.Disposable{constructor(l,P,M,A){super();this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E().zlib.createInflateRaw(A),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(v.VSBuffer.wrap(F))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class m extends R.Disposable{constructor(l,P){super();this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(v.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function g(a,l){if(l===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const le=a.readUInt32BE(re*4);a.writeUInt32BE(le^l,re*4)}const M=P*4,A=a.byteLength-M,F=l>>>24&255,U=l>>>16&255,Q=l>>>8&255;A>=1&&a.writeUInt8(a.readUInt8(M)^F,M),A>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),A>=3&&a.writeUInt8(a.readUInt8(M+2)^Q,M+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function c(){const a=(0,h.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)(E().os.tmpdir(),`vscode-ipc-${a}.sock`),r(l),l}e.createRandomIPCHandle=c;function s(a,l,P){const M=E().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):A=(0,D.join)(a,`${P}-${l}.sock`),r(A),A}e.createStaticIPCHandle=s;function r(a){const l=u[y.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends p.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new I.Protocol(new S(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(a){return new Promise((l,P)=>{const M=E().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),l(new i(M))})})}e.serve=n;function o(a,l){return new Promise((P,M)=>{const A=E().net.createConnection(a,()=>{A.removeListener("error",M),P(I.Client.fromSocket(new S(A,`ipc-client${l}`),l))});A.once("error",M)})}e.connect=o}),define(Z[100],ee([0,1,8,3,2,12]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function y(E){const S=E;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var h;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class p extends k.Disposable{constructor(S,f=Object.create(null)){super();this.database=S,this.options=f,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((f,d)=>this.accept(d,f)),S.deleted?.forEach(f=>this.accept(f,void 0))}accept(S,f){if(this.state===h.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(f)?d=this.cache.delete(S):this.cache.get(S)!==f&&(this.cache.set(S,f),d=!0),d&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,f){const d=this.cache.get(S);return(0,R.isUndefinedOrNull)(d)?f:d}getBoolean(S,f){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?f:d==="true"}getNumber(S,f){const d=this.get(S);return(0,R.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(S,f){if(this.state===h.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(S);const d=String(f);if(this.cache.get(S)!==d)return this.cache.set(S,d),this.pendingInserts.set(S,d),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===h.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((f,d)=>this.items.set(d,f)),S.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[148],ee([0,1,8,3,32,9,23]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(I,E=Object.create(null)){this.path=I,this.options=E,this.name=(0,R.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,E=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(f=>E.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(I){const E=await this.whenConnected;return this.doUpdateItems(E,I)}doUpdateItems(I,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,k.mapToString)(E.insert):"0"}), delete(${E.delete?(0,k.setToString)(E.delete):"0"})`),this.transaction(I,()=>{const S=E.insert,f=E.delete;if(S&&S.size>0){const d=[];d.push([]);let C=0;S.forEach((b,w)=>{let m=d[C];m.length>y.MAX_HOST_PARAMETERS&&(C++,m=[],d.push(m)),m.push(w,b)}),d.forEach(b=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,w=>w.run(b),()=>{const w=[];let m=0;return S.forEach((g,u)=>{w.push(u),m+=g.length}),`Keys: ${w.join(", ")} Length: ${m}`})})}if(f&&f.size){const d=[];d.push([]);let C=0;f.forEach(b=>{let w=d[C];w.length>y.MAX_HOST_PARAMETERS&&(C++,w=[],d.push(w)),w.push(b)}),d.forEach(b=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,w=>w.run(b),()=>{const w=[];return f.forEach(m=>{w.push(m)}),`Keys: ${w.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,I)}doClose(I,E){return new Promise((S,f)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===y.IN_MEMORY_PATH?S():!I.isErroneous&&!I.isInMemory?this.backup().then(S,C=>(this.logger.error(`[storage ${this.name}] backup(): ${C}`),S())):typeof E=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(C=>{const b=()=>this.doClose(C,void 0);return this.doUpdateItems(C,{insert:E()}).then(()=>b(),w=>(b(),Promise.reject(w)))})).then(S,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const E=await this.whenConnected,S=await this.get(E,I?"PRAGMA integrity_check":"PRAGMA quick_check"),f=I?S.integrity_check:S.quick_check;return E.isErroneous?`${f} (last error: ${E.lastError})`:E.isInMemory?`${f} (in-memory!)`:f}async connect(I,E=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${E})`);try{return await this.doConnect(I)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&E)return await(0,v.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(I,E){I.isErroneous=!0,I.lastError=E,this.logger.error(E)}doConnect(I){return new Promise((E,S)=>{new Promise((f,d)=>{H(["@vscode/sqlite3"],f,d)}).then(f=>{const d={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(I,C=>C?d.db&&C.code!=="SQLITE_CANTOPEN"?d.db.close(()=>S(C)):S(C):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(d),b=>d.db.close(()=>S(b)))),isInMemory:I===y.IN_MEMORY_PATH};d.db.on("error",C=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${C}`)),this.logger.isTracing&&d.db.on("trace",C=>this.logger.trace(`[storage ${this.name}] Trace (event): ${C}`))},S)})}exec(I,E){return new Promise((S,f)=>{I.db.exec(E,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),f(d)):S())})}get(I,E){return new Promise((S,f)=>{I.db.get(E,(d,C)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),f(d)):S(C))})}all(I,E){return new Promise((S,f)=>{I.db.all(E,(d,C)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),f(d)):S(C))})}transaction(I,E){return new Promise((S,f)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),E(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),f(d)):S())})})}prepare(I,E,S,f){const d=I.db.prepare(E),C=b=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${b} (${E}). Details: ${f()}`)};d.on("error",C),S(d),d.finalize(b=>{b&&C(b),d.removeListener("error",C)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class h{constructor(I){I&&typeof I.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[149],ee([11,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Z[150],ee([11,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[151],ee([11,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[152],ee([11,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Z[153],ee([11,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Z[154],ee([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[155],ee([11,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[156],ee([11,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[157],ee([11,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[158],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Z[159],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Z[160],ee([11,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Z[161],ee([11,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[162],ee([11,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[163],ee([11,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[164],ee([11,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[165],ee([11,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[166],ee([11,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Z[167],ee([11,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(Z[168],ee([11,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[169],ee([11,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[170],ee([11,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[171],ee([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[172],ee([11,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[173],ee([11,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(Z[174],ee([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[175],ee([11,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[176],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[177],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(Z[178],ee([0,1,3,2]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(y,h,p){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(y,h,p){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(y){super();this.channel=y}reload(y){this.channel.call("reload",[y])}get onReload(){return this.channel.listen("reload")}close(y){this.channel.call("close",[y])}get onClose(){return this.channel.listen("close")}attachSession(y,h,p){this.channel.call("attach",[y,h,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(y,h){this.channel.call("terminate",[y,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(y,h){return this.channel.call("openExtensionDevelopmentHostWindow",[y,h])}}e.ExtensionHostDebugChannelClient=R}),define(Z[179],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>H(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=v}),define(Z[180],ee([0,1,134,51,13,9,35,16,7]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(C,b,w){this._args=C,this.paths=b,this.productService=w,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",H).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const C=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",C)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(h.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const C=D.env.VSCODE_PORTABLE;return C?h.URI.file((0,R.join)(C,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const C=this.args["builtin-extensions-dir"];return C?(0,R.resolve)(C):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const C=this.args["extensions-download-dir"];return C?(0,R.resolve)(C):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const C=this.args["extensions-dir"];if(C)return(0,R.resolve)(C);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const w=D.env.VSCODE_PORTABLE;return w?(0,R.join)(w,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const C=this.args.extensionDevelopmentPath;if(Array.isArray(C))return C.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const C=this.args.extensionTestsPath;if(C)return/^[^:/?#]+?:\/\//.test(C)?h.URI.parse(C):h.URI.file((0,R.normalize)(C))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const C=this.args["disable-extension"];if(C){if(typeof C=="string")return[C];if(Array.isArray(C)&&C.length>0)return C}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,y.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return h.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const C=D.env.VSCODE_PORTABLE;return C?h.URI.file((0,R.join)(C,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],p.prototype,"appRoot",null),ve([t.memoize],p.prototype,"userHome",null),ve([t.memoize],p.prototype,"userDataPath",null),ve([t.memoize],p.prototype,"appSettingsHome",null),ve([t.memoize],p.prototype,"tmpDir",null),ve([t.memoize],p.prototype,"cacheHome",null),ve([t.memoize],p.prototype,"stateResource",null),ve([t.memoize],p.prototype,"userRoamingDataHome",null),ve([t.memoize],p.prototype,"userDataSyncHome",null),ve([t.memoize],p.prototype,"userDataSyncLogResource",null),ve([t.memoize],p.prototype,"editSessionsLogResource",null),ve([t.memoize],p.prototype,"sync",null),ve([t.memoize],p.prototype,"machineSettingsResource",null),ve([t.memoize],p.prototype,"workspaceStorageHome",null),ve([t.memoize],p.prototype,"localHistoryHome",null),ve([t.memoize],p.prototype,"keyboardLayoutResource",null),ve([t.memoize],p.prototype,"argvResource",null),ve([t.memoize],p.prototype,"isExtensionDevelopment",null),ve([t.memoize],p.prototype,"untitledWorkspacesHome",null),ve([t.memoize],p.prototype,"installSourcePath",null),ve([t.memoize],p.prototype,"builtinExtensionsPath",null),ve([t.memoize],p.prototype,"extensionsPath",null),ve([t.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],p.prototype,"extensionDevelopmentKind",null),ve([t.memoize],p.prototype,"extensionTestsLocationURI",null),ve([t.memoize],p.prototype,"debugExtensionHost",null),ve([t.memoize],p.prototype,"serviceMachineIdResource",null),ve([t.memoize],p.prototype,"telemetryLogResource",null),ve([t.memoize],p.prototype,"disableWorkspaceTrust",null),ve([t.memoize],p.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=p;function I(d,C){return f(d["inspect-extensions"],d["inspect-brk-extensions"],5870,C,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function E(d,C){return f(d["inspect-search"],d["inspect-brk-search"],5876,C,d.extensionEnvironment)}e.parseSearchPort=E;function S(d,C){return f(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,C,d.extensionEnvironment)}e.parsePtyHostPort=S;function f(d,C,b,w,m,g){const c=Number(C||d)||(w?null:b),s=c?Boolean(!!C):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:c,break:s,debugId:m,env:r}}}),define(Z[101],ee([0,1,269,4,152]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function y(d,C,b=D){const w={},m=["_"],g=[];for(const r in C){const i=C[r];i.alias&&(w[r]=i.alias),i.type==="string"||i.type==="string[]"?(m.push(r),i.deprecates&&m.push(...i.deprecates)):i.type==="boolean"&&(g.push(r),i.deprecates&&g.push(...i.deprecates))}const u=v(d,{string:m,boolean:g,alias:w}),c={},s=u;c._=u._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in C){const i=C[r];i.alias&&delete s[i.alias];let n=s[r];if(i.deprecates)for(const o of i.deprecates)s.hasOwnProperty(o)&&(n||(n=s[o],n&&b.onDeprecatedOption(o,i.deprecationMessage||(0,k.localize)(35,null,r))),delete s[o]);if(typeof n!="undefined"){if(i.type==="string[]"){if(Array.isArray(n)||(n=[n]),!i.allowEmptyValue){const o=n.filter(a=>a.length>0);o.length!==n.length&&(b.onEmptyValue(r),n=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(n)?(n=n.pop(),b.onMultipleValues(r,n)):!n&&!i.allowEmptyValue&&(b.onEmptyValue(r),n=void 0));c[r]=n,i.deprecationMessage&&b.onDeprecatedOption(r,i.deprecationMessage)}delete s[r]}for(const r in s)b.onUnknownOption(r);return c}e.parseArgs=y;function h(d,C){let b="";return C.args&&(Array.isArray(C.args)?b=` <${C.args.join("> <")}>`:b=` <${C.args}>`),C.alias?`-${C.alias} --${d}${b}`:`--${d}${b}`}function p(d,C){let b=0;const w=[];for(const c in d){const s=d[c],r=h(c,s);b=Math.max(b,r.length),w.push([r,s.description])}const m=b+2+1;if(C-m<25)return w.reduce((c,s)=>c.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const g=C-m-1,u=[];for(const c of w){const s=c[0],r=E(c[1],g),i=I(m-s.length-2);u.push("  "+s+i+r[0]);for(let n=1;n<r.length;n++)u.push(I(m)+r[n])}return u}e.formatOptions=p;function I(d){return" ".repeat(d)}function E(d,C){const b=[];for(;d.length;){const w=d.length<C?d.length:d.lastIndexOf(" ",C),m=d.slice(0,w).trim();d=d.slice(w),b.push(m)}return b}function S(d,C,b,w,m){const g=process.stdout.isTTY&&process.stdout.columns||80,u=m?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${b}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${C} [${(0,k.localize)(38,null)}]${u}`),c.push(""),m?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,C)):c.push((0,k.localize)(40,null,C)),c.push(""));const s={};for(const r in w){const i=w[r];if(i.description&&i.cat){let n=s[i.cat];n||(s[i.cat]=n={}),n[r]=i}}for(const r in s){const i=r,n=s[i];n&&(c.push(R[i]),c.push(...p(n,g)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=S;function f(d,C){return`${d||(0,k.localize)(41,null)}
${C||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=f}),define(Z[181],ee([0,1,77,178,101]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(y){super();this.windowsMainService=y}call(y,h,p){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1]):super.call(y,h,p)}async openExtensionDevelopmentHostWindow(y,h){const p=(0,k.parseArgs)(y,k.OPTIONS);p.debugRenderer=h;const I=p.extensionDevelopmentPath;if(!I)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:p});if(!h)return{success:!0};const S=E.win;if(!S)return{success:!0};const f=S.webContents.debugger;let d=f.isAttached()?1/0:0;const C=(0,v.createServer)(b=>{d++==0&&f.attach();let w=!1;const m=c=>{w||b.write(JSON.stringify(c)+"\0")},g=(c,s,r,i)=>m({method:s,params:r,sessionId:i});S.on("close",()=>{f.removeListener("message",g),b.end(),w=!0}),f.addListener("message",g);let u=Buffer.alloc(0);b.on("data",c=>{u=Buffer.concat([u,c]);for(let s=u.indexOf(0);s!==-1;s=u.indexOf(0)){let r;try{const i=u.slice(0,s).toString("utf8");u=u.slice(s+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(r.method,r.params,r.sessionId).then(i=>m({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>m({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",c=>{console.error("error on cdp pipe:",c)}),b.on("close",()=>{w=!0,--d==0&&f.detach()})});return await new Promise(b=>C.listen(0,b)),S.on("close",()=>C.close()),{rendererDebugPort:C.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[59],ee([0,1,270,153,101]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(S,f){const d={onUnknownOption:b=>{console.warn((0,t.localize)(0,null,b))},onMultipleValues:(b,w)=>{console.warn((0,t.localize)(1,null,b,w))},onEmptyValue:b=>{console.warn((0,t.localize)(2,null,b))},onDeprecatedOption:(b,w)=>{console.warn((0,t.localize)(3,null,b,w))}},C=(0,k.parseArgs)(S,k.OPTIONS,f?d:void 0);return C.goto&&C._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,t.localize)(4,null))),C["max-memory"]&&v(parseInt(C["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),C}function y(S){const f=S.findIndex(d=>!/^-/.test(d));if(f>-1)return[...S.slice(0,f),...S.slice(f+1)]}function h(S){let[,...f]=S;process.env.VSCODE_DEV&&(f=y(f)||[]);const d=!E(process.env);return D(f,d)}e.parseMainProcessArgv=h;function p(S){const[,,...f]=S;return D(f,!0)}e.parseCLIProcessArgv=p;function I(S,...f){const d=S.indexOf("--");return d===-1?S.push(...f):S.splice(d,0,...f),S}e.addArg=I;function E(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function H(e,v,t,k){function R(y){const h=D(y),p=[h];return e.isAbsolute(h)||p.unshift(k),e.resolve(...p)}function D(y){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,t);const I=y["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(E,"AppData","Roaming")}break;case"darwin":p=e.join(v.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[182],ee([0,271,30,13,16,35]),function(e,v,t,k,R,D){const y=R.dirname(k.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(R.joinPath(y,"package.json").fsPath);return H(v,t,h.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=H(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[183],ee([0,1,30,180,182]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(y,h){super(y,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(y)},h)}}e.NativeEnvironmentService=R}),define(Z[184],ee([0,1,29,30,31]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const y=(0,k.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(y,""),D&&console.log(`Marker file for --wait created: ${y}`),y}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=R}),define(Z[185],ee([0,1,16,94,156,186]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function h(w){return w=w.trim(),w==="*"||D.test(w)}e.isValidVersionStr=h;function p(w){if(!h(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=w.match(D);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=p;function I(w){if(!w)return null;const m=w.majorBase,g=w.majorMustEqual,u=w.minorBase;let c=w.minorMustEqual;const s=w.patchBase;let r=w.patchMustEqual;w.hasCaret&&(m===0||(c=!1),r=!1);let i=0;if(w.preRelease){const n=y.exec(w.preRelease);if(n){const[,o,a,l]=n;i=Date.UTC(Number(o),Number(a)-1,Number(l))}}return{majorBase:m,majorMustEqual:g,minorBase:u,minorMustEqual:c,patchBase:s,patchMustEqual:r,isMinimum:w.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function E(w,m,g){let u;typeof w=="string"?u=I(p(w)):u=w;let c;m instanceof Date?c=m.getTime():typeof m=="string"&&(c=new Date(m).getTime());let s;if(typeof g=="string"?s=I(p(g)):s=g,!u||!s)return!1;const r=u.majorBase,i=u.minorBase,n=u.patchBase;let o=s.majorBase,a=s.minorBase,l=s.patchBase;const P=s.notBefore;let M=s.majorMustEqual,A=s.minorMustEqual,F=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:i>a?!0:i<a||c&&c<P?!1:n>=l:(r===1&&o===0&&(!M||!A||!F)&&(o=1,a=0,l=0,M=!0,A=!1,F=!1),r<o?!1:r>o?!M:i<a?!1:i>a?!A:n<l?!1:n>l?!F:!(c&&c<P))}e.isValidVersion=E;function S(w,m,g,u,c){const s=[];if(typeof u.publisher!="undefined"&&typeof u.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof u.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof u.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!u.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof u.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof u.extensionDependencies!="undefined"&&!b(u.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof u.activationEvents!="undefined"){if(!b(u.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof u.main=="undefined"&&typeof u.browser=="undefined")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof u.extensionKind!="undefined"&&typeof u.main=="undefined"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof u.main!="undefined"){if(typeof u.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const n=(0,v.joinPath)(g,u.main);(0,v.isEqualOrParent)(n,g)||s.push([t.default.Warning,k.localize(10,null,n.path,g.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof u.browser!="undefined"){if(typeof u.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const n=(0,v.joinPath)(g,u.browser);(0,v.isEqualOrParent)(n,g)||s.push([t.default.Warning,k.localize(13,null,n.path,g.path)])}if(typeof u.activationEvents=="undefined")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!R.valid(u.version))return s.push([t.default.Error,k.localize(15,null)]),s;const r=[];if(!f(w,m,u,c,r))for(const n of r)s.push([t.default.Error,n]);return s}e.validateExtensionManifest=S;function f(w,m,g,u,c){return u||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:C(w,m,g.engines.vscode,c)}e.isValidExtensionVersion=f;function d(w,m,g){return w==="*"||C(m,g,w)}e.isEngineValid=d;function C(w,m,g,u=[]){const c=I(p(g));if(!c)return u.push(k.localize(16,null,g)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return u.push(k.localize(17,null,g)),!1}else if(!c.majorMustEqual)return u.push(k.localize(18,null,g)),!1;return E(w,m,c)?!0:(u.push(k.localize(19,null,w,g)),!1)}function b(w){if(!Array.isArray(w))return!1;for(let m=0,g=w.length;m<g;m++)if(typeof w[m]!="string")return!1;return!0}}),define(Z[187],ee([0,1,17,28]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,y){let h=y&&y.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();h=(0,t.isUUID)(I)?I:null}catch{h=null}if(!h){h=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(h))}catch{}}return y?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=k}),define(Z[68],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=v}),define(Z[188],ee([0,1,68]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(D,y,h){y instanceof v.SyncDescriptor||(y=new v.SyncDescriptor(y,[],h)),t.push([D,y])}e.registerSingleton=k;function R(){return t}e.getSingletonServiceDescriptors=R}),define(Z[189],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const y=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(D);y.outgoing.set(this._hashFn(D),h),h.incoming.set(this._hashFn(R),y)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const y of this._nodes.values())y.outgoing.delete(D),y.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let y=this._nodes.get(D);return y||(y=new v(R),this._nodes.set(D,y)),y}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,y]of this._nodes)R.push(`${D}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const y=new Set([R]),h=this._findCycle(D,y);if(h)return h}}_findCycle(R,D){for(const[y,h]of R.outgoing){if(D.has(y))return[...D,y].join(" -> ");D.add(y);const p=this._findCycle(h,D);if(p)return p;D.delete(y)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,y,h){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:D,index:h}):(y[v.DI_DEPENDENCIES]=[{id:D,index:h}],y[v.DI_TARGET]=y)}function k(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const y=function(h,p,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(y,h,I)};return y.toString=()=>D,v.serviceIds.set(D,y),y}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(Z[60],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(w){return w&&typeof w=="object"&&(!w.overrideIdentifier||typeof w.overrideIdentifier=="string")&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(w){return w&&typeof w=="object"&&(!w.overrideIdentifiers||Array.isArray(w.overrideIdentifiers))&&!w.overrideIdentifier&&(!w.resource||w.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.USER=2]="USER",w[w.USER_LOCAL=3]="USER_LOCAL",w[w.USER_REMOTE=4]="USER_REMOTE",w[w.WORKSPACE=5]="WORKSPACE",w[w.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",w[w.DEFAULT=7]="DEFAULT",w[w.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(w){switch(w){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function p(w,m){const g=Object.create(null);for(const u in w)I(g,u,w[u],m);return g}e.toValuesTree=p;function I(w,m,g,u){const c=m.split("."),s=c.pop();let r=w;for(let i=0;i<c.length;i++){const n=c[i];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${m} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=g}catch{u(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function E(w,m){const g=m.split(".");S(w,g)}e.removeFromValueTree=E;function S(w,m){const g=m.shift();if(m.length===0){delete w[g];return}if(Object.keys(w).indexOf(g)!==-1){const u=w[g];typeof u=="object"&&!Array.isArray(u)&&(S(u,m),Object.keys(u).length===0&&delete w[g])}}function f(w,m,g){function u(r,i){let n=r;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const c=m.split("."),s=u(w,c);return typeof s=="undefined"?g:s}e.getConfigurationValue=f;function d(w,m,g){Object.keys(m).forEach(u=>{u!=="__proto__"&&(u in w?v.isObject(w[u])&&v.isObject(m[u])?d(w[u],m[u],g):g&&(w[u]=m[u]):w[u]=m[u])})}e.merge=d;function C(w,m,g){const u=w.inspect(m),c=w.inspect(g);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=C;function b(w){return w.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Z[69],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,y){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=y}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const y of Object.keys(this.secretVault[R]||{}))D.push({account:y,password:this.secretVault[R][y]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[84],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(Z[102],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(Z[37],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[25],ee([0,1,51,9,83,37,183,5]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,y.refineServiceDecorator)(R.IEnvironmentService);class h extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([v.memoize],h.prototype,"cachedLanguagesPath",null),ve([v.memoize],h.prototype,"backupHome",null),ve([v.memoize],h.prototype,"backupWorkspacesPath",null),ve([v.memoize],h.prototype,"mainIPCHandle",null),ve([v.memoize],h.prototype,"mainLockfile",null),ve([v.memoize],h.prototype,"disableUpdates",null),ve([v.memoize],h.prototype,"disableKeytar",null),ve([v.memoize],h.prototype,"codeCachePath",null),ve([v.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Z[190],ee([0,1,154,5]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(w){switch(w){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(w){switch(w){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(w,m){switch(w){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function y(w,m){return m==="web"&&!w.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function h(w,m,g){return y(m,g)?!1:w==="undefined"||w==="universal"?!0:w==="unknown"?!1:w===g?!0:p(g).includes(w)}e.isTargetPlatformCompatible=h;function p(w){switch(w){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function I(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=I;var E;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=10]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var S;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var f;(function(w){w.Install="install",w.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var d;(function(w){w[w.None=1]="None",w[w.Install=2]="Install",w[w.Update=3]="Update",w[w.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var C;(function(w){w.Unsupported="Unsupported",w.Deprecated="Deprecated",w.Malicious="Malicious",w.Incompatible="Incompatible",w.IncompatiblePreRelease="IncompatiblePreRelease",w.IncompatibleTargetPlatform="IncompatibleTargetPlatform",w.ReleaseVersionNotFound="ReleaseVersionNotFound",w.Invalid="Invalid",w.Download="Download",w.Extract="Extract",w.Delete="Delete",w.Rename="Rename",w.CorruptZip="CorruptZip",w.IncompleteZip="IncompleteZip",w.Internal="Internal"})(C=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(m,g){super(m);this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(Z[191],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[192],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[103],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[193],ee([0,1,50,13,9,4,78,23,82,157,103]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=p.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await C.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{openTerminal(u,c){return this.spawnTerminal(v,u,h.getWindowsShell(),c)}spawnTerminal(u,c,s,r){const i=c.windowsExec||f.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=k.basename(i).toLowerCase();if(n==="cmder"||n==="cmder.exe")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((a,l)=>{const P=b(process),M=u.spawn(s,o,{cwd:r,env:P});M.on("error",l),M.on("exit",()=>a())})}runInTerminal(u,c,s,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,a)=>{const l=`"${c} - ${E}"`,P=`""${s.join('" "')}" & pause"`,M=["/c","start",l,"/wait",n,"/c",P],A=Object.assign({},b(process),r);Object.keys(A).filter(Q=>A[Q]===null).forEach(Q=>delete A[Q]);const F={cwd:c,env:A,windowsVerbatimArguments:!0};v.spawn(f.CMD,M,F).on("error",Q=>{a(w(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class d extends S{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,s,r,i){const n=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(n===I.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,H).fsPath,"-t",u||E,"-w",c];for(const U of s)M.push("-a"),M.push(U);if(r){const U=Object.assign({},b(process),r);for(const Q in U){const re=U[Q];re===null?(M.push("-u"),M.push(Q)):(M.push("-e"),M.push(`${Q}=${re}`))}}let A="";const F=v.spawn(d.OSASCRIPT,M);F.on("error",U=>{a(w(U))}),F.stderr.on("data",U=>{A+=U.toString()}),F.on("exit",U=>{if(U===0)o(void 0);else if(A){const Q=A.split(`
`,1);a(new Error(Q[0]))}else a(new Error(p.localize(1,null,l,U)))})}else a(new Error(p.localize(2,null,n)))})}spawnTerminal(u,c,s){const r=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",r];s&&o.push(s);const a=b(process),l=u.spawn("/usr/bin/open",o,{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class C extends S{openTerminal(u,c){return this.spawnTerminal(v,u,c)}runInTerminal(u,c,s,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):C.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const l=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${m(s)}; echo; read -p "${C.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const A=Object.assign({},b(process),r);Object.keys(A).filter(re=>A[re]===null).forEach(re=>delete A[re]);const F={cwd:c,env:A};let U="";const Q=v.spawn(P,l,F);Q.on("error",re=>{a(w(re))}),Q.stderr.on("data",re=>{U+=re.toString()}),Q.on("exit",re=>{if(re===0)o(void 0);else if(U){const le=U.split(`
`,1);a(new Error(le[0]))}else a(new Error(p.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!C._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)C._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await y.Promises.exists("/etc/debian_version");C._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return C._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,s){const r=c.linuxExec?Promise.resolve(c.linuxExec):C.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(o=>{const a=b(process),l=u.spawn(o,[],{cwd:s,env:a});l.on("error",n),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=C,C.WAIT_MESSAGE=p.localize(3,null);function b(g){const u={...g.env};return(0,D.sanitizeProcessEnvironment)(u),u}function w(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(p.localize(5,null,g.path)):g}function m(g){let u="";for(const c of g)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(Z[14],ee([0,1,32,9,27,12,7,159,5]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function p(N){return N.create===!0}e.isFileOpenForWriteOptions=p;var I;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(N){N[N.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var S;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=f;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function C(N){return!!(N.capabilities&32768)}e.hasFileCloneCapability=C;function b(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function w(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=w;function m(N){return!!(N.capabilities&2048)}e.hasFileReadCapability=m;function g(N){return f(N)?!!(N.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var u;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(W,_){super(W);this.code=_}}e.FileSystemProviderError=c;function s(N,W){const _=new c(N.toString(),W);return i(_,W),_}e.createFileSystemProviderError=s;function r(N){return N||s((0,y.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=r;function i(N,W){return N.name=W?`${W} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=i;function n(N){if(!N)return u.Unknown;if(N instanceof c)return N.code;const W=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!W)return u.Unknown;switch(W[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=n;function o(N){if(N instanceof F)return N.fileOperationResult;switch(n(N)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(W,_,T){this.resource=W,this.operation=_,this.target=T}isOperation(W){return this.operation===W}}e.FileOperationEvent=l;var P;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(P=e.FileChangeType||(e.FileChangeType={}));class M{constructor(W,_){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const T=new Map;for(const $ of W){const x=T.get($.type);switch(x?x.push([$.resource,$]):T.set($.type,[[$.resource,$]]),$.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}}for(const[$,x]of T)switch($){case 1:this.added=v.TernarySearchTree.forUris(()=>_),this.added.fill(x);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>_),this.updated.fill(x);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>_),this.deleted.fill(x);break}}contains(W,..._){return this.doContains(W,{includeChildren:!1},..._)}affects(W,..._){return this.doContains(W,{includeChildren:!0},..._)}doContains(W,_,...T){if(!W)return!1;const $=T.length>0;return!!((!$||T.includes(1))&&(this.added?.get(W)||_.includeChildren&&this.added?.findSuperstr(W))||(!$||T.includes(0))&&(this.updated?.get(W)||_.includeChildren&&this.updated?.findSuperstr(W))||(!$||T.includes(2))&&(this.deleted?.findSubstr(W)||_.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=M;function A(N,W,_){return!N||!W||N===W||W.length>N.length?!1:(W.charAt(W.length-1)!==t.sep&&(W+=t.sep),_?(0,k.startsWithIgnoreCase)(N,W):N.indexOf(W)===0)}e.isParent=A;class F extends Error{constructor(W,_,T){super(W);this.fileOperationResult=_,this.options=T}}e.FileOperationError=F;class U extends F{constructor(W,_,T){super(W,2,T);this.stat=_}}e.NotModifiedSinceFileOperationError=U;var Q;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function le(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=le;async function fe(N,W){if(!W.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(_=>{const T=W.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===N.scheme&&$.added&&(T.dispose(),_())})})}e.whenProviderRegistered=fe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(W){return(0,R.isNumber)(W)||(W=0),W<se.KB?(0,y.localize)(1,null,W.toFixed(0)):W<se.MB?(0,y.localize)(2,null,(W/se.KB).toFixed(2)):W<se.GB?(0,y.localize)(3,null,(W/se.MB).toFixed(2)):W<se.TB?(0,y.localize)(4,null,(W/se.GB).toFixed(2)):(0,y.localize)(5,null,(W/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var ue;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ue=e.Arch||(e.Arch={}));function K(N){return{maxFileSize:N===0?300*se.MB:16*se.GB,maxHeapSize:N===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=K}),define(Z[194],ee([0,1,17,43,18,3,2,57,7,28,14]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends D.Disposable{constructor(f,d){super();this.channel=f,this.extraCapabilities=d,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,p.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,d){const{buffer:C}=await this.channel.call("readFile",[f,d]);return C}readFileStream(f,d,C){const b=(0,y.newWriteableStream)(m=>v.VSBuffer.concat(m.map(g=>v.VSBuffer.wrap(g))).buffer),w=this.channel.listen("readFileStream",[f,d])(m=>{if(m instanceof v.VSBuffer)b.write(m.buffer);else{if(m==="end")b.end();else{let g=m;g instanceof Error||(g=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(g),I.FileSystemProviderErrorCode.Unknown)),b.error(g),b.end()}w.dispose()}});return C.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),w.dispose()}),b}writeFile(f,d,C){return this.channel.call("writeFile",[f,v.VSBuffer.wrap(d),C])}open(f,d){return this.channel.call("open",[f,d])}close(f){return this.channel.call("close",[f])}async read(f,d,C,b,w){const[m,g]=await this.channel.call("read",[f,d,w]);return C.set(m.buffer.slice(0,g),b),g}write(f,d,C,b,w){return this.channel.call("write",[f,d,v.VSBuffer.wrap(C),b,w])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,d){return this.channel.call("delete",[f,d])}rename(f,d,C){return this.channel.call("rename",[f,d,C])}copy(f,d,C){return this.channel.call("copy",[f,d,C])}cloneFile(f,d){return this.channel.call("cloneFile",[f,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const d=f;this._onDidChange.fire(d.map(C=>({resource:h.URI.revive(C.resource),type:C.type})))}else{const d=f;this._onDidWatchError.fire(d)}}))}watch(f,d){const C=(0,p.generateUuid)();return this.channel.call("watch",[this.sessionId,C,f,d]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,C]))}}e.DiskFileSystemProviderClient=E}),define(Z[104],ee([0,1,17,18,160,14]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,E,S,f,d,C){let b;try{await y(I,E,S,f,d,C)}catch(w){b=w}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b!="undefined"&&S.error(b),S.end()}}e.readFileIntoStream=D;async function y(I,E,S,f,d,C){h(C);const b=await I.open(E,{create:!1});try{h(C);let w=0,m=0,g=d&&typeof d.length=="number"?d.length:void 0,u=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,s=0;do m=await I.read(b,c,u.buffer,s,u.byteLength-s),c+=m,s+=m,w+=m,typeof g=="number"&&(g-=m),s===u.byteLength&&(await S.write(f(u)),u=v.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),s=0);while(m>0&&(typeof g!="number"||g>0)&&h(C)&&p(w,d));if(s>0){let r=s;typeof g=="number"&&(r=Math.min(s,g)),S.write(f(u.slice(0,r)))}}catch(w){throw(0,R.ensureFileSystemProviderError)(w)}finally{await I.close(b)}}function h(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function p(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[70],ee([0,1,95,2,9,4,7,14]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(w){return w.recursive===!0}e.isRecursiveWatchRequest=h;class p extends t.Disposable{constructor(m,g,u,c){super();this.onFileChanges=m,this.onLogMessage=g,this.verboseLogging=u,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),m.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),m.add(this.watcher.onDidError(g=>this.onError(g)))}onError(m){this.options.restartOnError?this.restartCounter<p.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=p,p.MAX_RESTARTS=5;class I extends p{constructor(m,g,u){super(m,g,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class E extends p{constructor(m,g,u){super(m,g,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function S(w){return w.map(m=>({type:m.type,resource:D.URI.file(m.path)}))}e.toFileChanges=S;function f(w){const m=new b;for(const g of w)m.processEvent(g);return m.coalesce()}e.coalesceEvents=f;function d(w,m){return typeof m=="string"&&!m.startsWith(v.GLOBSTAR)&&!(0,k.isAbsolute)(m)?{base:w,pattern:m}:m}e.normalizeWatcherPattern=d;function C(w,m){const g=[];for(const u of m)g.push((0,v.parse)(d(w,u)));return g}e.parseWatcherPatterns=C;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return R.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const g=this.mapPathToChange.get(this.toKey(m));let u=!1;if(g){const c=g.type,s=m.type;g.path!==m.path&&(m.type===2||m.type===1)?u=!0:c===1&&s===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(g)):c===2&&s===1?g.type=0:c===1&&s===0||(g.type=s)}else u=!0;u&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],g=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(m.push(u),!1):!0).sort((u,c)=>u.path.length-c.path.length).filter(u=>g.some(c=>(0,y.isParent)(u.path,c,!R.isLinux))?!1:(g.push(u.path),!0)).concat(m)}}}),define(Z[195],ee([0,1,29,8,21,31,2,80,9,4,96,23,70]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends D.Disposable{constructor(b,w,m,g){super();this.request=b,this.onDidFilesChange=w,this.onLogMessage=m,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await E.Promises.stat(b);this._register(await this.doWatch(b,w.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let w=b.path;try{w=await E.Promises.realpath(b.path),b.path===w&&(w=await(0,I.realcase)(b.path)??b.path),b.path!==w&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${w})`)}catch{}return w}async doWatch(b,w){if(p.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const m=new k.CancellationTokenSource(this.cts.token),g=new D.DisposableStore;try{const u=(0,h.basename)(b),c=(0,v.watch)(b);g.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${b}'`);const s=new Set;if(w)try{for(const i of await E.Promises.readdir(b))s.add(i)}catch(i){this.error(i)}const r=new Map;g.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,n)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),c.on("change",(i,n)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),p.isMacintosh&&(o=(0,y.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(w)if(i==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===u&&!await E.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,h.join)(b,o));if(m.token.isCancellationRequested)return;let P;l?s.has(o)?P=0:(P=1,s.add(o)):(s.delete(o),P=2),this.onFileChange({path:(0,h.join)(this.request.path,o),type:P})},f.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;s.has(o)?a=0:(a=1,s.add(o)),this.onFileChange({path:(0,h.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==u){const a=setTimeout(async()=>{const l=await E.Promises.exists(b);m.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await E.Promises.exists(b)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${u.toString()})`)}return(0,D.toDisposable)(()=>{m.dispose(!0),g.dispose()})}async onFileChange(b,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!w&&this.excludes.some(m=>m(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!w&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,S.coalesceEvents)(m);if(g.length>0){if(this.verboseLogging)for(const c of g)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(p.isLinux)return E.Promises.exists(b);try{const w=(0,h.basename)(b);return(await E.Promises.readdir((0,h.dirname)(b))).some(g=>g===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function d(C,b,w,m,g=512){const u=await E.Promises.open(C,"r"),c=Buffer.allocUnsafe(g),s=new k.CancellationTokenSource(m);let r,i=!1;const n={path:C,excludes:[],recursive:!1},o=new f(n,a=>{(async()=>{for(const{type:l}of a)if(l===0){if(i)return;i=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:P}=await E.Promises.read(u,c,0,g,null);if(!P||s.token.isCancellationRequested)break;b(c.slice(0,P))}}catch(P){r=new Error(P),s.dispose(!0)}finally{i=!1}}})()});return await o.ready,w(),new Promise((a,l)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await E.Promises.close(u)}catch(P){r=new Error(P)}r?l(r):a()})})}e.watchFileContents=d}),define(Z[196],ee([0,1,3,95,2,4,195]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const I=this.normalizeRequests(p),E=I.filter(f=>{const d=this.watchers.get(f.path);return d?!(0,t.patternsEquals)(d.request.excludes,f.excludes)||!(0,t.patternsEquals)(d.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!I.find(d=>d.path===f.path&&(0,t.patternsEquals)(d.excludes,f.excludes)&&(0,t.patternsEquals)(d.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.trace(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of E)this.startWatching(f)}startWatching(p){const I=new D.NodeJSFileWatcherLibrary(p,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),E={request:p,instance:I};this.watchers.set(p.path,E)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const I=this.watchers.get(p);I&&(this.watchers.delete(p),I.instance.dispose())}normalizeRequests(p){const I=new Map;for(const E of p){const S=R.isLinux?E.path:E.path.toLowerCase();I.set(S,E)}return Array.from(I.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,I]of this.watchers)I.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,I){return I?`[File Watcher (node.js)] ${p} (path: ${I.request.path})`:`[File Watcher (node.js)] ${p}`}}e.NodeJSWatcher=y}),define(Z[197],ee([0,1,70,196]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends v.AbstractNonRecursiveWatcherClient{constructor(D,y,h){super(D,y,h);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[198],ee([0,1,13,44,147,70]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(h,p,I){super(h,p,I);this.init()}createWatcher(h){const p=h.add(new k.Client(v.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(p.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(p.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Z[85],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[199],ee([0,1,8,18,68,189,5,85]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class p extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new y.ServiceCollection,C=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=C,this._parent=b,this._services.set(D.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...C){const b=S.traceInvocation(d);let w=!1;try{return d({get:g=>{if(w)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(g,b);if(!u)throw new Error(`[invokeFunction] unknown service '${g}'`);return u}},...C)}finally{w=!0,b.stop()}}createInstance(d,...C){let b,w;return d instanceof k.SyncDescriptor?(b=S.traceCreation(d.ctor),w=this._createInstance(d.ctor,d.staticArguments.concat(C),b)):(b=S.traceCreation(d),w=this._createInstance(d,C,b)),b.stop(),w}_createInstance(d,C=[],b){const w=D._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),m=[];for(const u of w){const c=this._getOrCreateServiceInstance(u.id,b);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),m.push(c)}const g=w.length>0?w[0].index:C.length;if(C.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${C.length} static arguments`);const u=g-C.length;u>0?C=C.concat(new Array(u)):C=C.slice(0,g)}return new d(...[...C,...m])}_setServiceInstance(d,C){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,C);else if(this._parent)this._parent._setServiceInstance(d,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const C=this._services.get(d);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):C}_getOrCreateServiceInstance(d,C){const b=this._getServiceInstanceOrDescriptor(d);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,C.branch(d,!0)):(C.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,C,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,C,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,C,b){const w=new R.Graph(u=>u.id.toString());let m=0;const g=[{id:d,desc:C,_trace:b}];for(;g.length;){const u=g.pop();if(w.lookupOrInsertNode(u),m++>1e3)throw new p(w);for(const c of D._util.getServiceDependencies(u.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(c.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:c.id,desc:s,_trace:u._trace.branch(c.id,!0)};w.insertEdge(u,r),g.push(r)}}}for(;;){const u=w.roots();if(u.length===0){if(!w.isEmpty())throw new p(w);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,C,b=[],w,m){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(C,b,w,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,C,b,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(d,C=[],b,w){if(b){const m=new v.IdleValue(()=>this._createInstance(d,C,w));return new Proxy(Object.create(null),{get(g,u){if(u in g)return g[u];const c=m.value;let s=c[u];return typeof s!="function"||(s=s.bind(c),g[u]=s),s},set(g,u,c){return m.value[u]=c,!0}})}else return this._createInstance(d,C,w)}_throwIfStrict(d,C){if(C&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=I;var E;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(E||(E={}));class S{constructor(d,C){this.type=d,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return h?new S(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(d){return h?new S(0,d.name):S._None}branch(d,C){const b=new S(2,d.toString());return this._dep.push([d,C,b]),b}stop(){const d=Date.now()-this._start;S._totals+=d;let C=!1;function b(m,g){const u=[],c=new Array(m+1).join("	");for(const[s,r,i]of g._dep)if(r&&i){C=!0,u.push(`${c}CREATES -> ${s}`);const n=b(m+1,i);n&&u.push(n)}else u.push(`${c}uses -> ${s}`);return u.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(d>2||C)&&console.log(w.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Z[6],ee([0,1,43,3,2,4,5]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function y(){return new Date().toISOString()}var h;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function p(r,i,n){switch(i){case h.Trace:r.trace(n);break;case h.Debug:r.debug(n);break;case h.Info:r.info(n);break;case h.Warning:r.warn(n);break;case h.Error:r.error(n);break;case h.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}e.log=p;function I(r){let i="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=I;class E extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class S extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,I([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,I([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,I([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,I([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(h.Error,I(o))}else this.log(h.Error,I([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,I([i,...n]))}flush(){}}e.AbstractMessageLogger=S;class f extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,i,...n):console.log(`[main ${y()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,i,...n):console.warn(`[main ${y()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,i,...n):console.error(`[main ${y()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class d extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class C extends E{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class b extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=b;class w extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=w;class m extends k.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=g;function u(r){if(r.verbose)return h.Trace;if(typeof r.logLevel=="string"){const i=c(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(r){switch(r){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function s(r){switch(r){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=s});var J=this&&this.__param||function(H,e){return function(v,t){e(v,t,H)}};define(Z[200],ee([0,1,69,3,2,6,4]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class St extends k.Disposable{constructor(p){super();this.logService=p,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(p,I){let E;try{E=await this.withKeytar()}catch{return null}const S=await E.getPassword(p,I);if(S)try{let{content:f,hasNextChunk:d}=JSON.parse(S);if(!f||!d)return S;let C=1;for(;d;){const b=await E.getPassword(p,`${I}-${C}`),w=JSON.parse(b);f+=w.content,d=w.hasNextChunk,C++}return f}catch{return S}return S}async setPassword(p,I,E){let S;try{S=await this.withKeytar()}catch(C){throw this.surfaceKeytarLoadError?.(C),C}const f=3,d=async(C,b,w)=>{let m=0,g;for(;m<f;)try{await S.setPassword(C,b,w);return}catch(u){g=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),m++,await new Promise(c=>setTimeout(c,200))}throw g};if(D.isWindows&&E.length>St.MAX_PASSWORD_LENGTH){let C=0,b=0,w=!0;for(;w;){const m=E.substring(C,C+St.PASSWORD_CHUNK_SIZE);C+=St.PASSWORD_CHUNK_SIZE,w=E.length-C>0;const g={content:m,hasNextChunk:w};await d(p,b?`${I}-${b}`:I,JSON.stringify(g)),b++}}else await d(p,I,E);this._onDidChangePassword.fire({service:p,account:I})}async deletePassword(p,I){let E;try{E=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const S=await E.getPassword(p,I);if(!S)return!1;const f=await E.deletePassword(p,I);try{let{content:d,hasNextChunk:C}=JSON.parse(S);if(d&&C){let b=1;for(;C;){const w=`${I}-${b}`,m=await E.getPassword(p,w);await E.deletePassword(p,w),C=JSON.parse(m).hasNextChunk,b++}}}catch{}return f&&this._onDidChangePassword.fire({service:p,account:I}),f}async findPassword(p){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(p)}async findCredentials(p){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(p)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};y.MAX_PASSWORD_LENGTH=2500,y.PASSWORD_CHUNK_SIZE=y.MAX_PASSWORD_LENGTH-100,y=ve([J(0,R.ILogService)],y),e.BaseCredentialsMainService=y}),define(Z[201],ee([0,1,24,8,18,3,2,9,70,6]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(S,f){super();this.logService=S,this.options=f,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const d={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},C=(0,v.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{C(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,h.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const d={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},C=(0,v.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{C(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,k.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,y.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[202],ee([0,1,24,8,17,21,3,67,56,2,32,13,71,16,57,158,14,104,6]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends p.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,s){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${c}`);const r=new p.DisposableStore;return this.provider.set(c,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:s}),r.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new b.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:c}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:s}),this.provider.delete(c),(0,p.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){s.push(r)}}),!this.provider.has(c)&&await t.Promises.settled(s)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,s){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return h.Iterable.map(this.provider,([c,s])=>({scheme:c,capabilities:s.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new b.FileOperationError((0,C.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const s=this.provider.get(c.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,C.localize)(1,null,c.toString()),r}return s}async withReadProvider(c){const s=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s)||(0,b.hasFileReadStreamCapability)(s)||(0,b.hasFileReadCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream, FileOpenReadWriteClose nor Readonly capability which is needed for the read operation.`)}async withWriteProvider(c){const s=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,s){try{return await this.doResolveFile(c,s)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,C.localize)(2,null,this.resourceForError(c)),1):(0,b.ensureFileSystemProviderError)(r)}}async doResolveFile(c,s){const r=await this.withProvider(c),i=this.isPathCaseSensitive(r),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await r.stat(c);let P;return this.toFileStat(r,c,l,void 0,!!a,(M,A)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(c,!0),n&&P.fill(!0,n)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&o?A===1:!1))}async toFileStat(c,s,r,i,n,o){const{providerExtUri:a}=this.getExtUri(c),l={resource:s,name:a.basename(s),isFile:(r.type&b.FileType.File)!=0,isDirectory:(r.type&b.FileType.Directory)!=0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(l.isDirectory&&o(l,i)){try{const P=await c.readdir(s),M=await t.Promises.settled(P.map(async([A,F])=>{try{const U=a.joinPath(s,A),Q=n?await c.stat(U):{type:F};return await this.toFileStat(c,U,Q,P.length,n,o)}catch(U){return this.logService.trace(U),null}}));l.children=(0,v.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const s=await this.withProvider(c),r=await s.stat(c);return this.toFileStat(s,c,r,void 0,!0,()=>!1)}async exists(c){const s=await this.withProvider(c);try{return!!await s.stat(c)}catch{return!1}}async canCreateFile(c,s){try{await this.doValidateCreateFile(c,s)}catch(r){return r}return!0}async doValidateCreateFile(c,s){if(!s?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,C.localize)(3,null,this.resourceForError(c)),3,s)}async createFile(c,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const i=await this.writeFile(c,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,i)),i}async writeFile(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,c,r)||await this.mkdirp(i,n.dirname(c));let a;if((0,b.hasReadWriteCapability)(i)&&!(s instanceof k.VSBuffer))if((0,d.isReadableStream)(s)){const l=await(0,d.peekStream)(s,3);l.ended?a=k.VSBuffer.concat(l.buffer):a=l}else a=(0,d.peekReadable)(s,l=>k.VSBuffer.concat(l),3);else a=s;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,r,a):await this.doWriteBuffered(i,c,r,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new b.FileOperationEvent(c,4))}catch(o){throw new b.FileOperationError((0,C.localize)(4,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,s,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,C.localize)(5,null,this.resourceForError(s)));let n;try{n=await c.stat(s)}catch{return}if((n.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,C.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:n.size}))throw new b.FileOperationError((0,C.localize)(7,null),3,r);return n}async readFile(c,s,r){const i=await this.withReadProvider(c);return s?.atomic?this.doReadFileAtomic(i,c,s,r):this.doReadFile(i,c,s,r)}async doReadFileAtomic(c,s,r,i){return new Promise((n,o)=>{this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,s,r,i);n(a)}catch(a){o(a)}})})}async doReadFile(c,s,r,i){const n=await this.doReadFileStream(c,s,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,k.streamToBuffer)(n.value)}}async readFileStream(c,s,r){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,s,r)}async doReadFileStream(c,s,r,i){const n=new R.CancellationTokenSource(i),o=this.validateReadFile(s,r).then(l=>l,l=>{throw n.cancel(),l});let a;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await o,r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&r?.preferUnbuffered?a=this.readFileUnbuffered(c,s,r):(0,b.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,s,n.token,r):a=this.readFileBuffered(c,s,n.token,r),{...await o,value:a}}catch(l){a&&await(0,d.consumeStream)(a);const P=(0,C.localize)(8,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(l).toString());throw l instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(P,l.stat,r):new b.FileOperationError(P,(0,b.toFileOperationResult)(l),r)}}readFileStreamed(c,s,r,i=Object.create(null)){const n=c.readFileStream(s,i,r);return(0,d.transform)(n,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new b.FileOperationError((0,C.localize)(9,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,s,r,i=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,w.readFileIntoStream)(c,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError((0,C.localize)(10,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),i)},r),n}readFileUnbuffered(c,s,r){const i=(0,d.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?n=await c.readFile(s,{atomic:!0}):n=await c.readFile(s),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(s,n.byteLength,r),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(c,s){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,C.localize)(11,null,this.resourceForError(c)),0,s);if(typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,C.localize)(12,null),r,s);return this.validateReadFileLimits(c,r.size,s),r}validateReadFileLimits(c,s,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&s>r.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,C.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,s,r){return this.doCanMoveCopy(c,s,"move",r)}async canCopy(c,s,r){return this.doCanMoveCopy(c,s,"copy",r)}async doCanMoveCopy(c,s,r,i){if(c.toString()!==s.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,c,o,s,r,i)}catch(n){return n}return!0}async move(c,s,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"move",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="move"?2:3,a)),a}async copy(c,s,r){const i=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,c,n,s,"copy",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="copy"?3:2,a)),a}async doMoveCopy(c,s,r,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,s,r,i,n,o);if(a&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(c===r&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(s,i,{overwrite:o});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(c,P,r,i):await this.doCopyFile(c,s,r,i)}return n}else return c===r?(await c.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(c,s,r,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(c,s,r,i){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,s,r,i);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,s,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,s,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,s,r,i)}async doCopyFolder(c,s,r,i){await r.mkdir(i),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,o):this.doCopyFile(c,n.resource,r,o)}))}async doValidateMoveCopy(c,s,r,i,n,o){let a=!1;if(c===r){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(s,i)),a&&n==="copy")throw new Error((0,C.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,s))throw new Error((0,C.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new b.FileOperationError((0,C.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(c===r){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(s,i))throw new Error((0,C.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const s=this.isPathCaseSensitive(c);return{providerExtUri:s?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(s,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,r)),r}async mkdirp(c,s){const r=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(s,i.dirname(s));)try{if(((await c.stat(s)).type&b.FileType.Directory)==0)throw new Error((0,C.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(s)),s=i.dirname(s)}for(let n=r.length-1;n>=0;n--){s=i.joinPath(s,r[n]);try{await c.mkdir(s)}catch(o){if((0,b.toFileSystemProviderErrorCode)(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,s){try{await this.doValidateDelete(c,s)}catch(r){return r}return!0}async doValidateDelete(c,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,C.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new b.FileOperationError((0,C.localize)(20,null,this.resourceForError(c)),1);if(!!!s?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,C.localize)(21,null,this.resourceForError(c)))}return r}async del(c,s){const r=await this.doValidateDelete(c,s),i=!!s?.useTrash,n=!!s?.recursive;await r.delete(c,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,s){const r=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(c,s))return;if(r===i&&(0,b.hasFileCloneCapability)(r))return r.cloneFile(c,s);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s));const n=this.writeQueue.queueFor(c,this.getExtUri(r).providerExtUri);return r===i&&(0,b.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(c,s,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,c,i,s))}watch(c,s={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,p.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(c,s);i?(0,p.dispose)(o):n=()=>(0,p.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(c,s){const r=await this.withProvider(c),i=(0,y.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(c),s]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(c,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,p.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,p.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,p.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,n,i):await this.doWriteReadableBufferedQueued(c,n,i)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,s,r){let i=0,n;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,s,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,a)=>{(0,d.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,s,l,l.byteLength,i,0)}catch(P){return a(P)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,s,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(c,s,r,i,n,o){let a=0;for(;a<i;)a+=await c.write(s,n+a,r.buffer,o+a,i-a)}async doWriteUnbuffered(c,s,r,i){return this.writeQueue.queueFor(s,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,s,r,i))}async doWriteUnbufferedQueued(c,s,r,i){let n;i instanceof k.VSBuffer?n=i:(0,d.isReadableStream)(i)?n=await(0,k.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?n=await(0,k.bufferedStreamToBuffer)(i):n=(0,k.readableToBuffer)(i),await c.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,s,r,i))}async doPipeBufferedQueued(c,s,r,i){let n,o;try{n=await c.open(s,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await c.read(n,l,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(r,o,a,M,l,P),l+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,s,r,i))}async doPipeUnbufferedQueued(c,s,r,i){return r.writeFile(i,await c.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,s,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,s,r,i))}async doPipeUnbufferedToBufferedQueued(c,s,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await c.readFile(s);await this.doWriteBuffer(r,n,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,s,r,i){const n=await(0,k.streamToBuffer)(this.readFileBuffered(c,s,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(c,s){if(c.capabilities&2048)throw new b.FileOperationError((0,C.localize)(22,null,this.resourceForError(s)),6);return c}throwIfFileIsReadonly(c,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,C.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===E.Schemas.file?c.fsPath:c.toString(!0)}};g=ve([J(0,m.ILogService)],g),e.FileService=g}),define(Z[86],ee([0,1,29,272,8,32,17,3,31,2,9,4,16,57,23,162,14,104,201,43,198,197]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class s extends m.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new R.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async a=>{try{let l;a.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(i,a.name))).type:l=this.toType(a),o.push([a.name,l])}catch(l){this.logService.trace(l)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=b.FileType.Unknown:i.isFile()?o=b.FileType.File:i.isDirectory()?o=b.FileType.Directory:o=b.FileType.Unknown,n&&(o|=b.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,n,o){const a=(0,f.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,w.readFileIntoStream)(this,i,a,l=>l.buffer,{...n,bufferSize:256*1024},o),a}async writeFile(i,n,o){let a;try{const l=this.toFilePath(i);if(!o.create||!o.overwrite){if(await d.Promises.exists(l)){if(!o.overwrite)throw(0,b.createFileSystemProviderError)((0,C.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,b.createFileSystemProviderError)((0,C.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){s.canFlush=i}async open(i,n){const o=this.toFilePath(i);let a;(0,b.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let l;try{if((0,b.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(o);M.mode&128||await d.Promises.chmod(o,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,b.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await d.Promises.truncate(o,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await d.Promises.open(o,P)}catch(P){throw a?.dispose(),(0,b.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,b.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,i),a){const P=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${o})`),this.mapHandleToLock.set(l,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${o})`),P.dispose())}return l}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&s.canFlush)try{await d.Promises.fdatasync(i)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.read(i,o,a,l,P)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,P,M)}return M}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,a,l){return(0,k.retry)(()=>this.doWrite(i,n,o,a,l),100,3)}async doWrite(i,n,o,a,l){const P=this.normalizePos(i,n);let M=null;try{M=(await d.Promises.write(i,o,a,l,P)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,P,M)}return M}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await d.Promises.move(a,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,C.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n);if(a!==l)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await d.Promises.copy(a,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,C.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,n,o,a){const l=this.toFilePath(i),P=this.toFilePath(n);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(l,P,!0)),M&&o==="copy")throw(0,b.createFileSystemProviderError)((0,C.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(P)){if(!a)throw(0,b.createFileSystemProviderError)((0,C.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const a=this.toFilePath(i),l=this.toFilePath(n),P=!!(this.capabilities&1024);if((0,h.isEqual)(a,l,!P))return;const M=new p.DisposableStore;try{const[A,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);M.add(A),M.add(F),o&&await d.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await d.Promises.copyFile(a,l)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(A)}finally{M.dispose()}}createUniversalWatcher(i,n,o){return new u.UniversalWatcherClient(a=>i(a),a=>n(a),o)}createNonRecursiveWatcher(i,n,o){return new c.NodeJSWatcherClient(a=>i(a),a=>n(a),o)}toFileSystemProviderError(i){if(i instanceof b.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,b.createFileSystemProviderError)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(Z[203],ee([0,1,3,86,2,17,57,21]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends k.Disposable{constructor(E,S){super();this.provider=E,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(E,S,f){const d=this.getUriTransformer(E);switch(S){case"stat":return this.stat(d,f[0]);case"readdir":return this.readdir(d,f[0]);case"open":return this.open(d,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(d,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(d,f[0],f[1],f[2]);case"rename":return this.rename(d,f[0],f[1],f[2]);case"copy":return this.copy(d,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(d,f[0],f[1]);case"mkdir":return this.mkdir(d,f[0]);case"delete":return this.delete(d,f[0],f[1]);case"watch":return this.watch(d,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(E,S,f){const d=this.getUriTransformer(E);switch(S){case"fileChange":return this.onFileChange(d,f[0]);case"readFileStream":return this.onReadFileStream(d,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(E,S){const f=this.transformIncoming(E,S,!0);return this.provider.stat(f)}readdir(E,S){const f=this.transformIncoming(E,S);return this.provider.readdir(f)}async readFile(E,S,f){const d=this.transformIncoming(E,S,!0),C=await this.provider.readFile(d,f);return R.VSBuffer.wrap(C)}onReadFileStream(E,S,f){const d=this.transformIncoming(E,S,!0),C=new y.CancellationTokenSource,b=new v.Emitter({onLastListenerRemove:()=>{C.cancel()}}),w=this.provider.readFileStream(d,f,C.token);return(0,D.listenStream)(w,{onData:m=>b.fire(R.VSBuffer.wrap(m)),onError:m=>b.fire(m),onEnd:()=>{b.fire("end"),b.dispose(),C.dispose()}}),b.event}writeFile(E,S,f,d){const C=this.transformIncoming(E,S);return this.provider.writeFile(C,f.buffer,d)}open(E,S,f){const d=this.transformIncoming(E,S,!0);return this.provider.open(d,f)}close(E){return this.provider.close(E)}async read(E,S,f){const d=R.VSBuffer.alloc(f),C=0,b=await this.provider.read(E,S,d.buffer,C,f);return[d,b]}write(E,S,f,d,C){return this.provider.write(E,S,f.buffer,d,C)}mkdir(E,S){const f=this.transformIncoming(E,S);return this.provider.mkdir(f)}delete(E,S,f){const d=this.transformIncoming(E,S);return this.provider.delete(d,f)}rename(E,S,f,d){const C=this.transformIncoming(E,S),b=this.transformIncoming(E,f);return this.provider.rename(C,b,d)}copy(E,S,f,d){const C=this.transformIncoming(E,S),b=this.transformIncoming(E,f);return this.provider.copy(C,b,d)}cloneFile(E,S,f){const d=this.transformIncoming(E,S),C=this.transformIncoming(E,f);return this.provider.cloneFile(d,C)}onFileChange(E,S){const f=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(E,f))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(E,S,f,d,C){const b=this.sessionToWatcher.get(S);if(b){const w=this.transformIncoming(E,d),m=b.watch(f,w,C);this.watchRequests.set(S+f,m)}}async unwatch(E,S){const f=E+S,d=this.watchRequests.get(f);d&&((0,k.dispose)(d),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,E]of this.watchRequests)E.dispose();this.watchRequests.clear();for(const[,E]of this.sessionToWatcher)E.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class p extends k.Disposable{constructor(E,S,f,d){super();this.uriTransformer=E,this.logService=f,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(E){const S=this._register(new v.Emitter);this._register(S.event(f=>{E.fire(f.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>E.fire(f)))}getRecursiveWatcherOptions(E){}getExtraExcludes(E){}watch(E,S,f){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(f.excludes=[...f.excludes,...d]),this.watcherRequests.set(E,this.fileWatcher.watch(S,f)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(E)),this.watcherRequests.delete(E)})}dispose(){super.dispose();for(const[,E]of this.watcherRequests)E.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=p}),define(Z[204],ee([0,1,15,161,4,7,14,9,203,141]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends h.AbstractDiskFileSystemProviderChannel{constructor(f,d,C){super(f,d);this.environmentService=C}getUriTransformer(f){return p.DefaultURITransformer}transformIncoming(f,d){return R.URI.revive(d)}async delete(f,d,C){if(!C.useTrash)return super.delete(f,d,C);const b=this.transformIncoming(f,d),w=(0,y.normalize)(b.fsPath);try{await v.shell.trashItem(w)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,y.basename)(w)):(0,t.localize)(1,null,(0,y.basename)(w)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,d){return new E(f,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class E extends h.AbstractSessionFileWatcher{watch(f,d,C){if(C.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,C)}}}),define(Z[105],ee([0,1,6]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(D=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(y=>{this._logger?.setLevel(y)}))}set logger(D){this._logger=D;for(const{level:y,args:h}of this.buffer)t(D,y).apply(D,h);this.buffer=[]}_log(D,...y){this._logger?t(this._logger,D).apply(this._logger,y):this.getLevel()<=D&&this.buffer.push({level:D,args:y})}trace(D,...y){this._log(v.LogLevel.Trace,D,...y)}debug(D,...y){this._log(v.LogLevel.Debug,D,...y)}info(D,...y){this._log(v.LogLevel.Info,D,...y)}warn(D,...y){this._log(v.LogLevel.Warning,D,...y)}error(D,...y){this._log(v.LogLevel.Error,D,...y)}critical(D,...y){this._log(v.LogLevel.Critical,D,...y)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[205],ee([0,1,8,17,16,14,5,105,6]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let I=class extends h.AbstractLogger{constructor(f,d,C,b,w){super();this.name=f,this.resource=d,this.donotUseFormatters=b,this.fileService=w,this.backupIndex=1,this.setLevel(C),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const f=arguments[0];if(f instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=f.stack,this._log(h.LogLevel.Error,(0,h.format)(d))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(f){if(f.fileOperationResult!==3)throw f}}_log(f,d){this.queue.queue(async()=>{await this.initializePromise;let C=await this.loadContent();C.length>p&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(C)),C=""),this.donotUseFormatters?C+=d:C+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(f)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(C))})}getCurrentTimestamp(){const f=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,C=new Date;return`${C.getFullYear()}-${f(C.getMonth()+1)}-${f(C.getDate())} ${f(C.getHours())}:${f(C.getMinutes())}:${f(C.getSeconds())}.${d(C.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(f){switch(f){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};I=ve([J(4,R.IFileService)],I),e.FileLogger=I;let E=class extends h.AbstractLoggerService{constructor(f,d,C){super(f.getLevel(),f.onDidChangeLogLevel);this.instantiationService=d,this.fileService=C}doCreateLogger(f,d,C){const b=new y.BufferLogService(d);return(0,R.whenProviderRegistered)(f,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(I,C?.name||(0,k.basename)(f),f,b.getLevel(),!!C?.donotUseFormatters)),b}};E=ve([J(0,h.ILogService),J(1,D.IInstantiationService),J(2,R.IFileService)],E),e.FileLoggerService=E}),define(Z[206],ee([0,1,3,7,6]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(S){this.service=S,this.onDidChangeLogLevel=v.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(S,f,d){switch(f){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class D{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){D.setLevel(this.channel,S)}static setLevel(S,f){return S.call("setLevel",f)}}e.LogLevelChannelClient=D;class y{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,f){throw new Error(`Event not found: ${f}`)}async call(S,f,d){switch(f){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${f}`)}createLogger(S,f){this.loggers.set(S.toString(),this.loggerService.createLogger(S,f))}consoleLog(S,f){let d=console.log;switch(S){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...f)}log(S,f){const d=this.loggers.get(S.toString());if(!d)throw new Error("Create the logger before logging");for(const[C,b]of f)(0,k.log)(d,C,b)}}e.LoggerChannel=y;class h extends k.AbstractLoggerService{constructor(S,f,d){super(S,f);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(S,f)=>{this.channel.call("consoleLog",[S,f])}})}doCreateLogger(S,f,d){return new p(this.channel,S,f,d)}}e.LoggerChannelClient=h;class p extends k.AbstractMessageLogger{constructor(S,f,d,C){super(C?.always);this.channel=S,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[f,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,f){const d=[[S,f]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(S){this.channel.call("log",[this.file,S])}}class I extends k.LogService{constructor(S,f){super(f);this.parent=S,this._register(S.onDidChangeLogLevel(d=>f.setLevel(d)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=I}),define(Z[106],ee([0,1,14,6]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(y,h,p,I,E){try{const S=await new Promise((d,C)=>{H(["spdlog"],d,C)});S.setFlushOn(t.LogLevel.Trace);const f=await S.createAsyncRotatingLogger(y,h,p,I);return E&&f.clearFormatters(),f}catch(S){console.error(S)}return null}function R(y,h,p){switch(h){case t.LogLevel.Trace:y.trace(p);break;case t.LogLevel.Debug:y.debug(p);break;case t.LogLevel.Info:y.info(p);break;case t.LogLevel.Warning:y.warn(p);break;case t.LogLevel.Error:y.error(p);break;case t.LogLevel.Critical:y.critical(p);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(h,p,I,E,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(h,p,I,E),this._register(this.onDidChangeLogLevel(f=>{this._logger?.setLevel(f)}))}async _createSpdLogLogger(h,p,I,E){const S=I?6:1,f=30/S*v.ByteSize.MB,d=await k(h,p,f,S,E);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:C,message:b}of this.buffer)R(this._logger,C,b);this.buffer=[]}}log(h,p){this._logger?R(this._logger,h,p):this.getLevel()<=h&&this.buffer.push({level:h,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(Z[207],ee([0,1,13,16,28,14,205,6,106]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends y.AbstractLoggerService{constructor(E,S){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=S}doCreateLogger(E,S,f){return E.scheme===v.Schemas.file?new h.SpdLogLogger(f?.name||(0,k.generateUuid)(),E.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,S):new D.FileLogger(f?.name??(0,t.basename)(E),E,S,!!f?.donotUseFormatters,this.fileService)}};p=ve([J(0,y.ILogService),J(1,R.IFileService)],p),e.LoggerService=p}),define(Z[208],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!v(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(Z[39],ee([0,1,3,56,2,5]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(p){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...p,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(p),t.Iterable.reduce(this.policies.entries(),(E,[S,f])=>({...E,[S]:f}),{})}getPolicyValue(p){return this.policies.get(p)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(p,[I,E])=>({...p,[I]:{definition:E,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class y{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(Z[209],ee([0,1,8,3,56,12,14,6,39]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function p(E,S){const f=[];for(const d of k.Iterable.concat(E.keys(),S.keys()))E.get(d)!==S.get(d)&&f.push(d);return f}let I=class extends h.AbstractPolicyService{constructor(S,f,d){super();this.file=S,this.fileService=f,this.logService=d,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const C=t.Event.filter(f.onDidFilesChange,b=>b.affects(S));this._register(f.watch(S)),this._register(C(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),d=JSON.parse(f.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const C of Object.keys(d))this.policyDefinitions[C]&&S.set(C,d[C])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=p(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};I=ve([J(1,D.IFileService),J(2,y.ILogService)],I),e.FilePolicyService=I}),define(Z[210],ee([0,1,3,2,39]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(h){this.service=h,this.disposables=new t.DisposableStore}listen(h,p){switch(p){case"onDidChange":return v.Event.map(this.service.onDidChange,I=>I.reduce((E,S)=>({...E,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${p}`)}call(h,p,I){switch(p){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${p}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(h,p){super();this.channel=p;for(const I in h){const{definition:E,value:S}=h[I];this.policyDefinitions[I]=E,S!==void 0&&this.policies.set(I,S)}this.channel.listen("onDidChange")(I=>{for(const E in I){const S=I[E];S===null?this.policies.delete(E):this.policies.set(E,S)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(h){const p=await this.channel.call("registerPolicyDefinitions",h);for(const I in p)this.policies.set(I,p[I])}}e.PolicyChannelClient=D}),define(Z[52],ee([0,1,13,4,35,16]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const y=t.globals.vscode.context.configuration();if(y)D=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const y=(0,R.dirname)(v.FileAccess.asFileUri("",H));D=H.__$__nodeRequire((0,R.joinPath)(y,"product.json").fsPath);const h=H.__$__nodeRequire((0,R.joinPath)(y,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:h.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Z[20],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[211],ee([0,1,76,6,20]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(y,h){this.productService=y,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(y,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(h);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,I,E]=p;let S=this.trustedExtensionUrlPublicKeys.get(y);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[y],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",y),!1;this.trustedExtensionUrlPublicKeys.set(y,[...S])}const f=Buffer.from(decodeURIComponent(E),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const d=f.slice(0,6),C=f.readUIntBE(0,6),b=Date.now()-C;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const w=f.slice(6),m=v.createVerify("SHA256");m.write(d),m.write(Buffer.from(I)),m.end();for(let g=0;g<S.length;g++){let u=S[g];if(u!==null){if(typeof u=="string")try{u=v.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),S[g]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${y}:`,c),S[g]=null;continue}if(m.verify(u,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};R=ve([J(0,k.IProductService),J(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[61],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[45],ee([0,1,120,12]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,y){v.ok(t.isString(D)),v.ok(t.isObject(y)),v.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,y)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(Z[212],ee([0,1,3,45]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,p){this.schemasById[k(h)]=p,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Z[62],ee([0,1,24,3,12,150,19,212,45]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=h.Registry.as(y.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const i=this.doRegisterConfigurations(s,r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(s,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(s){const r=[],i=[];for(const{overrides:n,source:o}of s)for(const a in n)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const l=this.configurationDefaultsOverrides.get(a),P=l?.valuesSources??new Map;if(o)for(const U of Object.keys(n[a]))P.set(U,o);const M={...l?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:M,valuesSources:P});const A=(0,D.getLanguageTagSettingPlainKey)(a),F={type:"object",default:M,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...C(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:o});const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:i,source:n}of s)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),l=k.isString(n)?n:n?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(l===P)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const M=this.configurationProperties[o];M&&(this.updatePropertyDefaultValue(o,M),this.updateSchema(o,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const i=[];return s.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(s){const r=[],i=n=>{if(n.properties)for(const o in n.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of s){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,i,n,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],l=s.properties;if(l)for(const M in l){const A=l[M];if(r&&g(M,A)){delete l[M];continue}if(A.source=i,A.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,A),e.OVERRIDE_PROPERTY_REGEX.test(M)?A.scope=void 0:(A.scope=k.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=k.isUndefinedOrNull(A.restricted)?!!n?.includes(M):A.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),a.push(M)}const P=s.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,r,i,n,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const i=this.configurationDefaultsOverrides.get(s);let n=i?.value,o=i?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),k.isUndefined(n)&&(n=w(r.type)),r.default=n,r.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",d=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(c){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=d.exec(c);for(;r?.length;){const i=r[1].trim();i&&s.push(i),r=d.exec(c)}}return(0,v.distinct)(s)}e.overrideIdentifiersFromKey=C;function b(c){return c.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function w(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const m=new S;h.Registry.add(e.Extensions.Configuration,m);function g(c,s){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):m.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):s.policy?.name&&m.getPolicyConfigurations().get(s.policy?.name)!==void 0?R.localize(9,null,c,s.policy?.name,m.getPolicyConfigurations().get(s.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function u(){const c=[],s=m.getConfigurationProperties();for(const r of Object.keys(s))c.push([r,s[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(Z[107],ee([0,1,24,3,42,2,32,49,12,7,19,62,45]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,I.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,I.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return v.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=y.deepClone(this.contents),n=y.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const l of a.overrides){const[P]=n.filter(M=>v.equals(M.identifiers,l.identifiers));P?(this.mergeContents(P.contents,l.contents),P.keys.push(...l.keys),P.keys=v.distinct(P.keys)):n.push(y.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new f(i,o,n)}freeze(){return this.frozen=!0,this}clone(){return new f(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const l=i[o];l&&(typeof a=="object"&&typeof l=="object"?(a=y.deepClone(a),this.mergeContents(a,l)):a=l),n[o]=a}return new f(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&h.isObject(r[n])&&h.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=y.deepClone(i[n])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?y.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const o=a=>{a&&(n?this.mergeContents(n,a):n=y.deepClone(a))};for(const a of this.overrides)v.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,I.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,I.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!h.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:o,overrides:a,restricted:l}=this.doParseRaw(r,i);this._configurationModel=new f(n,o,a),this._restrictedConfigurations=l||[]}doParseContent(r){let i={},n=null,o=[];const a=[],l=[];function P(A){Array.isArray(o)?o.push(A):n!==null&&(o[n]=A)}const M={onObjectBegin:()=>{const A={};P(A),a.push(o),o=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const A=[];P(A),a.push(o),o=A,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:P,onError:(A,F,U)=>{l.push({error:A,offset:F,length:U})}};if(r)try{k.visit(r,M),i=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(r,i){const n=S.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,n,!0,i);r=o.raw;const a=(0,I.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),l=Object.keys(r),P=this.toOverrides(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:l,overrides:P,restricted:o.restricted}}filter(r,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},l=[];for(const P in r)if(E.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const M=this.filter(r[P],i,!1,o);a[P]=M.raw,l.push(...M.restricted)}else{const M=i[P],A=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&l.push(P),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&M?.restricted||(a[P]=r[P]))}return{raw:a,restricted:l}}toOverrides(r,i){const n=[];for(const o of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in r[o])a[l]=r[o][l];n.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=d;class C extends R.Disposable{constructor(r,i,n,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class b{constructor(r,i,n,o,a=new f,l=new f,P=new D.ResourceMap,M=new f,A=new D.ResourceMap,F=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=l,this._folderConfigurations=P,this._memoryConfiguration=M,this._memoryConfigurationByResource=A,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidatedConfigurationModel(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new f,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const o=this.getConsolidatedConfigurationModel(r,i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),M=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),A=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),U=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),Q=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),re=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,le=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,fe=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(r):l.getValue(r),se=o.getValue(r),ue=v.distinct(o.overrides.map(K=>K.identifiers).flat()).filter(K=>o.getOverrideValue(r,K)!==void 0);return{defaultValue:P,policyValue:M,applicationValue:A,userValue:F,userLocalValue:U,userRemoteValue:Q,workspaceValue:re,workspaceFolderValue:le,memoryValue:fe,value:se,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:M!==void 0?{value:M}:void 0,application:A!==void 0?{value:A,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:re!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:le!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:fe!==void 0?{value:l.getValue(r),override:i.overrideIdentifier?l.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ue.length?ue:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:a,removed:l}=u(this._defaultConfiguration,r);i=[...o,...a,...l]}for(const o of i)for(const a of(0,E.overrideIdentifiersFromKey)(o)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=r.getKeysForOverrideIdentifier(a),M=[...P.filter(A=>l.indexOf(A)===-1),...l.filter(A=>P.indexOf(A)===-1),...l.filter(A=>!y.equals(this._defaultConfiguration.override(a).getValue(A),r.override(a).getValue(A)))];n.push([a,M])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this._policyConfiguration,r),a=[...i,...n,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.applicationConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateApplicationConfiguration(r),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.localUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.remoteUserConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(r),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:a}=u(this.workspaceConfiguration,r),l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(r),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:o,updated:a,removed:l,overrides:P}=u(n,i),M=[...o,...a,...l];return(M.length||!n)&&this.updateFolderConfiguration(r,i),{keys:M,overrides:P}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:a,overrides:l}=u(i,void 0);return{keys:[...n,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,n){let o=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(r);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),l=this.parseConfigurationModel(r.workspace),P=r.folders.reduce((M,A)=>(M.set(p.URI.revive(A[0]),this.parseConfigurationModel(A[1])),M),new D.ResourceMap);return new b(i,n,o,a,new f,l,P,new f,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=b;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,l])=>{const P=(0,D.getOrSet)(i,a,new Set);l.forEach(M=>P.add(M))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=w;class m{constructor(r,i,n,o){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(P=>a.add(P)),r.overrides.forEach(([,P])=>P.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const l=new f;this.affectedKeys.forEach(P=>l.setValue(P,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!y.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,I.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(r=r[o],!r)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=m;class g extends m{constructor(r,i,n,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=g;function u(s,r){const{added:i,removed:n,updated:o}=c(r,s),a=[],l=s?.getAllOverrideIdentifiers()||[],P=r?.getAllOverrideIdentifiers()||[];if(r){const M=P.filter(A=>!l.includes(A));for(const A of M)a.push([A,r.getKeysForOverrideIdentifier(A)])}if(s){const M=l.filter(A=>!P.includes(A));for(const A of M)a.push([A,s.getKeysForOverrideIdentifier(A)])}if(r&&s){for(const M of l)if(P.includes(M)){const A=c({contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});a.push([M,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:o,overrides:a}}function c(s,r){const i=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],n=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(s&&r){for(const a of r.keys)if(s.keys.indexOf(a)!==-1){const l=(0,I.getConfigurationValue)(r.contents,a),P=(0,I.getConfigurationValue)(s.contents,a);y.equals(l,P)||o.push(a)}}return{added:i,removed:n,updated:o}}}),define(Z[213],ee([0,1,24,3,2,49,12,19,107,62,6,39,45]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:g})=>this.onDidUpdateConfiguration(m,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=f;class d extends h.ConfigurationModel{constructor(m={}){const g=S.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(g),c=Object.create(null),s=[];for(const r in g){const i=m[r],n=i!==void 0?i:g[r].default;(0,y.addToValueTree)(c,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(c))p.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,p.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,y.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,s)}}e.DefaultConfigurationModel=d;class C{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=C;let b=class extends k.Disposable{constructor(m,g,u){super();this.defaultConfiguration=m,this.policyService=g,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const g={},u=[],c=S.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const s of m){const r=c[s];if(!r){u.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(s),g[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),u}onDidChangePolicies(m){const g=S.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),u=(0,v.coalesce)(m.map(c=>g.get(c)));this.update(u,!0)}update(m,g){const u=S.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),c=[],s=this._configurationModel.isEmpty();for(const r of m){const i=u[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(s?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),n))&&c.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of c)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=ve([J(1,E.IPolicyService),J(2,I.ILogService)],b),e.PolicyConfiguration=b}),define(Z[214],ee([0,1,8,3,2,16,19,107,213,39]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(S,f,d,C){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=d instanceof p.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,d,C)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,f)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:w})=>this.onDidDefaultConfigurationChange(b,w))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(S,f,new y.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const d=typeof S=="string"?S:void 0,C=(0,D.isConfigurationOverrides)(S)?S:(0,D.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(d,C,void 0)}updateValue(S,f,d,C){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(d,f,2)}onDidDefaultConfigurationChange(S,f){const d=this.configuration.toData(),C=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(C,d,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(d,f,7)}trigger(S,f,d){const C=new y.ConfigurationChangeEvent(S,{data:f},this.configuration);C.source=d,C.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[215],ee([0,1,18,5]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(y,h=k.Unknown,p){super(y);this._message=y,this._code=h,this._detail=p,this.isHandled=h===k.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===k.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===k.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}}e.RemoteAuthorityResolverError=R}),define(Z[63],ee([0,1,13]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=t;function k(p){if(!p)return;const I=p.indexOf("+");return I<0?p:p.substr(0,I)}e.getRemoteName=k;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(p){const{host:I,port:E}=h(p);if(typeof E=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.parseAuthorityWithPort=D;function y(p,I){let{host:E,port:S}=h(p);return typeof S=="undefined"&&(S=I),{host:E,port:S}}e.parseAuthorityWithOptionalPort=y;function h(p){const I=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=p.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const S=p.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:p,port:void 0}}}),define(Z[108],ee([0,1,27,5,63]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var h;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class p{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,b){if(typeof C=="undefined"||C===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof C=="string"||typeof b=="string"){const w=typeof C=="string"?C:C.value,m=typeof b=="string"?b:b.value;return v.equalsIgnoreCase(w,m)}return C._lower===b._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=p;function I(d){return E(d)}e.isApplicationScopedExtension=I;function E(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function f(d,C){if(C){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(C)}`;return d.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[109],ee([0,1,27,190,108,4,7,18,35]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,v.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=p;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,n,o)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new E({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(r){const i=S.exec(r);return i&&i[1]?[C(i[1]),i[2]]:[C(r),void 0]}e.getIdAndVersion=f;function d(r,i){return`${r}.${i}`}e.getExtensionId=d;function C(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function b(r,i){return C(d(r,i))}e.getGalleryExtensionId=b;function w(r,i){const n=[],o=a=>{for(const l of n)if(l.some(P=>p(i(P),i(a))))return l;return null};for(const a of r){const l=o(a);l?l.push(a):n.push([a])}return n}e.groupByExtension=w;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function g(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&n.every(l=>!p(l.identifier,{id:a}))){const l=r.filter(P=>p(P.identifier,{id:a}));l.length===1&&(n.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=u;async function c(r,i){if(!R.isLinux)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function s(r,i){const n=await c(r,i),o=(0,t.getTargetPlatform)(n?"alpine":R.platform,h.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Z[72],ee([0,1,8,17,2,32,7,109,14,5,6]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let E=class extends k.Disposable{constructor(f,d){super();this.fileService=f,this.logService=d,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(f){return this.withProfileExtensions(f)}addExtensionsToProfile(f,d){return this.withProfileExtensions(d,C=>(C=C.filter(b=>f.some(([w])=>!(0,y.areSameExtensions)(b.identifier,w.identifier))),C.push(...f.map(([b,w])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:w}))),C))}removeExtensionFromProfile(f,d){return this.withProfileExtensions(d,C=>C.filter(b=>!(0,y.areSameExtensions)(b.identifier,f)))}async withProfileExtensions(f,d){return this.getResourceAccessQueue(f).queue(async()=>{let C=[];try{const b=await this.fileService.readFile(f),w=JSON.parse(b.value.toString());for(const m of w){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}C.push({identifier:m.identifier,location:D.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(d){C=d(C);const b=C.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),metadata:w.metadata}));await this.fileService.writeFile(f,t.VSBuffer.fromString(JSON.stringify(b)))}return C})}getResourceAccessQueue(f){let d=this.resourcesAccessQueueMap.get(f);return d||(d=new v.Queue,this.resourcesAccessQueueMap.set(f,d)),d}};E=ve([J(0,h.IFileService),J(1,I.ILogService)],E),e.ExtensionsProfileScannerService=E}),define(Z[216],ee([0,1,8,17,21,18,3,2,28,98,215,63]),function(H,e,v,t,k,R,D,y,h,p,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var f;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function C(z){const q=new k.CancellationTokenSource;return setTimeout(()=>q.cancel(),z),q.token}function b(z,q){if(z.isCancellationRequested||q.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return z.onCancellationRequested(()=>L.cancel()),q.onCancellationRequested(()=>L.cancel()),L.token}class w{constructor(q){this._state="pending",this._disposables=new y.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),q.isCancellationRequested?this._timeout():this._disposables.add(q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(q){this._state==="pending"?this._disposables.add(q):q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(q))}reject(q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(q))}}function m(z,q){const L=new w(q);return L.registerDisposable(z.onControlMessage(O=>{const B=JSON.parse(O.toString()),V=W(B);V?L.reject(V):L.resolve(B)})),L.promise}function g(z,q,L,O,B,V,X,ne){const j=new w(ne);return q.connect(L,O,B,V,X,(te,ie)=>{j.didTimeout?(te&&z.error(te),ie?.dispose()):te||!ie?j.reject(te):j.resolve(ie)}),j.promise}function u(z,q){const L=new w(q);return z.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(z,q,L,O){const B=$(z,q);z.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let V;try{V=await g(z.logService,z.socketFactory,z.host,z.port,(0,E.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(q)}-${z.reconnectionToken}`,O)}catch(ie){throw z.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ie),ie}z.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let X,ne;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(V,null),X=z.reconnectionProtocol,ne=!1):(X=new p.PersistentProtocol(V,null),ne=!0),z.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const j=await u(z.signService.createNewMessage((0,h.generateUuid)()),O),te={type:"auth",auth:z.connectionToken||"00000000000000000000",data:j.data};X.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await m(X,b(O,C(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(z.logService.trace(`${B} 4/6. received SignRequest control message.`),!await u(z.signService.validate(j,ie.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const he=await u(z.signService.sign(ie.data),O),ke={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:q};return L&&(ke.args=L),z.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:X,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(z.logService.error(`${B} the handshake timed out. Error:`),z.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(ie)),ne&&N(X),ie}}async function s(z,q,L,O){const B=Date.now(),V=$(z,q),{protocol:X,ownsProtocol:ne}=await c(z,q,L,O),j=new w(O);return j.registerDisposable(X.onControlMessage(te=>{const ie=JSON.parse(te.toString()),ce=W(ie);ce?(z.logService.error(`${V} received error control message when negotiating connection. Error:`),z.logService.error(ce),ne&&N(X),j.reject(ce)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${x(B)}!`),j.resolve({protocol:X,firstMessage:ie}))})),j.promise}async function r(z,q){const{protocol:L}=await s(z,1,void 0,q);return{protocol:L}}async function i(z,q,L){const{protocol:O,firstMessage:B}=await s(z,2,q,L),V=B&&B.debugPort;return{protocol:O,debugPort:V}}async function n(z,q,L){const O=Date.now(),B=$(z,3),{protocol:V}=await c(z,3,q,L);return z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${x(O)}!`),V}async function o(z,q,L){const{host:O,port:B,connectionToken:V}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:O,port:B,connectionToken:V,reconnectionToken:q,reconnectionProtocol:L,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function a(z,q,L){return P(z,async O=>{const{protocol:B}=await r(O,k.CancellationToken.None);return new ue(z,q,L,O.reconnectionToken,B)})}e.connectRemoteAgentManagement=a;async function l(z,q){return P(z,async L=>{const{protocol:O,debugPort:B}=await i(L,q,k.CancellationToken.None);return new K(z,q,L.reconnectionToken,O,B)})}e.connectRemoteAgentExtensionHost=l;async function P(z,q){const L=5;for(let O=1;;O++)try{const B=(0,h.generateUuid)(),V=await o(z,B,null);return await q(V)}catch(B){if(O<L)z.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(B);else throw z.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(B),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}async function M(z,q,L){const O=await o(z,(0,h.generateUuid)(),null);return await n(O,{host:q,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function A(z){return(0,v.createCancelablePromise)(q=>new Promise((L,O)=>{const B=setTimeout(L,z*1e3);q.onCancellationRequested(()=>{clearTimeout(B),L()})}))}var F;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(q,L){this.reconnectionToken=q,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class Q{constructor(q,L,O,B){this.reconnectionToken=q,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Q;class re{constructor(q,L,O){this.reconnectionToken=q,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(q,L,O){this.reconnectionToken=q,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=le;class fe{constructor(q,L,O,B){this.reconnectionToken=q,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class se extends y.Disposable{constructor(q,L,O,B,V){super();this._connectionType=q,this._options=L,this.reconnectionToken=O,this.protocol=B,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(B.onSocketClose(X=>{const ne=T(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(X=>{const ne=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,y.toDisposable)(()=>{const X=se._instances.indexOf(this);X>=0&&se._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(q,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=q,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(q=>q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(q=>q._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const q=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const B=O<L.length?L[O]:L[L.length-1];try{if(B>0){const X=A(B);this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,X)),this._options.logService.info(`${q} waiting for ${B} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${q} resolving connection...`);const V=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${q} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,C(S)),this._options.logService.info(`${q} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(q,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(q,L,O):this._gotoPermanentFailure(q,L,O)}_gotoPermanentFailure(q,L,O){this._onDidStateChange.fire(new fe(this.reconnectionToken,q,L,O)),N(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class ue extends se{constructor(q,L,O,B,V){super(1,q,B,V,!0);this.client=this._register(new p.Client(V,{remoteAuthority:L,clientId:O},q.ipcLogger))}async _reconnect(q,L){await r(q,L)}}e.ManagementPersistentConnection=ue;class K extends se{constructor(q,L,O,B,V){super(2,q,O,B,!1);this._startArguments=L,this.debugPort=V}async _reconnect(q,L){await i(q,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function N(z){try{z.acceptDisconnect();const q=z.getSocket();z.dispose(),q.dispose()}catch(q){(0,R.onUnexpectedError)(q)}}function W(z){if(z&&z.type==="error"){const q=new Error(`Connection error: ${z.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function _(z,q){for(;z.length<q;)z+=" ";return z}function T(z,q,L){return`[remote-connection][${_(d(z),13)}][${q.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function $(z,q){return`${T(q,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function x(z){return`${Date.now()-z} ms`}}),define(Z[217],ee([0,1,77,83]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,y,h,p){const I=S=>p(S,void 0),E=v.createConnection({host:k,port:R},()=>{E.removeListener("error",I);const S=Buffer.alloc(16);for(let b=0;b<16;b++)S[b]=Math.round(Math.random()*256);const f=S.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${y}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];E.write(d.join(`\r
`)+`\r
\r
`);const C=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",C),p(void 0,new t.NodeSocket(E,h)))};E.on("data",C)});E.setNoDelay(!0),E.once("error",I)}}}),define(Z[53],ee([0,1,17,166,62,5,45]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function y(C){return C.res.statusCode&&C.res.statusCode>=200&&C.res.statusCode<300||C.res.statusCode===1223}e.isSuccess=y;function h(C){return C.res.statusCode===204}async function p(C){return h(C)?null:(await(0,v.streamToBuffer)(C.stream)).toString()}e.asText=p;async function I(C){if(!y(C))throw new Error("Server returned "+C.res.statusCode);return p(C)}e.asTextOrError=I;async function E(C){if(!y(C))throw new Error("Server returned "+C.res.statusCode);if(h(C))return null;const w=(await(0,v.streamToBuffer)(C.stream)).toString();try{return JSON.parse(w)}catch(m){throw m.message+=`:
`+w,m}}e.asJson=E;function S(C){d(C)}e.updateProxyConfigurationsScope=S;let f;function d(C){const b=D.Registry.as(k.Extensions.Configuration),w=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:C,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[f],remove:w?[w]:[]})}d(2)}),define(Z[218],ee([0,1,17,21]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){throw new Error("Invalid listen")}call(y,h,p,I=t.CancellationToken.None){switch(h){case"request":return this.service.request(p[0],I).then(async({res:E,stream:S})=>{const f=await(0,v.streamToBuffer)(S);return[{statusCode:E.statusCode,headers:E.headers},f]});case"resolveProxy":return this.service.resolveProxy(p[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(y){this.channel=y}async request(y,h){const[p,I]=await this.channel.call("request",[y],h);return{res:p,stream:(0,v.bufferToStream)(I)}}async resolveProxy(y){return this.channel.call("resolveProxy",[y])}}e.RequestChannelClient=R}),define(Z[219],ee([0,1,220,12]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,y){return D.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:D.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function R(D,y,h={}){const p=(0,v.parse)(D),I=h.proxyUrl||k(p,y);if(!I)return null;const E=(0,v.parse)(I);if(!/^https?:$/.test(E.protocol||""))return null;const S={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,t.isBoolean)(h.strictSSL)?h.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((f,d)=>{H(["http-proxy-agent"],f,d)}))(S):new(await new Promise((f,d)=>{H(["https-proxy-agent"],f,d)}))(S)}e.getProxyAgent=R}),define(Z[110],ee([0,1,50,9,167,21,43,18,4,28,144,59,8]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let d;async function C(w,m,g){return m["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!m["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=S.Promises.withAsyncBody(async(u,c)=>{const s=new R.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),c(new Error((0,k.localize)(0,null)))},f);try{u(await b(w,s.token))}catch(i){!(0,y.isCancellationError)(i)&&!s.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):u({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=C;async function b(w,m){const g=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",g);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",u);const c=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",r);const i=await(0,I.getSystemShell)(h.OS,r);return w.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(m.isCancellationRequested)return o((0,y.canceled)());const a=(0,t.basename)(i);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const A=(0,v.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(A.kill(),o((0,y.canceled)()))),A.on("error",Q=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(Q)),o(Q)});const F=[];A.stdout.on("data",Q=>F.push(Q));const U=[];A.stderr.on("data",Q=>U.push(Q)),A.on("close",(Q,re)=>{const le=Buffer.concat(F).toString("utf8");w.trace("getUnixShellEnvironment#raw",le);const fe=Buffer.concat(U).toString("utf8");if(fe.trim()&&w.trace("getUnixShellEnvironment#stderr",fe),Q||re)return o(new Error((0,k.localize)(2,null,Q,re)));const se=s.exec(le),ue=se?se[1]:"{}";try{const K=JSON.parse(ue);g?K.ELECTRON_RUN_AS_NODE=g:delete K.ELECTRON_RUN_AS_NODE,u?K.ELECTRON_NO_ATTACH_CONSOLE=u:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",K),n(K)}catch(K){w.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),o(K)}})})}}),define(Z[87],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[221],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>H(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const y=String(v._nextId++);return this.validators.set(y,D),{id:y,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=v,v._nextId=1}),define(Z[41],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[22],ee([0,1,15,40,8,3,2,4,35,12,5,6,41,25]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var d;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var C;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(C=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class yt extends D.Disposable{constructor(m,g,u){super();this.logService=m,this.stateMainService=g,this.environmentMainService=u,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const m=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",m);const g=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",g),v.app.once("will-quit",u=>{this.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",m),v.app.removeListener("window-all-closed",g),v.app.quit()})})}fireOnWillShutdown(m){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const g=[];return this._onWillShutdown.fire({reason:m,join(u){g.push(u)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(g)}catch(u){this.logService.error(u)}try{await this.stateMainService.close()}catch(u){this.logService.error(u)}})(),this.pendingWillShutdownPromise}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===m)return;this.trace(`lifecycle (main): phase changed (value: ${m})`),this._phase=m;const g=this.phaseWhen.get(this._phase);g&&(g.open(),this.phaseWhen.delete(this._phase))}async when(m){if(m<=this._phase)return;let g=this.phaseWhen.get(m);g||(g=new k.Barrier,this.phaseWhen.set(m,g)),await g.wait()}registerWindow(m){const g=new D.DisposableStore;this.windowCounter++,g.add(m.onWillLoad(c=>this._onWillLoadWindow.fire({window:m,workspace:c.workspace,reason:c.reason})));const u=(0,p.assertIsDefined)(m.win);u.on("close",c=>{const s=m.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.trace(`Lifecycle#window.on('close') - window ID ${m.id}`),c.preventDefault(),this.unload(m,1).then(r=>{if(r){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(m),m.close()})}),u.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.windowCounter--,g.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(m,g){await this.unload(m,3)||m.reload(g)}unload(m,g){const u=this.mapWindowIdToPendingUnload.get(m.id);if(u)return u;const c=this.doUnload(m,g).finally(()=>{this.mapWindowIdToPendingUnload.delete(m.id)});return this.mapWindowIdToPendingUnload.set(m.id,c),c}async doUnload(m,g){if(!m.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${m.id}`);const u=this._quitRequested?2:g,c=await this.onBeforeUnloadWindowInRenderer(m,u);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(m,u),!1)}handleWindowUnloadVeto(m){return m?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(m){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(m),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(m,g){return new Promise(u=>{const c=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${c}`,r=`vscode:cancel${c}`;t.validatedIpcMain.once(s,()=>{u(!1)}),t.validatedIpcMain.once(r,()=>{u(!0)}),m.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:r,reason:g})})}onWillUnloadWindowInRenderer(m,g){return new Promise(u=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(s,()=>u()),m.send("vscode:onWillUnload",{replyChannel:s,reason:g})})}quit(m){return this.trace(`Lifecycle#quit() - begin (willRestart: ${m})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(m&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(g=>{this.pendingQuitPromiseResolve=g,this.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}trace(m){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(m):this.logService.trace(m)}async relaunch(m){this.trace("Lifecycle#relaunch()");const g=process.argv.slice(1);if(m?.addArgs&&g.push(...m.addArgs),m?.removeArgs)for(const s of m.removeArgs){const r=g.indexOf(s);r>=0&&g.splice(r,1)}const u=()=>{try{if(y.isWindows){const s=(0,h.cwd)();s!==process.cwd()&&process.chdir(s)}}catch(s){this.logService.error(s)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:g})};v.app.once("quit",u),await this.quit(!0)&&v.app.removeListener("quit",u)}async kill(m){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const g of v.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let u;g.webContents&&!g.webContents.isDestroyed()?u=new Promise(c=>g.once("closed",c)):u=Promise.resolve(),g.destroy(),await u}})()]),v.app.exit(m)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=ve([J(0,E.ILogService),J(1,S.IStateMainService),J(2,f.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(Z[222],ee([0,1,4,3,2,5,22]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let y=class extends k.Disposable{constructor(I){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((E,S)=>{H(["native-keymap"],E,S)});this._keyboardLayoutData=h(I),v.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};y=ve([J(0,D.ILifecycleMainService)],y),e.KeyboardLayoutMainService=y;function h(p){const I=p.getKeyMap(),E=p.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:E}}}),define(Z[223],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(Z[224],ee([0,1,8,17,12,37,14,6]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(E,S,f){this.storagePath=E,this.logService=S,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}}getItem(E,S){const f=this.storage[E];return(0,k.isUndefinedOrNull)(f)?S:f}setItem(E,S){this.setItems([{key:E,data:S}])}setItems(E){let S=!1;for(const{key:f,data:d}of E)this.storage[f]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,S=!0):(this.storage[f]=d,S=!0));S&&this.save()}removeItem(E){(0,k.isUndefined)(this.storage[E])||(this.storage[E]=void 0,this.save())}async save(E){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){if(!this.initializing)return;await this.initializing;const E=JSON.stringify(this.storage,null,4);if(E!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(E)),this.lastSavedStorageContents=E}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let p=class{constructor(E,S,f){this.fileStorage=new h(E.stateResource,S,f)}async init(){await this.fileStorage.init()}getItem(E,S){return this.fileStorage.getItem(E,S)}};p=ve([J(0,R.IEnvironmentService),J(1,y.ILogService),J(2,D.IFileService)],p),e.StateService=p}),define(Z[225],ee([0,1,224]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[111],ee([0,1,4,35,7,28]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function y(p,I,E,S,f,d,C,b,w,m){const g=Object.create(null);g["common.machineId"]=C,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=f,g.version=d,g["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,v.PlatformToString)(v.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=S,g["common.product"]=m||"desktop",b&&(g["common.msftInternal"]=b);let u=0;const c=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(g["common.snap"]="true");const s=D(E);s&&(g["common.platformDetail"]=s);try{const r=await p.readFile(k.URI.file(w));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=y;function h(p){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return p.some(S=>E===S)}e.verifyMicrosoftInternalDomain=h}),define(Z[38],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[226],ee([0,1,30,56,8,42,13,9,4,7,81,23,97,84,14,20,38]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const w=new Map;async function m(r,i){const n=`${r}::${i.join(":")}`,o=w.get(n);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function A(U,Q,re,le){const fe=Q.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let ue;try{ue=await E.Promises.readdir(Q,{withFileTypes:!0})}catch{se();return}if(le.count>=M){le.count+=ue.length,le.maxReached=!0,se();return}let K=ue.length;if(K===0){se();return}let N=ue;le.count+ue.length>M&&(le.maxReached=!0,K=M-le.count,N=ue.slice(0,K)),le.count+=ue.length;for(const W of N)if(W.isDirectory()){if(re.includes(W.name)||await A(U,(0,y.join)(Q,W.name),re,le),--K==0){se();return}}else{const _=W.name.lastIndexOf(".");if(_>=0){const T=W.name.substring(_+1);T&&l.set(T,(l.get(T)??0)+1)}for(const T of a)T.relativePathPattern?.test(fe)!==!1&&T.filePattern.test(W.name)&&P.set(T.tag,(P.get(T.tag)??0)+1);if(--K==0){se();return}}})}const F=k.Promises.withAsyncBody(async U=>{const Q={count:0,maxReached:!1};await A(r,r,i,Q);const re=await c(r);U({configFiles:g(P),fileTypes:g(l),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:re})});return w.set(n,F),F}e.collectWorkspaceStats=m;function g(r){return[...t.Iterable.map(r.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function u(){const r={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=u;async function c(r){try{const i=new Map,n=(0,y.join)(r,".vscode","launch.json"),o=await E.Promises.readFile(n),a=[],l=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return g(i)}catch{return[]}}e.collectLaunchConfigs=c;let s=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const o=v.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(v.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||n.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,l]=o,P=this.formatProcessList(i,a);return n.forEach(M=>{if((0,f.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const A of Object.keys(M.workspaceMetadata)){const F=M.workspaceMetadata[A];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),l+=`|    Folder (${A}): ${U}`,l+=this.formatWorkspaceStats(F)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:l,cpus:P}=u(),M={os:l,memory:o,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return h.isWindows||(M.load=`${v.loadavg().map(A=>Math.round(A)).join(", ")}`),h.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,n){const o=[];return(0,S.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,f.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),o.push(`Folder (${P}): ${A}`),o.push(this.formatWorkspaceStats(M))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const l=(F,U)=>{const Q=` ${F}(${U})`;a+Q.length>o?(n.push(P),P="|                 ",a=P.length):a+=Q.length,P+=Q};let P="|      File types:";const M=10,A=i.fileTypes.length>M?M:i.fileTypes.length;for(let F=0;F<A;F++){const U=i.fileTypes[F];l(U.name,U.count)}if(n.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(F=>{l(F.name,F.count)}),n.push(P)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),n.push(F)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const P=p.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;o.push(m(M,["node_modules",".git"]).then(A=>{let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),n.push(`|    Folder (${(0,y.basename)(M)}): ${F}`),n.push(this.formatWorkspaceStats(A))}).catch(A=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${A.toString()})`)}))}else n.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,l){const P=l===0;let M;P?M=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(M=`${M} (${n.get(a.pid)})`));const A=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(A/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(i,n,o,F,l+1))}async getWorkspaceFileExtensions(i){const n=new Set;for(const{uri:o}of i.folders){const a=p.URI.revive(o);if(a.scheme!==D.Schemas.file)continue;const l=a.fsPath;try{(await m(l,["node_modules",".git"])).fileTypes.forEach(M=>n.add(M.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=p.URI.revive(n);if(o.scheme!==D.Schemas.file)continue;const a=o.fsPath;try{const l=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};s=ve([J(0,b.ITelemetryService),J(1,C.IProductService)],s),e.DiagnosticsService=s}),define(Z[227],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:y,data:h}){return this.appenders.forEach(p=>p.log(y,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,y=>`Failed to log telemetry: ${console.warn(y)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[73],ee([0,1,49,93,12,19,111,38]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class p{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:w(r.sourceConfig)})})}e.configurationTelemetry=I;function E(c,s){return!(s.disableTelemetry||!c.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=E;function S(c){const s=c.getValue(y.TELEMETRY_SETTING_ID),r=c.getValue("telemetry.enableCrashReporter");if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function f(c){const s={},r={},i={};b(c,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=f;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function C(c){if(!c)return"none";for(const s of d)if(c.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=C;function b(c,s,r=0,i){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const o=c[n],a=i?i+n:n;Array.isArray(o)?s[a]=(0,v.safeStringify)(o):o instanceof Date?s[a]=o.toISOString():(0,k.isObject)(o)?r<2?b(o,s,r+1,a+"."):s[a]=(0,v.safeStringify)(o):s[a]=o}}function w(c){if(!c)return[];const s=[];return m(s,"",c),s}function m(c,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(i=>m(c,s?`${s}.${i}`:i,r[i])):c.push(s)}function g(c,s){const r=c.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||i}e.isInternalTelemetry=g;function u(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=u}),define(Z[228],ee([0,1,187,73]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,y,h,p,I,E){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},f=await(0,v.getServiceMachineId)(y,p,I),{sessionId:d}=await E.getTelemetryInfo();return(0,t.supportsTelemetry)(D,y)&&(0,t.getTelemetryLevel)(h)===3&&(S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=d),S}e.resolveMarketplaceHeaders=k}),define(Z[229],ee([0,1,2,49,93,4,27,168,19,62,52,20,45,38,73]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let C=class{constructor(m,g,u){this._configurationService=g,this._productService=u,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,g){this._experimentProperties[m]=g}_updateTelemetryLevel(){let m=(0,d.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const u=g.usage?3:g.error?2:0;m=Math.min(m,u)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,g=m.sessionID,u=m["common.machineId"],c=m["common.firstSessionDate"],s=m["common.msftInternal"];return{sessionId:g,machineId:u,firstSessionDate:c,msftInternal:s}}dispose(){this._disposables.dispose()}_log(m,g,u,c){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(s=>{u=(0,t.mixin)(u,s),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,r=>{if(typeof r=="string")return this._cleanupInfo(r,c)}),this._appenders.forEach(r=>r.log(m,u))},s=>{console.error(s)})}publicLog(m,g,u){return this._log(m,3,g,u)}publicLog2(m,g,u){return this.publicLog(m,g,u)}publicLogError(m,g){return this._sendErrorTelemetry?this._log(m,2,g,!0):Promise.resolve(void 0)}publicLogError2(m,g){return this.publicLogError(m,g)}_anonymizeFilePaths(m){let g=m;const u=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(m);if(!n)break;u.push([n.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const i=s.exec(m);if(!i)break;!c.test(i[0])&&u.every(([n,o])=>i.index<n||i.index>=o)&&(g+=m.substring(r,i.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<m.length&&(g+=m.substr(r)),g}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const g=m.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(g))return`<REDACTED: ${c.label}>`;return m}_cleanupInfo(m,g){let u=m;g&&(u=this._anonymizeFilePaths(u));for(const c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};C.IDLE_START_EVENT_NAME="UserIdleStart",C.IDLE_STOP_EVENT_NAME="UserIdleStop",C=ve([J(1,h.IConfigurationService),J(2,E.IProductService)],C),e.TelemetryService=C;function b(){const w=(0,y.localize)(0,null,I.default.nameLong),m=I.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,y.localize)(3,null),u=(0,y.localize)(4,null),c=(0,y.localize)(5,null),s=(0,y.localize)(6,null),r=(0,y.localize)(7,null),i=`
|       | ${u} | ${c} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,y.localize)(8,null);return`
${w} ${m} ${g}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}S.Registry.as(p.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(p.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,y.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,y.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[230],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[231],ee([0,1,121,3,2,5,45,230]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var h;(function(b){function w(m){return m&&typeof m=="object"&&typeof m.id=="string"}b.isThemeColor=w})(h=e.ThemeColor||(e.ThemeColor={}));function p(b){return{id:b}}e.themeColorFromId=p;var I;(function(b){function w(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||h.isThemeColor(n.color))}b.isThemeIcon=w;const m=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function g(n){const o=m.exec(n);if(!o)return;const[,a]=o;return{id:a}}b.fromString=g;function u(n){return{id:n}}b.fromId=u;function c(n,o){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),o&&(a=`${a}~${o}`),{id:a}}b.modify=c;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}b.getModifier=s;function r(n,o){return n.id===o.id&&n.color?.id===o.color?.id}b.isEqual=r;function i(n,o){return{id:n.id,color:o?p(o):void 0}}b.asThemeIcon=i,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function E(b){switch(b){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,k.toDisposable)(()=>{const m=this.themingParticipants.indexOf(w);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const f=new S;D.Registry.add(e.Extensions.ThemingContribution,f);function d(b){return f.onColorThemeChange(b)}e.registerThemingParticipant=d;class C extends k.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,m){let g=this.theme.getColor(w);return g&&m&&(g=m(g,this.theme)),g?g.toString():null}}e.Themable=C}),define(Z[64],ee([0,1,15,3,2,4,19,5,41]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const p="#FFFFFF",I="#1E1E1E",E="#000000",S="#FFFFFF",f="theme",d="themeBackground",C="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(m,g){super();this.stateMainService=m,this.configurationService=g,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return m.dark?E:S;let g=this.stateMainService.getItem(d,null);if(!g)switch(this.stateMainService.getItem(f,"vs-dark").split(" ")[0]){case"vs":g=p;break;case"hc-black":g=E;break;case"hc-light":g=S;break;default:g=I}return R.isMacintosh&&g.toUpperCase()===I&&(g="#171717"),g}saveWindowSplash(m,g){this.stateMainService.setItems([{key:f,data:g.baseTheme},{key:d,data:g.colorInfo.background},{key:C,data:g}]),typeof m=="number"&&this.updateBackgroundColor(m,g)}updateBackgroundColor(m,g){for(const u of v.BrowserWindow.getAllWindows())if(u.id===m){u.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(C)}};b=ve([J(0,h.IStateMainService),J(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(Z[112],ee([0,1,3,4,5,6]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(C){C.Http="http",C.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(C){C.ConstantPrivate="constantPrivate",C.Private="private",C.Public="public"})(y=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(C){C[C.Notify=1]="Notify",C[C.OpenBrowser=2]="OpenBrowser",C[C.OpenPreview=3]="OpenPreview",C[C.Silent=4]="Silent",C[C.Ignore=5]="Ignore",C[C.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(C){if(C.scheme!=="http"&&C.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(C.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(C){return e.LOCALHOST_ADDRESSES.indexOf(C)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(C){return e.ALL_INTERFACES_ADDRESSES.indexOf(C)>=0}e.isAllInterfaces=E;function S(C,b){return b?b!==1&&C<1024:!t.isWindows&&C<1024}e.isPortPrivileged=S;class f{constructor(b,w,m){this.remoteAddress=b,this.localAddress=w,this._dispose=m,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let d=class{constructor(b){this.logService=b,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],w=Array.from(this._tunnels.values());for(const m of w){const g=Array.from(m.values());for(const u of g){const c=await u.value;c&&b.push(c)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:w}of b.values())await w.then(m=>m?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,w,m,g,u=!1,c,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${m} on local port ${g}.`),!b)return;if(w||(w="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(b,w,m,g,u,c,s);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==w||i.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const w=this._tunnels.get(b.tunnelRemoteHost);if(w){const m=w.get(b.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,m))}}}}async tryDisposeTunnel(b,w,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${w}.`);const g=m.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(w),g}}async closeTunnel(b,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${w} `);const m=this._tunnels.get(b);if(m&&m.has(w)){const g=m.get(w);g.refcount=0,await this.tryDisposeTunnel(b,w,g)}}addTunnelToMap(b,w,m){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(w,{refcount:1,value:m})}async removeEmptyTunnelFromMap(b,w){const m=this._tunnels.get(b);m&&(await m.get(w)||m.delete(w),m.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,w){const m=[b];I(b)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(b)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const g=m.map(u=>this._tunnels.get(u));for(const u of g){const c=u?.get(w);if(c)return c}}canTunnel(b){return!!p(b)}createWithProvider(b,w,m,g,u,c,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${m} on local port ${g}.`);const r=m;this._factoryInProgress.add(r);const n={elevationRequired:u?S(g===void 0?m:g):!1},o={remoteAddress:{host:w,port:m},localAddressPort:g,privacy:c,public:c?c!==y.Private:void 0,protocol:s},a=b.forwardPort(o,n);return a?(this.addTunnelToMap(w,m,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};d=ve([J(0,R.ILogService)],d),e.AbstractTunnelService=d}),define(Z[232],ee([0,1,77,92,217,8,2,19,6,20,216,112,87]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(m,g,u,c,s){let r;for(let i=3;i&&(r?.dispose(),r=await new d(m,g,u,c,s).waitForReady(),!(s&&t.BROWSER_RESTRICTED_PORTS[s]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class d extends D.Disposable{constructor(g,u,c,s,r){super();this.defaultTunnelHost=u,this.suggestedLocalPort=r,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let g=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(g){g.pause();const u=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),s=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&g.write(r.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),s.end()}),g.on("close",()=>s.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),s.destroy()}),s.on("end",()=>g.end()),s.on("close",()=>g.end()),s.on("error",()=>{g.destroy()}),g.pipe(s),s.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),s.end()})}}let C=class extends E.AbstractTunnelService{constructor(g,u,c,s,r){super(u);this.socketFactory=g,this.signService=c,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,u,c,s,r,i,n){const o=this.getTunnelFromMap(u,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,s,r,i,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${s}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},l=f(a,this.defaultTunnelHost,u,c,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};C=ve([J(1,h.ILogService),J(2,S.ISignService),J(3,p.IProductService),J(4,y.IConfigurationService)],C),e.BaseTunnelService=C;let b=class extends C{constructor(g,u,c,s){super(k.nodeSocketFactory,g,u,c,s)}};b=ve([J(0,h.ILogService),J(1,S.ISignService),J(2,p.IProductService),J(3,y.IConfigurationService)],b),e.TunnelService=b;let w=class extends D.Disposable{constructor(g,u,c,s){super();this.logService=g,this.productService=u,this.signService=c,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(g,u,c,s,r,i,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${r}.`),!this._tunnelServices.has(g)){const a=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(g,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(u,c,s,r,i,n,o)}};w=ve([J(0,h.ILogService),J(1,p.IProductService),J(2,S.ISignService),J(3,y.IConfigurationService)],w),e.SharedTunnelsService=w}),define(Z[46],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[233],ee([0,1,4,169,62,45]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[234],ee([0,1,3,46]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(y){this.service=y}listen(y,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(y,h,p){switch(h){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(p)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=k;class R{constructor(y){this.channel=y,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(y){this._state=y,this._onStateChange.fire(y)}checkForUpdates(y){return this.channel.call("checkForUpdates",y)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(y){return this.channel.call("_applySpecificUpdate",y)}}e.UpdateChannelClient=R}),define(Z[88],ee([0,1,8,21,3,19,25,22,6,20,53,46]),function(H,e,v,t,k,R,D,y,h,p,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(d,C,b){return`${b.updateUrl}/api/update/${d}/${C}/${b.commit}`}e.createUpdateURL=S;let f=class{constructor(C,b,w,m,g,u){this.lifecycleMainService=C,this.configurationService=b,this.environmentMainService=w,this.requestService=m,this.logService=g,this.productService=u,this._state=E.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(C){this.logService.info("update#setState",C.type),this._state=C,this._onStateChange.fire(C)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const C=this.getUpdateMode(),b=this.getProductQuality(C);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),C==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}C==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(C){return C==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(C=60*60*1e3){return(0,v.timeout)(C).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(C){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(C)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(C){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(C=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${C}`),!C&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(C){}getUpdateType(){return 1}doQuitAndInstall(){}};f=ve([J(0,y.ILifecycleMainService),J(1,R.IConfigurationService),J(2,D.IEnvironmentMainService),J(3,I.IRequestService),J(4,h.ILogService),J(5,p.IProductService)],f),e.AbstractUpdateService=f}),define(Z[235],ee([0,1,15,51,3,2,19,25,22,6,20,53,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let C=class extends d.AbstractUpdateService{constructor(w,m,g,u,c,s,r){super(w,m,u,c,s,r);this.telemetryService=g,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,m)=>m)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,m,g)=>({url:m,version:g,productVersion:g}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,m,g,u)=>({releaseNotes:m,version:g,productVersion:g,date:u}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(f.State.Idle(1,g))}buildUpdateFeedUrl(w){let m;this.productService.darwinUniversalAssetId?m=this.productService.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,d.createUpdateURL)(m,w,this.productService);try{v.autoUpdater.setFeedURL({url:g})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return g}doCheckForUpdates(w){this.setState(f.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(f.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],C.prototype,"onRawError",null),ve([t.memoize],C.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],C.prototype,"onRawUpdateAvailable",null),ve([t.memoize],C.prototype,"onRawUpdateDownloaded",null),C=ve([J(0,h.ILifecycleMainService),J(1,D.IConfigurationService),J(2,S.ITelemetryService),J(3,y.IEnvironmentMainService),J(4,E.IRequestService),J(5,p.ILogService),J(6,I.IProductService)],C),e.DarwinUpdateService=C}),define(Z[236],ee([0,1,50,29,8,3,9,25,22,6,38,46]),function(H,e,v,t,k,R,D,y,h,p,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(C,b,w){if(this.lifecycleMainService=C,this.logService=w,this._state=E.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}get state(){return this._state}setState(C){this.logService.info("update#setState",C.type),this._state=C,this._onStateChange.fire(C)}scheduleCheckForUpdates(C=60*60*1e3){return(0,k.timeout)(C).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(C){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(C)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(C){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(C=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${C}`),!C&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(C){}};S=ve([J(0,h.ILifecycleMainService),J(1,y.IEnvironmentMainService),J(2,p.ILogService)],S);let f=class extends S{constructor(C,b,w,m,g,u){super(w,m,g);this.snap=C,this.snapRevision=b,this.telemetryService=u;const c=(0,t.watch)(D.dirname(this.snap)),s=R.Event.fromNodeEventEmitter(c,"change",(o,a)=>a),r=R.Event.filter(s,o=>o==="current"),n=R.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{n.dispose(),c.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(C=>{C?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,C.message||C))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const C=await new Promise((w,m)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(g,u)=>g?m(g):w(u))),b=D.basename(C);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,C=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=ve([J(2,h.ILifecycleMainService),J(3,y.IEnvironmentMainService),J(4,p.ILogService),J(5,I.ITelemetryService)],f),e.SnapUpdateService=f}),define(Z[54],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(Z[237],ee([0,1,54,188,14,16,127,3,2]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class p{constructor(S){this.uri=S,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let I=class{constructor(S){this._fileService=S,this._dispooables=new h.DisposableStore,this._limit=2**16;const f=new Map,d=C=>{let b=f.get(C.scheme);return b===void 0&&(b=S.hasProvider(C)&&!this._fileService.hasCapability(C,1024),f.set(C.scheme,b)),b};this._dispooables.add(y.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(C=>{f.delete(C.scheme)})),this.extUri=new R.ExtUri(d),this._canonicalUris=new D.SkipList((C,b)=>this.extUri.compare(C,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new p(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((d,C)=>d[1].touch<C[1].touch?1:d[1].touch>C[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let d=0;d<f;d++)this._canonicalUris.set(S[d][0],S[d][1].touch())}};I=ve([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(v.IUriIdentityService,I,!0)}),define(Z[113],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[238],ee([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(y){this.handler=y}listen(y,h){throw new Error(`Event not found: ${h}`)}call(y,h,p){switch(h){case"handleURL":return this.handler.handleURL(v.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=t;class k{constructor(y){this.channel=y}handleURL(y,h){return this.channel.call("handleURL",[y.toJSON(),h])}}e.URLHandlerChannelClient=k;class R{constructor(y){this.next=y}async routeCall(y,h,p,I){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(p){const E=v.URI.revive(p);if(E&&E.query){const S=/\bwindowId=(\d+)/.exec(E.query);if(S){const f=S[1],d=new RegExp(`window:${f}`),C=y.connections.find(b=>d.test(b.ctx));if(C)return C}}}return this.next.routeCall(y,h,p,I)}routeEvent(y,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=R}),define(Z[239],ee([0,1,8,2,7,20]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,I){const E=[...this.handlers.values()];return(0,v.first)(E.map(S=>()=>S.handleURL(p,I)),void 0,!1).then(S=>S||!1)}registerHandler(p){return this.handlers.add(p),(0,t.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=D;let y=class extends D{constructor(p){super();this.productService=p}create(p){let{authority:I,path:E,query:S,fragment:f}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&E&&E.indexOf("/")!==0&&(E=`/${E}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:E,query:S,fragment:f})}};y=ve([J(0,R.IProductService)],y),e.NativeURLService=y}),define(Z[240],ee([0,1,15,8,3,2,4,7]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(I){try{return y.URI.parse(I)}catch{return null}}class p{constructor(E,S,f,d,C){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=E,D.isWindows){const m=d.isBuilt?[]:[`"${d.appRoot}"`];m.push("--open-url","--"),v.app.setAsDefaultProtocolClient(C.urlProtocol,process.execPath,m)}const b=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(m,g)=>({event:m,url:g})),({event:m,url:g})=>(m.preventDefault(),g));this.disposables.add(b(m=>{const g=h(m);!g||this.urlService.open(g,{originalUrl:m})})),f.getWindows().filter(m=>m.isReady).length>0?this.flush():k.Event.once(f.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||E.push(S);E.length!==0&&(this.uris=E,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Z[241],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[242],ee([0,1,15,2,13,7]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,h)}handleWebviewRequest(h,p){try{const I=R.URI.parse(h.url),E=D.validWebviewFilePaths.get(I.path);if(typeof E=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${E}`,f=k.FileAccess.asFileUri(S,H);return p(decodeURIComponent(f.fsPath))}else return p({error:-10})}catch{}return p({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[74],ee([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.isUserDataProfileInfo=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(E){return!!E.workspaceUri}e.isWorkspaceToOpen=t;function k(E){return!!E.folderUri}e.isFolderToOpen=k;function R(E){return!!E.fileUri}e.isFileToOpen=R;function D(E){const S=y(E),f=E.getValue("window.menuBarVisibility");return f==="default"||S==="native"&&f==="compact"||v.isMacintosh&&v.isNative?"classic":f}e.getMenuBarVisibility=D;function y(E){if(v.isWeb)return"custom";const S=E.getValue("window");if(S){if(v.isMacintosh&&S.nativeTabs===!0||v.isMacintosh&&S.nativeFullScreen===!1)return"native";const C=S.titleBarStyle;if(C==="native"||C==="custom")return C}return v.isLinux?"native":"custom"}e.getTitleBarStyle=y;function h(E,S){if(!v.isWindows||v.isWeb||!S.isBuilt||y(E)==="native")return!1;const f=E.getValue("window.experimental.windowControlsOverlay.enabled");return typeof f=="boolean"?f:!0}e.useWindowControlsOverlay=h;function p(E){const S=E;return!!(S&&typeof S=="object"&&typeof S.name=="string")}e.isUserDataProfileInfo=p;function I(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=I}),define(Z[114],ee([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(y){y[y.INITIAL=1]="INITIAL",y[y.LOAD=2]="LOAD",y[y.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(y){y[y.CLOSE=1]="CLOSE",y[y.QUIT=2]="QUIT",y[y.RELOAD=3]="RELOAD",y[y.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(y=1){return{width:1024,height:768,mode:y}};e.defaultWindowState=k;var R;(function(y){y[y.Maximized=0]="Maximized",y[y.Normal=1]="Normal",y[y.Minimized=2]="Minimized",y[y.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(y){y[y.UNRESPONSIVE=1]="UNRESPONSIVE",y[y.CRASHED=2]="CRASHED",y[y.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(Z[33],ee([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[243],ee([0,1,15,21,3,67,2,28,69,102,6,20,33]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(C){C[C.Initial=1]="Initial",C[C.StoredCredentialsUsed=2]="StoredCredentialsUsed",C[C.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let d=class extends D.Disposable{constructor(b,w,m,g,u){super();this.logService=b,this.windowsMainService=w,this.credentialsService=m,this.encryptionMainService=g,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(v.app,"login",(w,m,g,u,c)=>({event:w,webContents:m,req:g,authInfo:u,callback:c}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:w,req:m,callback:g}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&m.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}g(u?.username,u?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(b);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const w=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let m,g;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));m=i.username,g=i.password}}catch(r){this.logService.error(r)}if(this.state!==f.StoredCredentialsUsed&&typeof m=="string"&&typeof g=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:m,password:g};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:b,username:this.sessionCredentials?.username??m,password:this.sessionCredentials?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,y.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=f.LoginDialogShown;const s=await new Promise(r=>{const i=async(n,o,a)=>{if(o===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),a){const l={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(P){this.logService.error(P)}r({username:l.username,password:l.password})}else r(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=s,s}};d=ve([J(0,I.ILogService),J(1,S.IWindowsMainService),J(2,h.ICredentialsMainService),J(3,p.IEncryptionMainService),J(4,E.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[244],ee([0,1,69,6,37,20,33,200]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=class extends y.BaseCredentialsMainService{constructor(I,E,S,f){super(I);this.environmentMainService=E,this.productService=S,this.windowsMainService=f,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((E,S)=>{H(["keytar"],E,S)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};h=ve([J(0,t.ILogService),J(1,k.INativeEnvironmentService),J(2,R.IProductService),J(3,D.IWindowsMainService)],h),e.CredentialsNativeMainService=h}),define(Z[245],ee([0,1,18,2,3,6,22,79,50,273,8,13,49,4,35,15,33]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const w=C.UtilityProcess,m=typeof w!="undefined";let g=class Lt{constructor(r,i,n){this._logService=r,this._windowsMainService=n,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return m}async createExtensionHost(r){if(this._shutdown)throw(0,v.canceled)();const i=String(++Lt._lastId);let n;if(r){if(!m)throw new Error("Cannot use UtilityProcess!");n=new c(i,this._logService,this._windowsMainService)}else n=new u(i,this._logService);return this._extHosts.set(i,n),n.onExit(({pid:o,code:a,signal:l})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${l}.`),setTimeout(()=>{n.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,n]of this._extHosts)i.push(n.waitForExit(r));return I.Promises.settled(i).then(()=>{})}};g._lastId=0,g=ve([J(0,R.ILogService),J(1,D.ILifecycleMainService),J(2,b.IWindowsMainService)],g),e.ExtensionHostStarter=g;let u=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){f.isCI&&this._logService.info("Calling fork to start extension host...");const i=y.StopWatch.create(!1);this._process=(0,h.fork)(E.FileAccess.asFileUri("bootstrap-fork",H).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,d.cwd)()},r));const n=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${n} ms).`);const a=new p.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const l=new p.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};u=ve([J(1,R.ILogService)],u);let c=class extends t.Disposable{constructor(r,i,n){super();this.id=r,this._logService=i,this._windowsMainService=n,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const n=i.win;if(!n||n.isDestroyed()||n.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=E.FileAccess.asFileUri("bootstrap-fork.js",H).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=r.execArgv||[],M={...r.env};for(const re of Object.keys(M))M[re]=String(M[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new w(a,l,{serviceName:o,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const A=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(A(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const F=(re,le)=>{le.type==="Utility"&&le.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};C.app.on("child-process-gone",F),this._register((0,t.toDisposable)(()=>{C.app.off("child-process-gone",F)}));const{port1:U,port2:Q}=new C.MessageChannelMain;this._process.postMessage("port",null,[Q]),n.webContents.postMessage(r.responseChannel,r.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};c=ve([J(1,R.ILogService),J(2,b.IWindowsMainService)],c)}),define(Z[246],ee([0,1,15,3,2,242,33]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let y=class extends k.Disposable{constructor(p){super();this.windowsMainService=p,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(p,I){let E;if(typeof p.windowId=="number"){const{windowId:S}=p,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);E=f.win.webContents}else{const{webContentsId:S}=p;if(E=v.webContents.fromId(S),!E)throw new Error(`Invalid webContentsId: ${S}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(I)}async findInFrame(p,I,E,S){const d=this.getFrameByName(p,I);if(typeof d.findInFrame=="function"){d.findInFrame(E,{findNext:S.findNext,forward:S.forward});const C=(b,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),d.removeListener("found-in-frame",C))};d.on("found-in-frame",C)}}async stopFindInFrame(p,I,E){const f=this.getFrameByName(p,I);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(p,I){const E=this.windowsMainService.getWindowById(p.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${p}`);const S=E.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===I);if(!S)throw new Error(`Unknown frame: ${I}`);return S}};y=ve([J(0,D.IWindowsMainService)],y),e.WebviewMainService=y}),define(Z[247],ee([0,1,8,3,2]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:y,onDidFocusWindow:h,getActiveWindowId:p}){super();this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(y,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>p()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(y){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=y}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[26],ee([0,1,173,9,32,16,7,5,13]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=p;function I(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=I;function E(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=E;function S(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=S;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function C(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=C;class b{constructor(n,o,a,l,P){this._id=n,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class w{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function m(i){return new w({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=c;function s(i,n){return!u(i,n)&&!c(i)}e.isSavedWorkspace=s;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===g}e.hasWorkspaceFileExtension=r}),define(Z[248],ee([0,1,76,29,31,13,9,4,16,7,23,177,19,25,14,6,176,26]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class{constructor(u,c,s){this.configurationService=c,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,k.isEqual)(r,i,!y.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:p.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let s=[];try{Array.isArray(u.folderWorkspaceInfos)?s=u.folderWorkspaceInfos.map(r=>({folderUri:p.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(s=u.folderURIWorkspaces.map(r=>({folderUri:p.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(r=>u.workspace.id===r.workspace.id)||(this.workspaces.push(u),this.saveSync());const s=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(s,c),s}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,s=this.workspaces.findIndex(r=>r.workspace.id===c);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(s=>this.backupUriComparer.isEqual(u,s.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const s=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:c}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,D.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,s=[];for(const r of u){const i=r.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const n=this.getBackupPath(i.id);await this.doHasBackups(n)?i.configPath.scheme!==R.Schemas.file||await I.Promises.exists(i.configPath.fsPath)?s.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return s}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.folderUri,n=this.backupUriComparer.getComparisonKey(i);if(!s.has(n)){s.add(n);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await I.Promises.exists(i.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],s=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!s.has(i)){s.add(i);const n=this.getBackupPath(i);await this.doHasBackups(n)?c.push(r):await this.deleteStaleBackup(n)}}return c}async deleteStaleBackup(u){try{await I.Promises.exists(u)&&await I.Promises.rm(u,I.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{await I.Promises.rename(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const s=this.getBackupPath(c);try{t.renameSync(u,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,E.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,b.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await I.Promises.readdir(u);for(const s of c)try{if((await I.Promises.readdir((0,D.join)(u,s))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,I.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let s;return c.scheme===R.Schemas.file?s=y.isLinux?c.fsPath:c.fsPath.toLowerCase():s=c.toString().toLowerCase(),(0,v.createHash)("md5").update(s).digest("hex")}};m=ve([J(0,f.IEnvironmentMainService),J(1,S.IConfigurationService),J(2,C.ILogService)],m),e.BackupMainService=m}),define(Z[55],ee([0,1,15,8,67,36,2,80,4,12,23,151,5,6,26]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let C=class{constructor(w){this.logService=w,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(w,m){return this.doPick({...w,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},m)}pickFolder(w,m){return this.doPick({...w,pickFolders:!0,title:(0,E.localize)(1,null)},m)}pickFile(w,m){return this.doPick({...w,pickFiles:!0,title:(0,E.localize)(2,null)},m)}pickWorkspace(w,m){const g=(0,E.localize)(3,null),u=(0,R.mnemonicButtonLabel)((0,E.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...w,pickFiles:!0,title:g,filters:c,buttonLabel:u},m)}async doPick(w,m){const g={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(g.properties=void 0,w.pickFiles&&w.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&g.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(g,(0,p.withNullAsUndefined)(m||v.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(w){if(w){let m=this.windowDialogQueues.get(w.id);return m||(m=new t.Queue,this.windowDialogQueues.set(w.id,m)),m}else return this.noWindowDialogueQueue}showMessageBox(w,m){return this.getWindowDialogQueue(m).queue(async()=>m?v.dialog.showMessageBox(m,w):v.dialog.showMessageBox(w))}async showSaveDialog(w,m){const g=this.acquireFileDialogLock(w,m);if(!g)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(m).queue(async()=>{let u;return m?u=await v.dialog.showSaveDialog(m,w):u=await v.dialog.showSaveDialog(w),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,D.dispose)(g)}}normalizePath(w){return w&&h.isMacintosh&&(w=(0,y.normalizeNFC)(w)),w}normalizePaths(w){return w.map(m=>this.normalizePath(m))}async showOpenDialog(w,m){w.defaultPath&&(await I.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const g=this.acquireFileDialogLock(w,m);if(!g)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(m).queue(async()=>{let u;return m?u=await v.dialog.showOpenDialog(m,w):u=await v.dialog.showOpenDialog(w),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,D.dispose)(g)}}acquireFileDialogLock(w,m){if(!m)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",w);let g=this.windowFileDialogLocks.get(m.id);g||(g=new Set,this.windowFileDialogLocks.set(m.id,g));const u=(0,k.hash)(w);if(!g.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",w),g.add(u),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",w),g?.delete(u),g?.size===0&&this.windowFileDialogLocks.delete(m.id)})}};C=ve([J(0,f.ILogService)],C),e.DialogMainService=C}),define(Z[249],ee([0,1,3,2,58,26]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(h,p){super();this.logService=h,this.storageMainService=p,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(p.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,p){this._register(v.Event.debounce(h.onDidChangeStorage,(I,E)=>(I?I.push(E):I=[E],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&p.fire(this.serializeStorageChangeEvents(I,h))}))}serializeStorageChangeEvents(h,p){const I=new Map,E=new Set;return h.forEach(S=>{const f=p.get(S.key);typeof f=="string"?I.set(S.key,f):E.add(S.key)}),{changed:Array.from(I.entries()),deleted:Array.from(E.values())}}listen(h,p,I){switch(p){case"onDidChangeStorage":{const E=I.profile?(0,k.revive)(I.profile):void 0;if(!E)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(E.id);return S||(S=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(E),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(E.id,S)),S.event}}throw new Error(`Event not found: ${p}`)}async call(h,p,I){const E=I.profile?(0,k.revive)(I.profile):void 0,S=(0,R.reviveIdentifier)(I.workspace),f=await this.withStorageInitialized(E,S);switch(p){case"getItems":return Array.from(f.items.entries());case"updateItems":{const d=I;if(d.insert)for(const[C,b]of d.insert)f.set(C,b);d.delete?.forEach(C=>f.delete(C));break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(h,p){let I;p?I=this.storageMainService.workspaceStorage(p):h?I=this.storageMainService.profileStorage(h):I=this.storageMainService.applicationStorage;try{await I.init()}catch(E){this.logService.error(`StorageIPC#init: Unable to init ${p?"workspace":h?"profile":"application"} storage due to ${E}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[34],ee([0,1,67,3,2,16,12,7,170,37,14,5,6,26,32,54,8,28]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&y.URI.isUri(r.location)&&y.URI.isUri(r.globalStorageHome)&&y.URI.isUri(r.settingsResource)&&y.URI.isUri(r.keybindingsResource)&&y.URI.isUri(r.tasksResource)&&y.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||y.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function g(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:y.URI.revive(s.location).with({scheme:r}),globalStorageHome:y.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:y.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:y.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:y.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:y.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:y.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(s,r,i){return{id:(0,v.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i}}e.toUserDataProfile=u;let c=class extends k.Disposable{constructor(r,i,n,o){super();this.environmentService=r,this.fileService=i,this.uriIdentityService=n,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(a=>u(a.name,a.location,a.useDefaultFlags)):[];let i;const n=new d.ResourceMap,o=u((0,h.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[l,P]of Object.entries(a.workspaces)){const M=y.URI.parse(l),A=y.URI.parse(P),F=r.find(U=>this.uriIdentityService.extUri.isEqual(U.location,A));F&&n.set(M,F)}if(a.emptyWindow){const l=y.URI.parse(a.emptyWindow);i=r.find(P=>this.uriIdentityService.extUri.isEqual(P.location,l))}}this._profilesObject={profiles:r,workspaces:n,emptyWindow:i}}return this._profilesObject}async reload(){return this._profilesObject=void 0,this.profiles}getProfile(r,i){if(!this.enabled)return this.defaultProfile;const n=this.getWorkspace(r);let o=y.URI.isUri(n)?this.profilesObject.workspaces.get(n):this.profilesObject.emptyWindow;return o||(o=i,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,f.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,f.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.doCreateProfile(r,i);return n&&await this.setProfileForWorkspace(o,n),o}async doCreateProfile(r,i){let n=this.profileCreationPromises.get(r);return n||(n=(async()=>{try{const o=this.profiles.find(P=>P.name===r);if(o)return o;const a=u(r,(0,R.joinPath)(this.profilesHome,(0,v.hash)((0,w.generateUuid)()).toString(16)),i);await this.fileService.createFolder(a.location);const l=[];return this._onWillCreateProfile.fire({profile:a,join(P){l.push(P)}}),await b.Promises.settled(l),this.updateProfiles([a],[],[]),a}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,n)),n}async updateProfile(r,i,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=u(i,o.location,n),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const n=this.profiles.find(o=>o.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,n)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);const n=[];this._onWillRemoveProfile.fire({profile:i,join(o){n.push(o)}}),await b.Promises.settled(n),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,i,n){const o=[];for(let a of[...this.profilesObject.profiles,...r])a.isDefault||i.some(l=>a.id===l.id)||(a=n.find(l=>a.id===l.id)??a,o.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,i,n)}triggerProfilesChanges(r,i,n){this._onDidChangeProfiles.fire({added:r,removed:i,updated:n,all:this.profiles})}updateWorkspaceAssociation(r,i){const n=this.getWorkspace(r);y.URI.isUri(n)?(this.profilesObject.workspaces.delete(n),i&&this.profilesObject.workspaces.set(n,i)):this.profilesObject.emptyWindow=i,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[n,o]of this.profilesObject.workspaces.entries())r[n.toString()]=o.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};c.PROFILES_KEY="userDataProfiles",c.PROFILE_ASSOCIATIONS_KEY="profileAssociations",c=ve([J(0,p.IEnvironmentService),J(1,I.IFileService),J(2,C.IUriIdentityService),J(3,S.ILogService)],c),e.UserDataProfilesService=c}),define(Z[89],ee([0,1,24,8,49,17,18,42,137,2,13,9,4,16,186,94,12,7,155,37,109,108,185,14,5,6,20,3,58,72,34,54]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ue){function K(N,W){if(N===W)return!0;const _=Object.keys(N),T=new Set;for(const $ of Object.keys(W))T.add($);if(_.length!==T.size)return!1;for(const $ of _){if(N[$]!==W[$])return!1;T.delete($)}return T.size===0}ue.equals=K})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let U=class extends p.Disposable{constructor(K,N,W,_,T,$,x,z,q,L,O){super();this.systemExtensionsLocation=K,this.userExtensionsLocation=N,this.extensionsControlLocation=W,this.cacheLocation=_,this.userDataProfilesService=T,this.extensionsProfileScannerService=$,this.fileService=x,this.logService=z,this.environmentService=q,this.productService=L,this.instantiationService=O,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(le,(0,f.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(le,(0,f.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,N){const[W,_]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(N)]),T=await this.scanExtensionsUnderDevelopment(K,[...W,..._]);return this.dedupExtensions(W,_,T,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const N=[];N.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),N.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[W,_]=await Promise.all(N);return this.applyScanOptions([...W,..._],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let _=await(K.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return _=await this.applyScanOptions(_,1,K,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(K,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const W=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===I.Schemas.file).map(async _=>{const T=await this.createExtensionScannerInput(_,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(T)).map(x=>(x.type=N.find(z=>(0,u.areSameExtensions)(z.identifier,x.identifier))?.type??x.type,this.extensionsScanner.validate(x,T)))}))).flat();return this.applyScanOptions(W,"development",K,!0)}return[]}async scanExistingExtension(K,N,W){const _=await this.createExtensionScannerInput(K,!1,N,!0,W.language),T=await this.extensionsScanner.scanExtension(_);return!T||!W.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(K,N,W){const _=await this.createExtensionScannerInput(K,!1,N,!0,W.language),T=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions(T,N,W,!0)}async scanMetadata(K){const N=(0,f.joinPath)(K,"package.json"),W=(await this.fileService.readFile(N)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(K,N){const W=(0,f.joinPath)(K,"package.json"),_=(await this.fileService.readFile(W)).value.toString(),T=JSON.parse(_);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,T.__metadata={...T.__metadata,...N},await this.fileService.writeFile((0,f.joinPath)(K,"package.json"),R.VSBuffer.fromString(JSON.stringify(T,null,"	")))}async applyScanOptions(K,N,W,_){return W.includeAllVersions||(K=this.dedupExtensions(N===0?K:void 0,N===1?K:void 0,N==="development"?K:void 0,await this.getTargetPlatform(),_)),W.includeInvalid||(K=K.filter(T=>T.isValid)),K.sort((T,$)=>{const x=E.basename(T.location.fsPath),z=E.basename($.location.fsPath);return x<z?-1:x>z?1:0})}dedupExtensions(K,N,W,_,T){const $=(z,q,L)=>{if(z.isValid&&!q.isValid)return!1;if(z.isValid===q.isValid){if(T&&d.gt(z.manifest.version,q.manifest.version))return this.logService.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(d.eq(z.manifest.version,q.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${q.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===_)return this.logService.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${z.location.path} with ${q.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${q.location.path}.`),!0},x=new Map;return K?.forEach(z=>{const q=c.ExtensionIdentifier.toKey(z.identifier.id),L=x.get(q);(!L||$(L,z,!1))&&x.set(q,z)}),N?.forEach(z=>{const q=c.ExtensionIdentifier.toKey(z.identifier.id),L=x.get(q);if(!L&&K&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!L||$(L,z,!1))&&x.set(q,z)}),W?.forEach(z=>{const q=c.ExtensionIdentifier.toKey(z.identifier.id),L=x.get(q);(!L||$(L,z,!0))&&x.set(q,z),x.set(q,z)}),[...x.values()]}async scanDefaultSystemExtensions(K,N){this.logService.trace("Started scanning system extensions");const W=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),T=await(K&&!W.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return this.logService.trace("Scanned system extensions:",T.length),T}async scanDevSystemExtensions(K,N){const W=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!W?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=N?await this.getBuiltInExtensionControl():{},T=[],$=w.URI.file(E.normalize(E.join(I.FileAccess.asFileUri("",H).fsPath,"..",".build","builtInExtensions")));for(const z of W){const q=_[z.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":T.push((0,f.joinPath)($,z.name));break;default:T.push(w.URI.file(q));break}}const x=await Promise.all(T.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",x.length),(0,v.coalesce)(x)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,N,W,_,T,$=!0){const x=await this.getTranslations(T??S.language),z=await this.getMtime(K),q=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=q?await this.getMtime(q):void 0;return new Q(K,z,q,L,N,W,_,$,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,T,x)}async getMtime(K){try{const N=await this.fileService.stat(K);if(typeof N.mtime=="number")return N.mtime}catch{}}};U=ve([J(4,M.IUserDataProfilesService),J(5,P.IExtensionsProfileScannerService),J(6,r.IFileService),J(7,n.ILogService),J(8,g.IEnvironmentService),J(9,o.IProductService),J(10,i.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class Q{constructor(K,N,W,_,T,$,x,z,q,L,O,B,V,X){this.location=K,this.mtime=N,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=_,this.profile=T,this.type=$,this.excludeObsolete=x,this.validate=z,this.productVersion=q,this.productDate=L,this.productCommit=O,this.devMode=B,this.language=V,this.translations=X}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,N){return(0,f.isEqual)(K.location,N.location)&&K.mtime===N.mtime&&(0,f.isEqual)(K.applicationExtensionslocation,N.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&K.profile===N.profile&&K.type===N.type&&K.excludeObsolete===N.excludeObsolete&&K.validate===N.validate&&K.productVersion===N.productVersion&&K.productDate===N.productDate&&K.productCommit===N.productCommit&&K.devMode===N.devMode&&K.language===N.language&&F.equals(K.translations,N.translations)}}let re=class extends p.Disposable{constructor(K,N,W,_,T){super();this.obsoleteFile=K,this.extensionsProfileScannerService=N,this.uriIdentityService=W,this.fileService=_,this.logService=T}async scanExtensions(K){const N=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let W={};if(K.excludeObsolete&&K.type===1)try{const _=(await this.fileService.readFile(this.obsoleteFile)).value.toString();W=JSON.parse(_)}catch{}return(0,b.isEmptyObject)(W)?N:N.filter(_=>!W[u.ExtensionKey.create(_).toString()])}async scanExtensionsFromLocation(K){const N=await this.fileService.resolve(K.location);if(!N.children?.length)return[];const W=await Promise.all(N.children.map(async _=>{if(!_.isDirectory||K.type===1&&(0,f.basename)(_.resource).indexOf(".")===0)return null;const T=new Q(_.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(T)}));return(0,v.coalesce)(W).sort((_,T)=>_.location.path<T.location.path?-1:1)}async scanExtensionsFromProfile(K){let N=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){N=N.filter(_=>!_.metadata?.isApplicationScoped);const W=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,_=>!!_.metadata?.isApplicationScoped,K);N.push(...W)}return N}async scanExtensionsFromProfileResource(K,N,W){const _=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!_.length)return[];const T=await Promise.all(_.map(async $=>{if(N($)){const x=new Q($.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(x,$.metadata)}return null}));return(0,v.coalesce)(T)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,f.joinPath)(K.location,"package.json"))){const N=await this.scanExtension(K);return N?[N]:[]}else return await this.scanExtensions(K)}catch(N){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,D.getErrorMessage)(N)),[]}}async scanExtension(K,N){try{let W=await this.scanExtensionManifest(K.location);if(W){W.publisher||(W.publisher=c.UNDEFINED_PUBLISHER),N=N??W.__metadata,delete W.__metadata;const _=(0,u.getGalleryExtensionId)(W.publisher,W.name),T=N?.id?{id:_,uuid:N.id}:{id:_},$=N?.isSystem?0:K.type,x=$===0||!!N?.isBuiltin;W=await this.translateManifest(K.location,W,Q.createNlsConfiguration(K));const z={type:$,identifier:T,manifest:W,location:K.location,isBuiltin:x,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return K.validate?this.validate(z,K):z}}catch(W){K.type!==0&&this.logService.error(W)}return null}validate(K,N){let W=!0;const _=(0,s.validateExtensionManifest)(N.productVersion,N.productDate,N.location,K.manifest,K.isBuiltin);for(const[T,$]of _)T===C.default.Error&&(W=!1,this.logService.error(this.formatMessage(N.location,$)));return K.isValid=W,K.validations=_,K}async scanExtensionManifest(K){const N=(0,f.joinPath)(K,"package.json");let W;try{W=(await this.fileService.readFile(N)).value.toString()}catch(T){return(0,r.toFileOperationResult)(T)!==1&&this.logService.error(this.formatMessage(K,(0,m.localize)(0,null,N.path,T.message))),null}let _;try{_=JSON.parse(W)}catch{const $=[];(0,y.parse)(W,$);for(const x of $)this.logService.error(this.formatMessage(K,(0,m.localize)(1,null,N.path,x.offset,x.length,(0,h.getParseErrorMessage)(x.error))));return null}return(0,y.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(K,(0,m.localize)(2,null,N.path))),null):_}async translateManifest(K,N,W){const _=await this.getLocalizedMessages(K,N,W);if(_)try{const T=[],$=await this.resolveOriginalMessageBundle(_.default,T);if(T.length>0)return T.forEach(z=>{this.logService.error(this.formatMessage(K,(0,m.localize)(3,null,_.default?.path,(0,h.getParseErrorMessage)(z.error))))}),N;if((0,y.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(K,(0,m.localize)(4,null,_.default?.path))),N;const x=_.values||Object.create(null);this.replaceNLStrings(W.pseudo,N,x,$,K)}catch{}return N}async getLocalizedMessages(K,N,W){const _=(0,f.joinPath)(K,"package.nls.json"),T=(q,L)=>{L.forEach(O=>{this.logService.error(this.formatMessage(K,(0,m.localize)(5,null,q?.path,(0,h.getParseErrorMessage)(O.error))))})},$=q=>{this.logService.error(this.formatMessage(K,(0,m.localize)(6,null,q?.path)))},x=`${N.publisher}.${N.name}`,z=W.translations[x];if(z)try{const q=w.URI.file(z),L=(await this.fileService.readFile(q)).value.toString(),O=[],B=(0,y.parse)(L,O);return O.length>0?(T(q,O),{values:void 0,default:_}):(0,y.getNodeType)(B)!=="object"?($(q),{values:void 0,default:_}):{values:B.contents?B.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let L;try{L=await this.findMessageBundles(K,W)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const O=(await this.fileService.readFile(L.localized)).value.toString(),B=[],V=(0,y.parse)(O,B);return B.length>0?(T(L.localized,B),{values:void 0,default:L.original}):(0,y.getNodeType)(V)!=="object"?($(L.localized),{values:void 0,default:L.original}):{values:V,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(K,N){if(K)try{const W=(await this.fileService.readFile(K)).value.toString();return(0,y.parse)(W,N)}catch{return null}else return null}findMessageBundles(K,N){return new Promise((W,_)=>{const T=$=>{const x=(0,f.joinPath)(K,`package.nls.${$}.json`);this.fileService.exists(x).then(z=>{z&&W({localized:x,original:(0,f.joinPath)(K,"package.nls.json")});const q=$.lastIndexOf("-");q===-1?W({localized:(0,f.joinPath)(K,"package.nls.json"),original:null}):($=$.substring(0,q),T($))})};if(N.devMode||N.pseudo||!N.language)return W({localized:(0,f.joinPath)(K,"package.nls.json"),original:null});T(N.language)})}replaceNLStrings(K,N,W,_,T){const $=(x,z,q)=>{const L=x[z];if((0,b.isString)(L)){const O=L,B=O.length;if(B>1&&O[0]==="%"&&O[B-1]==="%"){const V=O.substr(1,B-2);let X=W[V];X===void 0&&_&&(X=_[V]);let ne=typeof X=="string"?X:X.message;if(ne!==void 0)if(K&&(ne="\uFF3B"+ne.replace(/[aouei]/g,"$&$&")+"\uFF3D"),q&&_&&(z==="title"||z==="category")){const j=_[V],te={value:ne,original:typeof j=="string"?j:j?.message};x[z]=te}else x[z]=ne;else this.logService.warn(this.formatMessage(T,(0,m.localize)(7,null,V)))}}else if((0,b.isObject)(L))for(const O in L)L.hasOwnProperty(O)&&(O==="commands"?$(L,O,!0):$(L,O,q));else if(Array.isArray(L))for(let O=0;O<L.length;O++)$(L,O,q)};for(const x in N)N.hasOwnProperty(x)&&$(N,x)}formatMessage(K,N){return`[${K.path}]: ${N}`}};re=ve([J(1,P.IExtensionsProfileScannerService),J(2,A.IUriIdentityService),J(3,r.IFileService),J(4,n.ILogService)],re);let le=class extends re{constructor(K,N,W,_,T,$){super(N,W,_,T,$);this.cacheFile=K,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const N=await this.readExtensionCache();if(this.input=K,N&&N.input&&Q.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(_=>(_.location=w.URI.revive(_.location),_));const W=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:W}),W}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),N=JSON.parse(K.value.toString());return{result:N.result,input:(0,l.revive)(N.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(K)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const N=K.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(W,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(_){this.logService.error(_)}}};le=ve([J(2,P.IExtensionsProfileScannerService),J(3,A.IUriIdentityService),J(4,r.IFileService),J(5,n.ILogService)],le);function fe(ue,K){const N=(0,u.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:N,identifier:new c.ExtensionIdentifier(N),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:K,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=fe;class se extends U{constructor(K,N,W,_,T,$,x,z,q,L,O){super(K,N,(0,f.joinPath)(W,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(_,c.MANIFEST_CACHE_FOLDER),T,$,x,z,q,L,O);this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const B=await this.fileService.readFile(w.URI.file(S.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=se}),define(Z[250],ee([0,1,7,37,72,89,14,5,6,20,34]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends R.NativeExtensionsScannerService{constructor(f,d,C,b,w,m,g){super(v.URI.file(w.builtinExtensionsPath),v.URI.file(w.extensionsPath),w.userHome,v.URI.file(w.userDataPath),f,d,C,b,w,m,g)}};E=ve([J(0,I.IUserDataProfilesService),J(1,k.IExtensionsProfileScannerService),J(2,D.IFileService),J(3,h.ILogService),J(4,t.INativeEnvironmentService),J(5,p.IProductService),J(6,y.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(Z[251],ee([0,1,15,40,2,32,13,9,4,7,28,37,6,34]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends k.Disposable{constructor(b,w,m){super();this.logService=m,this.validRoots=R.TernarySearchTree.forPaths(!h.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(w.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=v.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(w,m)=>this.handleResourceRequest(w,m)),b.protocol.interceptFileProtocol(D.Schemas.file,(w,m)=>this.handleFileRequest(w,m)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const w=(0,y.normalize)(b);return this.validRoots.get(w)?k.Disposable.None:(this.validRoots.set(w,!0),(0,k.toDisposable)(()=>this.validRoots.delete(w)))}handleFileRequest(b,w){const m=p.URI.parse(b.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),w({error:-3})}handleResourceRequest(b,w){const m=this.requestToNormalizedFilePath(b);return this.validRoots.findSubstr(m)?w({path:m}):this.validExtensions.has((0,y.extname)(m).toLowerCase())?w({path:m}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),w({error:-3}))}requestToNormalizedFilePath(b){const w=p.URI.parse(b.url),m=D.FileAccess.asFileUri(w);return(0,y.normalize)(m.fsPath)}createIPCObjectUrl(){let b;const w=p.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),m=w.toString(),g=async()=>b;return t.validatedIpcMain.handle(m,g),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:w,update:u=>b=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),t.validatedIpcMain.removeHandler(m)}}}};d=ve([J(0,E.INativeEnvironmentService),J(1,f.IUserDataProfilesService),J(2,S.ILogService)],d),e.ProtocolMainService=d}),define(Z[252],ee([0,1,15,40,8,3,2,13,12,99,25,22,6,52,61,64,43,34,39]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends D.Disposable{constructor(c,s,r,i,n,o,a,l,P){super();this.machineId=c,this.userEnv=s,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=n,this.logService=o,this.policyService=a,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,s)=>this.onWindowConnection(c,s)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,s)=>this.onWorkerConnection(c,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,s){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[r])}onWorkerConnection(c,s){this.logService.trace("SharedProcess: onWorkerConnection",s);const r=new D.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,s),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",s))},n=v.BrowserWindow.fromId(s.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!s.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===n)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(n,"closed")(()=>i("closed"))),n.webContents.postMessage(s.reply.channel,s.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...s){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...s)}catch(r){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:f.default,policiesData:this.policyService.serialize()}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,s,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:s}})))}async connect(){await this.whenIpcReady;const c=(0,h.assertIsDefined)(this.window);return(0,p.connect)(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};g=ve([J(2,I.IEnvironmentMainService),J(3,w.IUserDataProfilesService),J(4,E.ILifecycleMainService),J(5,S.ILogService),J(6,m.IPolicyService),J(7,C.IThemeMainService),J(8,d.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[115],ee([0,1,8,3,2,71,12,100,5,34]),function(H,e,v,t,k,R,D,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var E;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var f;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(g={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,u){if(u===I){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:u,target:this.getKeyTargets(g)[u]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,u,c){return this.getStorage(u)?.get(g,c)}getBoolean(g,u,c){return this.getStorage(u)?.getBoolean(g,c)}getNumber(g,u,c){return this.getStorage(u)?.getNumber(g,c)}store(g,u,c,s){if((0,D.isUndefinedOrNull)(u)){this.remove(g,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,c,s),this.getStorage(c)?.set(g,u)})}remove(g,u){this.withPausedEmitters(()=>{this.updateKeyTarget(g,u,void 0),this.getStorage(u)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,u){const c=[],s=this.getKeyTargets(g);for(const r of Object.keys(s))s[r]===u&&c.push(r);return c}updateKeyTarget(g,u,c){const s=this.getKeyTargets(u);typeof c=="number"?s[g]!==c&&(s[g]=c,this.getStorage(u)?.set(I,JSON.stringify(s))):typeof s[g]=="number"&&(delete s[g],this.getStorage(u)?.set(I,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const u=this.get(I,g);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=E.NONE){this._onWillSaveState.fire({reason:g});const u=this.getStorage(-1),c=this.getStorage(0),s=this.getStorage(1);switch(g){case E.NONE:await v.Promises.settled([u?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await v.Promises.settled([u?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return w(g,u,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,u){return this.emitWillSaveState(E.NONE),(0,p.isUserDataProfile)(g)?this.switchToProfile(g,u):this.switchToWorkspace(g,u)}canSwitchProfile(g,u){return!(g.id===u.id||C(u)&&C(g))}switchData(g,u,c,s){this.withPausedEmitters(()=>{if(s)for(const[r,i]of g)u.set(r,i);else{const r=new Set;for(const[i,n]of g)r.add(i),u.get(i)!==n&&this.emitDidChangeValue(c,i);for(const[i]of u.items)r.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function C(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=C;class b extends d{constructor(){super();this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=b;async function w(m,g,u,c,s,r){const i=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,o=new Map;m.forEach((U,Q)=>{n.set(Q,U),o.set(Q,i(U))});const a=new Map,l=new Map;g.forEach((U,Q)=>{a.set(Q,U),l.set(Q,i(U))});const P=new Map,M=new Map;u.forEach((U,Q)=>{P.set(Q,U),M.set(Q,i(U))}),console.group(c!==s?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const A=[];if(n.forEach((U,Q)=>{A.push({key:Q,value:U})}),console.table(A),console.groupEnd(),console.log(o),c!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const U=[];a.forEach((Q,re)=>{U.push({key:re,value:Q})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const F=[];P.forEach((U,Q)=>{F.push({key:Q,value:U})}),console.table(F),console.groupEnd(),console.log(M)}e.logStorage=w}),define(Z[253],ee([0,1,24,8,3,2,9,79,7,23,100,148,6,115,38,26]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(n=>this._onDidChangeStorage.fire({key:n}))),await this.doInit(r);const i=r.getBoolean(f.IS_NEW_KEY);i===void 0?r.set(f.IS_NEW_KEY,!0):i&&r.set(f.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new y.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class w extends b{constructor(r,i,n,o){super(n,o);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,w.STORAGE_NAME)}async doCreate(){return new I.Storage(new E.SQLiteStorageDatabase(this.path??E.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}w.STORAGE_NAME="state.vscdb";class m extends w{constructor(r,i,n,o){super(r,i,n,o)}}e.ProfileStorageMain=m;class g extends w{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const n=r.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof n=="undefined"?null:n),r.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=g;class u extends b{constructor(r,i,n,o,a){super(n,a);this.workspace=r,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,u.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new E.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,u.WORKSPACE_STORAGE_NAME);return await p.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await p.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,C.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,C.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const n=(0,D.join)(r,u.WORKSPACE_META_NAME);await p.Promises.exists(n)||await p.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=u,u.WORKSPACE_STORAGE_NAME="state.vscdb",u.WORKSPACE_META_NAME="workspace.json";class c extends b{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(Z[254],ee([0,1,58,37,14,6,223,54,34]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let p=class Pt extends h.UserDataProfilesService{constructor(E,S,f,d,C){super(f,d,S,C);this.stateService=E}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(Pt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(Pt.PROFILE_ASSOCIATIONS_KEY,{}))}};p=ve([J(0,D.IStateService),J(1,y.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(Z[65],ee([0,1,7,37,14,5,6,41,54,34,254]),function(H,e,v,t,k,R,D,y,h,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(p.IUserDataProfilesService);let E=class bt extends I.UserDataProfilesService{constructor(f,d,C,b,w){super(f,d,C,b,w);this.stateMainService=f}isEnabled(){return this.enabled}saveStoredProfiles(f){this.stateMainService.setItem(bt.PROFILES_KEY,f)}saveStoredProfileAssociations(f){this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,f)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",d=this.stateMainService.getItem(f,void 0);if(d){this.stateMainService.removeItem(f);const C=d.reduce((b,{workspace:w,profile:m})=>(b[v.URI.revive(w).toString()]=v.URI.revive(m).toString(),b),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:C})}return super.getStoredProfileAssociations()}};E=ve([J(0,y.IStateMainService),J(1,h.IUriIdentityService),J(2,t.IEnvironmentService),J(3,k.IFileService),J(4,D.ILogService)],E),e.UserDataProfilesMainService=E}),define(Z[255],ee([0,1,2,16,72,89,14,34,65]),function(H,e,v,t,k,R,D,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let p=class extends v.Disposable{constructor(E,S,f,d){super();this.userDataProfilesService=E,this.fileService=S,this.extensionsScannerService=f,this.extensionsProfileScannerService=d,this._register(E.onWillCreateProfile(C=>{E.profiles.length===1&&C.join(this.initialize())})),this._register(E.onDidChangeProfiles(C=>{E.profiles.length===1&&this.uninitialize()}))}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const S=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(S.map(f=>[f,f.metadata]),E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,y.EXTENSIONS_RESOURCE_NAME)}};p=ve([J(0,h.IUserDataProfilesMainService),J(1,D.IFileService),J(2,R.IExtensionsScannerService),J(3,k.IExtensionsProfileScannerService)],p),e.DefaultExtensionsProfileInitHandler=p}),define(Z[90],ee([0,1,48,2,37,14,5,22,6,115,253,34,65]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let f=class extends t.Disposable{constructor(b,w,m,g,u){super();this.logService=b,this.environmentService=w,this.userDataProfilesService=m,this.lifecycleMainService=g,this.fileService=u,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=b.reason,b.join(this.applicationStorage.close());for(const[,w]of this.mapProfileToStorage)b.join(w.close());for(const[,w]of this.mapWorkspaceToStorage)b.join(w.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(b=>{b.join((async()=>{await this.fileService.exists(b.profile.globalStorageHome)||await this.fileService.createFolder(b.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(b=>{const w=this.mapProfileToStorage.get(b.profile.id);w&&b.join(w.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const b=new I.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,p.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let w=this.mapProfileToStorage.get(b.id);return w||(this.logService.trace(`StorageMainService: creating profile storage (${b.name})`),w=this.createProfileStorage(b),this.mapProfileToStorage.set(b.id,w),(0,v.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${b.name})`),this.mapProfileToStorage.delete(b.id)})),w}createProfileStorage(b){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.ProfileStorageMain(b,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(b){let w=this.mapWorkspaceToStorage.get(b.id);return w||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),w=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,w),(0,v.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),w}createWorkspaceStorage(b){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};f=ve([J(0,h.ILogService),J(1,k.IEnvironmentService),J(2,S.IUserDataProfilesMainService),J(3,y.ILifecycleMainService),J(4,R.IFileService)],f),e.StorageMainService=f,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let d=class extends p.AbstractStorageService{constructor(b,w){super();this.userDataProfilesService=b,this.storageMainService=w,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(b){if(b===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(b){if(b===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};d=ve([J(0,E.IUserDataProfilesService),J(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(Z[116],ee([0,1,16,7,26]),function(H,e,v,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(h,p,I){for(const S of h){const f=S.openedWorkspace;if((0,k.isWorkspaceIdentifier)(f)){const d=I(f);if(d){if(d.folders.some(C=>v.extUriBiasedIgnorePathCase.isEqualOrParent(p,C.uri)))return S}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(p,f.configPath))return S}}const E=h.filter(S=>(0,k.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(p,S.openedWorkspace.uri));if(E.length)return E.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(h,p){for(const I of h)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,p)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,p))return I}e.findWindowOnWorkspaceOrFolder=D;function y(h,p){const I=E=>p.some(S=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(E)));for(const E of h)if(E.config?.extensionDevelopmentPath?.some(S=>I(S)))return E}e.findWindowOnExtensionDevelopmentPath=y}),define(Z[256],ee([0,1,15,2,4,16,7,19,22,6,41,33,114,26]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class kt extends t.Disposable{constructor(u,c,s,r,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=s,this.logService=r,this.configurationService=i,this._state=C(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&u.add(c.lastActiveWindow.uiState.display))}const s=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);s&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(s),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!s.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=0):u.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.toWindowState(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?k.isMacintosh&&n.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=0):u.add(n.uiState.display)),n}));const r=w(c);this.stateMainService.setItem(kt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(s=>{const r=(0,f.isWorkspaceIdentifier)(u.openedWorkspace)&&s.workspace?.id===u.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&s.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(s.folderUri,u.openedWorkspace.uri);(r||i)&&(s.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{windowId:u.id,workspace:(0,f.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),s=this.configurationService.getValue("window");if(c.mode===3){let r;c.hasDefaultState?r=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):r=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),r||(c.mode=0)}return c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,f.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(u.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let s;const r=v.screen.getAllDisplays();if(r.length===1)s=r[0];else{if(k.isMacintosh){const a=v.screen.getCursorScreenPoint();s=v.screen.getDisplayNearestPoint(a)}!s&&c&&(s=v.screen.getDisplayMatching(c.getBounds())),s||(s=v.screen.getPrimaryDisplay()||r[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(s.bounds.x+s.bounds.width/2-i.width/2),i.y=Math.round(s.bounds.y+s.bounds.height/2-i.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;c.some(s=>s.x===u.x||s.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=ve([J(0,E.IWindowsMainService),J(1,I.IStateMainService),J(2,h.ILifecycleMainService),J(3,p.ILogService),J(4,y.IConfigurationService)],d),e.WindowsStateHandler=d;function C(g){const u={openedWindows:[]},c=g||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(s=>b(s))),u}e.restoreWindowsState=C;function b(g){const u={uiState:g.uiState};return g.backupPath&&(u.backupPath=g.backupPath),g.remoteAuthority&&(u.remoteAuthority=g.remoteAuthority),g.folder&&(u.folderUri=D.URI.parse(g.folder)),g.workspaceIdentifier&&(u.workspace={id:g.workspaceIdentifier.id,configPath:D.URI.parse(g.workspaceIdentifier.configURIPath)}),u}function w(g){return{lastActiveWindow:g.lastActiveWindow&&m(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&m(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(u=>m(u))}}e.getWindowsStateStoreData=w;function m(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(Z[91],ee([0,1,31,42,124,36,13,9,4,16,7,5,63,26]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function C(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=C;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function w(M){return m(M)||g(M)}e.isStoredWorkspaceFolder=w;function m(M){const A=M;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function g(M){const A=M;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function u(M,A,F,U,Q){if(M.scheme!==U.scheme)return{name:F,uri:M.toString(!0)};let re=A?void 0:Q.relativePath(U,M);if(re!==void 0)re.length===0?re=".":h.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,h.isWindows&&(re=c(re));else if(Q.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:F,uri:M.toString(!0)};return{name:F,path:re}}e.getStoredWorkspaceFolder=u;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,v.isUNC)(M)||(M=(0,v.toSlashes)(M)),M}function s(M,A,F){const U=[],Q=new Set,re=F.dirname(A);for(const le of M){let fe;if(m(le))le.path&&(fe=F.resolvePath(re,le.path));else if(g(le))try{fe=I.URI.parse(le.uri),fe.path[0]!==y.posix.sep&&(fe=fe.with({path:y.posix.sep+fe.path}))}catch(se){console.warn(se)}if(fe){const se=F.getComparisonKey(fe);if(!Q.has(se)){Q.add(se);const ue=le.name||F.basenameOrAuthority(fe);U.push(new f.WorkspaceFolder({uri:fe,name:ue,index:U.length},le))}}}return U}e.toWorkspaceFolders=s;function r(M,A,F,U,Q){const re=i(A,M),le=Q.dirname(A),fe=Q.dirname(U),se=[];for(const W of re.folders){const _=m(W)?Q.resolvePath(le,W.path):I.URI.parse(W.uri);let T;F?T=!1:T=!m(W)||(0,y.isAbsolute)(W.path),se.push(u(_,T,W.name,fe,Q))}const ue={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,ue);let N=k.applyEdits(M,K);return(0,p.isEqualAuthority)(re.remoteAuthority,(0,S.getRemoteAuthority)(U))&&(N=k.applyEdits(N,k.removeProperty(N,["remoteAuthority"],ue))),N}e.rewriteWorkspaceFileForNewLocation=r;function i(M,A){const F=t.parse(A);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(U=>w(U));else throw new Error(`${M} looks like an invalid workspace file.`);return F}function n(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function l(M,A){const F={workspaces:[],files:[]};if(M){const U=function(re,le){for(let fe=0;fe<re.length;fe++)try{le(re[fe],fe)}catch(se){A.warn(`Error restoring recent entry ${JSON.stringify(re[fe])}: ${se.toString()}. Skip entry.`)}},Q=M;Array.isArray(Q.entries)&&U(Q.entries,re=>{const le=re.label,fe=re.remoteAuthority;n(re)?F.workspaces.push({label:le,remoteAuthority:fe,workspace:{id:re.workspace.id,configPath:I.URI.parse(re.workspace.configPath)}}):o(re)?F.workspaces.push({label:le,remoteAuthority:fe,folderUri:I.URI.parse(re.folderUri)}):a(re)&&F.files.push({label:le,remoteAuthority:fe,fileUri:I.URI.parse(re.fileUri)})})}return F}e.restoreRecentlyOpened=l;function P(M){const A={entries:[]};for(const F of M.workspaces)C(F)?A.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):A.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of M.files)A.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return A}e.toStoreData=P}),define(Z[117],ee([0,1,76,29,13,4,16]),function(H,e,v,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function y(p){function I(){let E=p.scheme===k.Schemas.file?(0,D.originalFSPath)(p):p.toString();return R.isLinux||(E=E.toLowerCase()),(0,v.createHash)("md5").update(E).digest("hex")}return{id:I(),configPath:p}}e.getWorkspaceIdentifier=y;function h(p,I){function E(){if(p.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(p.toString()).digest("hex");if(!I)try{I=(0,t.statSync)(p.fsPath)}catch{return}let f;return R.isLinux?f=I.ino:R.isMacintosh?f=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?f=Math.floor(I.birthtimeMs):f=I.birthtime.getTime()),(0,v.createHash)("md5").update(p.fsPath).update(f?String(f):"").digest("hex")}const S=E();if(typeof S=="string")return{id:S,uri:p}}e.getSingleFolderWorkspaceIdentifier=h}),define(Z[47],ee([0,1,15,29,3,42,36,2,13,9,16,12,23,175,60,55,25,5,6,20,65,116,26,91,117]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let n=class extends y.Disposable{constructor(a,l,P,M,A,F){super();this.environmentMainService=a,this.logService=l,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=A,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,l=>S.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(a,l){if(!!this.isWorkspacePath(a)&&a.scheme===h.Schemas.file)try{const P=l(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,s.isUntitledWorkspace)(a,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,l){try{const P=this.doParseStoredWorkspace(a,l),M=(0,i.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,r.toWorkspaceFolders)(P.folders,M.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,l){const P=(0,R.parse)(l);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,r.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),A=P.configPath.fsPath;return await S.Promises.mkdir((0,p.dirname)(A),{recursive:!0}),await S.Promises.writeFile(A,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,l){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,l),A=P.configPath.fsPath;return(0,t.mkdirSync)((0,p.dirname)(A),{recursive:!0}),(0,S.writeFileSync)(A,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],l){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,I.joinPath)(this.untitledWorkspacesHome,P),A=(0,I.joinPath)(M,s.UNTITLED_WORKSPACE_NAME),F=[];for(const U of a)F.push((0,r.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,I.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(A),storedWorkspace:{folders:F,remoteAuthority:l}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,s.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const l=(0,I.originalFSPath)(a.configPath);try{(0,S.rimrafSync)((0,p.dirname)(l));const P=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,S.writeFileSync)((0,p.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${l} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const l=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,I.joinPath)(this.untitledWorkspacesHome,P,s.UNTITLED_WORKSPACE_NAME));for(const P of l){const M=(0,i.getWorkspaceIdentifier)(P),A=this.resolveLocalWorkspaceSync(P);A?a.push({workspace:M,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return a}async enterWorkspace(a,l,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,l,P))return;const A=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!A)return this._onDidEnterWorkspace.fire({window:a,workspace:A.workspace}),A}async isValidTargetWorkspacePath(a,l,P){if(!P)return!0;if((0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,f.localize)(0,null))],message:(0,f.localize)(1,null,(0,I.basename)(P)),detail:(0,f.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,E.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,l){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,s.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=l,a.config.backupPath=P,{workspace:l,backupPath:P}}};n=ve([J(0,b.IEnvironmentMainService),J(1,m.ILogService),J(2,u.IUserDataProfilesMainService),J(3,d.IBackupMainService),J(4,C.IDialogMainService),J(5,g.IProductService)],n),e.WorkspacesManagementMainService=n}),define(Z[118],ee([0,1,40,21,5,33,26,47]),function(H,e,v,t,k,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,k.createDecorator)(e.ID);let h=class{constructor(I,E){this.windowsMainService=I,this.workspacesManagementMainService=E}async getRemoteDiagnostics(I){const E=this.windowsMainService.getWindows();return(await Promise.all(E.map(f=>new Promise(d=>{const C=f.remoteAuthority;if(C){const b=`vscode:getDiagnosticInfoResponse${f.id}`,w={includeProcesses:I.includeProcesses,folders:I.includeWorkspaceMetadata?this.getFolderURIs(f):void 0};f.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:b,args:w}),v.validatedIpcMain.once(b,(m,g)=>{g||d({hostName:C,errorMessage:`Unable to resolve connection to '${C}'.`}),d(g)}),setTimeout(()=>{d({hostName:C,errorMessage:`Connection to '${C}' could not be established`})},5e3)}else d(void 0)})))).filter(f=>!!f)}getFolderURIs(I){const E=[],S=I.openedWorkspace;if((0,D.isSingleFolderWorkspaceIdentifier)(S))E.push(S.uri);else if((0,D.isWorkspaceIdentifier)(S)){const f=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);f&&f.folders.forEach(C=>{E.push(C.uri)})}return E}};h=ve([J(0,R.IWindowsMainService),J(1,y.IWorkspacesManagementMainService)],h),e.DiagnosticsMainService=h}),define(Z[119],ee([0,1,15,24,4,12,7,23,19,59,5,6,113,33,26,47]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let b=class{constructor(m,g,u,c,s){this.logService=m,this.windowsMainService=g,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=s}async start(m,g){this.logService.trace("Received data from other instance: ",m,g),k.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(m);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:s,url:r}of u)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(m,g)}parseOpenUrl(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,t.coalesce)(m._urls.map(g=>{try{return{uri:D.URI.parse(g),url:g}}catch{return null}})):[]}async startOpenWindow(m,g){const u=(0,p.isLaunchedFromCli)(g)?0:4;let c=[];const s=m.wait&&m.waitMarkerFilePath?D.URI.file(m.waitMarkerFilePath):void 0,r=m.remote||void 0,i={context:u,cli:m,userEnv:g,waitMarkerFileURI:s,remoteAuthority:r};if(m.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,i);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let n=!1;if(m["new-window"]||m["unity-launch"])n=!0;else if(m["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),c=[o]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(s&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,y.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const m=[];return v.BrowserWindow.getAllWindows().forEach(g=>{const u=this.windowsMainService.getWindowById(g.id);u?m.push(this.codeWindowToInfo(u)):m.push(this.browserWindowToInfo(g))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}getFolderURIs(m){const g=[],u=m.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(u))g.push(u.uri);else if((0,d.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(r=>{g.push(r.uri)})}return g}codeWindowToInfo(m){const g=this.getFolderURIs(m),u=(0,R.assertIsDefined)(m.win);return this.browserWindowToInfo(u,g,m.remoteAuthority)}browserWindowToInfo(m,g=[],u){return{pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:g,remoteAuthority:u}}};b=ve([J(0,E.ILogService),J(1,f.IWindowsMainService),J(2,S.IURLService),J(3,C.IWorkspacesManagementMainService),J(4,h.IConfigurationService)],b),e.LaunchMainService=b}),define(Z[66],ee([0,1,50,15,30,142,51,3,36,2,13,9,4,7,96,81,23,92,165,55,25,5,22,6,20,64,33,26,47,17]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends p.Disposable{constructor(F,U,Q,re,le,fe,se,ue,K){super();this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=Q,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=fe,this.productService=se,this.themeMainService=ue,this.workspacesManagementMainService=K,this.onDidOpenWindow=y.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=y.Event.filter(y.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:W,y:_})=>({windowId:N.id,x:W,y:_})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,W)=>W.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,W)=>W.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,W)=>W.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=y.Event.any(y.Event.map(y.Event.filter(y.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),y.Event.filter(y.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,W)=>W.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=y.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new y.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=y.Event.debounce(y.Event.any(y.Event.filter(y.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,W,_)=>_),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),y.Event.fromNodeEventEmitter(t.screen,"display-added"),y.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,Q){return Array.isArray(U)?this.doOpenWindow(F,U,Q):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,Q=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){this.windowById(F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.windowById(F)?.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async updateWindowControls(F,U){const Q=this.windowById(F);Q&&Q.updateWindowControls(U)}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId),this.windowById(F)?.focus({force:U?.force??!1})}async setMinimumSize(F,U,Q){const re=this.windowById(F);if(re?.win){const[le,fe]=re.win.getSize(),[se,ue]=re.win.getMinimumSize(),[K,N]=[U??se,Q??ue],[W,_]=[Math.max(le,K),Math.max(fe,N)];(se!==K||ue!==N)&&re.win.setMinimumSize(K,N),(le!==W||fe!==_)&&re.win.setSize(W,_)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:Q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,d.realpath)(U);if(Q===le)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(Q,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,m.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,m.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(fe)}catch{throw new Error((0,m.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await b.Promises.unlink(U)}catch(Q){switch(Q.code){case"EACCES":{const{response:re}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,m.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,m.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(le)}catch{throw new Error((0,m.localize)(7,null,U))}break}case"ENOENT":break;default:throw Q}}}async getShellCommandLink(){const F=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(F))throw new Error((0,m.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFileFolder(U);Q&&this.doOpenPicked(await Promise.all(Q.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:f.URI.file(re)}:{fileUri:f.URI.file(re)})),U,F)}async pickFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFolder(U);Q&&this.doOpenPicked(Q.map(re=>({folderUri:f.URI.file(re)})),U,F)}async pickFileAndOpen(F,U){const Q=await this.dialogMainService.pickFile(U);Q&&this.doOpenPicked(Q.map(re=>({fileUri:f.URI.file(re)})),U,F)}async pickWorkspaceAndOpen(F,U){const Q=await this.dialogMainService.pickWorkspace(U);Q&&this.doOpenPicked(Q.map(re=>({workspaceUri:f.URI.file(re)})),U,F)}doOpenPicked(F,U,Q){this.windowsMainService.open({context:3,contextWindowId:Q,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}async showItemInFolder(F,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){this.windowById(F)?.setRepresentedFilename(U)}async setDocumentEdited(F,U){this.windowById(F)?.setDocumentEdited(U)}async openExternal(F,U){return S.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,Q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=Q}moveItemToTrash(F,U){return t.shell.trashItem(U)}async isAdmin(){let F;return S.isWindows?F=(await new Promise((U,Q)=>{H(["native-is-elevated"],U,Q)}))():F=process.getuid()===0,F}async writeElevated(F,U,Q,re){const le=await new Promise((fe,se)=>{H(["@vscode/sudo-prompt"],fe,se)});return new Promise((fe,se)=>{const ue=[`"${this.cliPath}"`];re?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${U.fsPath}"`,`"${Q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(ue.join(" "),K,(N,W,_)=>{W&&this.logService.trace(`[sudo-prompt] received stdout: ${W}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),N?se(N):fe(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return C.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(F,U,Q){process.kill(U,Q)}async readClipboardText(F,U){return t.clipboard.readText(U)}async writeClipboardText(F,U,Q){return t.clipboard.writeText(U,Q)}async readClipboardFindText(F){return t.clipboard.readFindText()}async writeClipboardFindText(F,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,Q,re){return t.clipboard.writeBuffer(U,Buffer.from(Q.buffer),re)}async readClipboardBuffer(F,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(F,U,Q){return t.clipboard.has(U,Q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){this.windowById(F)?.updateTouchBar(U)}async notifyReady(F){this.windowById(F)?.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const Q=this.windowById(F);if(Q){if((0,a.isWorkspaceIdentifier)(Q.openedWorkspace)){const re=Q.openedWorkspace.configPath;if(re.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const Q=this.windowById(U);if(Q?.win)return Q.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const re=this.windowById(F)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(F,U,Q,re,le=1){return(0,w.findFreePort)(U,Q,re,le)}async openDevTools(F,U){const Q=this.windowById(F);Q?.win&&Q.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const Q=this.windowById(F);Q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&Q.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,Q,re){if(!S.isWindows)return;const le=await new Promise((fe,se)=>{H(["@vscode/windows-registry"],fe,se)});try{return le.GetStringRegKey(U,Q,re)}catch{return}}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([J(1,o.IWindowsMainService),J(2,g.IDialogMainService),J(3,s.ILifecycleMainService),J(4,u.IEnvironmentMainService),J(5,r.ILogService),J(6,i.IProductService),J(7,n.IThemeMainService),J(8,l.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Z[257],ee([0,1,15,40,30,36,2,13,4,97,163,84,118,55,25,5,119,6,66,52,20,61,74]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,C.createDecorator)("issueMainService");let r=class At{constructor(n,o,a,l,P,M,A,F,U,Q){this.userEnv=n,this.environmentMainService=o,this.launchMainService=a,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=A,this.nativeHostMainService=F,this.protocolMainService=U,this.productService=Q,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async n=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(n,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async n=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,I.localize)(0,null),rootProcess:await(0,p.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,E.isRemoteDiagnosticError)(P)?o.push({name:P.hostName,rootProcess:P}):P.processes&&o.push({name:P.hostName,rootProcess:P.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(n,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async n=>{const o={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(n,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async n=>{const o=await this.getPerformanceInfo();this.safeSend(n,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const n={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(n,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(n,o)=>{const{id:a,from:l,args:P}=o;let M;switch(l){case"issueReporter":M=this.issueReporterParentWindow;break;case"processExplorer":M=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}M?.webContents.send("vscode:runAction",{id:a,from:l,args:P})}),t.validatedIpcMain.on("vscode:openExternal",(n,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",n=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",n=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async n=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(n,"vscode:windowsInfoResponse",o.windows)})}safeSend(n,o,...a){n.sender.isDestroyed()||n.sender.send(o,...a)}async openReporter(n){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:n.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:n,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:g.default}),this.issueReporterWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(n){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new D.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,a,{backgroundColor:n.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:n.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:n,product:g.default}),this.processExplorerWindow.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(n){n.isMinimized()&&n.restore(),n.focus()}createBrowserWindow(n,o,a,l){const P=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:n.width,height:n.height,minWidth:300,minHeight:200,x:n.x,y:n.y,title:a.title,backgroundColor:a.backgroundColor||At.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}async getSystemStatus(){const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(n,o)}getWindowPosition(n,o,a){let l;const P=v.screen.getAllDisplays();if(P.length===1)l=P[0];else{if(h.isMacintosh){const F=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(F)}!l&&n&&(l=v.screen.getDisplayMatching(n.getBounds())),l||(l=v.screen.getPrimaryDisplay()||P[0])}const M={width:o,height:a},A=l.bounds;return M.x=A.x+A.width/2-M.width/2,M.y=A.y+A.height/2-M.height/2,A.width>0&&A.height>0&&(M.x<A.x&&(M.x=A.x),M.y<A.y&&(M.y=A.y),M.x>A.x+A.width&&(M.x=A.x),M.y>A.y+A.height&&(M.y=A.y),M.width>A.width&&(M.width=A.width),M.height>A.height&&(M.height=A.height)),M}async getPerformanceInfo(){try{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(n,o)}catch(n){throw this.logService.warn("issueService#getPerformanceInfo ",n.message),n}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=ve([J(1,d.IEnvironmentMainService),J(2,b.ILaunchMainService),J(3,w.ILogService),J(4,E.IDiagnosticsService),J(5,S.IDiagnosticsMainService),J(6,f.IDialogMainService),J(7,m.INativeHostMainService),J(8,c.IProtocolMainService),J(9,u.IProductService)],r),e.IssueMainService=r}),define(Z[258],ee([0,1,21,19,25,22,6,66,20,53,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(C,b,w,m,g,u,c,s){super(C,b,m,g,u,s);this.telemetryService=w,this.nativeHostMainService=c}buildUpdateFeedUrl(C){return(0,S.createUpdateURL)(`linux-${process.arch}`,C,this.productService)}doCheckForUpdates(C){!this.url||(this.setState(E.State.CheckingForUpdates(C)),this.requestService.request({url:this.url},v.CancellationToken.None).then(p.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!C}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!C});const w=C?b.message||b:void 0;this.setState(E.State.Idle(1,w))}))}async doDownloadUpdate(C){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):C.update.url&&this.nativeHostMainService.openExternal(void 0,C.update.url),this.setState(E.State.Idle(1))}};f=ve([J(0,R.ILifecycleMainService),J(1,t.IConfigurationService),J(2,I.ITelemetryService),J(3,k.IEnvironmentMainService),J(4,p.IRequestService),J(5,D.ILogService),J(6,y.INativeHostMainService),J(7,h.IProductService)],f),e.LinuxUpdateService=f}),define(Z[259],ee([0,1,50,29,30,8,21,51,9,7,128,23,19,25,14,22,6,66,20,53,38,46,88]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,l=1e3){for(;!a();)await(0,R.timeout)(l)}let i;function n(){return typeof i=="undefined"&&(i=t.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends s.AbstractUpdateService{constructor(l,P,M,A,F,U,Q,re,le){super(l,P,A,F,U,le);this.telemetryService=M,this.fileService=Q,this.nativeHostMainService=re}get cachePath(){const l=h.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(l,{recursive:!0}).then(()=>l)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,s.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(g.asJson).then(P=>{const M=n();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(A=>E.Promises.exists(A).then(F=>{if(F)return Promise.resolve(A);const U=P.url,Q=P.hash,re=`${A}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(le=>this.fileService.writeFile(p.URI.file(re),le.stream)).then(Q?()=>(0,I.checksum)(re,P.hash):()=>{}).then(()=>E.Promises.rename(re,A)).then(()=>A)})).then(A=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},F&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(c.State.Idle(n(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(n()))}async getUpdatePackagePath(l){const P=await this.cachePath;return h.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,M=await this.cachePath,F=(await E.Promises.readdir(M)).filter(P).map(async U=>{try{await E.Promises.unlink(h.join(M,U))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=h.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(n()))});const A=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Q)=>{H(["windows-mutex"],U,Q)});r(()=>F.isActive(A)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([y.memoize],o.prototype,"cachePath",null),o=ve([J(0,C.ILifecycleMainService),J(1,S.IConfigurationService),J(2,u.ITelemetryService),J(3,f.IEnvironmentMainService),J(4,g.IRequestService),J(5,b.ILogService),J(6,d.IFileService),J(7,w.INativeHostMainService),J(8,m.IProductService)],o),e.Win32UpdateService=o}),define(Z[260],ee([0,1,15,8,21,43,3,36,2,13,9,71,4,7,171,60,19,55,25,59,14,22,6,20,61,228,90,38,231,64,74,33,26,47,114,122,39,34,58,41,52]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P,M,A,F,U,Q,re,le,fe,se,ue,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var N;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(N||(N={}));let W=class Mt extends h.Disposable{constructor(T,$,x,z,q,L,O,B,V,X,ne,j,te,ie,ce,he,ke,Le,Me){super();this.logService=$,this.environmentMainService=x,this.policyService=z,this.userDataProfilesService=q,this.fileService=L,this.applicationStorageMainService=O,this.storageMainService=B,this.configurationService=V,this.themeMainService=X,this.workspacesManagementMainService=ne,this.backupMainService=j,this.telemetryService=te,this.dialogMainService=ie,this.lifecycleMainService=ce,this.productService=he,this.protocolMainService=ke,this.windowsMainService=Le,this.stateMainService=Me,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Ae,Ve]=this.restoreWindowState(T.state);this.windowState=Ae,this.logService.trace("window#ctor: using window state",Ae);const me=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Ee=!1;typeof pe?.experimental?.useSandbox=="boolean"?Ee=pe.experimental.useSandbox:Ee=typeof K.default.quality=="string"&&K.default.quality!=="stable";const Y={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!me,title:this.productService.nameLong,webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(pe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Ee?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?Y.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(Y.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(Y.fullscreenable=!1),S.isMacintosh&&(Y.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(Y.acceptFirstMouse=!1));const ae=S.isMacintosh&&pe?.nativeTabs===!0;ae&&(Y.tabbingIdentifier=this.productService.nameShort);const de=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(Y.titleBarStyle="hidden",S.isMacintosh||(Y.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const Se=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ce=re.Color.fromHex(Se).isDarker()?"#FFFFFF":"#000000";Y.titleBarOverlay={height:29,color:Se,symbolColor:Ce},this.hasWindowControlOverlay=!0}if((0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Y),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,S.isMacintosh&&de&&this._win.setSheetOffset(22),de&&(S.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||S.isMacintosh)){const Se=this.stateMainService.getItem(Mt.windowControlHeightStateStorageKey);Se&&this.updateWindowControls({height:Se})}if(S.isWindows&&de){const Se=278;this._win.hookWindowMessage(Se,()=>{const[Ce,Te]=this._win.getPosition(),Oe=v.screen.getCursorScreenPoint(),Be=Oe.x-Ce,Ne=Oe.y-Te;return(()=>!(Be>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Be,y:Ne})),0})}(S.isMacintosh||S.isWindows)&&Ve&&(!ae||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Se=>typeof Se=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),me&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getProfile(this.config.workspace??"empty-window",(0,se.revive)(this.config.profiles.workspace)):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(T){S.isMacintosh?this._win.setRepresentedFilename(T):this.representedFilename=T}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(T){S.isMacintosh&&this._win.setDocumentEdited(T),this.documentEdited=T}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(T){S.isMacintosh&&T?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.whenReadyCallbacks.push(T)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(T=>{function $(){x.dispose(),z.dispose(),T()}const x=this.onDidClose(()=>$()),z=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,x)=>this.onWindowError(2,x)),this._win.webContents.on("did-fail-load",($,x,z)=>this.onWindowError(3,{reason:z,exitCode:x})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration($=>this.onConfigurationUpdated($))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async($,x)=>{const z=await this.getMarketplaceHeaders();x({cancel:!1,requestHeaders:Object.assign($.requestHeaders,z)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,n.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(T,$){switch(T){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${$?.reason||"<unknown>"}, code: ${$?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${$?.reason||"<unknown>"}, code: ${$?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:T,reason:$?.reason,code:$?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const x=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(x.response!==1){const z=x.response===0;this.destroyWindow(z,x.checkboxChecked)}}else if(T===2){let x;$?x=(0,d.localize)(7,null,$.reason,$.exitCode??"<unknown>"):x=(0,d.localize)(6,null);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,y.mnemonicButtonLabel)((0,d.localize)(9,null))],message:x,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),q=z.response===0;this.destroyWindow(q,z.checkboxChecked)}break}}async destroyWindow(T,$){const x=this._config?.workspace;if($&&x)try{const z=this.storageMainService.workspaceStorage(x);await z.init(),z.delete("memento/workbench.parts.editor"),await z.close()}catch(z){this.logService.error(z)}if(this._onDidDestroy.fire(),this._win?.destroy(),T&&this._config){let z,q;(0,F.isSingleFolderWorkspaceIdentifier)(x)?z={folderUri:x.uri}:(0,F.isWorkspaceIdentifier)(x)?z={workspaceUri:x.configPath}:q=!0;const[L]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:z?[z]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});L.focus()}}onDidDeleteUntitledWorkspace(T){this._config?.workspace?.id===T.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(T){const $=this.getMenuBarVisibility();$!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=$,this.setMenuBarVisibility($));let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=z;const q=x||"",L=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${L}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:L,pacScript:""})}}addTabbedWindow(T){S.isMacintosh&&T.win&&this._win.addTabbedWindow(T.win)}load(T,$=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(T,$),this.readyState===0?this._config=T:this.pendingLoadConfig=T,this.readyState=1,this._win.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",H).toString(!0));const x=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:T.workspace,reason:$.isReload?3:x?2:1})}updateConfiguration(T,$){const x=(this._config??this.pendingLoadConfig)?.userEnv;if(x){const z=(0,g.isLaunchedFromCli)(x)&&!(0,g.isLaunchedFromCli)(T.userEnv),q=this.isExtensionDevelopmentHost;(z||q)&&(T.userEnv={...x,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(T["disable-extensions"]=$.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this._win.isMaximized(),T.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),T.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(T)}async reload(T){const $=Object.assign({},this._config);$.workspace=await this.validateWorkspaceBeforeReload($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToMerge,delete $.filesToWait,this.isExtensionDevelopmentHost&&T&&($.verbose=T.verbose,$.debugId=T.debugId,$.extensionEnvironment=T.extensionEnvironment,$["inspect-extensions"]=T["inspect-extensions"],$["inspect-brk-extensions"]=T["inspect-brk-extensions"],$["extensions-dir"]=T["extensions-dir"]),$.isInitialStartup=!1,$.policiesData=this.policyService.serialize(),$.profiles={all:this.userDataProfilesService.profiles,workspace:this.profile||this.userDataProfilesService.defaultProfile},this.load($,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async validateWorkspaceBeforeReload(T){if((0,F.isWorkspaceIdentifier)(T.workspace)){const $=T.workspace.configPath;if($.scheme===p.Schemas.file&&!await this.fileService.exists($))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(T.workspace)){const $=T.workspace.uri;if($.scheme===p.Schemas.file&&!await this.fileService.exists($))return}return T.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let x;try{x=v.screen.getDisplayMatching(this.getBounds())}catch{}const z=(0,Q.defaultWindowState)();return{mode:3,display:x?x.id:void 0,width:this.windowState.width||z.width,height:this.windowState.height||z.height,x:this.windowState.x||0,y:this.windowState.y||0}}const T=Object.create(null);let $;if(!S.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?T.mode=0:T.mode=1,$===1||$===0){let x;$===1?x=this.getBounds():x=this._win.getNormalBounds(),T.x=x.x,T.y=x.y,T.width=x.width,T.height=x.height}return T}updateWindowControls(T){T.height&&this.stateMainService.setItem(Mt.windowControlHeightStateStorageKey,T.height),S.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0}):S.isMacintosh&&T.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(T.height-15)/2})}restoreWindowState(T){(0,E.mark)("code/willRestoreCodeWindowState");let $=!1;if(T)try{const x=v.screen.getAllDisplays();$=x.length>1,T=this.validateWindowState(T,x)}catch(x){this.logService.warn(`Unexpected error validating window state: ${x}
${x.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[T||(0,Q.defaultWindowState)(),$]}validateWindowState(T,$){if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const q=this.getWorkingArea($[0]);if(q){let L=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!q||(T.x<q.x&&(T.x=q.x),T.y<q.y&&(T.y=q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",q),L(),T.width>q.width&&(T.width=q.width),T.height>q.height&&(T.height=q.height),T.x>q.x+q.width-128&&(T.x=q.x+q.width-T.width),T.y>q.y+q.height-128&&(T.y=q.y+q.height-T.height),L()}return T}if(T.display&&T.mode===3){const q=$.find(L=>L.id===T.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const L=(0,Q.defaultWindowState)(3);return L.x=q.bounds.x,L.y=q.bounds.y,L}}let x,z;try{x=v.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),z=this.getWorkingArea(x)}catch{}if(x&&z&&T.x+T.width>z.x&&T.y+T.height>z.y&&T.x<z.x+z.width&&T.y<z.y+z.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",z),T}getWorkingArea(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,$]=this._win.getPosition(),[x,z]=this._win.getSize();return{x:T,y:$,width:x,height:z}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(T){this.useNativeFullScreen()?this.setNativeFullScreen(T):this.setSimpleFullScreen(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return S.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(T){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(T)}doSetNativeFullScreen(T){S.isMacintosh&&(this.transientIsNativeFullScreen=T,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(T)}setSimpleFullScreen(T){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(T),this._win.webContents.focus()}useNativeFullScreen(){const T=this.configurationService.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let T=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}setMenuBarVisibility(T,$=!0){S.isMacintosh||(T==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),T==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(T)}):this.doSetMenuBarVisibility(T))}doSetMenuBarVisibility(T){const $=this.isFullScreen;switch(T){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(T,$,...x){this.isReady?this.send(T,...x):this.ready().then(()=>{$.isCancellationRequested||this.send(T,...x)})}send(T,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this._win.webContents.send(T,...$)}catch(x){this.logService.warn(`Error sending IPC message to channel '${T}' of window ${this._id}: ${(0,R.toErrorMessage)(x)}`)}}}updateTouchBar(T){!S.isMacintosh||this.touchBarGroups.forEach(($,x)=>{const z=T[x];$.segments=this.createTouchBarGroupSegments(z)})}createTouchBar(){if(!!S.isMacintosh){for(let T=0;T<10;T++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(T=[]){const $=this.createTouchBarGroupSegments(T),x=new v.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:x.segments[z].id,from:"touchbar"})}});return x}createTouchBarGroupSegments(T=[]){return T.map(x=>{let z;x.icon&&!l.ThemeIcon.isThemeIcon(x.icon)&&x.icon?.dark?.scheme===p.Schemas.file&&(z=v.nativeImage.createFromPath(f.URI.revive(x.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let q;return typeof x.title=="string"?q=x.title:q=x.title.value,{id:x.id,label:z?void 0:q,icon:z}})}dispose(){super.dispose(),this._win=null}};W.windowControlHeightStateStorageKey="windowControlHeight",W=ve([J(1,s.ILogService),J(2,m.IEnvironmentMainService),J(3,le.IPolicyService),J(4,fe.IUserDataProfilesService),J(5,u.IFileService),J(6,o.IApplicationStorageMainService),J(7,o.IStorageMainService),J(8,b.IConfigurationService),J(9,P.IThemeMainService),J(10,U.IWorkspacesManagementMainService),J(11,C.IBackupMainService),J(12,a.ITelemetryService),J(13,w.IDialogMainService),J(14,c.ILifecycleMainService),J(15,r.IProductService),J(16,i.IProtocolMainService),J(17,A.IWindowsMainService),J(18,ue.IStateMainService)],W),e.CodeWindow=W}),define(Z[75],ee([0,1,15,24,8,3,36,2,13,4,16,7,23,174,5,22,6,90,91,26,47]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class it extends y.Disposable{constructor(r,i,n,o){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=n,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],n=[];for(const o of r)if((0,m.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,m.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(n,o.fileUri)>=0,l=o.fileUri.scheme===h.Schemas.file&&it.COMMON_FILES_FILTER.indexOf((0,I.basename)(o.fileUri))>=0;!a&&!l&&(n.push(o),p.isWindows&&o.fileUri.scheme===h.Schemas.file&&v.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,n),i.length>it.MAX_TOTAL_RECENT_ENTRIES&&(i.length=it.MAX_TOTAL_RECENT_ENTRIES),n.length>it.MAX_TOTAL_RECENT_ENTRIES&&(n.length=it.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:n}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=l=>{const P=this.location(l);for(const M of r)if(I.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},n=await this.getRecentlyOpened(),o=n.workspaces.filter(i),a=n.files.filter(i);(o.length!==n.workspaces.length||a.length!==n.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const r=[],i=[];return await this.addEntriesFromStorage(r,i),{workspaces:r,files:i}}async addEntriesFromStorage(r,i){const n=await this.getRecentlyOpenedFromStorage();for(const o of n.workspaces){const a=(0,m.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of n.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(it.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(n){this.logService.error("Unexpected error parsing opened paths list",n)}return(0,m.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(it.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,m.toStoreData)(r)),-1,1)}location(r){return(0,m.isRecentFolder)(r)?r.folderUri:(0,m.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(n=>(0,m.isRecentWorkspace)(n)&&n.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(n=>(0,m.isRecentFolder)(n)&&I.extUriBiasedIgnorePathCase.isEqual(n.folderUri,i))}indexOfFile(r,i){return r.findIndex(n=>I.extUriBiasedIgnorePathCase.isEqual(n.fileUri,i))}async handleWindowsJumpList(){!p.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!p.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of v.app.getJumpListSettings().removedItems){const l=a.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&i.push(E.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let n=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const l=(0,m.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(l,a.label);let A;return E.URI.isUri(l)?A=`--folder-uri "${l.toString()}"`:(n=!0,A=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:n?(0,f.localize)(2,null):(0,f.localize)(3,null),items:o})}r.push({type:"recent"});try{const i=v.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(E.URI.isUri(r))return{title:(0,I.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,f.localize)(4,null),description:""};let n=(0,I.basename)(r.configPath);return n.endsWith(g.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,n),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,D.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;v.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let n=0;for(let a=0;a<r.workspaces.length&&n<it.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const l=this.location(r.workspaces[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);await S.Promises.exists(P)&&(i.push(P),n++)}}const o=[];for(let a=0;a<r.files.length&&n<it.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const l=this.location(r.files[a]);if(l.scheme===h.Schemas.file){const P=(0,I.originalFSPath)(l);if(it.COMMON_FILES_FILTER.includes((0,I.basename)(l))||i.includes(P))continue;await S.Promises.exists(P)&&(o.push(P),n++)}}o.reverse().forEach(a=>v.app.addRecentDocument(a)),i.reverse().forEach(a=>v.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([J(0,b.ILogService),J(1,u.IWorkspacesManagementMainService),J(2,C.ILifecycleMainService),J(3,w.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[261],ee([0,1,15,8,21,36,4,7,164,19,25,22,6,208,66,20,41,38,46,74,33,75]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let r=class Dt{constructor(o,a,l,P,M,A,F,U,Q,re,le){this.updateService=o,this.configurationService=a,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=A,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,g.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(A,F,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const A=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${A}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!D.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(D.isMacintosh?new v.Menu:null);return}const a=new v.Menu;let l;if(D.isMacintosh){const M=new v.Menu;l=new v.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new v.Menu;M.append(new v.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(A)}if(this.shouldDrawMenu("Edit")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(A)}if(this.shouldDrawMenu("Selection")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(A)}if(this.shouldDrawMenu("View")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(A)}if(this.shouldDrawMenu("Go")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(A)}if(this.shouldDrawMenu("Run")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(A)}if(this.shouldDrawMenu("Terminal")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(A)}let P;if(this.shouldDrawMenu("Window")){const M=new v.Menu;P=new v.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(A)}a.items&&a.items.length>0?v.Menu.setApplicationMenu(a):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const fe=new v.Menu;this.setMenuById(fe,"Preferences"),P=new v.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:fe})}const M=new v.Menu,A=new v.MenuItem({label:h.localize(12,null),role:"services",submenu:M}),F=new v.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new v.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(fe,se,ue)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(ue)&&this.nativeHostMainService.quit(void 0)}})),le=[a];le.push(...l),P&&le.push(i(),P),le.push(i(),A,i(),F,U,Q,i(),re),le.forEach(fe=>o.append(fe))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(h.localize(17,null)),(0,R.mnemonicButtonLabel)(h.localize(18,null))],message:h.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(o){if(!D.isMacintosh&&(0,g.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(l=>{if((0,f.isMenubarMenuItemSeparator)(l))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(l)){const P=new v.Menu,M=new v.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),o.append(M)}else(0,f.isMenubarMenuItemRecentAction)(l)?o.append(this.createOpenRecentMenuItem(l)):(0,f.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?o.append(new v.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):o.append(this.createMenuItem(l.label,l.id,!1,l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):o.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(l=>o.append(l)),o.append(i()))}createOpenRecentMenuItem(o){const a=y.URI.revive(o.uri),l=o.id,P=l==="openRecentFile"?{fileUri:a}:l==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new v.MenuItem(this.likeAction(l,{label:o.label,click:(M,A,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!D.isMacintosh&&(o.ctrlKey||o.shiftKey)||D.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,l){const P={label:this.mnemonicLabel(o),role:l,enabled:!0};return new v.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(o){const a=new v.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new v.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new v.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(i()),A.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,l,i(),M,...A,i(),P].forEach(F=>o.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,l,P){const M=this.mnemonicLabel(o),A=typeof a=="function"?a:(le,fe,se)=>{const ue=le?le.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),ue&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ue}):this.runActionInRenderer({type:"commandId",commandId:K})},F=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,Q={label:M,click:A,enabled:F};U&&(Q.type="checkbox",Q.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?Q.role="cut":re==="editor.action.clipboardCopyAction"?Q.role="copy":re==="editor.action.clipboardPasteAction"&&(Q.role="paste"),re==="undo"?Q.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?Q.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(A,{inDevTools:le=>le.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(re,Q))}makeContextAwareClickHandler(o,a){return(l,P,M)=>{const A=v.BrowserWindow.getFocusedWindow();if(!A)return a.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return a.inDevTools(A.webContents.devToolsWebContents);o(l,P||A,M)}}runActionInRenderer(o){let a=v.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const l=a?this.windowsMainService.getWindowById(a.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",o),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const P={id:o.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:o.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const l=typeof o=="string"?this.keybindings[o]:void 0;if(l?.label){if(l.isNative!==!1)a.accelerator=l.label,a.userSettingsLabel=l.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${l.label}]`:a.label=`${a.label} [${l.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,l=!a.accelerator){l&&(a=this.withKeybinding(o,a));const P=a.click;return a.click=(M,A,F)=>{this.reportMenuActionTelemetry(o),P?.(M,A,F)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ve([J(0,m.IUpdateService),J(1,p.IConfigurationService),J(2,u.IWindowsMainService),J(3,I.IEnvironmentMainService),J(4,w.ITelemetryService),J(5,c.IWorkspacesHistoryMainService),J(6,b.IStateMainService),J(7,E.ILifecycleMainService),J(8,S.ILogService),J(9,d.INativeHostMainService),J(10,C.IProductService)],r),e.Menubar=r;function i(){return new v.MenuItem({type:"separator"})}}),define(Z[262],ee([0,1,5,22,6,261]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let D=class{constructor(h,p,I){this.instantiationService=h,this.lifecycleMainService=p,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(h,p){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(p,h)}};D=ve([J(0,v.IInstantiationService),J(1,t.ILifecycleMainService),J(2,k.ILogService)],D),e.MenubarMainService=D}),define(Z[263],ee([0,1,15,29,30,24,21,3,31,48,36,2,13,9,71,4,35,16,12,7,172,60,19,55,25,14,5,22,6,52,20,61,63,41,74,260,116,256,26,117,75,47,64,34,39]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P,M,A,F,U,Q,re,le,fe,se,ue,K,N,W,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(q){return(0,se.isWorkspaceIdentifier)(q?.workspace)}function x(q){return(0,se.isSingleFolderWorkspaceIdentifier)(q?.workspace)}let z=class lt extends E.Disposable{constructor(L,O,B,V,X,ne,j,te,ie,ce,he,ke,Le,Me,Ae,Ve,me,pe){super();this.machineId=L,this.initialUserEnv=O,this.logService=B,this.stateMainService=V,this.policyService=X,this.environmentMainService=ne,this.userDataProfilesService=j,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=ce,this.workspacesHistoryMainService=he,this.workspacesManagementMainService=ke,this.instantiationService=Le,this.dialogMainService=Me,this.fileService=Ae,this.productService=Ve,this.protocolMainService=me,this.themeMainService=pe,this._onDidOpenWindow=this._register(new y.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new y.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new y.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new y.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new y.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new fe.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new E.DisposableStore;if(O.add(y.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const B of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(B));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const B=this.environmentMainService.args,V=O?.remoteAuthority||void 0,X=!0,ne=O?.forceReuseWindow,j=!ne;return this.open({...L,cli:B,forceEmpty:X,forceNewWindow:j,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],B=[],V=[],X=[],ne=[];let j,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const Me of ie)x(Me)?L.addMode?O.push(Me):B.push(Me):$(Me)?V.push(Me):Me.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),j.filesToOpenOrCreate.push(Me)):Me.backupPath?ne.push({backupFolder:(0,f.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):te++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...X),ne.push(...this.backupMainService.getEmptyWindowBackupPaths())):ne.length=0;const{windows:ce,filesOpenedInWindow:he}=this.doOpen(L,V,B,ne,te,j,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),ce.length>1)if(he)he.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ve=!0;if(Me){const me=ce.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,Ve=!1)}if(Ae)for(let me=ce.length-1;me>=0;me--){const pe=ce[me];if(!(pe.openedWorkspace&&X.some(Ee=>pe.openedWorkspace&&Ee.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&ne.some(Ee=>pe.backupPath&&Ee.backupFolder===(0,f.basename)(pe.backupPath)))){pe.focus(),Ve=!1;break}}Ve&&ce[ce.length-1].focus()}const ke=j&&j.filesToDiff.length>0,Le=j&&j.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!ke&&!Le&&!L.noRecentEntry){const Me=[];for(const Ae of ie)$(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):x(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const B=L.waitMarkerFileURI;L.context===0&&B&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch{}})()}doOpen(L,O,B,V,X,ne,j){const te=[];let ie;function ce(me,pe){te.push(me),pe&&(ie=me,ne=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ke}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const me=j[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(me);pe&&ce(this.doAddFoldersToExistingWindow(pe,j.map(Ee=>Ee.workspace.uri)))}const Le=B.length+O.length+V.length;if(ne&&Le===0){const me=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],pe=this.getWindows().filter(Y=>ne&&(0,w.isEqualAuthority)(Y.remoteAuthority,ne.remoteAuthority));let Ee;me?.fileUri&&!ke&&((L.context===4||L.context===0||L.context===1)&&(Ee=(0,le.findWindowOnFile)(pe,me.fileUri,Y=>Y.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Y.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?B.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,Ee,ne),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const Me=(0,R.distinct)(O,me=>me.workspace.id);if(Me.length>0){const me=(0,R.coalesce)(Me.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(me.length>0){const pe=me[0],Ee=(0,w.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,Ee),!!Ee),he=!0}Me.forEach(pe=>{if(me.some(ae=>ae.openedWorkspace&&ae.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,Y=(0,w.isEqualAuthority)(ne?.remoteAuthority,Ee)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,he,Y),!!Y),he=!0})}const Ae=(0,R.distinct)(B,me=>w.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(pe=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(me.length>0){const pe=me[0],Ee=(0,w.isEqualAuthority)(ne?.remoteAuthority,pe.remoteAuthority)?ne:void 0;ce(this.doOpenFilesInExistingWindow(L,pe,Ee),!!Ee),he=!0}Ae.forEach(pe=>{if(me.some(ae=>(0,se.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(ae.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,Y=(0,w.isEqualAuthority)(ne?.remoteAuthority,Ee)?ne:void 0;ce(this.doOpenFolderOrWorkspace(L,pe,he,Y),!!Y),he=!0})}const Ve=(0,R.distinct)(V,me=>me.backupFolder);if(Ve.length>0&&Ve.forEach(me=>{const pe=me.remoteAuthority,Ee=(0,w.isEqualAuthority)(ne?.remoteAuthority,pe)?ne:void 0;ce(this.doOpenEmpty(L,!0,pe,Ee,me),!!Ee),he=!0}),te.length===0||ne){ne&&!X&&X++;const me=ne?ne.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<X;pe++)ce(this.doOpenEmpty(L,he,me,ne),!!ne),he=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,O,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:B}),O.focus();const V={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToMerge:B?.filesToMerge,filesToWait:B?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const B={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,B),L}doOpenEmpty(L,O,B,V,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:B,filesToOpen:V,forceNewWindow:O});let ne;return!O&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:B,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:X})}doOpenFolderOrWorkspace(L,O,B,V,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!B&&!X&&typeof L.contextWindowId=="number"&&(X=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:X,userDataProfileInfo:O.userDataProfileInfo})}getPathsToOpen(L){let O,B=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),B=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),B=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&B){const X=O.filter(ne=>x(ne));if(X.length>1){const ne=X[0].remoteAuthority;if(X.every(j=>(0,w.isEqualAuthority)(j.remoteAuthority,ne))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(X.map(te=>({uri:te.workspace.uri})));O.push({workspace:j,remoteAuthority:ne}),O=O.filter(te=>!x(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(X=>$(X)||x(X)||X.backupPath)),O}doExtractPathsFromAPI(L){const O=[],B={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const X=this.resolveOpenable(V,B);if(X)X.label=V.label,O.push(X);else{const ne=this.resourceFromOpenable(V),j={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:ne.scheme===S.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:ne.scheme===S.Schemas.file?(0,u.localize)(3,null,(0,I.getPathLabel)(ne,{os:C.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,m.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],B={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const te of V){const ie=this.cliArgToUri(te);if(ie){const ce=this.resolveOpenable({folderUri:ie},B);ce&&O.push(ce)}}const X=L["file-uri"];if(X)for(const te of X){const ie=this.cliArgToUri(te);if(ie){const ce=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(te)?{workspaceUri:ie}:{fileUri:ie},B);ce&&O.push(ce)}}const ne=L._;for(const te of ne){const ie=B.remoteAuthority?this.doResolvePathRemote(te,B):this.doResolveFilePath(te,B);ie&&O.push(ie)}const j=L.profile;if(j)for(const te of O)te.userDataProfileInfo={name:j};return O}cliArgToUri(L){try{const O=g.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of O)if(V.workspace){const X=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});$(X)&&B.push(X)}else if(V.folderUri){const X=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});x(X)&&B.push(X)}else L!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const B=this.resourceFromOpenable(L);return B.scheme===S.Schemas.file?((0,Q.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let B=this.resourceFromOpenable(L);const V=(0,F.getRemoteAuthority)(B)||O.remoteAuthority;if(B=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(B)),(0,Q.isFileToOpen)(L)){if(O.gotoLineMode){const{path:X,line:ne,column:j}=(0,h.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:X}),options:{selection:ne?{startLineNumber:ne,startColumn:j||1}:void 0},remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,ue.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let B,V;O.gotoLineMode&&({path:L,line:B,column:V}=(0,h.parseLineAndColumnAware)(L)),L=(0,h.sanitizeFilePath)((0,f.normalize)(L),(0,b.cwd)());try{const X=(0,t.statSync)(L);if(X.isFile()){if(!O.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(g.URI.file(L));if(ne)return ne.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:g.URI.file(L),type:n.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0}}}else{if(X.isDirectory())return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(g.URI.file(L),X),type:n.FileType.Directory,exists:!0};if(!C.isWindows&&L==="/dev/null")return{fileUri:g.URI.file(L),type:n.FileType.File,exists:!0}}}catch{const ne=g.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),O.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const B=L.charCodeAt(0),V=O.remoteAuthority;let X,ne;O.gotoLineMode&&({path:L,line:X,column:ne}=(0,h.parseLineAndColumnAware)(L)),B!==47&&((0,h.isWindowsDriveLetter)(B)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,h.toSlashes)(L)),L=`/${L}`);const j=g.URI.from({scheme:S.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:X?{startLineNumber:X,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ue.getWorkspaceIdentifier)(j),remoteAuthority:V};if(O.gotoLineMode||f.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:X?{startLineNumber:X,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),B=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let X=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(B==="on"||B==="off")&&(X=B==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(C.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,O){const B=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(B)return this.lifecycleMainService.reload(B,O.cli),B.focus(),[B];let V=O.cli["folder-uri"]||[],X=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!V.length&&!X.length&&!O.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,he=ce&&(ce.workspace||ce.folderUri);he&&(g.URI.isUri(he)?he.scheme===S.Schemas.file?ne=[he.fsPath]:V=[he.toString()]:he.configPath.scheme===S.Schemas.file?ne=[(0,w.originalFSPath)(he.configPath)]:X=[he.configPath.toString()])}let j=O.remoteAuthority;for(const ce of L)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=g.URI.parse(ce),ke=(0,F.getRemoteAuthority)(he);ke&&(j?(0,w.isEqualAuthority)(ke,j)||this.logService.error("more than one extension development path authority"):j=ke)}ne=ne.filter(ce=>{const he=g.URI.file(ce);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:(0,w.isEqualAuthority)((0,F.getRemoteAuthority)(he),j)}),V=V.filter(ce=>{const he=this.cliArgToUri(ce);return he&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,w.isEqualAuthority)((0,F.getRemoteAuthority)(he),j):!1}),X=X.filter(ce=>{const he=this.cliArgToUri(ce);return he&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),he)?!1:he?(0,w.isEqualAuthority)((0,F.getRemoteAuthority)(he),j):!1}),O.cli._=ne,O.cli["folder-uri"]=V,O.cli["file-uri"]=X;const te=!ne.length&&!V.length&&!X.length,ie={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j};return this.open(ie)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,workspace:L.userDataProfileInfo??this.userDataProfilesService.getProfile(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesService.defaultProfile)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const X=V.config;!B.extensionDevelopmentPath&&X&&!!X.extensionDevelopmentPath&&(B.extensionDevelopmentPath=X.extensionDevelopmentPath,B.extensionDevelopmentKind=X.extensionDevelopmentKind,B["enable-proposed-api"]=X["enable-proposed-api"],B.verbose=X.verbose,B["inspect-extensions"]=X["inspect-extensions"],B["inspect-brk-extensions"]=X["inspect-brk-extensions"],B.debugId=X.debugId,B.extensionEnvironment=X.extensionEnvironment,B["extensions-dir"]=X["extensions-dir"],B["disable-extensions"]=X["disable-extensions"])}else{const X=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:X,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),lt.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,p.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,p.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const j=(0,m.assertIsDefined)(ne.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return B.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(X=>{X||this.doOpenInBrowserWindow(V,B,L)}):this.doOpenInBrowserWindow(V,B,L),V}doOpenInBrowserWindow(L,O,B){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,O.remoteAuthority)}L.load(O)}onWindowClosed(L){const O=lt.WINDOWS.indexOf(L);lt.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=v.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,w.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(B=>B.lastFocusTime));return L.find(B=>B.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return lt.WINDOWS}getWindowCount(){return lt.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(B=>B.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=v.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};z.WINDOWS=[],z=ve([J(2,l.ILogService),J(3,U.IStateMainService),J(4,T.IPolicyService),J(5,i.IEnvironmentMainService),J(6,_.IUserDataProfilesService),J(7,a.ILifecycleMainService),J(8,c.IBackupMainService),J(9,s.IConfigurationService),J(10,K.IWorkspacesHistoryMainService),J(11,N.IWorkspacesManagementMainService),J(12,o.IInstantiationService),J(13,r.IDialogMainService),J(14,n.IFileService),J(15,M.IProductService),J(16,A.IProtocolMainService),J(17,W.IThemeMainService)],z),e.WindowsMainService=z}),define(Z[264],ee([0,1,60,33,75,47]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(h,p,I,E){this.workspacesManagementMainService=h,this.windowsMainService=p,this.workspacesHistoryMainService=I,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,p){const I=this.windowsMainService.getWindowById(h);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(h,p,I){return this.workspacesManagementMainService.createUntitledWorkspace(p,I)}deleteUntitledWorkspace(h,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(h,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}removeRecentlyOpened(h,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([J(0,R.IWorkspacesManagementMainService),J(1,t.IWindowsMainService),J(2,k.IWorkspacesHistoryMainService),J(3,v.IBackupMainService)],D),e.WorkspacesMainService=D}),define(Z[265],ee([0,1,15,40,29,30,17,43,18,31,48,42,36,2,13,9,4,12,7,28,81,132,44,146,99,243,149,60,248,19,69,181,84,118,55,102,179,25,59,110,191,211,192,245,103,193,194,14,204,86,68,5,85,257,222,119,22,6,206,262,66,20,63,252,87,41,249,90,111,38,227,229,73,46,234,235,258,236,259,113,238,239,240,241,246,33,263,247,26,91,75,264,47,244,39,210,65,255,218,53,72,89,250]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P,M,A,F,U,Q,re,le,fe,se,ue,K,N,W,_,T,$,x,z,q,L,O,B,V,X,ne,j,te,ie,ce,he,ke,Le,Me,Ae,Ve,me,pe,Ee,Y,ae,de,Se,Ce,Te,Oe,Be,Ne,_e,qe,G,oe,ge,ye,we,Ie,We,ze,Ke,Qe,Ye,et,ot,at,Tt,Ot,Ft,Wt,_t,Ut,Nt,Rt,Bt,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends f.Disposable{constructor(be,De,Re,Pe,Ue,Ge,$e,He,Fe,je){super();this.mainProcessNodeIpcServer=be,this.userEnv=De,this.mainInstantiationService=Re,this.logService=Pe,this.environmentMainService=Ue,this.lifecycleMainService=Ge,this.configurationService=$e,this.stateMainService=He,this.fileService=Fe,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const be=Fe=>Fe?.startsWith(`${d.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((Fe,je,xe,Je)=>be(Je.requestingUrl)?xe(De.has(je)):xe(!1)),v.session.defaultSession.setPermissionCheckHandler((Fe,je,xe,Je)=>be(Je.requestingUrl)?De.has(je):!1);const Re=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Pe=Fe=>{for(let je=Fe;je;je=je.parent)if(je.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Ue=Fe=>Fe.resourceType==="xhr"||Pe(Fe.frame),Ge=Fe=>{const je=Fe.frame;if(!je||!this.windowsMainService)return!1;const xe=v.BrowserWindow.getAllWindows();for(const Je of xe)if(je.processId===Je.webContents.mainFrame.processId)return!0;return!1},$e=(Fe,je)=>{if(Fe.path!=="/index.html")return!0;const xe=je.frame;if(!xe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((Fe,je)=>{const xe=m.URI.parse(Fe.url);return xe.scheme===d.Schemas.vscodeWebview&&!$e(xe,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),je({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!Ge(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),je({cancel:!0})):xe.path.endsWith(".svg")&&!Re.has(xe.scheme)?je({cancel:!Ue(Fe)}):je({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((Fe,je)=>{const xe=Fe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const rt=m.URI.parse(Fe.url);if(rt.path.endsWith(".svg")&&Re.has(rt.scheme))return xe["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:xe});if(!rt.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ut=>ut.toLowerCase().includes("image/svg")))return je({cancel:!Ue(Fe)})}return je({cancel:!1})});const He=v.session.defaultSession;typeof He.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&He.setCodeCachePath((0,C.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,h.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,h.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Re,Pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),v.app.on("activate",(Re,Pe)=>{this.logService.trace("app#activate"),Pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Re,Pe)=>{Pe.on("will-navigate",Ue=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ue.preventDefault()}),Pe.setWindowOpenHandler(({url:Ue})=>(this.nativeHostMainService?.openExternal(void 0,Ue),{action:"deny"}))});let be=[],De;v.app.on("open-file",(Re,Pe)=>{this.logService.trace("app#open-file: ",Pe),Re.preventDefault(),be.push(this.getWindowOpenableFromPathSync(Pe)),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],De=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Pe=this.windowsMainService?.getWindowByWebContents(Re.sender);let Ue,Ge;return Pe?.config?(Ue=Pe.config,Ge={...process.env,...Pe.config.userEnv}):(Ue=this.environmentMainService.args,Ge=process.env),this.resolveShellEnvironment(Ue,Ge,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Pe,Ue)=>{const Ge=this.validateNlsPath([Pe]);if(!Ge||typeof Ue!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ge,D.VSBuffer.fromString(Ue))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Pe)=>{const Ue=this.validateNlsPath(Pe);if(!Ue)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ue)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(be){let De;for(const Re of be)typeof Re=="string"&&(typeof De!="string"?De=Re:De=(0,C.join)(De,Re));if(!(typeof De!="string"||!(0,C.isAbsolute)(De)||!(0,p.isEqualOrParent)(De,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return m.URI.file(De)}onUnexpectedError(be){if(be){const De={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;b.isWindows&&be&&v.app.setAppUserModelId(be);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const De=new r.Server;this.lifecycleMainService.onWillShutdown(Fe=>{Fe.reason===2&&De.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Pe,sharedProcessReady:Ue,sharedProcessClient:Ge}=this.setupSharedProcess(Re),$e=await this.initServices(Re,Pe,Ue);this.setUpHandlers($e),$e.invokeFunction(Fe=>this.initChannels(Fe,De,Ge));const He=$e.invokeFunction(Fe=>this.openFirstWindow(Fe,De));$e.invokeFunction(Fe=>this.afterWindowOpen(Fe,Pe)),this.environmentMainService.args.trace&&$e.invokeFunction(Fe=>this.stopTracingEventually(Fe,He))}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(_t.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(ae.machineIdKey);return(!be||b.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,u.getMachineId)(),this.stateMainService.setItem(ae.machineIdKey,be)),be}setupSharedProcess(be){const De=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,be,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ue=await De.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Ue,"main")})(),Pe=(async()=>(await De.whenReady(),Re))();return{sharedProcess:De,sharedProcessReady:Pe,sharedProcessClient:Re}}async initServices(be,De,Re){const Pe=new V.ServiceCollection;switch(process.platform){case"win32":Pe.set(Te.IUpdateService,new O.SyncDescriptor(qe.Win32UpdateService));break;case"linux":b.isLinuxSnap?Pe.set(Te.IUpdateService,new O.SyncDescriptor(_e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(Te.IUpdateService,new O.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Pe.set(Te.IUpdateService,new O.SyncDescriptor(Be.DarwinUpdateService));break}Pe.set(We.IWindowsMainService,new O.SyncDescriptor(ze.WindowsMainService,[be,this.userEnv])),Pe.set(Q.IDialogMainService,new O.SyncDescriptor(Q.DialogMainService)),Pe.set(j.ILaunchMainService,new O.SyncDescriptor(j.LaunchMainService)),Pe.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Pe.set(F.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Re.then(Ge=>Ge.getChannel("diagnostics"))))),Pe.set(X.IIssueMainService,new O.SyncDescriptor(X.IssueMainService,[this.userEnv])),Pe.set(re.IEncryptionMainService,new O.SyncDescriptor(le.EncryptionMainService,[be])),Pe.set(ne.IKeyboardLayoutMainService,new O.SyncDescriptor(ne.KeyboardLayoutMainService)),Pe.set(ke.INativeHostMainService,new O.SyncDescriptor(ke.NativeHostMainService,[De])),Pe.set(M.ICredentialsMainService,new O.SyncDescriptor(Tt.CredentialsNativeMainService)),Pe.set(we.IWebviewManagerService,new O.SyncDescriptor(Ie.WebviewMainService)),Pe.set(Ye.IWorkspacesService,new O.SyncDescriptor(ot.WorkspacesMainService)),Pe.set(at.IWorkspacesManagementMainService,new O.SyncDescriptor(at.WorkspacesManagementMainService)),Pe.set(et.IWorkspacesHistoryMainService,new O.SyncDescriptor(et.WorkspacesHistoryMainService)),Pe.set(he.IMenubarMainService,new O.SyncDescriptor(he.MenubarMainService)),Pe.set(K.IExtensionUrlTrustService,new O.SyncDescriptor(N.ExtensionUrlTrustService)),Pe.set(W.IExtensionHostStarter,new O.SyncDescriptor(_.ExtensionHostStarter)),Pe.set(Ee.IStorageMainService,new O.SyncDescriptor(Ee.StorageMainService)),Pe.set(Ee.IApplicationStorageMainService,new O.SyncDescriptor(Ee.ApplicationStorageMainService)),b.isWindows?Pe.set(T.IExternalTerminalMainService,new O.SyncDescriptor($.WindowsExternalTerminalService)):b.isMacintosh?Pe.set(T.IExternalTerminalMainService,new O.SyncDescriptor($.MacExternalTerminalService)):b.isLinux&&Pe.set(T.IExternalTerminalMainService,new O.SyncDescriptor($.LinuxExternalTerminalService));const Ue=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Pe.set(a.IBackupMainService,Ue),Pe.set(G.IURLService,new O.SyncDescriptor(ge.NativeURLService)),(0,Ce.supportsTelemetry)(this.productService,this.environmentMainService)){const Ge=(0,Ce.isInternalTelemetry)(this.productService,this.configurationService),$e=(0,s.getDelayedChannel)(Re.then(Je=>Je.getChannel("telemetryAppender"))),He=new de.TelemetryAppenderClient($e),Fe=(0,Y.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,be,Ge,this.environmentMainService.installSourcePath),je=(0,Ce.getPiiPathsFromEnvironment)(this.environmentMainService),xe={appenders:[He],commonProperties:Fe,piiPaths:je,sendErrorTelemetry:!0};Pe.set(ae.ITelemetryService,new O.SyncDescriptor(Se.TelemetryService,[xe]))}else Pe.set(ae.ITelemetryService,Ce.NullTelemetryService);return Pe.set(Rt.IExtensionsProfileScannerService,new O.SyncDescriptor(Rt.ExtensionsProfileScannerService)),Pe.set(Bt.IExtensionsScannerService,new O.SyncDescriptor(zt.ExtensionsScannerService)),await Ue.initialize(),this.mainInstantiationService.createChild(Pe)}initChannels(be,De,Re){const Pe=s.ProxyChannel.fromService(be.get(j.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Pe);const Ue=s.ProxyChannel.fromService(be.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Ue);const Ge=new Ft.PolicyChannel(be.get(Ot.IPolicyService));De.registerChannel("policy",Ge),Re.then(tt=>tt.registerChannel("policy",Ge));const $e=this.fileService.getProvider(d.Schemas.file);(0,w.assertType)($e instanceof L.DiskFileSystemProvider);const He=new q.DiskFileSystemProviderChannel($e,this.logService,this.environmentMainService);De.registerChannel(x.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He),Re.then(tt=>tt.registerChannel(x.LOCAL_FILE_SYSTEM_CHANNEL_NAME,He));const Fe=s.ProxyChannel.fromService(be.get(Wt.IUserDataProfilesMainService));De.registerChannel("userDataProfiles",Fe),Re.then(tt=>tt.registerChannel("userDataProfiles",Fe));const je=new Ut.RequestChannel(be.get(Nt.IRequestService));Re.then(tt=>tt.registerChannel("request",je));const xe=new Oe.UpdateChannel(be.get(Te.IUpdateService));De.registerChannel("update",xe);const Je=s.ProxyChannel.fromService(be.get(X.IIssueMainService));De.registerChannel("issue",Je);const rt=s.ProxyChannel.fromService(be.get(re.IEncryptionMainService));De.registerChannel("encryption",rt);const ut=s.ProxyChannel.fromService(be.get(M.ICredentialsMainService));De.registerChannel("credentials",ut);const Ct=s.ProxyChannel.fromService(be.get(Ve.ISignService));De.registerChannel("sign",Ct);const Ze=s.ProxyChannel.fromService(be.get(ne.IKeyboardLayoutMainService));De.registerChannel("keyboardLayout",Ze),this.nativeHostMainService=be.get(ke.INativeHostMainService);const ht=s.ProxyChannel.fromService(this.nativeHostMainService);De.registerChannel("nativeHost",ht),Re.then(tt=>tt.registerChannel("nativeHost",ht));const dt=s.ProxyChannel.fromService(be.get(Ye.IWorkspacesService));De.registerChannel("workspaces",dt);const ft=s.ProxyChannel.fromService(be.get(he.IMenubarMainService));De.registerChannel("menubar",ft);const pt=s.ProxyChannel.fromService(be.get(G.IURLService));De.registerChannel("url",pt);const wt=s.ProxyChannel.fromService(be.get(K.IExtensionUrlTrustService));De.registerChannel("extensionUrlTrust",wt);const gt=s.ProxyChannel.fromService(be.get(we.IWebviewManagerService));De.registerChannel("webview",gt);const ct=this._register(new pe.StorageDatabaseChannel(this.logService,be.get(Ee.IStorageMainService)));De.registerChannel("storage",ct),Re.then(tt=>tt.registerChannel("storage",ct));const vt=s.ProxyChannel.fromService(be.get(T.IExternalTerminalMainService));De.registerChannel("externalTerminal",vt);const Xe=new ce.LogLevelChannel(be.get(ie.ILogService));De.registerChannel("logLevel",Xe),Re.then(tt=>tt.registerChannel("logLevel",Xe));const nt=new ce.LoggerChannel(be.get(ie.ILoggerService));De.registerChannel("logger",nt),Re.then(tt=>tt.registerChannel("logger",nt));const st=new A.ElectronExtensionHostDebugBroadcastChannel(be.get(We.IWindowsMainService));De.registerChannel("extensionhostdebugservice",st);const mt=s.ProxyChannel.fromService(be.get(W.IExtensionHostStarter));De.registerChannel(W.ipcExtensionHostStarterChannelName,mt)}openFirstWindow(be,De){const Re=this.windowsMainService=be.get(We.IWindowsMainService),Pe=be.get(G.IURLService),Ue=be.get(ke.INativeHostMainService);this.lifecycleMainService.phase=2;const Ge=[],$e=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Xe=>{try{return{uri:m.URI.parse(Xe),url:Xe}}catch{return}}).filter(Xe=>{if(!Xe||this.shouldBlockURI(Xe.uri))return!1;const nt=this.getWindowOpenableFromProtocolLink(Xe.uri);return nt?(Ge.push(nt),!1):!0}),He=this,Fe=this.environmentMainService,je=this.productService,xe=this.logService;Pe.registerHandler({async handleURL(Xe,nt){if(xe.trace("app#handleURL: ",Xe.toString(!0),nt),Xe.scheme===je.urlProtocol&&Xe.path==="workspace"&&(Xe=Xe.with({authority:"file",path:m.URI.parse(Xe.query).path,query:""})),He.shouldBlockURI(Xe))return!0;let st=!1;const mt=new URLSearchParams(Xe.query);mt.get("windowId")==="_blank"&&(mt.delete("windowId"),Xe=Xe.with({query:mt.toString()}),st=!0),st||(st=b.isMacintosh&&Re.getWindowCount()===0);const tt=He.getWindowOpenableFromProtocolLink(Xe);if(xe.trace("app#handleURL: windowOpenableFromProtocolLink = ",tt),tt){const[It]=Re.open({context:5,cli:{...Fe.args},urisToOpen:[tt],forceNewWindow:st,gotoLineMode:!0});return It.focus(),!0}if(st){const[It]=Re.open({context:5,cli:{...Fe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Me.getRemoteAuthority)(Xe)});return await It.ready(),Pe.open(Xe,nt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:Ue.onDidOpenWindow,onDidFocusWindow:Ue.onDidFocusWindow,getActiveWindowId:()=>Ue.getActiveWindowId(-1)})),rt=new s.StaticRouter(Xe=>Je.getActiveClientId().then(nt=>Xe===nt)),ut=new oe.URLHandlerRouter(rt),Ct=De.getChannel("urlHandler",ut);Pe.registerHandler(new oe.URLHandlerChannelClient(Ct)),this._register(new ye.ElectronURLListener($e,Pe,Re,this.environmentMainService,this.productService));const Ze=this.environmentMainService.args,ht=global.macOpenFiles,dt=(0,se.isLaunchedFromCli)(process.env)?0:4,ft=Ze._.length,pt=!!Ze["folder-uri"],wt=!!Ze["file-uri"],gt=Ze["skip-add-to-recently-opened"]===!0,ct=Ze.wait&&Ze.waitMarkerFilePath?m.URI.file(Ze.waitMarkerFilePath):void 0,vt=Ze.remote||void 0;return Ge.length>0?Re.open({context:dt,cli:Ze,urisToOpen:Ge,gotoLineMode:!0,initialStartup:!0}):Ze["new-window"]&&!ft&&!pt&&!wt?Re.open({context:dt,cli:Ze,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:gt,waitMarkerFileURI:ct,initialStartup:!0,remoteAuthority:vt}):ht.length&&!ft&&!pt&&!wt?Re.open({context:1,cli:Ze,urisToOpen:ht.map(Xe=>this.getWindowOpenableFromPathSync(Xe)),noRecentEntry:gt,waitMarkerFileURI:ct,initialStartup:!0}):Re.open({context:dt,cli:Ze,forceNewWindow:Ze["new-window"]||!ft&&Ze["unity-launch"],diffMode:Ze.diff,mergeMode:Ze.merge,noRecentEntry:gt,waitMarkerFileURI:ct,gotoLineMode:Ze.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(be){return!!(be.authority===d.Schemas.file&&b.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,S.getPathLabel)(be,{os:b.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===d.Schemas.file){const De=m.URI.file(be.fsPath);return(0,Qe.hasWorkspaceFileExtension)(De)?{workspaceUri:De}:{fileUri:De}}else if(be.authority===d.Schemas.vscodeRemote){const De=be.path.indexOf(C.posix.sep,1);if(De!==-1){const Re=be.path.substring(1,De),Pe=be.path.substring(De),Ue=m.URI.from({scheme:d.Schemas.vscodeRemote,authority:Re,path:Pe,query:be.query,fragment:be.fragment});return(0,Qe.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Ue}:/:[\d]+$/.test(Pe)?{fileUri:Ue}:{folderUri:Ue}}}}}getWindowOpenableFromPathSync(be){try{if((0,k.statSync)(be).isDirectory())return{folderUri:m.URI.file(be)};if((0,Qe.hasWorkspaceFileExtension)(be))return{workspaceUri:m.URI.file(be)}}catch{}return{fileUri:m.URI.file(be)}}async afterWindowOpen(be,De){this.lifecycleMainService.phase=3;let Re=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0);const Pe=be.get(ae.ITelemetryService);this._register(De.onDidError(({type:$e,details:He})=>{let Fe;switch($e){case 1:Fe="SharedProcess: detected unresponsive window";break;case 2:Fe=`SharedProcess: crashed (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break;case 3:Fe=`SharedProcess: failed to load (detail: ${He?.reason??"<unknown>"}, code: ${He?.exitCode??"<unknown>"})`;break}(0,h.onUnexpectedError)(new Error(Fe)),Pe.publicLog2("sharedprocesserror",{type:$e,reason:He?.reason,code:He?.exitCode,visible:De.isVisible(),shuttingdown:Re})}));const Ue=this.productService.win32MutexName;if(b.isWindows&&Ue)try{const $e=H.__$__nodeRequire("windows-mutex").Mutex,He=new $e(Ue);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>He.release())}catch($e){this.logService.error($e)}v.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,($e,He)=>{He({url:$e.url.replace(/^vscode-remote-resource:/,"http:"),method:$e.method})});const Ge=be.get(Te.IUpdateService);(Ge instanceof qe.Win32UpdateService||Ge instanceof Ne.LinuxUpdateService||Ge instanceof Be.DarwinUpdateService)&&await Ge.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const He=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,E.stripComments)(He))["enable-crash-reporter"]===void 0){const xe=(0,Ce.getTelemetryLevel)(this.configurationService)>=1,Je=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${xe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],rt=He.substring(0,He.length-2).concat(`,
`,Je.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(rt))}}catch($e){this.logService.error($e)}}async resolveShellEnvironment(be,De,Re){try{return await(0,ue.getResolvedShellEnv)(this.logService,be,De)}catch(Pe){const Ue=(0,y.toErrorMessage)(Pe);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Ue):this.logService.error(Ue)}return{}}stopTracingEventually(be,De){this.logService.info("Tracing: waiting for windows to get ready...");const Re=be.get(Q.IDialogMainService);let Pe=!1;const Ue=async $e=>{if(Pe)return;Pe=!0;const He=await v.contentTracing.stopRecording(`${(0,p.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);$e?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${He}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,He),buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,w.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Ge=setTimeout(()=>Ue(!0),3e4);Promise.all(De.map($e=>$e.ready())).then(()=>{clearTimeout(Ge),Ue(!1)})}};Et=ve([J(2,B.IInstantiationService),J(3,ie.ILogService),J(4,fe.IEnvironmentMainService),J(5,te.ILifecycleMainService),J(6,P.IConfigurationService),J(7,me.IStateMainService),J(8,z.IFileService),J(9,Le.IProductService)],Et),e.CodeApplication=Et}),define(Z[266],ee([0,1,39,8,274,2]),function(H,e,v,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends v.AbstractPolicyService{constructor(h){super();this.productName=h,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((p,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,h,E=>{for(const S in E){const f=E[S];f===void 0?this.policies.delete(S):this.policies.set(S,f)}this._onDidChange.fire(Object.keys(E)),p()})}catch(E){I(E)}}))}}e.NativePolicyService=D}),define(Z[267],ee([0,1,220,8,17,18,2,12,19,37,110,6,219,275]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends D.Disposable{constructor(b,w,m){super();this.environmentService=w,this.logService=m,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,w){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:m,strictSSL:g}=this;let u;try{u=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...u},s=b.agent?b.agent:await(0,S.getProxyAgent)(b.url||"",c,{proxyUrl:m,strictSSL:g});b.agent=s,b.strictSSL=g,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(b,w);return this.logService.trace("RequestService#request (node) - success",b.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",b.url,r),r}}async getNodeRequest(b){return((0,v.parse)(b.url).protocol==="https:"?await new Promise((g,u)=>{H(["https"],g,u)}):await new Promise((g,u)=>{H(["http"],g,u)})).request}_request(b,w){return t.Promises.withAsyncBody(async(m,g)=>{const u=(0,v.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),s={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,y.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(s.auth=b.user+":"+b.password);const r=c(s,i=>{const n=(0,y.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...b,url:i.headers.location,followRedirects:n-1},w).then(m,g);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),m({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});r.on("error",g),b.timeout&&r.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&r.write(b.data),r.end(),w.onCancellationRequested(()=>{r.abort(),g(new R.CancellationError)})})}async resolveProxy(b){}};d=ve([J(0,h.IConfigurationService),J(1,p.INativeEnvironmentService),J(2,E.ILogService)],d),e.RequestService=d}),define(Z[268],ee([0,1,15,267]),function(H,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return v.net.request}class R extends t.RequestService{request(y,h){return super.request({...y||{},getRawRequest:k},h)}}e.RequestMainService=R}),define(Z[276],ee([0,1,15,29,7,24,8,43,18,31,48,36,13,9,71,4,35,27,23,44,83,265,10,19,214,226,25,59,184,14,202,86,68,199,85,22,105,6,207,106,52,20,61,251,112,232,53,268,87,221,41,225,73,64,65,39,266,209,2,54,237,34,233]),function(H,e,v,t,k,R,D,y,h,p,I,E,S,f,d,C,b,w,m,g,u,c,s,r,i,n,o,a,l,P,M,A,F,U,Q,re,le,fe,se,ue,K,N,W,_,T,$,x,z,q,L,O,B,V,X,ne,j,te,ie,ce,he,ke,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Me{main(){try{this.startup()}catch(me){console.error(me.message),v.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,pe,Ee,Y,ae,de,Se,Ce]=this.createServices();try{try{await this.initServices(Ee,Ce,Y,ae)}catch(Te){throw this.handleStartupDataDirError(Ee,Se.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(fe.ILogService),Be=Te.get(re.ILifecycleMainService),Ne=Te.get(P.IFileService),_e=await this.claimInstance(Oe,Ee,Be,me,Se,!0);return m.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(qe=>{Oe.warn(`Error writing main lockfile: ${qe.stack}`)}),de.logger=new ue.SpdLogLogger("main",(0,f.join)(Ee.logsPath,"main.log"),!0,!1,de.getLevel()),(0,I.once)(Be.onWillShutdown)(qe=>{Ne.dispose(),Y.dispose(),qe.join(m.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,_e,pe).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new Q.ServiceCollection,pe=new ce.DisposableStore;process.once("exit",()=>pe.dispose());const Ee={_serviceBrand:void 0,...K.default};me.set(N.IProductService,Ee);const Y=new o.EnvironmentMainService(this.resolveArgs(),Ee),ae=this.patchEnvironment(Y);me.set(o.IEnvironmentMainService,Y);const de=new le.BufferLogService,Se=pe.add(new fe.MultiplexLogService([new fe.ConsoleMainLogger((0,fe.getLogLevel)(Y)),de]));me.set(fe.ILogService,Se);const Ce=new M.FileService(Se);me.set(P.IFileService,Ce);const Te=new A.DiskFileSystemProvider(Se);Ce.registerProvider(S.Schemas.file,Te);const Oe=new ke.UriIdentityService(Ce);me.set(he.IUriIdentityService,Oe),me.set(fe.ILoggerService,new se.LoggerService(Se,Ce));const Be=new B.StateMainService(Y,Se,Ce);me.set(O.IStateMainService,Be);const Ne=new ne.UserDataProfilesMainService(Be,Oe,Y,Ce,Se);me.set(ne.IUserDataProfilesMainService,Ne);const _e=C.isWindows&&Ee.win32RegValueName?pe.add(new te.NativePolicyService(Ee.win32RegValueName)):Y.policyFile?pe.add(new ie.FilePolicyService(Y.policyFile,Ce,Se)):new j.NullPolicyService;me.set(j.IPolicyService,_e);const qe=new i.ConfigurationService(Ne.defaultProfile.settingsResource,Ce,_e,Se);return me.set(r.IConfigurationService,qe),me.set(re.ILifecycleMainService,new F.SyncDescriptor(re.LifecycleMainService)),me.set(x.IRequestService,new F.SyncDescriptor(z.RequestMainService)),me.set(X.IThemeMainService,new F.SyncDescriptor(X.ThemeMainService)),me.set(q.ISignService,new F.SyncDescriptor(L.SignService)),me.set(T.ITunnelService,new F.SyncDescriptor($.TunnelService)),me.set(W.IProtocolMainService,new F.SyncDescriptor(_.ProtocolMainService)),[new U.InstantiationService(me,!0),ae,Y,qe,Be,de,Ee,Ne]}patchEnvironment(me){const pe={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const Y=process.env[Ee];typeof Y=="string"&&(pe[Ee]=Y)}),Object.assign(process.env,pe),pe}async initServices(me,pe,Ee,Y){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,pe.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(ae=>ae?m.Promises.mkdir(ae,{recursive:!0}):void 0)),Y.init(),Ee.initialize()]),pe.setEnablement(!!Ee.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,pe,Ee,Y,ae,de){let Se;try{(0,d.mark)("code/willStartMainServer"),Se=await(0,u.serve)(pe.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>Se.dispose())}catch(Ce){if(Ce.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,ae.nameLong,Ce),Ce;let Te;try{Te=await(0,u.connect)(pe.mainIPCHandle,"main")}catch(_e){if(!de||C.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,ae.nameShort),(0,s.localize)(1,null),ae.nameLong),_e;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(qe){throw me.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(me,pe,Ee,Y,ae,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(_e),Te.dispose(),new Error(_e)}let Oe;!pe.args.wait&&!pe.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,ae.nameShort),(0,s.localize)(3,null),ae.nameLong)},1e4));const Be=g.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Ne=g.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return Y.invokeFunction(async()=>{const _e=new n.DiagnosticsService(V.NullTelemetryService,ae),qe=await Be.getMainProcessInfo(),G=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),oe=await _e.getDiagnostics(qe,G);throw console.log(oe),new h.ExpectedError});throw C.isWindows&&await this.windowsAllowSetForegroundWindow(Be,me),me.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new h.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(me,pe,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const Y=(0,R.coalesce)([me.userDataPath,me.extensionsPath,u.XDG_RUNTIME_DIR]).map(ae=>(0,E.getPathLabel)(k.URI.file(ae),{os:C.OS,tildify:me}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,y.toErrorMessage)(Ee),Y.join(`
`)),pe)}}showStartupWarningDialog(me,pe,Ee){v.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,s.localize)(6,null))],message:me,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,pe){if(C.isWindows){const Ee=await me.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((Y,ae)=>{H(["windows-foreground-love"],Y,ae)})).allowSetForegroundWindow(Ee)}catch(Y){pe.error(Y)}}}quit(me,pe){const Ee=me.get(fe.ILogService),Y=me.get(re.ILifecycleMainService);let ae=0;pe&&(pe.isExpected?pe.message&&Ee.trace(pe.message):(ae=1,pe.stack?Ee.error(pe.stack):Ee.error(`Startup error: ${pe.toString()}`))),Y.kill(ae)}resolveArgs(){const me=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const pe=(0,l.createWaitMarkerFile)(me.verbose);pe&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",pe),me.waitMarkerFilePath=pe)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const pe=this.doValidatePaths(me._,me.goto);me._=pe}return me}doValidatePaths(me,pe){const Ee=(0,b.cwd)(),Y=me.map(Se=>{let Ce=String(Se),Te;pe&&(Te=(0,p.parseLineAndColumnAware)(Ce),Ce=Te.path),Ce&&(Ce=this.preparePath(Ee,Ce));const Oe=(0,p.sanitizeFilePath)(Ce,Ee),Be=(0,f.basename)(Oe);return Be&&!(0,p.isValidBasename)(Be)?null:pe&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),ae=C.isWindows||C.isMacintosh,de=(0,R.distinct)(Y,Se=>Se&&ae?Se.toLowerCase():Se||"");return(0,R.coalesce)(de)}preparePath(me,pe){return C.isWindows&&(pe=(0,w.rtrim)(pe,'"')),pe=(0,w.trim)((0,w.trim)(pe," "),"	"),C.isWindows&&(pe=(0,f.resolve)(me,pe),pe=(0,w.rtrim)(pe,".")),pe}toPath(me){const pe=[me.path];return typeof me.line=="number"&&pe.push(String(me.line)),typeof me.column=="number"&&pe.push(String(me.column)),pe.join(":")}}new Me().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/28f604dec81b609dd7e69362585f7a99d4c48f88/core/vs/code/electron-main/main.js.map
